/*
 ****************************************************************************************
 * DISCLAIMER
 ****************************************************************************************
 * This software and/or information (the "Material") is supplied by Renesas Electronics
 * Corporation. and is only intended for use with Renesas products. No other uses are authorized.
 * The Material is owned by Renesas Electronics Corporation and is protected under all applicable laws,
 * including copyright laws.
 * THIS MATERIAL IS PROVIDED "AS IS," AND RENESAS MAKES NO WARRANTIES REGARDING THIS MATERIAL,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
 * TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER RENESAS ELECTRONICS CORP. NOR ANY OF ITS
 * AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS MATERIAL, EVEN IF RENESAS OR ITS AFFILIATES
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this Material
 * and to discontinue its availability
 *
 ****************************************************************************************
*/
#include "ble_app_thread.h"
#include "ble_host_thread.h"
#include "rble_api.h"
#include "rble_host.h"
#include "config.h"

void ble_app_thread_entry(void);

extern RBLE_STATUS APP_Run( uint32_t run_command );
extern bool APP_Init( void );
extern void update_BdAddress(uint8_t *ptr);


/* BLE App Thread entry function */
void ble_app_thread_entry(void)
{
    uint32_t run_cmd;
    RBLE_STATUS sts;
    //fmi_product_info_t  b_info;
    //fmi_product_info_t *p_info = &b_info;
    uint32_t events;

    // Wait for BLE ready event
    tx_event_flags_get(&g_ble_ready_event, 0x01, TX_OR, &events, TX_WAIT_FOREVER);
    // breathe
    tx_thread_sleep(10);

    //g_fmi0.p_api->productInfoGet(&p_info);
    //update_BdAddress(&p_info->unique_id[0]);

    APP_Init();
    /* In this thread the commands are processed related GAP, SCP  */
    while (1)
    {
        tx_queue_receive(&g_RunCmd, &run_cmd, TX_WAIT_FOREVER);
        sts = APP_Run(run_cmd);
        if (sts != RBLE_OK)
        {
        // TODO: Add status logging if error code returned (cmd, status)
        }
        // No need to delay message processing
        //tx_thread_sleep (1);
    }
}
