package com.xaplos.hcsolution;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.widget.TextView;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;

public class ActivityActivity extends AppCompatActivity implements BLEManager.BLEManagerNotifyListener {
    private final BLEManager mBle = BLEManager.getInstance();
    private TextView mSteps;
    private TextView mDistance;
    private TextView mCalories;

    private BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            mSteps.setText("-");
            mDistance.setText("- Mi");
            mCalories.setText("- kcal");
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_activity);
        getSupportActionBar().hide();

        // register for disconnect event
        IntentFilter filter = new IntentFilter();
        filter.addAction("com.xaplos.BleDisconnect");
        registerReceiver(receiver, filter);

        mSteps = (TextView)findViewById(R.id.text_view_steps_value);
        mDistance = (TextView)findViewById(R.id.text_view_distance_value);
        mCalories = (TextView)findViewById(R.id.text_view_calories_value);

        mBle.addNotifyListener(this);
    }

    @Override
    public void onNotification(Bundle notification) {
        int steps = notification.getInt("Steps");
        mSteps.setText(String.valueOf(steps));

        int distance = notification.getInt("Distance");
        mDistance.setText(String.valueOf(distance / 100.0) + " Mi");

        int calories = notification.getInt("Calories");
        mCalories.setText(String.valueOf(calories) + " kCal");
    }
}
