package com.xaplos.hcsolution;

import android.bluetooth.BluetoothGattCharacteristic;
import android.os.Bundle;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.Random;
import java.util.UUID;

/*

typedef struct activity_data_t
{
    uint16_t light;
    uint16_t pressure;
    uint16_t temperature;
    uint16_t humidity;
    uint16_t distance;
    uint16_t calories;
    uint16_t steps;
}
activity_data;

*/

public class ActivityDemoCharacteristic extends BLECharacteristic {
    @SuppressWarnings("unused")
    private static final String TAG = "ActivityDemoCharacteristic";

    // UUID for reporting characteristic of on-board sensor value
    private static final UUID uuidDemoSensor = UUID.fromString("01000000-0000-0000-0000-0000000000C0");

    @Override
    public String getCharacteristicName() {
        return "Sensor";
    }

    @Override
    public UUID getCharacteristicUuid() {
        return uuidDemoSensor;
    }

    @Override
    public Bundle parseCharacteristicValue(BluetoothGattCharacteristic characteristic) {
        Bundle results = new Bundle();
        ByteBuffer buffer = ByteBuffer.wrap(characteristic.getValue());
        buffer.order(ByteOrder.LITTLE_ENDIAN);

        short raw = buffer.getShort();
        results.putInt("Light", raw & 0xffff);
        raw = buffer.getShort();
        results.putInt("Pressure", raw & 0xffff);
        raw = buffer.getShort();
        results.putInt("Temperature", raw & 0xffff);
        raw = buffer.getShort();
        results.putInt("Humidity", raw & 0xffff);
        raw = buffer.getShort();
        results.putInt("Distance", raw & 0xffff);
        raw = buffer.getShort();
        results.putInt("Calories", raw & 0xffff);
        raw = buffer.getShort();
        results.putInt("Steps", raw & 0xffff);

        return results;
    }

    @Override
    public Bundle emulateCharacteristic() {
        Bundle results = new Bundle();
        Random random = new Random();
        results.putFloat("Sensor", random.nextInt(0xffff));

        return results;
    }
}
