package com.xaplos.hcsolution;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class ActivityDemoDevice extends BLEDevice {
    private final static String TAG = "ActivityDemoDevice";

    private static final UUID uuidDemoService = UUID.fromString("00000000-0000-0000-0000-0000000000C0");
    private ArrayList<BLECharacteristic>mList;

    @Override
    public List<BLECharacteristic> getCharacteristics() {
        if (mList == null) {
            mList = new ArrayList<>();
            mList.add(new ActivityDemoCharacteristic());
            mList.add(new HealthcareDemoCharacteristic());
        }

        return mList;
    }

    @Override
    public String getDeviceName() {
        return TAG;
    }

    @Override
    public UUID getServiceUuid() {
        return uuidDemoService;
    }
}
