package com.xaplos.hcsolution;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.widget.TextView;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;

public class SpO2Activity extends AppCompatActivity implements BLEManager.BLEManagerNotifyListener {
    private final BLEManager mBle = BLEManager.getInstance();
    private TextView mSpo2;
    private TextView mBpm;

    private BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            mSpo2.setText("- %");
            mBpm.setText("- bpm");
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.spo2_activity);
        getSupportActionBar().hide();

        // register for disconnect event
        IntentFilter filter = new IntentFilter();
        filter.addAction("com.xaplos.BleDisconnect");
        registerReceiver(receiver, filter);

        mSpo2 = (TextView)findViewById(R.id.text_view_spo2_value);
        mBpm = (TextView)findViewById(R.id.text_view_bpm_value);

        mBle.addNotifyListener(this);
    }

    @Override
    public void onNotification(Bundle notification) {
        int spo2 = notification.getInt("SpO2");
        mSpo2.setText(String.valueOf(spo2) + " %");

        int bpm = notification.getInt("BPM");
        mBpm.setText(String.valueOf(bpm) + " bpm");
    }
}
