/*
 ****************************************************************************************
 * DISCLAIMER
 ****************************************************************************************
 * This software and/or information (the "Material") is supplied by Renesas Electronics
 * Corporation. and is only intended for use with Renesas products. No other uses are authorized.
 * The Material is owned by Renesas Electronics Corporation and is protected under all applicable laws,
 * including copyright laws.
 * THIS MATERIAL IS PROVIDED "AS IS," AND RENESAS MAKES NO WARRANTIES REGARDING THIS MATERIAL,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
 * TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER RENESAS ELECTRONICS CORP. NOR ANY OF ITS
 * AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS MATERIAL, EVEN IF RENESAS OR ITS AFFILIATES
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this Material
 * and to discontinue its availability
 *
 ****************************************************************************************
 * led_pulse_ssp.h
 *
 *  Created on: Dec 16, 2015
 *      Author: alejandro
 ****************************************************************************************
 */

#ifndef HAL_LED_PULSE_SSP_H_
#define HAL_LED_PULSE_SSP_H_

#include "hal_data.h"

typedef struct
{
    const timer_instance_t *timer;
    timer_cfg_t cfg;    // storage for configuration ... API keeps reference to it
                        // internally
    timer_on_gpt_cfg_t *gpt;
    ioport_port_pin_t pin_enable;   // separate PIN in board
    uint8_t pin;        // kind'a weird but that is how the API calls it ...
                        // Which output pin to update (A/0, B/1 or C/2)
    uint32_t freq;
    int duty;
    bool open;
}pulse_context_t;

#endif /* HAL_LED_PULSE_SSP_H_ */
