/*
 ****************************************************************************************
 * DISCLAIMER
 ****************************************************************************************
 * This software and/or information (the "Material") is supplied by Renesas Electronics
 * Corporation. and is only intended for use with Renesas products. No other uses are authorized.
 * The Material is owned by Renesas Electronics Corporation and is protected under all applicable laws,
 * including copyright laws.
 * THIS MATERIAL IS PROVIDED "AS IS," AND RENESAS MAKES NO WARRANTIES REGARDING THIS MATERIAL,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
 * TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER RENESAS ELECTRONICS CORP. NOR ANY OF ITS
 * AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS MATERIAL, EVEN IF RENESAS OR ITS AFFILIATES
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this Material
 * and to discontinue its availability
 *
 ****************************************************************************************
 * fir.c
 *
 *  Created on: Jul 23, 2016
 *      Author: mitsumono
 ****************************************************************************************
*/

#include "fir_conf.h"
#include <stdlib.h>
/*
static int filter_taps[FILTER_TAP_NUM] = {
   0,
  -2,
  -3,
  -5,
  -8,
  -10,
  -12,
  -12,
  -10,
  -5,
  5,
  20,
  39,
  62,
  87,
  111,
  131,
  142,
  140,
  118,
  75,
  7,
  -85,
  -198,
  -326,
  -458,
  -581,
  -680,
  -736,
  -731,
  -649,
  -475,
  -200,
  179,
  657,
  1224,
  1860,
  2539,
  3228,
  3894,
  4501,
  5015,
  5405,
  5649,
  5732,
  5649,
  5405,
  5015,
  4501,
  3894,
  3228,
  2539,
  1860,
  1224,
  657,
  179,
  -200,
  -475,
  -649,
  -731,
  -736,
  -680,
  -581,
  -458,
  -326,
  -198,
  -85,
  7,
  75,
  118,
  140,
  142,
  131,
  111,
  87,
  62,
  39,
  20,
  5,
  -5,
  -10,
  -12,
  -12,
  -10,
  -8,
  -5,
  -3,
  -2
};
*/

static int filter_taps_opt[FILTER_TAP_NUM_OPT] = {
  -3,
  -4,
  -6,
  -8,
  -11,
  -14,
  -17,
  -20,
  -23,
  -25,
  -26,
  -26,
  -24,
  -20,
  -13,
  -4,
  8,
  23,
  40,
  59,
  80,
  100,
  120,
  138,
  151,
  160,
  162,
  157,
  141,
  116,
  80,
  33,
  -24,
  -90,
  -164,
  -243,
  -324,
  -402,
  -475,
  -537,
  -584,
  -610,
  -611,
  -584,
  -523,
  -427,
  -292,
  -119,
  91,
  338,
  618,
  927,
  1258,
  1605,
  1959,
  2314,
  2658,
  2984,
  3283,
  3547,
  3767,
  3938,
  4055,
  4114,
  4114,
  4055,
  3938,
  3767,
  3547,
  3283,
  2984,
  2658,
  2314,
  1959,
  1605,
  1258,
  927,
  618,
  338,
  91,
  -119,
  -292,
  -427,
  -523,
  -584,
  -611,
  -610,
  -584,
  -537,
  -475,
  -402,
  -324,
  -243,
  -164,
  -90,
  -24,
  33,
  80,
  116,
  141,
  157,
  162,
  160,
  151,
  138,
  120,
  100,
  80,
  59,
  40,
  23,
  8,
  -4,
  -13,
  -20,
  -24,
  -26,
  -26,
  -25,
  -23,
  -20,
  -17,
  -14,
  -11,
  -8,
  -6,
  -4,
  -3
};


int inputs_int [2002] = {
                                29044,
                                28675,
                                28224,
                                27710,
                                27178,
                                26681,
                                26264,
                                25950,
                                25749,
                                25657,
                                25655,
                                25722,
                                25834,
                                25970,
                                26115,
                                26261,
                                26400,
                                26526,
                                26637,
                                26732,
                                26806,
                                26850,
                                26858,
                                26827,
                                26758,
                                26661,
                                26551,
                                26442,
                                26348,
                                26277,
                                26230,
                                26204,
                                26195,
                                26202,
                                26222,
                                26253,
                                26290,
                                26328,
                                26362,
                                26384,
                                26391,
                                26383,
                                26361,
                                26328,
                                26290,
                                26252,
                                26219,
                                26196,
                                26186,
                                26185,
                                26190,
                                26196,
                                26198,
                                26193,
                                26179,
                                26157,
                                26130,
                                26104,
                                26081,
                                26056,
                                26026,
                                25987,
                                25939,
                                25886,
                                25831,
                                25778,
                                25730,
                                25689,
                                25656,
                                25629,
                                25609,
                                25600,
                                25605,
                                25627,
                                25662,
                                25705,
                                25750,
                                25795,
                                25839,
                                25884,
                                25930,
                                25973,
                                26009,
                                26034,
                                26041,
                                26026,
                                25989,
                                25938,
                                25881,
                                25828,
                                25785,
                                25765,
                                25779,
                                25840,
                                25956,
                                26134,
                                26374,
                                26676,
                                27032,
                                27426,
                                27840,
                                28251,
                                28637,
                                28974,
                                29243,
                                29434,
                                29546,
                                29582,
                                29552,
                                29462,
                                29318,
                                29129,
                                28905,
                                28647,
                                28350,
                                28012,
                                27640,
                                27255,
                                26886,
                                26556,
                                26284,
                                26078,
                                25946,
                                25888,
                                25899,
                                25969,
                                26076,
                                26200,
                                26321,
                                26423,
                                26500,
                                26552,
                                26583,
                                26593,
                                26584,
                                26557,
                                26518,
                                26473,
                                26433,
                                26401,
                                26380,
                                26371,
                                26371,
                                26378,
                                26392,
                                26409,
                                26426,
                                26444,
                                26461,
                                26471,
                                26465,
                                26438,
                                26388,
                                26318,
                                26232,
                                26133,
                                26027,
                                25917,
                                25807,
                                25704,
                                25613,
                                25536,
                                25465,
                                25391,
                                25307,
                                25207,
                                25090,
                                24965,
                                24843,
                                24739,
                                24663,
                                24620,
                                24609,
                                24630,
                                24681,
                                24751,
                                24827,
                                24898,
                                24955,
                                24991,
                                25005,
                                24996,
                                24962,
                                24901,
                                24816,
                                24718,
                                24626,
                                24557,
                                24523,
                                24528,
                                24571,
                                24649,
                                24754,
                                24875,
                                25001,
                                25116,
                                25192,
                                25192,
                                25102,
                                24946,
                                24772,
                                24638,
                                24590,
                                24662,
                                24861,
                                25174,
                                25575,
                                26030,
                                26507,
                                26972,
                                27395,
                                27753,
                                28032,
                                28227,
                                28342,
                                28383,
                                28362,
                                28292,
                                28187,
                                28059,
                                27921,
                                27784,
                                27648,
                                27504,
                                27345,
                                27183,
                                27037,
                                26928,
                                26872,
                                26878,
                                26943,
                                27061,
                                27222,
                                27413,
                                27617,
                                27818,
                                28001,
                                28158,
                                28281,
                                28362,
                                28401,
                                28398,
                                28360,
                                28292,
                                28205,
                                28116,
                                28040,
                                27985,
                                27948,
                                27913,
                                27868,
                                27806,
                                27722,
                                27614,
                                27484,
                                27335,
                                27171,
                                26998,
                                26825,
                                26670,
                                26553,
                                26484,
                                26460,
                                26469,
                                26498,
                                26532,
                                26557,
                                26562,
                                26540,
                                26486,
                                26405,
                                26300,
                                26185,
                                26072,
                                25972,
                                25890,
                                25826,
                                25781,
                                25747,
                                25718,
                                25683,
                                25623,
                                25521,
                                25379,
                                25215,
                                25061,
                                24948,
                                24898,
                                24923,
                                25020,
                                25178,
                                25377,
                                25596,
                                25814,
                                26013,
                                26179,
                                26305,
                                26389,
                                26435,
                                26447,
                                26430,
                                26391,
                                26337,
                                26273,
                                26203,
                                26136,
                                26080,
                                26048,
                                26051,
                                26102,
                                26211,
                                26387,
                                26630,
                                26931,
                                27275,
                                27643,
                                28016,
                                28375,
                                28705,
                                28995,
                                29237,
                                29429,
                                29573,
                                29673,
                                29736,
                                29765,
                                29765,
                                29740,
                                29696,
                                29639,
                                29576,
                                29512,
                                29449,
                                29376,
                                29276,
                                29134,
                                28949,
                                28735,
                                28513,
                                28311,
                                28154,
                                28060,
                                28038,
                                28085,
                                28189,
                                28329,
                                28489,
                                28653,
                                28794,
                                28877,
                                28869,
                                28742,
                                28479,
                                28082,
                                27577,
                                27007,
                                26423,
                                25879,
                                25415,
                                25054,
                                24808,
                                24670,
                                24622,
                                24643,
                                24706,
                                24785,
                                24857,
                                24910,
                                24941,
                                24952,
                                24956,
                                24963,
                                24981,
                                25013,
                                25062,
                                25118,
                                25173,
                                25223,
                                25270,
                                25312,
                                25348,
                                25377,
                                25396,
                                25404,
                                25399,
                                25378,
                                25350,
                                25325,
                                25304,
                                25287,
                                25268,
                                25244,
                                25208,
                                25158,
                                25092,
                                25013,
                                24929,
                                24846,
                                24771,
                                24716,
                                24687,
                                24680,
                                24685,
                                24693,
                                24696,
                                24688,
                                24668,
                                24636,
                                24596,
                                24553,
                                24512,
                                24475,
                                24445,
                                24423,
                                24415,
                                24427,
                                24464,
                                24525,
                                24607,
                                24710,
                                24835,
                                24989,
                                25180,
                                25408,
                                25672,
                                25967,
                                26287,
                                26623,
                                26964,
                                27299,
                                27609,
                                27878,
                                28098,
                                28261,
                                28366,
                                28414,
                                28410,
                                28356,
                                28262,
                                28141,
                                28029,
                                27957,
                                27924,
                                27891,
                                27819,
                                27689,
                                27506,
                                27289,
                                27064,
                                26855,
                                26684,
                                26562,
                                26490,
                                26462,
                                26472,
                                26514,
                                26591,
                                26709,
                                26859,
                                27027,
                                27194,
                                27345,
                                27468,
                                27556,
                                27607,
                                27621,
                                27603,
                                27557,
                                27487,
                                27399,
                                27311,
                                27232,
                                27168,
                                27119,
                                27077,
                                27027,
                                26956,
                                26853,
                                26713,
                                26540,
                                26353,
                                26176,
                                26033,
                                25944,
                                25919,
                                25958,
                                26055,
                                26196,
                                26363,
                                26535,
                                26691,
                                26816,
                                26899,
                                26935,
                                26927,
                                26881,
                                26810,
                                26724,
                                26633,
                                26545,
                                26464,
                                26381,
                                26292,
                                26195,
                                26094,
                                25992,
                                25892,
                                25789,
                                25677,
                                25558,
                                25440,
                                25335,
                                25263,
                                25241,
                                25276,
                                25368,
                                25513,
                                25706,
                                25941,
                                26212,
                                26515,
                                26846,
                                27208,
                                27600,
                                28015,
                                28441,
                                28861,
                                29256,
                                29607,
                                29897,
                                30116,
                                30261,
                                30338,
                                30355,
                                30325,
                                30260,
                                30172,
                                30068,
                                29954,
                                29829,
                                29684,
                                29505,
                                29284,
                                29027,
                                28750,
                                28476,
                                28224,
                                28009,
                                27844,
                                27734,
                                27679,
                                27674,
                                27708,
                                27768,
                                27836,
                                27902,
                                27955,
                                27989,
                                28001,
                                27991,
                                27961,
                                27918,
                                27866,
                                27809,
                                27751,
                                27695,
                                27644,
                                27598,
                                27559,
                                27524,
                                27490,
                                27455,
                                27419,
                                27384,
                                27354,
                                27337,
                                27338,
                                27358,
                                27397,
                                27446,
                                27496,
                                27532,
                                27542,
                                27516,
                                27448,
                                27342,
                                27205,
                                27051,
                                26889,
                                26728,
                                26578,
                                26450,
                                26350,
                                26281,
                                26241,
                                26228,
                                26240,
                                26274,
                                26326,
                                26389,
                                26456,
                                26519,
                                26566,
                                26586,
                                26575,
                                26536,
                                26474,
                                26394,
                                26301,
                                26197,
                                26091,
                                25988,
                                25893,
                                25807,
                                25726,
                                25650,
                                25578,
                                25519,
                                25475,
                                25451,
                                25446,
                                25464,
                                25505,
                                25574,
                                25679,
                                25833,
                                26052,
                                26341,
                                26695,
                                27098,
                                27529,
                                27963,
                                28378,
                                28758,
                                29093,
                                29376,
                                29609,
                                29793,
                                29930,
                                30019,
                                30059,
                                30053,
                                30009,
                                29935,
                                29841,
                                29741,
                                29653,
                                29578,
                                29499,
                                29400,
                                29276,
                                29133,
                                28983,
                                28842,
                                28724,
                                28640,
                                28599,
                                28600,
                                28634,
                                28693,
                                28767,
                                28848,
                                28923,
                                28980,
                                29009,
                                29008,
                                28982,
                                28942,
                                28895,
                                28845,
                                28794,
                                28741,
                                28689,
                                28637,
                                28588,
                                28543,
                                28503,
                                28466,
                                28431,
                                28398,
                                28361,
                                28312,
                                28238,
                                28131,
                                27986,
                                27804,
                                27594,
                                27375,
                                27172,
                                27005,
                                26888,
                                26827,
                                26817,
                                26846,
                                26903,
                                26975,
                                27053,
                                27129,
                                27197,
                                27252,
                                27289,
                                27308,
                                27310,
                                27298,
                                27275,
                                27244,
                                27207,
                                27160,
                                27105,
                                27039,
                                26961,
                                26870,
                                26767,
                                26655,
                                26538,
                                26422,
                                26316,
                                26227,
                                26153,
                                26092,
                                26042,
                                26003,
                                25977,
                                25965,
                                25965,
                                25975,
                                25988,
                                26000,
                                26005,
                                25997,
                                25969,
                                25919,
                                25843,
                                25745,
                                25633,
                                25508,
                                25375,
                                25255,
                                25184,
                                25187,
                                25272,
                                25435,
                                25663,
                                25937,
                                26241,
                                26564,
                                26893,
                                27219,
                                27531,
                                27821,
                                28084,
                                28314,
                                28509,
                                28673,
                                28811,
                                28930,
                                29032,
                                29119,
                                29193,
                                29253,
                                29298,
                                29328,
                                29344,
                                29350,
                                29350,
                                29345,
                                29333,
                                29313,
                                29285,
                                29248,
                                29196,
                                29116,
                                28989,
                                28803,
                                28562,
                                28281,
                                27976,
                                27668,
                                27378,
                                27125,
                                26923,
                                26781,
                                26698,
                                26669,
                                26686,
                                26743,
                                26828,
                                26928,
                                27028,
                                27121,
                                27197,
                                27251,
                                27273,
                                27257,
                                27202,
                                27110,
                                26982,
                                26823,
                                26646,
                                26468,
                                26308,
                                26180,
                                26090,
                                26036,
                                26013,
                                26009,
                                26013,
                                26010,
                                25991,
                                25946,
                                25875,
                                25779,
                                25661,
                                25530,
                                25393,
                                25260,
                                25139,
                                25037,
                                24961,
                                24916,
                                24900,
                                24910,
                                24941,
                                24986,
                                25038,
                                25091,
                                25136,
                                25165,
                                25173,
                                25156,
                                25113,
                                25045,
                                24952,
                                24831,
                                24688,
                                24544,
                                24440,
                                24418,
                                24489,
                                24631,
                                24798,
                                24940,
                                25019,
                                25011,
                                24907,
                                24717,
                                24463,
                                24182,
                                23924,
                                23737,
                                23663,
                                23731,
                                23953,
                                24322,
                                24816,
                                25398,
                                26029,
                                26669,
                                27279,
                                27827,
                                28289,
                                28651,
                                28908,
                                29067,
                                29142,
                                29150,
                                29106,
                                29026,
                                28921,
                                28800,
                                28667,
                                28523,
                                28363,
                                28180,
                                27974,
                                27764,
                                27576,
                                27436,
                                27362,
                                27362,
                                27429,
                                27546,
                                27688,
                                27832,
                                27963,
                                28071,
                                28152,
                                28207,
                                28235,
                                28235,
                                28208,
                                28158,
                                28092,
                                28014,
                                27928,
                                27834,
                                27736,
                                27634,
                                27527,
                                27412,
                                27290,
                                27164,
                                27037,
                                26915,
                                26804,
                                26711,
                                26640,
                                26596,
                                26580,
                                26586,
                                26607,
                                26632,
                                26651,
                                26660,
                                26653,
                                26630,
                                26590,
                                26532,
                                26458,
                                26366,
                                26258,
                                26138,
                                26015,
                                25899,
                                25799,
                                25720,
                                25670,
                                25651,
                                25658,
                                25683,
                                25714,
                                25741,
                                25752,
                                25740,
                                25701,
                                25636,
                                25549,
                                25450,
                                25349,
                                25258,
                                25185,
                                25133,
                                25101,
                                25085,
                                25078,
                                25070,
                                25050,
                                25007,
                                24934,
                                24835,
                                24718,
                                24599,
                                24491,
                                24406,
                                24350,
                                24322,
                                24324,
                                24355,
                                24420,
                                24527,
                                24687,
                                24907,
                                25185,
                                25515,
                                25885,
                                26284,
                                26696,
                                27104,
                                27485,
                                27817,
                                28082,
                                28269,
                                28374,
                                28400,
                                28357,
                                28263,
                                28136,
                                27995,
                                27851,
                                27706,
                                27557,
                                27402,
                                27252,
                                27120,
                                27015,
                                26941,
                                26896,
                                26881,
                                26890,
                                26920,
                                26970,
                                27033,
                                27109,
                                27202,
                                27317,
                                27452,
                                27595,
                                27725,
                                27820,
                                27863,
                                27848,
                                27774,
                                27648,
                                27479,
                                27273,
                                27042,
                                26804,
                                26577,
                                26368,
                                26188,
                                26043,
                                25943,
                                25891,
                                25887,
                                25924,
                                25991,
                                26072,
                                26150,
                                26212,
                                26256,
                                26279,
                                26282,
                                26266,
                                26234,
                                26189,
                                26137,
                                26084,
                                26036,
                                25996,
                                25962,
                                25932,
                                25898,
                                25853,
                                25787,
                                25690,
                                25562,
                                25417,
                                25282,
                                25186,
                                25152,
                                25185,
                                25283,
                                25433,
                                25618,
                                25823,
                                26036,
                                26246,
                                26441,
                                26609,
                                26735,
                                26816,
                                26848,
                                26836,
                                26785,
                                26709,
                                26621,
                                26532,
                                26450,
                                26379,
                                26322,
                                26277,
                                26236,
                                26189,
                                26128,
                                26053,
                                25965,
                                25871,
                                25777,
                                25692,
                                25618,
                                25560,
                                25523,
                                25512,
                                25541,
                                25621,
                                25764,
                                25976,
                                26253,
                                26583,
                                26947,
                                27327,
                                27704,
                                28062,
                                28383,
                                28648,
                                28834,
                                28928,
                                28936,
                                28875,
                                28772,
                                28651,
                                28532,
                                28435,
                                28370,
                                28332,
                                28305,
                                28274,
                                28239,
                                28211,
                                28201,
                                28216,
                                28256,
                                28317,
                                28395,
                                28484,
                                28576,
                                28668,
                                28758,
                                28846,
                                28929,
                                29004,
                                29061,
                                29094,
                                29095,
                                29061,
                                28992,
                                28893,
                                28768,
                                28628,
                                28482,
                                28340,
                                28206,
                                28084,
                                27974,
                                27877,
                                27796,
                                27734,
                                27691,
                                27663,
                                27647,
                                27630,
                                27604,
                                27560,
                                27495,
                                27412,
                                27321,
                                27232,
                                27144,
                                27054,
                                26956,
                                26843,
                                26708,
                                26552,
                                26378,
                                26191,
                                25998,
                                25810,
                                25637,
                                25496,
                                25393,
                                25327,
                                25290,
                                25271,
                                25258,
                                25242,
                                25218,
                                25182,
                                25130,
                                25058,
                                24965,
                                24858,
                                24749,
                                24653,
                                24578,
                                24531,
                                24510,
                                24509,
                                24518,
                                24530,
                                24535,
                                24522,
                                24486,
                                24423,
                                24337,
                                24237,
                                24137,
                                24038,
                                23942,
                                23850,
                                23760,
                                23675,
                                23595,
                                23521,
                                23457,
                                23410,
                                23388,
                                23400,
                                23458,
                                23574,
                                23757,
                                24017,
                                24353,
                                24748,
                                25178,
                                25614,
                                26030,
                                26407,
                                26736,
                                27009,
                                27223,
                                27376,
                                27453,
                                27432,
                                27305,
                                27089,
                                26822,
                                26541,
                                26271,
                                26034,
                                25854,
                                25752,
                                25748,
                                25852,
                                26061,
                                26358,
                                26718,
                                27115,
                                27525,
                                27926,
                                28301,
                                28633,
                                28910,
                                29119,
                                29252,
                                29309,
                                29291,
                                29210,
                                29081,
                                28919,
                                28740,
                                28557,
                                28374,
                                28184,
                                27982,
                                27771,
                                27563,
                                27374,
                                27216,
                                27101,
                                27033,
                                27013,
                                27037,
                                27096,
                                27178,
                                27273,
                                27369,
                                27462,
                                27549,
                                27627,
                                27692,
                                27740,
                                27766,
                                27770,
                                27753,
                                27713,
                                27654,
                                27581,
                                27500,
                                27415,
                                27332,
                                27253,
                                27181,
                                27116,
                                27055,
                                26997,
                                26943,
                                26893,
                                26847,
                                26804,
                                26763,
                                26726,
                                26697,
                                26680,
                                26675,
                                26680,
                                26690,
                                26696,
                                26695,
                                26683,
                                26660,
                                26627,
                                26587,
                                26537,
                                26476,
                                26406,
                                26340,
                                26298,
                                26298,
                                26355,
                                26462,
                                26590,
                                26686,
                                26693,
                                26581,
                                26368,
                                26110,
                                25875,
                                25725,
                                25701,
                                25826,
                                26095,
                                26486,
                                26964,
                                27488,
                                28016,
                                28510,
                                28939,
                                29279,
                                29519,
                                29656,
                                29702,
                                29670,
                                29578,
                                29443,
                                29282,
                                29113,
                                28949,
                                28788,
                                28618,
                                28427,
                                28222,
                                28019,
                                27837,
                                27693,
                                27596,
                                27543,
                                27527,
                                27549,
                                27607,
                                27679,
                                27738,
                                27761,
                                27731,
                                27640,
                                27494,
                                27304,
                                27083,
                                26845,
                                26601,
                                26361,
                                26133,
                                25928,
                                25751,
                                25607,
                                25499,
                                25425,
                                25381,
                                25367,
                                25380,
                                25410,
                                25445,
                                25471,
                                25478,
                                25464,
                                25431,
                                25381,
                                25316,
                                25240,
                                25158,
                                25078,
                                25005,
                                24940,
                                24885,
                                24845,
                                24823,
                                24822,
                                24840,
                                24878,
                                24936,
                                25010,
                                25094,
                                25179,
                                25256,
                                25321,
                                25375,
                                25426,
                                25477,
                                25527,
                                25568,
                                25594,
                                25605,
                                25610,
                                25619,
                                25629,
                                25625,
                                25592,
                                25515,
                                25377,
                                25174,
                                24914,
                                24623,
                                24331,
                                24071,
                                23869,
                                23751,
                                23735,
                                23825,
                                24011,
                                24279,
                                24611,
                                24986,
                                25383,
                                25776,
                                26143,
                                26468,
                                26741,
                                26962,
                                27135,
                                27268,
                                27373,
                                27455,
                                27520,
                                27568,
                                27603,
                                27634,
                                27667,
                                27703,
                                27736,
                                27764,
                                27780,
                                27779,
                                27760,
                                27726,
                                27678,
                                27614,
                                27519,
                                27371,
                                27167,
                                26923,
                                26676,
                                26465,
                                26316,
                                26243,
                                26247,
                                26321,
                                26452,
                                26626,
                                26825,
                                27027,
                                27211,
                                27360,
                                27463,
                                27516,
                                27522,
                                27486,
                                27420,
                                27336,
                                27246,
                                27155,
                                27069,
                                26996,
                                26939,
                                26898,
                                26873,
                                26857,
                                26843,
                                26827,
                                26807,
                                26783,
                                26756,
                                26725,
                                26690,
                                26656,
                                26627,
                                26599,
                                26566,
                                26524,
                                26468,
                                26403,
                                26335,
                                26268,
                                26204,
                                26145,
                                26091,
                                26043,
                                26001,
                                25960,
                                25918,
                                25874,
                                25828,
                                25774,
                                25714,
                                25649,
                                25584,
                                25521,
                                25461,
                                25404,
                                25351,
                                25312,
                                25301,
                                25325,
                                25387,
                                25480,
                                25594,
                                25716,
                                25833,
                                25931,
                                26000,
                                26032,
                                26024,
                                25975,
                                25888,
                                25770,
                                25632,
                                25485,
                                25344,
                                25226,
                                25148,
                                25126,
                                25172,
                                25297,
                                25503,
                                25787,
                                26137,
                                26538,
                                26971,
                                27411,
                                27836,
                                28228,
                                28574,
                                28865,
                                29091,
                                29245,
                                29324,
                                29337,
                                29302,
                                29238,
                                29163,
                                29090,
                                29028,
                                28984,
                                28958,
                                28935,
                                28893,
                                28813,
                                28692,
                                28542,
                                28378,
                                28216,
                                28069,
                                27953,
                                27878,
                                27850,
                                27867,
                                27925,
                                28017,
                                28137,
                                28271,
                                28405,
                                28520,
                                28604,
                                28651,
                                28654,
                                28611,
                                28524,
                                28398,
                                28243,
                                28069,
                                27882,
                                27689,
                                27498,
                                27314,
                                27143,
                                26991,
                                26863,
                                26766,
                                26704,
                                26674,
                                26668,
                                26678,
                                26696,
                                26716,
                                26735,
                                26749,
                                26757,
                                26755,
                                26744,
                                26722,
                                26689,
                                26651,
                                26612,
                                26572,
                                26531,
                                26482,
                                26420,
                                26339,
                                26240,
                                26131,
                                26022,
                                25925,
                                25851,
                                25808,
                                25799,
                                25826,
                                25885,
                                25969,
                                26071,
                                26181,
                                26294,
                                26405,
                                26510,
                                26608,
                                26697,
                                26777,
                                26844,
                                26894,
                                26922,
                                26926,
                                26904,
                                26855,
                                26781,
                                26685,
                                26572,
                                26448,
                                26324,
                                26214,
                                26132,
                                26091,
                                26105,
                                26182,
                                26323,
                                26524,
                                26785,
                                27097,
                                27426,
                                27726,
                                27960,
                                28117,
                                28207,
                                28249,
                                28266,
                                28278,
                                28303,
                                28350,
                                28420,
                                28507,
                                28600,
                                28694,
                                28782,
                                28863,
                                28937,
                                29006,
                                29069,
                                29122,
                                29161,
                                29181,
                                29183,
                                29168,
                                29137,
                                29093,
                                29046,
                                29000,
                                28950,
                                28877,
                                28758,
                                28588,
                                28372,
                                28120,
                                27840,
                                27533,
                                27204,
                                26854,
                                26485,
                                26110,
                                25753,
                                25443,
                                25199,
                                25030,
                                24939,
                                24921,
                                24967,
                                25063,
                                25195,
                                25348,
                                25507,
                                25658,
                                25790,
                                25891,
                                25958,
                                25986,
                                25975,
                                25917,
                                25813,
                                25671,
                                25509,
                                25344,
                                25192,
                                25064,
                                24971,
                                24918,
                                24902,
                                24916,
                                24951,
                                24997,
                                25048,
                                25093,
                                25126,
                                25139,
                                25127,
                                25089,
                                25025,
                                24938,
                                24835,
                                24722,
                                24607,
                                24498,
                                24404,
                                24333,
                                24286,
                                24257,
                                24236,
                                24211,
                                24177,
                                24129,
                                24068,
                                23992,
                                23906,
                                23815,
                                23730,
                                23656,
                                23595,
                                23545,
                                23506,
                                23482,
                                23469,
                                23456,
                                23425,
                                23362,
                                23264,
                                23135,
                                22988,
                                22835,
                                22686,
                                22556,
                                22463,
                                22424,
                                22456,
                                22569,
                                22767,
                                23043,
                                23381,
                                23765,
                                24171,
                                24577,
                                24960,
                                25296,
                                25568,
                                25766,
                                25889,
                                25941,
                                25930,
                                25863,
                                25753,
                                25621,
                                25486,
                                25357,
                                25241,
                                25141,
                                25057,
                                24985,
                                24918,
                                24828,
                                24680,
                                24459,
                                24185,
                                23897,
                                23638,
                                23439,
                                23323,
                                23302,
                                23377,
                                23543,
                                23792,
                                24106,
                                24466,
                                24846,
                                25220,
                                25563,
                                25858,
                                26097,
                                26273,
                                26386,
                                26435,
                                26423,
                                26353,
                                26227,
                                26051,
                                25827,
                                25561,
                                25271,
                                24984,
                                24732,
                                24538,
                                24417,
                                24374,
                                24405,
                                24501,
                                24649,
                                24832,
                                25031,
                                25228,
                                25411,
                                25576,
                                25724,
                                25855,
                                25969,
                                26065,
                                26145,
                                26205,
                                26236,
                                26228,
                                26172,
                                26063,
                                25899,
                                25690,
                                25446,
                                25186,
                                24936,
                                24718,
                                24550,
                                24435,
                                24370,
                                24341,
                                24330,
                                24320,
                                24299,
                                24258,
                                24200,
                                24129,
                                24050,
                                23971,
                                23890,
                                23811,
                                23741,
                                23689,
                                23656,
                                23641,
                                23639,
                                23649,
                                23670,
                                23701,
                                23733,
                                23760,
                                23776,
                                23774,
                                23748,
                                23702,
                                23641,
                                23577,
                                23526,
                                23504,
                                23518,
                                23575,
                                23683,
                                23844,
                                24058,
                                24320,
                                24616,
                                24935,
                                25262,
                                25582,
                                25883,
                                26151,
                                26372,
                                26536,
                                26645,
                                26705,
                                26724,
                                26707,
                                26663,
                                26597,
                                26519,
                                26436,
                                26354,
                                26263,
                                26149,
                                26008,
                                25857,
                                25719,
                                25617,
                                25571,
                                25602,
                                25719,
                                25920,
                                26188,
                                26497,
                                26818,
                                27126,
                                27406,
                                27641,
                                27821,
                                27937,
                                27986,
                                27974,
                                27908,
                                27800,
                                27666,
                                27522,
                                27385,
                                27263,
                                27164,
                                27092,
                                27044,
                                27017,
                                27003,
                                26995,
                                26984,
                                26967,
                                26940,
                                26900,
                                26853,
                                26803,
                                26758,
                                26725,
                                26708,
                                26697,
                                26686,
                                26684,
                                26705,
                                26756,
                                26836,
                                26937,
                                27051,
                                27172,
                                27289,
                                27392,
                                27469,
                                27511,
                                27517,
                                27489,
                                27434,
                                27359,
                                27271,
                                27176,
                                27078,
                                26979,
                                26883,
                                26793,
                                26715,
                                26652,
                                26598,
                                26546,
                                26490,
                                26427,
                                26358,
                                26285,
                                26209,
                                26133,
                                26058,
                                25987,
                                25921,
                                25865,
                                25823,
                                25798,
                                25791,
                                25799,
                                25816,
                                25838,
                                25857,
                                25872,
                                25882,
                                25887,
                                25886,
                                25882,
                                25880,
                                25888,
                                25918,
                                25981,
                                26084,
                                26231,
                                26421,
                                26652,
                                26916,
                                27198,
                                27476,
                                27728,
                                27928,
                                28061,
                                28126,
                                28139,
                                28122,
                                28095,
                                28073,
                                28066,
                                28079,
                                28117,
                                28174,
                                28248,
                                28331,
                                28421,
                                28512,
                                28599,
                                28682,
                                28759,
                                28826,
                                28878,
                                28911,
                                28926,
                                28925,
                                28910,
                                28877,
                                28826



};


lpf *lpf_init()
{
    lpf *lp = malloc(sizeof(lpf));
    //q15_t *inputArr = (q15_t *) malloc(sizeof(q15_t) * FILTER_TAP_NUM);
    q15_t *state_buff= (q15_t *) malloc(sizeof(q15_t) * FILTER_TAP_NUM_OPT);
    arm_fir_instance_q15 *fir = (arm_fir_instance_q15 *) malloc(sizeof(arm_fir_instance_q15));
    arm_fir_init_q15(fir,(uint16_t)FILTER_TAP_NUM_OPT, (q15_t *)filter_taps_opt,state_buff,1);
    //lp->inputValues=inputArr;
    lp->numTaps = FILTER_TAP_NUM_OPT;
    lp->inputHead=0;
    lp->outputValid=0;
    lp->currOutput=0;
    lp->fir=fir;
    return lp;
}

void lpf_in(lpf* lp, int Input) {
    //lp->inputValues[lp->inputHead] = (q15_t) Input;
    q15_t In;
    In = (q15_t) Input;

    arm_fir_q15(lp->fir,&In,&lp->currOutput,1);
    if (lp->inputHead != lp->numTaps) {
        lp->inputHead++;
    }else if (lp->outputValid != 1){
        lp->outputValid = 1;
    }
}
int lpf_out(lpf* lp){

    if(lp->outputValid==0)
        return 0;
    return (int) lp->currOutput;
}

int lpf_process(lpf* lp, int Input)
{
    lpf_in(lp, Input);
    return lpf_out(lp);
}
