/*
 ****************************************************************************************
 * DISCLAIMER
 ****************************************************************************************
 * This software and/or information (the "Material") is supplied by Renesas Electronics
 * Corporation. and is only intended for use with Renesas products. No other uses are authorized.
 * The Material is owned by Renesas Electronics Corporation and is protected under all applicable laws,
 * including copyright laws.
 * THIS MATERIAL IS PROVIDED "AS IS," AND RENESAS MAKES NO WARRANTIES REGARDING THIS MATERIAL,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
 * TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER RENESAS ELECTRONICS CORP. NOR ANY OF ITS
 * AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS MATERIAL, EVEN IF RENESAS OR ITS AFFILIATES
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this Material
 * and to discontinue its availability
 *
 ****************************************************************************************

FIR filter designed with
http://t-filter.appspot.com

sampling frequency: 200 Hz

fixed point precision: 16 bits

* 0 Hz - 3 Hz
  gain = 1
  desired ripple = 0.01 dB
  actual ripple = 0.00 dB

* 15 Hz - 100 Hz
  gain = 0
  desired attenuation = -80 dB
  actual attenuation = -92.69 dB

*/
#define ARM_MATH_CM4
#include "arm_math.h"
#define FILTER_TAP_NUM 88
#define FILTER_TAP_NUM_OPT 128

typedef struct lpf
{
    const arm_fir_instance_q15 *fir;
    //q15_t *inputValues;
    int numTaps;
    int inputHead;
    int outputValid;
    q15_t currOutput;
} lpf;

typedef struct st_lpf_api
{
    lpf  (* init_fir)();
    void (* lpf_in)(lpf* lpf, int Input);
    int  (* lpf_out)(lpf* lpf);
    int  (* lpf_process)(lpf*, int Input);
}lpf_api_t;

lpf *lpf_init();
void lpf_in(lpf* lpf, int Input);
int lpf_out(lpf* lpf);
int lpf_process(lpf*, int Input);

