/*
  ****************************************************************************************
 * DISCLAIMER
 ****************************************************************************************
 * This software and/or information (the "Material") is supplied by Renesas Electronics
 * Corporation. and is only intended for use with Renesas products. No other uses are authorized.
 * The Material is owned by Renesas Electronics Corporation and is protected under all applicable laws,
 * including copyright laws.
 * THIS MATERIAL IS PROVIDED "AS IS," AND RENESAS MAKES NO WARRANTIES REGARDING THIS MATERIAL,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
 * TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER RENESAS ELECTRONICS CORP. NOR ANY OF ITS
 * AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS MATERIAL, EVEN IF RENESAS OR ITS AFFILIATES
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this Material
 * and to discontinue its availability
 *
 ****************************************************************************************
 * d7seg_config.h
 *
 *  Created on: Dec 9, 2015
 *      Author: alejandro
 ****************************************************************************************
 */

#ifndef D7SEG_CONFIG_H_
#define D7SEG_CONFIG_H_

/**
 * specifics for the 3 digits display used in Pulse Ox board LCD-S301C31TR
 */
#define LCD_DIGITS      3
#define LCD_HAS_DOT     1
#define LCD_DOT_COUNT   2

#define D7SEG_INT_FORMAT       "%3d"
#define D7SEG_FLOAT_FORMAT     "%3.0f"
#define D7SEG_FLOAT_FORMAT1    "%4.1f"
#define D7SEG_FLOAT_FORMAT2    "%4.2f"

/**
 * specifics on what segments were used to connect to the physical 7 segment LCD
 * display in the Pulse Ox board
 */
#define D7SEG_A1        0
#define D7SEG_B1        14
#define D7SEG_C1        15
#define D7SEG_D1        16
#define D7SEG_E1        17
#define D7SEG_F1        18
#define D7SEG_G1        19

#define D7SEG_A2        21
#define D7SEG_B2        22
#define D7SEG_C2        23
#define D7SEG_D2        24
#define D7SEG_E2        25
#define D7SEG_F2        28
#define D7SEG_G2        29

#define D7SEG_A3        30
#define D7SEG_B3        38
#define D7SEG_C3        39
#define D7SEG_D3        40
#define D7SEG_E3        41
#define D7SEG_F3        48
#define D7SEG_G3        49

#define D7SEG_DP1       50
#define D7SEG_DP2       51
#define D7SEG_DP3       D7SEG_INVALID

#endif /* D7SEG_CONFIG_H_ */
