/*
 ****************************************************************************************
 * DISCLAIMER
 ****************************************************************************************
 * This software and/or information (the "Material") is supplied by Renesas Electronics
 * Corporation. and is only intended for use with Renesas products. No other uses are authorized.
 * The Material is owned by Renesas Electronics Corporation and is protected under all applicable laws,
 * including copyright laws.
 * THIS MATERIAL IS PROVIDED "AS IS," AND RENESAS MAKES NO WARRANTIES REGARDING THIS MATERIAL,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
 * TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER RENESAS ELECTRONICS CORP. NOR ANY OF ITS
 * AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS MATERIAL, EVEN IF RENESAS OR ITS AFFILIATES
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this Material
 * and to discontinue its availability
 *
 ****************************************************************************************
 *
 * @file		prf_sel.h
 *
 * @brief	Setting of Profile Selection
 *
 * Copyright(C) 2013-2014 Renesas Electronics Corporation
 *
 * $Rev: 6019 $
 *
 ****************************************************************************************
 */

#ifndef _PRF_SEL_H_
#define _PRF_SEL_H_

/**
 * INCLUDE FILES
 ****************************************************************************************
 */

/**
 * TYPE DEFINES
 ****************************************************************************************
 */

/**
 * DEFINES
 ****************************************************************************************
 */
#ifdef USE_SAMPLE_PROFILE
#define USE_CUSTOM_DEMO
#endif

/* for Profile Selection (Set to 0 if the profile is not selected.) */
#ifndef USE_SAMPLE_PROFILE
#define PRF_SEL_ANPS    0   /* Alert Notification Profile Server role */
#define PRF_SEL_ANPC    0   /* Alert Notification Profile Client role */
#define PRF_SEL_BLPS    0   /* Blood Pressure Profile Sensor role */
#define PRF_SEL_BLPC    0   /* Blood Pressure Profile Collector role */
#define PRF_SEL_CPPS    0   /* Cycling Power Profile Sensor role */
#define PRF_SEL_CPPC    0   /* Cycling Power Profile Collector role */
#define PRF_SEL_CSCS    0   /* Cycling Speed and Cadence Profile Sensor role */
#define PRF_SEL_CSCC    0   /* Cycling Speed and Cadence Profile Collector role */
#define PRF_SEL_FMPT    0   /* Find Me Profile Target role */
#define PRF_SEL_FMPL    0   /* Find Me Profile Locator role */
#define PRF_SEL_GLPS    0   /* Glucose Profile Sensor role */
#define PRF_SEL_GLPC    0   /* Glucose Profile Collector role */
#define PRF_SEL_HTPT    0   /* Health Thermometer Profile Thermometer role */
#define PRF_SEL_HTPC    0   /* Health Thermometer Profile Collector role */
#define PRF_SEL_HRPS    0   /* Heart Rate Profile Sensor role */
#define PRF_SEL_HRPC    0   /* Heart Rate Profile Collector role */
#define PRF_SEL_HGHD    0   /* HID over GATT Profile HID Device role */
#define PRF_SEL_HGRH    0   /* HID over GATT Profile Report Host role */
#define PRF_SEL_HGBH    0   /* HID over GATT Profile Boot Host role */
#define PRF_SEL_LNPS    0   /* Location and Navigation Profile Sensor role */
#define PRF_SEL_LNPC    0   /* Location and Navigation Profile Collector role */
#define PRF_SEL_PASS    0   /* Phone Alert Status Profile Server role */
#define PRF_SEL_PASC    0   /* Phone Alert Status Profile Client role */
#define PRF_SEL_PXPR    0   /* Proximity Profile Reporter role */
#define PRF_SEL_PXPM    0   /* Proximity Profile Monitor role */
#define PRF_SEL_RSCS    0   /* Running Speed and Cadence Profile Sensor role */
#define PRF_SEL_RSCC    0   /* Running Speed and Cadence Profile Collector role */
#define PRF_SEL_SPPS    0   /* Scan Parameters Profile Scan Server role */
#define PRF_SEL_SPPC    0   /* Scan Parameters Profile Scan Client role */
#define PRF_SEL_TIPS    0   /* Time Profile Server role */
#define PRF_SEL_TIPC    0   /* Time Profile Client role */
#else
#define PRF_SEL_ANPS    0   /* Alert Notification Profile Server role */
#define PRF_SEL_ANPC    0   /* Alert Notification Profile Client role */
#define PRF_SEL_BLPS    0   /* Blood Pressure Profile Sensor role */
#define PRF_SEL_BLPC    0   /* Blood Pressure Profile Collector role */
#define PRF_SEL_CPPS    0   /* Cycling Power Profile Sensor role */
#define PRF_SEL_CPPC    0   /* Cycling Power Profile Collector role */
#define PRF_SEL_CSCS    0   /* Cycling Speed and Cadence Profile Sensor role */
#define PRF_SEL_CSCC    0   /* Cycling Speed and Cadence Profile Collector role */
#define PRF_SEL_FMPT    0   /* Find Me Profile Target role */
#define PRF_SEL_FMPL    0   /* Find Me Profile Locator role */
#define PRF_SEL_GLPS    0   /* Glucose Profile Sensor role */
#define PRF_SEL_GLPC    0   /* Glucose Profile Collector role */
#define PRF_SEL_HTPT    0   /* Health Thermometer Profile Thermometer role */
#define PRF_SEL_HTPC    0   /* Health Thermometer Profile Collector role */
#define PRF_SEL_HRPS    0   /* Heart Rate Profile Sensor role */
#define PRF_SEL_HRPC    0   /* Heart Rate Profile Collector role */
#define PRF_SEL_HGHD    0   /* HID over GATT Profile HID Device role */
#define PRF_SEL_HGRH    0   /* HID over GATT Profile Report Host role */
#define PRF_SEL_HGBH    0   /* HID over GATT Profile Boot Host role */
#define PRF_SEL_LNPS    0   /* Location and Navigation Profile Sensor role */
#define PRF_SEL_LNPC    0   /* Location and Navigation Profile Collector role */
#define PRF_SEL_PASS    0   /* Phone Alert Status Profile Server role */
#define PRF_SEL_PASC    0   /* Phone Alert Status Profile Client role */
#define PRF_SEL_PXPR    0   /* Proximity Profile Reporter role */
#define PRF_SEL_PXPM    0   /* Proximity Profile Monitor role */
#define PRF_SEL_RSCS    0   /* Running Speed and Cadence Profile Sensor role */
#define PRF_SEL_RSCC    0   /* Running Speed and Cadence Profile Collector role */
#define PRF_SEL_SPPS    0   /* Scan Parameters Profile Scan Server role */
#define PRF_SEL_SPPC    0   /* Scan Parameters Profile Scan Client role */
#define PRF_SEL_TIPS    0   /* Time Profile Server role */
#define PRF_SEL_TIPC    0   /* Time Profile Client role */
#endif

/* Flag indicating if use Link Loss Service */
    /* If use LLS without PXP, set to 1. */
    #define USE_LINK_LOSS_SERVICE           0

/* Flag indicating if use Tx Power Service */
    /* If use TPS without PXP, set to 1. */
    #define USE_TX_POWER_SERVICE            0

/* Flag indicating if use Immediate Alert Service */
    /* If use IAS without PXP and FMP, set to 1. */
    #define USE_IMMEDIATE_ALERT_SERVICE     0

/* Flag indicating if use Device Information Service */
    /* If use DIS without HTP, BLP and so on, set to 1. */
    #define USE_DEV_INFO_SERVICE            0

/* Flag indicating if use Device Information Service (PnP characteristic) */
    /* If use DIS(PnP) without HOGP, set to 1. */
    #define USE_DEV_INFO_SERVICE_PNP        0

/* Flag indicating if use Battery Service */
    /* If use BAS without HOGP, CPP, LNP, set to 1. */
    #define USE_BATTERY_SERVICE             0

/* Flag indicating if use Scan Parameters Service */
    /* If use ScPS without ScPP, set to 1. */
    #define USE_SCAN_PARAMETER_SERVICE      0



    #define PXPR_TABLE_SIZE     0
    #define FMPT_TABLE_SIZE     0
    #define HTPT_TABLE_SIZE     0
    #define BLPS_TABLE_SIZE     0
    #define HGHD_TABLE_SIZE     0
    #define SPPS_TABLE_SIZE     0
    #define HRPS_TABLE_SIZE     0
    #define CSCS_TABLE_SIZE     0
    #define GLPS_TABLE_SIZE     0
    #define CPPS_TABLE_SIZE     0
    #define TIPS_TABLE_SIZE     0
    #define ANPS_TABLE_SIZE     0
    #define LNPS_TABLE_SIZE     0
    #define PASS_TABLE_SIZE     0
    #define RSCS_TABLE_SIZE     0

#define HOST_TABLE_SIZE         87

#define GATT_DB_STRUCT_SIZE     6

#define RBLE_TABLE_SIZE  ((PXPR_TABLE_SIZE + FMPT_TABLE_SIZE + HTPT_TABLE_SIZE + BLPS_TABLE_SIZE \
                         + HGHD_TABLE_SIZE + SPPS_TABLE_SIZE + HRPS_TABLE_SIZE + CSCS_TABLE_SIZE \
                         + GLPS_TABLE_SIZE + CPPS_TABLE_SIZE + TIPS_TABLE_SIZE + ANPS_TABLE_SIZE \
                         + LNPS_TABLE_SIZE + PASS_TABLE_SIZE + RSCS_TABLE_SIZE \
                         + HOST_TABLE_SIZE) * GATT_DB_STRUCT_SIZE)


/**
 * STRUCTURE DECLARATIONS
 ****************************************************************************************
 */

/**
 * GLOBAL VARIABLE DECLARATIONS
 ****************************************************************************************
 */

#endif /* _PRF_SEL_H_ */
