//
//  SensorData.m
//  BLE-Demo
//
//  Created by James Roth on 4/2/14.
//  Copyright (c) 2014 Xaplos, Inc. All rights reserved.
//

#import "SensorData.h"


@implementation SensorData

- (NSDictionary *)characteristicDataToValues:(NSData *)data {
    const UInt8 *bytes = [data bytes];
    int index = 0;
    // all data coming over as uint16_t
    uint16_t rawData;
    
    // light
    float light;
    rawData = bytes[index + 1] << 8 | bytes[index + 0];
    light = rawData / 10.0f;
    NSString *lightString = [NSString stringWithFormat:@"%1.1f", light];
    index += 2;
    
    // pressure
    float pressure;
    rawData = bytes[index + 1] << 8 | bytes[index + 0];
    pressure = rawData / 100.0f;
    NSString *pressureString = [NSString stringWithFormat:@"%1.2f", pressure];
    index += 2;
    
    // temperature
    float temperature;
    rawData = bytes[index + 1] << 8 | bytes[index + 0];
    temperature = rawData / 10.0f;
    NSString *temperatureString = [NSString stringWithFormat:@"%1.1f", temperature];
    index += 2;
    
    // humidity
    float humidity;
    rawData = bytes[index + 1] << 8 | bytes[index + 0];
    humidity = rawData / 10.0f;
    NSString *humidityString = [NSString stringWithFormat:@"%1.1f", humidity];
    index += 2;
    
    // distance
    float distance;
    rawData = bytes[index + 1] << 8 | bytes[index + 0];
    distance = rawData / 100.0f;
    NSString *distanceString = [NSString stringWithFormat:@"%1.2f", distance];
    index += 2;
    
    // calories
    uint16_t calories = bytes[index + 1] << 8 | bytes[index + 0];
    index += 2;
    NSString *caloriesString = [NSString stringWithFormat:@"%d", calories];
    
    // steps
    uint16_t steps = bytes[index + 1] << 8 | bytes[index + 0];
    NSString *stepsString = [NSString stringWithFormat:@"%d", steps];

    NSDictionary *result = [NSDictionary dictionaryWithObjectsAndKeys:
                            lightString, @"Light",
                            pressureString, @"Pressure",
                            temperatureString, @"Temperature",
                            humidityString, @"Humidity",
                            distanceString, @"Distance",
                            caloriesString, @"Calories",
                            stepsString, @"Steps",
                            nil];
    
    return result;
}

@end
