//
//  SpO2ViewController.m
//  BLE Solution
//
//  Created by Mark F Rodriguez on 7/26/16.
//  Copyright © 2016 Mark F Rodriguez. All rights reserved.
//

#import "SpO2ViewController.h"

@interface SpO2ViewController ()

@end

@implementation SpO2ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    // Tell notification center to inform on "HealthDataReceived" notifications
    // using the bleNotification: selector. By specifying object:nil, informing
    // the notification center we are not interested in who posted the notification.
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(spo2Notification:)
                                                 name:@"HealthDataReceived"
                                               object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(spo2Disconnect:)
                                                 name:@"BleDisconnected"
                                               object:nil];
}

- (void) spo2Notification:(NSNotification *) notification
{
    if ([[notification name] isEqualToString:@"HealthDataReceived"]) {
        NSDictionary *values = [NSDictionary dictionaryWithDictionary:notification.userInfo];
        
        // spo2
        [self.spo2Label setText:[values valueForKey:@"SpO2"]];
        
        // heart rate
        [self.heartRateLabel setText:[values valueForKey:@"HeartRate"]];
    }
}

- (void) spo2Disconnect:(NSNotification *) notification
{
    if ([[notification name] isEqualToString:@"BleDisconnected"]) {
        // spo2
        [self.spo2Label setText:@"-"];
        
        // heart rate
        [self.heartRateLabel setText:@"-"];
    }
}

- (void)dealloc {
    // Must remove observer; otherwise the Notification Center will
    // continue to try and send notification objects to the deallocated
    // object
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
