//
//  StartViewController.h
//  BLE Solution
//
//  Created by Mark F Rodriguez on 7/26/16.
//  Copyright © 2016 Mark F Rodriguez. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "LeDiscovery.h"
#import "BleDemoServices.h"

#define STATES_LIST(FILTER)         \
FILTER(STATE_DISCONNECTED)      \
FILTER(STATE_DISCOVER)          \
FILTER(STATE_CONNECTING)        \
FILTER(STATE_CONNECTED)         \
FILTER(STATE_STREAM)            \
FILTER(STATE_STOP)

#define STATES_ENUM_FILTER(x)       x,

enum BleState {
    STATES_LIST(STATES_ENUM_FILTER)
};


@interface StartViewController : UIViewController <LeDiscoveryDelegate, NotificationDelgate>

// App version information
@property (nonatomic, weak) IBOutlet UILabel *versionLabel;
// BLE connect button and status info
@property (nonatomic, weak) IBOutlet UILabel *labelStatus;
@property (nonatomic, weak) IBOutlet UIButton *buttonConnect;
// BLE related support
@property (nonatomic, strong) LeDiscovery *discovery;
@property (nonatomic, retain) CBPeripheral *peripheral;
// BLE state management
@property (nonatomic, setter = setState:, getter = getState) enum BleState state;
@property (nonatomic) enum BleState _state;
@property (nonatomic, retain) NSDictionary *stateNames;
@property (nonatomic) BOOL isFirstDataStream;

// BLE button handler
- (IBAction)buttonConnectPressed:(id)sender;
// Email button handler
- (IBAction)buttonEmailPressed:(id)sender;


@end

