/*
 ****************************************************************************************
 * DISCLAIMER
 ****************************************************************************************
 * This software and/or information (the "Material") is supplied by Renesas Electronics
 * Corporation. and is only intended for use with Renesas products. No other uses are authorized.
 * The Material is owned by Renesas Electronics Corporation and is protected under all applicable laws,
 * including copyright laws.
 * THIS MATERIAL IS PROVIDED "AS IS," AND RENESAS MAKES NO WARRANTIES REGARDING THIS MATERIAL,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
 * TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER RENESAS ELECTRONICS CORP. NOR ANY OF ITS
 * AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS MATERIAL, EVEN IF RENESAS OR ITS AFFILIATES
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this Material
 * and to discontinue its availability
 *
 ****************************************************************************************
*/
#include "application_dispatcher_thread.h"
#include "ble_host_thread.h"
#include "common.h"
#include "stdio.h"

void application_dispatcher_thread_entry(void);

extern void activity_notification( activity_data   *data);
extern void healthcare_notification( healthcare_data   *data);

activity_data g_activity_data;
healthcare_data g_healthcare_data;

/* Application Dispatcher Thread entry function */
/*
 *  This  is the thread which dispatches the sensor data to the BLE
 */
void application_dispatcher_thread_entry(void)
{
    uint32_t events;

    // clear out data
    memset(&g_activity_data, 0, sizeof(g_activity_data));
    memset(&g_healthcare_data, 0, sizeof(g_healthcare_data));

    // Wait for BLE ready event
    tx_event_flags_get(&g_ble_ready_event, 0x01, TX_OR, &events, TX_WAIT_FOREVER);

    while (1)
    {
        // send data over BLE every 1 second
        tx_thread_sleep (100);
        tx_mutex_get(&g_dispatch_mutex, TX_WAIT_FOREVER);
        tx_mutex_get(&g_data_mutex, TX_WAIT_FOREVER);
        healthcare_notification(&g_healthcare_data);
        tx_mutex_put(&g_data_mutex);
    }
}
