/*
 ****************************************************************************************
 * DISCLAIMER
 ****************************************************************************************
 * This software and/or information (the "Material") is supplied by Renesas Electronics
 * Corporation. and is only intended for use with Renesas products. No other uses are authorized.
 * The Material is owned by Renesas Electronics Corporation and is protected under all applicable laws,
 * including copyright laws.
 * THIS MATERIAL IS PROVIDED "AS IS," AND RENESAS MAKES NO WARRANTIES REGARDING THIS MATERIAL,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
 * TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER RENESAS ELECTRONICS CORP. NOR ANY OF ITS
 * AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS MATERIAL, EVEN IF RENESAS OR ITS AFFILIATES
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this Material
 * and to discontinue its availability
 *
 ****************************************************************************************
 * events.h
 *
 *  Created on: Feb 23, 2016
 *      Author: alejandro
 ****************************************************************************************
 */

#ifndef EVENTS_H_
#define EVENTS_H_

#include "pulse_adc.h"

#define NEXT_FLAG(FLAG) ((FLAG) << 1)

enum
{
    BTN_SILENCE_EVENT = NEXT_FLAG(PULSE_EVENT_LAST),
    BTN_DOWN_EVENT = NEXT_FLAG(BTN_SILENCE_EVENT),
    BTN_UP_EVENT = NEXT_FLAG(BTN_DOWN_EVENT),
    BTN_ENTER_EVENT = NEXT_FLAG(BTN_UP_EVENT),
    BTN_SWITCH_EVENT = NEXT_FLAG(BTN_ENTER_EVENT),
    BTN_LAST_EVENT  = BTN_SWITCH_EVENT,
    // screen update events
    SHOW_HEART_RATE_EVENT = NEXT_FLAG(BTN_LAST_EVENT),
    SHOW_OXIGEN_SAT_EVENT = NEXT_FLAG(SHOW_HEART_RATE_EVENT),
    SHOW_LAST_EVENT = SHOW_OXIGEN_SAT_EVENT,
    // idle related events
    IDLE_ENTER_EVENT = NEXT_FLAG(SHOW_LAST_EVENT),
    IDLE_EXIT_EVENT = NEXT_FLAG(IDLE_ENTER_EVENT),
    // add any more events below
};

#define BTN_EVENT_MASK  (BTN_SILENCE_EVENT  |   \
                         BTN_DOWN_EVENT     |   \
                         BTN_UP_EVENT       |   \
                         BTN_ENTER_EVENT    |   \
                         BTN_SWITCH_EVENT)

#define PULSE_EVENT_MASK (PULSE_R_EVENT_FLAG | PULSE_IR_EVENT_FLAG)

#define SHOW_ITEMS_MASK (SHOW_HEART_RATE_EVENT | SHOW_OXIGEN_SAT_EVENT)

#define IDLE_EVENTS_MASK (IDLE_ENTER_EVENT | IDLE_EXIT_EVENT)

#endif /* EVENTS_H_ */
