/*
 ****************************************************************************************
 * DISCLAIMER
 ****************************************************************************************
 * This software and/or information (the "Material") is supplied by Renesas Electronics
 * Corporation. and is only intended for use with Renesas products. No other uses are authorized.
 * The Material is owned by Renesas Electronics Corporation and is protected under all applicable laws,
 * including copyright laws.
 * THIS MATERIAL IS PROVIDED "AS IS," AND RENESAS MAKES NO WARRANTIES REGARDING THIS MATERIAL,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
 * TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER RENESAS ELECTRONICS CORP. NOR ANY OF ITS
 * AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS MATERIAL, EVEN IF RENESAS OR ITS AFFILIATES
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this Material
 * and to discontinue its availability
 *
 ****************************************************************************************
 * d7seg_ssp.c
 *
 *  Created on: Dec 9, 2015
 *      Author: alejandro
 ****************************************************************************************
 */

#include "d7seg.h"
#include "hal_data.h"

/***
 * @brief Please refer to the header for details
 */
void hal_d7seg_write (int seg, int v)
{
    slcdc_ctrl_t *const ctrl = g_slcdc.p_ctrl;
    const slcdc_api_t const *api = g_slcdc.p_api;
    slcdc_size_t data = (slcdc_size_t)v;

    // call specific to synergy
    api->write (ctrl, (slcdc_size_t)seg, &data, (slcdc_size_t)1);
}

/***
 * @brief Please refer to the header for details
 */
int hal_d7seg_open (void)
{
    ssp_err_t err;
    slcdc_ctrl_t *const ctrl = g_slcdc.p_ctrl;
    slcdc_cfg_t  const * const cfg = g_slcdc.p_cfg;
    const slcdc_api_t const *api = g_slcdc.p_api;

    err = api->open (ctrl, cfg);

    if (SSP_SUCCESS == err)
    {
        err = api->start (ctrl);
    }

    return err;
}
