/*
 ****************************************************************************************
 * DISCLAIMER
 ****************************************************************************************
 * This software and/or information (the "Material") is supplied by Renesas Electronics
 * Corporation. and is only intended for use with Renesas products. No other uses are authorized.
 * The Material is owned by Renesas Electronics Corporation and is protected under all applicable laws,
 * including copyright laws.
 * THIS MATERIAL IS PROVIDED "AS IS," AND RENESAS MAKES NO WARRANTIES REGARDING THIS MATERIAL,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
 * TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER RENESAS ELECTRONICS CORP. NOR ANY OF ITS
 * AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS MATERIAL, EVEN IF RENESAS OR ITS AFFILIATES
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this Material
 * and to discontinue its availability
 *
 ****************************************************************************************
 * pulse_adc_process.h
 *
 *  Created on: Jun 20, 2016
 *      Author: alejandro
 ****************************************************************************************
 */

#ifndef PULSE_ADC_PROCESS_H_
#define PULSE_ADC_PROCESS_H_

typedef struct
{
    uint16_t hr;
    uint16_t o2;
}results_t;

typedef struct
{
    TX_EVENT_FLAGS_GROUP *event;
    TX_MUTEX *mutex;
    int red;
    int ired;
    int stat_lost;
    results_t results;
    bool idle;
}pulse_ox_context_t;

#define OFFSET_INIT 4500    // 1.2 V Initial offset value for 2nd Amp stage offset scaled to 14 bits.
                            // Set_Offset_v2 re-scales this to 12 bits

void pulse_ox_update (uint16_t hr, uint16_t o2);
void pulse_ox_get_hr (uint16_t *hr);
void pulse_ox_get_o2 (uint16_t *hr);

void pulse_ox_idle_enter (void);
void pulse_ox_idle_exit (void);

int Set_Offset ( float Value );
int Set_Offset_v2 ( uint16_t Value );

#endif /* PULSE_ADC_PROCESS_H_ */
