/**
 ****************************************************************************************
 *
 * @file        rble_sample_app.c
 *
 * @brief   rBLE Sample Application
 *
 * Copyright(C) 2013-2015 Renesas Electronics Corporation
 *
 * $Rev: 8245 $
 *
 ****************************************************************************************
 */
#include "rwble_config.h"
#include "arch.h"

#ifdef  CFG_SAMPLE

#ifdef CONFIG_EMBEDDED

#include    <stdio.h>
#include    <string.h>
#include    <stdlib.h>

#include    "rble.h"
#include    "rble_app.h"
#include    "menu_sel.h"
#include    "console.h"

#include    "prf_sel.h"

#ifdef USE_CUSTOM_DEMO
//#include    "push_sw.h"
#endif
/**************************** Define Declaration **************************************/
#if (PRF_SEL_FMPL)
#define         USE_FMPL_SAMPLE
#endif
#if (PRF_SEL_FMPT)
#define         USE_FMPT_SAMPLE
#endif
#if (PRF_SEL_PXPR)
#define         USE_PXPR_SAMPLE
#endif
#if (PRF_SEL_PXPM)
#define         USE_PXPM_SAMPLE
#endif
#if (PRF_SEL_HTPC)
#define         USE_HTPC_SAMPLE
#endif
#if (PRF_SEL_HTPT)
#define         USE_HTPT_SAMPLE
#endif
#if (PRF_SEL_BLPC)
#define         USE_BLPC_SAMPLE
#endif
#if (PRF_SEL_BLPS)
#define         USE_BLPS_SAMPLE
#endif
#if (PRF_SEL_HGHD)
#define         USE_HGHD_SAMPLE
#endif
#if (PRF_SEL_HGBH)
#define         USE_HGBH_SAMPLE
#endif
#if (PRF_SEL_HGRH)
#define         USE_HGRH_SAMPLE
#endif
#if (PRF_SEL_SPPC)
#define         USE_SCPPC_SAMPLE
#endif
#if (PRF_SEL_SPPS)
#define         USE_SCPPS_SAMPLE
#endif
#if (PRF_SEL_HRPC)
#define         USE_HRPC_SAMPLE
#endif
#if (PRF_SEL_HRPS)
#define         USE_HRPS_SAMPLE
#endif
#if (PRF_SEL_CSCC)
#define         USE_CSCC_SAMPLE
#endif
#if (PRF_SEL_CSCS)
#define         USE_CSCS_SAMPLE
#endif
#if (PRF_SEL_GLPC)
#define         USE_GLPC_SAMPLE
#endif
#if (PRF_SEL_GLPS)
#define         USE_GLPS_SAMPLE
#endif
#if (PRF_SEL_CPPC)
#define         USE_CPPC_SAMPLE
#endif
#if (PRF_SEL_CPPS)
#define         USE_CPPS_SAMPLE
#endif

#if (PRF_SEL_TIPC)
#define         USE_TIPC_SAMPLE
#endif
#if (PRF_SEL_TIPS)
#define         USE_TIPS_SAMPLE
#endif

#if (PRF_SEL_ANPC)
#define         USE_ANPC_SAMPLE
#endif
#if (PRF_SEL_ANPS)
#define         USE_ANPS_SAMPLE
#endif
#if (PRF_SEL_LNPS)
#define         USE_LNPS_SAMPLE
#endif
#if (PRF_SEL_LNPC)
#define         USE_LNPC_SAMPLE
#endif
#if (PRF_SEL_PASS)
#define         USE_PASPS_SAMPLE
#endif
#if (PRF_SEL_PASC)
#define         USE_PASPC_SAMPLE
#endif
#if (PRF_SEL_RSCS)
#define         USE_RSCPS_SAMPLE
#endif
#if (PRF_SEL_RSCC)
#define         USE_RSCPC_SAMPLE
#endif

#ifdef USE_SAMPLE_PROFILE
//mfr #define         USE_SCPC_SAMPLE
#define         USE_SCPS_SAMPLE
#endif

#define         USE_VS_SAMPLE
#define         USE_PTS_SAMPLE
#define         ILLEGAL_CONNECTION_HANDLE           0xffff

enum RBLE_APP_KEY_FLAG_enum {
    RBLE_APP_LTK,
    RBLE_APP_ENCKEY,
    RBLE_APP_IDKEY,
    RBLE_APP_SIGNKEY
};

typedef struct {
    BOOL                            Key_Set_Flags;
    struct RBLE_EVT_SM_Key_t        EncKey;
    struct RBLE_EVT_SM_Key_t        IrKey;
    struct RBLE_EVT_SM_Key_t        SignKey;
} RBLE_APP_KEY_DATA;


#ifdef USE_PTS_SAMPLE
typedef struct {
    BOOL                            Gap_Sec_Test;
    BOOL                            Seq_Enc_Req;
    BOOL                            Auth_Req;
    uint8_t                         Ltk_Cnt;
    BOOL                            ChangeParam;
    BOOL                            ChangeParamResp;
    BOOL                            FMPT_Enable;
    BOOL                            PXPR_Enable;
    BOOL                            HTPT_Enable;
    BOOL                            BLPS_Enable;
    BOOL                            HOGPD_Enable;
    BOOL                            SCPP_Enable;
    BOOL                            HRPS_Enable;
    BOOL                            CSCPS_Enable;
    BOOL                            CSCP_LinkLoss;
    BOOL                            GLPS_Enable;
    BOOL                            TIPS_Enable;
    BOOL                            LNPS_Enable;
    BOOL                            LNPS_PosQual;
    uint16_t                        LNPS_PosQual_Flags;
    BOOL                            LNPC_AutoRouteSet;
    BOOL                            CPS_Enable;
    BOOL                            CPS_Manual_Res;
    BOOL                            CPP_Enable;
    BOOL                            CPP_Con_2nd;
    BOOL                            CPP_RcvAdv;
    BOOL                            PASPS_Enable;
    BOOL                            RSCPS_Enable;
} RBLE_PTS_FLG;
#endif

typedef struct {
    uint16_t                        Handle;
    uint16_t                        Size;
    uint8_t                         Data[ RBLE_GATT_MAX_LONG_VALUE ];
} RBLE_GATT_DATA;

#ifdef USE_CUSTOM_DEMO
typedef struct {
    BOOL        Notify_en;
    BOOL        Indicate_en;
    BOOL        Timer_en;
    uint16_t    Timer_interval;
    uint8_t     Notify_len;
    uint8_t     Indicate_len;
} RBLE_SCP_SAMPLE_INFO;
#endif
/******************************* PRIVATE PROTOTYPE ************************************/
static void RBLE_App_Test_Start( void );            /* Test Start( Menu Select ) */
static BOOL RBLE_APP_Exit( void );
static void RBLE_APP_CallBack(RBLE_MODE mode );

/* --------------------------- Generic Access Profile --------------------------------*/
static void RBLE_APP_GAP_CallBack( RBLE_GAP_EVENT *event );                                 /* GAP Call Back */
static BOOL RBLE_GAP_Reset_Test( void );                                                    /* A GAP_Reset command is executed. */
static BOOL RBLE_GAP_Set_Name_Test( void );                                                 /* A GAP_Set_Name command is executed. */
static BOOL RBLE_GAP_Observation_Enable_Test( void );                                       /* A GAP_Observation_Enable command is executed. */
static BOOL RBLE_GAP_Observation_Disable_Test( void );                                      /* A GAP_Observation_Disable command is executed. */
static BOOL RBLE_GAP_Broadcast_Enable_Test( void );                                         /* A GAP_Broadcast_Enable command is executed. */
static BOOL RBLE_GAP_Broadcast_Disable_Test( void );                                        /* A GAP_Broadcast_Disable command is executed. */
static BOOL RBLE_GAP_Set_Bonding_Mode_Test( void );                                         /* A GAP_Set_Bonding_Mode command is executed. */
static BOOL RBLE_GAP_Set_Security_Request_Test( void );                                     /* A GAP_Set_Security_Request command is executed. */
static BOOL RBLE_GAP_Get_Device_Info_Test( void );                                          /* A GAP_Get_Device_Info command is executed. */
static BOOL RBLE_GAP_Get_White_List_Size_Test( void );                                      /* A GAP_Get_White_List_Size command is executed. */
static BOOL RBLE_GAP_Add_To_White_List_Test( void );                                        /* A GAP_Add_To_White_List command is executed. */
static BOOL RBLE_GAP_Del_From_White_List_Test( void );                                      /* A GAP_Del_From_White_List command is executed. */
static BOOL RBLE_GAP_Get_Remote_Device_Name_Test( void );                                   /* A GAP_Get_Remote_Device_Name command is executed. */
static BOOL RBLE_GAP_Get_Remote_Device_Info_Test( void );                                   /* A GAP_Get_Remote_Device_Info command is executed. */
static BOOL RBLE_GAP_Device_Search_Test( void );                                            /* A GAP_Device_Search command is executed. */
static BOOL RBLE_GAP_Set_Random_Address_Test( void );                                       /* A GAP_Set_Random_Address command is executed. */
static BOOL RBLE_GAP_Set_Privacy_Feature_Test( void );                                      /* A GAP_Set_Privacy_Feature command is executed. */
static BOOL RBLE_GAP_Create_Connection_Test( void );                                        /* A GAP_Create_Connection command is executed. */
static BOOL RBLE_GAP_Connection_Cancel_Test( void );                                        /* A GAP_Connection_Cancel command is executed. */
static BOOL RBLE_GAP_Disconnect_Test( void );                                               /* A GAP_Disconnect command is executed. */
static BOOL RBLE_GAP_Start_Bonding_Test( void );                                            /* A GAP_Start_Bonding command is executed. */
static BOOL RBLE_GAP_Bonding_Info_Ind_Test( void );                                         /* A GAP_Bonding_Info_Ind command is executed. */
static BOOL RBLE_GAP_Bonding_Response_Test( void );                                         /* A GAP_Bonding_Response command is executed. */
static BOOL RBLE_GAP_Change_Connection_Param_Test( void );                                  /* A GAP_Change_Connection_Param command is executed. */
static BOOL RBLE_GAP_Channel_Map_Req_Test( void );                                          /* A GAP_Channel_Map_Req command is executed. */
static BOOL RBLE_GAP_Read_RSSI_Test( void );                                                /* A GAP_Read RSSI Request command is excuted. */
static BOOL RBLE_GAP_Authorized_Ind_Test( void );                                           /* A GAP_Authorized_Ind command is excuted. */

/* --------------------------- Security Manager --------------------------------------*/
static void RBLE_APP_SM_CallBack( RBLE_SM_EVENT *event );                                   /* SM Call Back */
static BOOL RBLE_SM_Set_Key_Test( void );                                                   /* A SM_Set_Key command is executed. */
static BOOL RBLE_SM_Set_Key_Test_Csrk( void );                                              /* A SM_Set_Key_Test command is executed. */
static BOOL RBLE_SM_Start_Enc_Test( void );                                                 /* A SM_Start_Enc command is executed. */
static BOOL RBLE_SM_Tk_Req_Resp_Test( void );                                               /* A SM_Tk_Req_Resp command is executed. */
static BOOL RBLE_SM_Ltk_Req_Resp_Test( void );                                              /* A SM_Ltk_Req_Resp command is executed. */
static BOOL RBLE_SM_Irk_Req_Resp_Test( void );                                              /* A SM_Irk_Req_Resp command is executed. */
static BOOL RBLE_SM_Csrk_Req_Resp_Test( void );                                             /* A SM_Csrk_Req_Resp command is executed. */
static BOOL RBLE_SM_Chk_Bd_Addr_Req_Resp_Test( void );                                      /* A SM_Chk_Bd_Addr_Req_Resp command is executed. */

/* ---------------------------------- GATT ------------------------------------------*/
static void RBLE_APP_GATT_CallBack( RBLE_GATT_EVENT *event );                               /* GATT Call Back */
static BOOL RBLE_GATT_Enable_Test( void );                                                  /* A GATT Enable command is executed. */
static BOOL RBLE_GATT_Discovery_Service_Request_Test( void );
static BOOL RBLE_GATT_Discovery_Char_Request_Test( void );
static BOOL RBLE_GATT_Discovery_Char_Descriptor_Request_Test( void );
static BOOL RBLE_GATT_Read_Char_Request_Test( void );
static BOOL RBLE_GATT_Write_Char_Request_Test( void );
static BOOL RBLE_GATT_Write_Reliable_Request_Test( void );
static BOOL RBLE_GATT_Execute_Write_Char_Request_Test( void );
static BOOL RBLE_GATT_Notify_Request_Test( void );
static BOOL RBLE_GATT_Indicate_Request_Test( void );
static BOOL RBLE_GATT_Write_Response_Test( void );
static BOOL RBLE_GATT_Set_Permission_Test( void );
static BOOL RBLE_GATT_Set_Data_Test( void );


/* --------------------------- Find Me Profile ---------------------------------------*/
#ifdef USE_FMPL_SAMPLE
static void RBLE_APP_FMPL_CallBack( RBLE_FMPL_EVENT *event );                               /* FMP(Locator) Call Back */
#endif
#ifdef USE_FMPT_SAMPLE
static void RBLE_APP_FMPT_CallBack( RBLE_FMPT_EVENT *event );                               /* FMP(Target) Call Back */
#endif
#ifdef USE_FMPT_SAMPLE
static BOOL RBLE_FMP_Target_Enable_Test( void );                                            /* A FMP_Target_Enable command is executed. */
static BOOL RBLE_FMP_Target_Disable_Test( void );                                           /* A FMP_Target_Disable command is executed. */
#endif
#ifdef USE_FMPL_SAMPLE
static BOOL RBLE_FMP_Locator_Enable_Test( void );                                           /* A FMP_Locator_Enable command is executed. */
static BOOL RBLE_FMP_Locator_Disable_Test( void );                                          /* A FMP_Locator_Disable command is executed. */
static BOOL RBLE_FMP_Locator_Set_Alert_Test( void );                                        /* A FMP_Locator_Set_Alert command is executed. */
#endif

/* ------------------------- Health Thermometer Profile-------------------------------*/
#ifdef USE_HTPC_SAMPLE
static void RBLE_APP_HTPC_CallBack( RBLE_HTPC_EVENT *event );                               /* HTP(Collector) Call Back */
#endif
#ifdef USE_HTPT_SAMPLE
static void RBLE_APP_HTPT_CallBack( RBLE_HTPT_EVENT *event );                               /* HTP(Thermometer) Call Back */
#endif
#ifdef USE_HTPT_SAMPLE
static BOOL RBLE_HTP_Thermometer_Enable_Test( void );                                       /* A HTP_Thermometer_Enable command is executed. */
static BOOL RBLE_HTP_Thermometer_Disable_Test( void );                                      /* A HTP_Thermometer_Disable command is executed. */
static BOOL RBLE_HTP_Thermometer_Send_Temp_Test( void );                                    /* A HTP_Thermometer_Send_Temp command is executed. */
static BOOL RBLE_HTP_Thermometer_Req_Measurement_Period_Ind_Test( void );                   /* A HTP_Thermometer_Req_Measurement_Period_Ind command is executed. */
#endif
#ifdef USE_HTPC_SAMPLE
static BOOL RBLE_HTP_Collector_Enable_Test( void );                                         /* A HTP_Collector_Enable command is executed. */
static BOOL RBLE_HTP_Collector_Disable_Test( void );                                        /* A HTP_Collector_Disable command is executed. */
static BOOL RBLE_HTP_Collector_Read_Char_Test( void );                                      /* A HTP_Collector_Read_Char command is executed. */
static BOOL RBLE_HTP_Collector_Write_Char_Test( void );                                     /* A HTP_Collector_Write_Char command is executed. */
static BOOL RBLE_HTP_Collector_Set_Measurement_Period_Test( void );                         /* A HTP_Collector_Set_Measurement_Period command is executed. */
#endif

/* ------------------------- Proximity Profile----------------------------------------*/
#ifdef USE_PXPR_SAMPLE
static void RBLE_APP_PXPR_CallBack( RBLE_PXPR_EVENT *event );                               /* PXP(Reporter) Call Back */
#endif
#ifdef USE_PXPM_SAMPLE
static void RBLE_APP_PXPM_CallBack( RBLE_PXPM_EVENT *event );                               /* PXP(Monitor) Call Back */
#endif
#ifdef USE_PXPR_SAMPLE
static BOOL RBLE_PXP_Reporter_Enable_Test( void );                                          /* A PXP_Reporter_Enable command is executed. */
static BOOL RBLE_PXP_Reporter_Disable_Test( void );                                         /* A PXP_Reporter_Disable command is executed. */
#endif
#ifdef USE_PXPM_SAMPLE
static BOOL RBLE_PXP_Monitor_Enable_Test( void );                                           /* A PXP_Monitor_Enable command is executed. */
static BOOL RBLE_PXP_Monitor_Disable_Test( void );                                          /* A PXP_Monitor_Disable command is executed. */
static BOOL RBLE_PXP_Monitor_Get_Alert_Level_Test( void );                                  /* A PXP_Monitor_Get_Alert_Level command is executed. */
static BOOL RBLE_PXP_Monitor_Set_Alert_Level_Test( void );                                  /* A PXP_Monitor_Set_Alert_Level command is executed. */
static BOOL RBLE_PXP_Monitor_Get_Tx_Power_Test( void );                                     /* A PXP_Monitor_Get_Tx_Power command is executed. */
#endif

/* ------------------------- Blood Pressure Profile-----------------------------------*/
#ifdef USE_BLPC_SAMPLE
static void RBLE_APP_BLPC_CallBack( RBLE_BLPC_EVENT *event );                               /* BLP(Collector) Call Back */
#endif
#ifdef USE_BLPS_SAMPLE
static void RBLE_APP_BLPS_CallBack( RBLE_BLPS_EVENT *event );                               /* BLP(Sensor) Call Back */
#endif
#ifdef USE_BLPS_SAMPLE
static BOOL RBLE_BLP_Sensor_Enable_Test( void );                                            /* A BLP_Sensor_Enable command is executed. */
static BOOL RBLE_BLP_Sensor_Disable_Test( void );                                           /* A BLP_Sensor_Disable command is executed. */
static BOOL RBLE_BLP_Sensor_Send_Measurements_Test( void );                                 /* A BLP_Sensor_Send_Measurements command is executed. */
#endif
#ifdef USE_BLPC_SAMPLE
static BOOL RBLE_BLP_Collector_Enable_Test( void );                                         /* A BLP_Collector_Enable command is executed. */
static BOOL RBLE_BLP_Collector_Disable_Test( void );                                        /* A BLP_Collector_Disable command is executed. */
static BOOL RBLE_BLP_Collector_Read_Char_Test( void );                                      /* A BLP_Collector_Read_Char command is executed. */
static BOOL RBLE_BLP_Collector_Write_Char_Test( void );                                     /* A BLP_Collector_Write_Char command is executed. */
#endif

/* ------------------------- Heart Rate Profile-----------------------------------*/
#ifdef USE_HRPC_SAMPLE
static void RBLE_APP_HRPC_CallBack( RBLE_HRPC_EVENT *event );                               /* HRP(Collector) Call Back */
#endif
#ifdef USE_HRPS_SAMPLE
static void RBLE_APP_HRPS_CallBack( RBLE_HRPS_EVENT *event );                               /* HRP(Sensor) Call Back */
#endif
#ifdef USE_HRPS_SAMPLE
static BOOL RBLE_HRP_Sensor_Enable_Test( void );                                            /* A HRP_Sensor_Enable command is executed. */
static BOOL RBLE_HRP_Sensor_Disable_Test( void );                                           /* A HRP_Sensor_Disable command is executed. */
static BOOL RBLE_HRP_Sensor_Send_Measurements_Test( void );                                 /* A HRP_Sensor_Send_Measurements command is executed. */
#endif
#ifdef USE_HRPC_SAMPLE
static BOOL RBLE_HRP_Collector_Enable_Test( void );                                         /* A HRP_Collector_Enable command is executed. */
static BOOL RBLE_HRP_Collector_Disable_Test( void );                                        /* A HRP_Collector_Disable command is executed. */
static BOOL RBLE_HRP_Collector_Read_Char_Test( void );                                      /* A HRP_Collector_Read_Char command is executed. */
static BOOL RBLE_HRP_Collector_Write_Control_Point_Test( void );                            /* A HRP_Collector_Write_Control_Point command is executed. */
static BOOL RBLE_HRP_Collector_Write_Char_Test( void );                                     /* A HRP_Collector_Write_Char command is executed. */
#endif

/* ------------------------- Cycling Speed and Cadence Profile-----------------------------------*/
#ifdef USE_CSCC_SAMPLE
static void RBLE_APP_CSCPC_CallBack( RBLE_CSCPC_EVENT *event );                             /* CSCP(Collector) Call Back */
#endif
#ifdef USE_CSCS_SAMPLE
static void RBLE_APP_CSCPS_CallBack( RBLE_CSCPS_EVENT *event );                             /* CSCP(Sensor) Call Back */
#endif
#ifdef USE_CSCS_SAMPLE
static BOOL RBLE_CSCP_Sensor_Enable_Test( void );                                           /* A CSCP_Sensor_Enable command is executed. */
static BOOL RBLE_CSCP_Sensor_Disable_Test( void );                                          /* A CSCP_Sensor_Disable command is executed. */
static BOOL RBLE_CSCP_Sensor_Send_Measurements_Test( void );                                /* A CSCP_Sensor_Send_Measurements command is executed. */
static BOOL RBLE_CSCP_Sensor_Send_Sc_Control_Point_Test( void );                            /* A CSCP_Sensor_Send_SC_Control_Point command is executed. */
#endif
#ifdef USE_CSCC_SAMPLE
static BOOL RBLE_CSCP_Collector_Enable_Test( void );                                        /* A CSCP_Collector_Enable command is executed. */
static BOOL RBLE_CSCP_Collector_Disable_Test( void );                                       /* A CSCP_Collector_Disable command is executed. */
static BOOL RBLE_CSCP_Collector_Read_Char_Test( void );                                     /* A CSCP_Collector_Read_Char command is executed. */
static BOOL RBLE_CSCP_Collector_Write_SC_Control_Point_Test( void );                        /* A CSCP_Collector_Write_SC_Control_Point command is executed. */
static BOOL RBLE_CSCP_Collector_Write_Char_Test( void );                                    /* A CSCP_Collector_Write_Char command is executed. */
#endif

/* ------------------------- Glucose Profile-----------------------------------*/
#ifdef USE_GLPC_SAMPLE
static void RBLE_APP_GLPC_CallBack( RBLE_GLPC_EVENT *event );                               /* GLP(Collector) Call Back */
#endif
#ifdef USE_GLPS_SAMPLE
static void RBLE_APP_GLPS_CallBack( RBLE_GLPS_EVENT *event );                               /* GLP(Sensor) Call Back */
#endif
#ifdef USE_GLPS_SAMPLE
static BOOL RBLE_GLP_Sensor_Enable_Test( void );                                            /* A GLP_Sensor_Enable command is executed. */
static BOOL RBLE_GLP_Sensor_Disable_Test( void );                                           /* A GLP_Sensor_Disable command is executed. */
static BOOL RBLE_GLP_Sensor_Send_Measurements_Test( void );                                 /* A GLP_Sensor_Send_Measurements command is executed. */
static BOOL RBLE_GLP_Sensor_Send_Measurements_Context_Test( void );                         /* A GLP_Sensor_Send_Measurements_Context command is executed. */
static BOOL RBLE_GLP_Sensor_Send_RA_Control_Point_Test( void );                             /* A GLP_Sensor_Send_RA_Control_Point command is executed. */
#endif
#ifdef USE_GLPC_SAMPLE
static BOOL RBLE_GLP_Collector_Enable_Test( void );                                         /* A GLP_Collector_Enable command is executed. */
static BOOL RBLE_GLP_Collector_Disable_Test( void );                                        /* A GLP_Collector_Disable command is executed. */
static BOOL RBLE_GLP_Collector_Read_Char_Test( void );                                      /* A GLP_Collector_Read_Char command is executed. */
static BOOL RBLE_GLP_Collector_Write_RA_Control_Point_Test( void );                         /* A GLP_Collector_Write_RA_Control_Point command is executed. */
static BOOL RBLE_GLP_Collector_Write_Char_Test( void );                                     /* A GLP_Collector_Write_Char command is executed. */
#endif

/* ------------------------- Cycling Power Profile-------------------------------*/
#ifdef  USE_CPPC_SAMPLE
static void RBLE_APP_CPPC_CallBack( RBLE_CPPC_EVENT *event );                               /* CPPC(Collector) Call Back */
#endif
#ifdef  USE_CPPS_SAMPLE
static void RBLE_APP_CPPS_CallBack( RBLE_CPPS_EVENT *event );                               /* CPPS(Sensor) Call Back */
#endif
#ifdef  USE_CPPS_SAMPLE
static BOOL RBLE_CPP_Sensor_Enable_Test( void );                                            /* A CPP_Sensor_Enable command is executed. */
static BOOL RBLE_CPP_Sensor_Disable_Test( void );                                           /* A CPP_Sensor_Disable command is executed. */
static BOOL RBLE_CPP_Sensor_Send_Measurements_Test( void );                                 /* A CPP_Sensor_Send_Measurements command is executed. */
static BOOL RBLE_CPP_Sensor_Broadcast_Measurements_Test( void );                            /* A CPP_Sensor_Broadcast_Measurements command is executed. */
static BOOL RBLE_CPP_Sensor_Send_Vector_Test( void );                                       /* A CPP_Sensor_Send_Vector command is executed. */
static BOOL RBLE_CPP_Sensor_Send_CP_Control_Point_Test( void );                             /* A CPP_Sensor_Send_CP_Control_Point command is executed. */
static BOOL RBLE_CPP_Sensor_Send_Battery_Level_Test( void );                                /* A CPP_Sensor_Send_Battery_Level command is executed. */
static BOOL RBLE_CPP_Sensor_Send_Write_Response_Test( void );                               /* A CPP_Sensor_Send_Write_Response command is executed. */
#endif
#ifdef  USE_CPPC_SAMPLE
static BOOL RBLE_CPP_Collector_Enable_Test( void );                                         /* A CPP_Collector_Enable command is executed. */
static BOOL RBLE_CPP_Collector_Disable_Test( void );                                        /* A CPP_Collector_Disable command is executed. */
static BOOL RBLE_CPP_Collector_Read_Char_Test( void );                                      /* A CPP_Collector_Read_Char command is executed. */
static BOOL RBLE_CPP_Collector_Write_CP_Control_Point_Test( void );                         /* A CPP_Collector_Write_CP_Control_Point command is executed. */
static BOOL RBLE_CPP_Collector_Write_Char_Test( void );                                     /* A CPP_Collector_Write_Char command is executed. */
#endif

/* ------------------------- Time Profile-----------------------------------*/
#ifdef USE_TIPS_SAMPLE
static void RBLE_APP_TIPS_CallBack( RBLE_TIPS_EVENT *event );                               /* TIP(Server) Call Back */
#endif
#ifdef USE_TIPC_SAMPLE
static void RBLE_APP_TIPC_CallBack( RBLE_TIPC_EVENT *event );                               /* TIP(Client) Call Back */
#endif
#ifdef USE_TIPS_SAMPLE
static BOOL RBLE_TIP_Server_Enable_Test( void );                                            /* A TIP_Server_Enable command is executed */
static BOOL RBLE_TIP_Server_Disable_Test( void );                                           /* A TIP_Server_Disable command is executed */
static BOOL RBLE_TIP_Server_Send_Current_Time_Test( void );                                 /* A TIP_Server_Send_Current_Time command is executed */
static BOOL RBLE_TIP_Server_Write_Data_Test( void );                                        /* A TIP_Server_Write_Data command is executed */
#endif
#ifdef USE_TIPC_SAMPLE
static BOOL RBLE_TIP_Client_Enable_Test( void );                                            /* A TIP_Client_Enable command is executed */
static BOOL RBLE_TIP_Client_Disable_Test( void );                                           /* A TIP_Client_Disable command is executed */
static BOOL RBLE_TIP_Client_Read_Char_Test( void );                                         /* A TIP_Client_Read_Char command is executed */
static BOOL RBLE_TIP_Client_Write_Char_Test( void );                                        /* A TIP_Client_Write_Char command is executed */
static BOOL RBLE_TIP_Client_Write_Time_Update_CP_Test( void );                              /* A TIP_Client_Write_Time_Update_CP command is executed */
#endif

/* ------------------------- ANP Profile-----------------------------------*/
#ifdef USE_ANPS_SAMPLE
static void RBLE_APP_ANPS_CallBack( RBLE_ANPS_EVENT *event );                               /* ANP(Server) Call Back */
#endif
#ifdef USE_ANPC_SAMPLE
static void RBLE_APP_ANPC_CallBack( RBLE_ANPC_EVENT *event );                               /* ANP(Client) Call Back */
#endif
#ifdef USE_ANPS_SAMPLE
static BOOL RBLE_ANP_Server_Enable_Test( void );                                            /* A ANP_Server_Enable command is executed */
static BOOL RBLE_ANP_Server_Disable_Test( void );                                           /* A ANP_Server_Disable command is executed */
static BOOL RBLE_ANP_Server_Send_New_Alert_Test( void );                                    /* A ANP_Server_Send_New_Alert command is executed */
static BOOL RBLE_ANP_Server_Send_Unread_Alert_Test( void );                                 /* A ANP_Server_Send_Unread_Alert command is executed */
#endif
#ifdef USE_ANPC_SAMPLE
static BOOL RBLE_ANP_Client_Enable_Test( void );                                            /* A ANP_Client_Enable command is executed */
static BOOL RBLE_ANP_Client_Disable_Test( void );                                           /* A ANP_Client_Disable command is executed */
static BOOL RBLE_ANP_Client_Read_Char_Test( void );                                         /* A ANP_Client_Read_Char command is executed */
static BOOL RBLE_ANP_Client_Write_Alert_Notification_CP_Test( void );                       /* A ANP_Client_Write_Alert_Notification_CP command is executed */
static BOOL RBLE_ANP_Client_Write_Char_Test( void );                                        /* A ANP_Client_Write_Char command is executed */
#endif

/* ------------------------- LNP Profile-----------------------------------*/
#ifdef USE_LNPS_SAMPLE
static void RBLE_APP_LNPS_CallBack( RBLE_LNPS_EVENT *event );                               /* LNP(Sensor) Call Back */
#endif
#ifdef USE_LNPC_SAMPLE
static void RBLE_APP_LNPC_CallBack( RBLE_LNPC_EVENT *event );                               /* LNP(Collector) Call Back */
#endif
#ifdef USE_LNPS_SAMPLE
static BOOL RBLE_LNP_Sensor_Enable_Test( void );                                            /* A LNP_Sensor_Enable command is executed */
static BOOL RBLE_LNP_Sensor_Disable_Test( void );                                           /* A LNP_Sensor_Disable command is executed */
static BOOL RBLE_LNP_Sensor_Send_Location_Speed_Test( void );                               /* A LNP_Sensor_Send_Location_Speed command is executed */
static BOOL RBLE_LNP_Sensor_Set_Position_Quality_Test( void );                              /* A LNP_Sensor_Set_Position_Quality command is executed */
static BOOL RBLE_LNP_Sensor_Send_LN_Control_Point_Test( void );                             /* A LNP_Sensor_Send_LN_Control_Point command is executed */
static BOOL RBLE_LNP_Sensor_Send_Navigation_Test( void );                                   /* A LNP_Sensor_Send_Navigation command is executed */
static BOOL RBLE_LNP_Sensor_Send_Battery_Level_Test( void );                                /* A LNP_Sensor_Send_Battery_Level command is executed */
#endif
#ifdef USE_LNPC_SAMPLE
static BOOL RBLE_LNP_Collector_Enable_Test( void );                                         /* A LNP_Collector_Enable command is executed */
static BOOL RBLE_LNP_Collector_Disable_Test( void );                                        /* A LNP_Collector_Disable command is executed */
static BOOL RBLE_LNP_Collector_Read_Char_Test( void );                                      /* A LNP_Collector_Read_Char command is executed */
static BOOL RBLE_LNP_Collector_Write_LN_Control_Point_Test( void );                         /* A LNP_Collector_Write_LN_Control_Point command is executed */
static BOOL RBLE_LNP_Collector_Write_Char_Test( void );                                     /* A LNP_Collector_Write_Char command is executed */
#endif

/* ------------------------- Phone Alert Status Profile-----------------------------------*/
#ifdef USE_PASPS_SAMPLE
static void RBLE_APP_PASPS_CallBack( RBLE_PASPS_EVENT *event );                             /* PASP(Server) Call Back */
#endif
#ifdef USE_PASPC_SAMPLE
static void RBLE_APP_PASPC_CallBack( RBLE_PASPC_EVENT *event );                             /* PASP(Client) Call Back */
#endif
#ifdef USE_PASPS_SAMPLE
static BOOL RBLE_PASP_Server_Enable_Test( void );                                           /* A PASP_Server_Enable command is executed */
static BOOL RBLE_PASP_Server_Disable_Test( void );                                          /* A PASP_Server_Disable command is executed */
static BOOL RBLE_PASP_Server_Send_Alert_Status_Test( void );                                /* A PASP_Server_Send_Alert_Status command is executed */
static BOOL RBLE_PASP_Server_Send_Ringer_Setting_Test( void );                              /* A PASP_Server_Send_Ringer_Setting command is executed */
#endif
#ifdef USE_PASPC_SAMPLE
static BOOL RBLE_PASP_Client_Enable_Test( void );                                           /* A PASP_Client_Enable command is executed */
static BOOL RBLE_PASP_Client_Disable_Test( void );                                          /* A PASP_Client_Disable command is executed */
static BOOL RBLE_PASP_Client_Read_Char_Test( void );                                        /* A PASP_Client_Read_Char command is executed */
static BOOL RBLE_PASP_Client_Write_Ringer_Control_Point_Test( void );                       /* A PASP_Client_Write_Ringer_Control_Point command is executed */
static BOOL RBLE_PASP_Client_Write_Char_Test( void );                                       /* A PASP_Client_Write_Char command is executed */
#endif

/* ------------------------- Running Speed and Cadence Profile-----------------------------------*/
#ifdef USE_RSCPS_SAMPLE
static void RBLE_APP_RSCPS_CallBack( RBLE_RSCPS_EVENT *event );                             /* RSCP(Sensor) Call Back */
#endif
#ifdef USE_RSCPC_SAMPLE
static void RBLE_APP_RSCPC_CallBack( RBLE_RSCPC_EVENT *event );                             /* RSCP(Collector) Call Back */
#endif
#ifdef USE_RSCPS_SAMPLE
static BOOL RBLE_RSCP_Sensor_Enable_Test( void );                                           /* A RSCP_Sensor_Enable command is executed */
static BOOL RBLE_RSCP_Sensor_Disable_Test( void );                                          /* A RSCP_Sensor_Disable command is executed */
static BOOL RBLE_RSCP_Sensor_Send_Measurements_Test( void );                                /* A RSCP_Sensor_Send_Measurements command is executed */
static BOOL RBLE_RSCP_Sensor_Send_SC_Control_Point_Test( void );                            /* A RSCP_Sensor_Send_SC_Control_Point command is executed */
#endif
#ifdef USE_RSCPC_SAMPLE
static BOOL RBLE_RSCP_Collector_Enable_Test( void );                                        /* A RSCP_Collector_Enable command is executed */
static BOOL RBLE_RSCP_Collector_Disable_Test( void );                                       /* A RSCP_Collector_Disable command is executed */
static BOOL RBLE_RSCP_Collector_Read_Char_Test( void );                                     /* A RSCP_Collector_Read_Char command is executed */
static BOOL RBLE_RSCP_Collector_Write_SC_Control_Point_Test( void );                        /* A RSCP_Collector_Write_SC_Control_Point command is executed */
static BOOL RBLE_RSCP_Collector_Write_Char_Test( void );                                    /* A RSCP_Collector_Write_Char command is executed */
#endif

/* ------------------------- HID over GATT Profile-------------------------------*/
#ifdef USE_HGHD_SAMPLE
static void RBLE_APP_HGHD_CallBack( RBLE_HGHD_EVENT *event );                               /* HOGP(HostDevice) Call Back */
#endif
#ifdef USE_HGBH_SAMPLE
static void RBLE_APP_HGBH_CallBack( RBLE_HGBH_EVENT *event );                               /* HOGP(BootHost) Call Back */
#endif
#ifdef USE_HGRH_SAMPLE
static void RBLE_APP_HGRH_CallBack( RBLE_HGRH_EVENT *event );                               /* HOGP(ReportHost) Call Back */
#endif
#ifdef USE_HGHD_SAMPLE
static BOOL RBLE_HGP_HDevice_Enable_Test( void );                                           /* A HGP_HDevice_Enable command is executed. */
static BOOL RBLE_HGP_HDevice_Disable_Test( void );                                          /* A HGP_HDevice_Disable command is executed. */
static BOOL RBLE_HGP_HDevice_Send_Report_Test( void );                                      /* A HGP_HDevice_Send_Report command is executed. */
static BOOL RBLE_HGP_HDevice_Send_Battery_Level_Test( void );                               /* A HGP_HDevice_Send_Battery_Level command is executed. */
#endif
#ifdef USE_HGBH_SAMPLE
static BOOL RBLE_HGP_BHost_Enable_Test( void );                                             /* A HGP_BHost_Enable command is executed. */
static BOOL RBLE_HGP_BHost_Disable_Test( void );                                            /* A HGP_BHost_Disable command is executed. */
static BOOL RBLE_HGP_BHost_Read_Char_Test( void );                                          /* A HGP_BHost_Read_Char command is executed. */
static BOOL RBLE_HGP_BHost_Read_By_UUID_Char_Test( void );                                  /* A HGP_BHost_Read_By_UUID_Char command is executed. */
static BOOL RBLE_HGP_BHost_Write_Char_Test( void );                                         /* A HGP_BHost_Write_Char command is executed. */
static BOOL RBLE_HGP_BHost_Set_Report_Test( void );                                         /* A HGP_BHost_Set_Report command is executed. */
static BOOL RBLE_HGP_BHost_Write_Protocol_Mode_Test( void );                                /* A HGP_BHost_Write_Protocol_Mode command is executed. */
static BOOL RBLE_HGP_BHost_Data_Output_Test( void );                                        /* A HGP_BHost_Data_Output command is executed. */
#endif
#ifdef USE_HGRH_SAMPLE
static BOOL RBLE_HGP_RHost_Enable_Test( void );                                             /* A HGP_RHost_Enable command is executed. */
static BOOL RBLE_HGP_RHost_Disable_Test( void );                                            /* A HGP_RHost_Disable command is executed. */
static BOOL RBLE_HGP_RHost_Read_Char_Test( void );                                          /* A HGP_RHost_Read_Char command is executed. */
static BOOL RBLE_HGP_RHost_Read_By_UUID_Char_Test( void );                                  /* A HGP_RHost_Read_By_UUID_Char command is executed. */
static BOOL RBLE_HGP_RHost_Read_Long_Char_Test( void );                                     /* A HGP_RHost_Read_Long_Char command is executed. */
static BOOL RBLE_HGP_RHost_Write_Char_Test( void );                                         /* A HGP_RHost_Write_Char command is executed. */
static BOOL RBLE_HGP_RHost_Set_Report_Test( void );                                         /* A HGP_RHost_Set_Report command is executed. */
static BOOL RBLE_HGP_RHost_Write_Protocol_Mode_Test( void );                                /* A HGP_RHost_Write_Protocol_Mode command is executed. */
static BOOL RBLE_HGP_RHost_Data_Output_Test( void );                                        /* A HGP_RHost_Data_Output command is executed. */
static BOOL RBLE_HGP_RHost_Write_Control_Point_Test( void );                                /* A HGP_RHost_Write_Control_Point command is executed. */
#endif

/* ------------------------- Scan Parameters Profile-------------------------------*/
#ifdef  USE_SCPPC_SAMPLE
static void RBLE_APP_SPPC_CallBack( RBLE_SPPC_EVENT *event );                               /* SCPP(Server) Call Back */
#endif
#ifdef  USE_SCPPS_SAMPLE
static void RBLE_APP_SPPS_CallBack( RBLE_SPPS_EVENT *event );                               /* SCPP(Client) Call Back */
#endif
#ifdef  USE_SCPPS_SAMPLE
static BOOL RBLE_SPP_Server_Enable_Test( void );                                            /* A SPP_Server_Enable command is executed. */
static BOOL RBLE_SPP_Server_Disable_Test( void );                                           /* A SPP_Server_Disable command is executed. */
static BOOL RBLE_SPP_Server_Send_Refresh_Test( void );                                      /* A SPP_Server_Send_Refresh command is executed. */
#endif
#ifdef  USE_SCPPC_SAMPLE
static BOOL RBLE_SPP_Client_Enable_Test( void );                                            /* A SPP_Client_Enable command is executed. */
static BOOL RBLE_SPP_Client_Disable_Test( void );                                           /* A SPP_Client_Disable command is executed. */
static BOOL RBLE_SPP_Client_Write_Char_Test( void );                                        /* A SPP_Client_Write_Char command is executed. */
static BOOL RBLE_SPP_Client_Write_Interval_Test( void );                                    /* A SPP_Client_Write_Interval command is executed. */
#endif

/* ------------------------- Sample Custom Profile-----------------------------------*/
#ifdef USE_SCPS_SAMPLE
static void RBLE_APP_SCPS_CallBack( RBLE_SCPS_EVENT *event );                               /* SCP(Server) Call Back */
#endif
#ifdef USE_SCPC_SAMPLE
static void RBLE_APP_SCPC_CallBack( RBLE_SCPC_EVENT *event );                               /* SCP(Client) Call Back */
#endif
#ifdef USE_SCPS_SAMPLE
static BOOL RBLE_SCP_Server_Enable_Test( void );                                            /* A SCP_Server_Enable command is executed. */
static BOOL RBLE_SCP_Server_Disable_Test( void );                                           /* A SCP_Server_Disable command is executed. */
static BOOL RBLE_SCP_Server_Send_Notify_Test( void );                                       /* A SCP_Server_Send_Notify command is executed. */
static BOOL RBLE_SCP_Server_Send_Indicate_Test( void );                                     /* A SCP_Server_Send_Indicate command is executed. */
#endif
#ifdef USE_SCPC_SAMPLE
static BOOL RBLE_SCP_Client_Enable_Test( void );                                            /* A SCP_Client_Enable command is executed. */
static BOOL RBLE_SCP_Client_Disable_Test( void );                                           /* A SCP_Client_Disable command is executed. */
static BOOL RBLE_SCP_Client_Read_Char_Test( void );                                         /* A SCP_Client_Read_Char command is executed. */
static BOOL RBLE_SCP_Client_Write_Char_Test( void );                                        /* A SCP_Client_Write_Char command is executed. */
#endif

/* ------------------------- Vendor Specific------------------------------------------*/
#ifdef USE_VS_SAMPLE
static void RBLE_APP_VS_CallBack( RBLE_VS_EVENT *event );                                   /* Vendor Specific Call Back */
static BOOL RBLE_VS_Enable_Test( void );                                                    /* Vendor Specific Command Enable */
static BOOL RBLE_VS_Test_Rx_Start_Test( void );                                             /* Direct Test (RxTestStart) */
static BOOL RBLE_VS_Test_Tx_Start_Test( void );                                             /* Direct Test (TxTestStart) */
static BOOL RBLE_VS_Test_End_Test( void );                                                  /* Direct Test End */
static BOOL RBLE_VS_Test_Set_Parameter_Test( void );                                        /* Direct Test Parameter Set */
static BOOL RBLE_VS_Test_Read_RSSI_Test( void );                                            /* Direct Test Read RSSI */
static BOOL RBLE_VS_Write_BdAddress_Test( void );                                           /* Write Bluetooth Address */
static BOOL RBLE_VS_Set_Tx_Power_Test( void );                                              /* Set Tx Power */
static BOOL RBLE_VS_GPIO_Dir_Test( void );                                                  /* GPIO Dir */
static BOOL RBLE_VS_GPIO_Access_Test( void );                                               /* GPIO Access */
static BOOL RBLE_VS_Flash_Management_Test( void );                                          /* Data Flash Management */
static BOOL RBLE_VS_Flash_Access_Test( void );                                              /* Data Flash Access */
static BOOL RBLE_VS_Flash_Operation_Test( void );                                           /* Data Flash Operation */
static BOOL RBLE_VS_Flash_Get_Space_Test( void );                                           /* Data Flash Get Space */
static BOOL RBLE_VS_Flash_Get_EEL_Ver_Test( void );                                         /* Data Flash Get EEL Version */
static BOOL RBLE_VS_Adapt_Enable_Test( void );                                              /* Adaptable Function Enable */
static BOOL RBLE_VS_Set_Params_Test( void );                                                /* Set Parameters */
static BOOL RBLE_VS_RF_Control_Test( void );                                                /* RF Control */
#endif

/* ------------------------- Firmware Update ------------------------------------------*/
#if defined(USE_FW_UPDATE_PROFILE)&&defined(WIN32)
static BOOL RBLE_FW_UPDATE_Test( void );                                                    /* FW update start */

extern RBLE_STATUS FW_Update_Sender_Start( uint8_t file_num, uint8_t start_area );
#endif

void BdAddress_Disp( RBLE_BD_ADDR *Addr_p );
void AdvRepot_Disp( RBLE_ADV_REPORT *Report_p );
void Uuid128_Disp( uint8_t *p );

void RBLE_Status_Disp( RBLE_STATUS Status );
void KeyDisp( struct RBLE_EVT_SM_Key_t *Key_p );
void RandomDataDisp( RBLE_RAND_NB *p );
void KeyDataDisp( RBLE_KEY_VALUE *p );
char_t *Get_Status_Str( RBLE_STATUS Status );
void ATT_Info_Disp( RBLE_ATT_INFO_DATA *p );
void Print_Dump( uint8_t *p, uint16_t len );
char_t  *Get_Att_Code_Str( uint8_t att_code );
void Select_Param_No_Disp(uint32_t no);
void Connection_Handle_Disp( uint16_t conhdl );
void Illegal_Connection_Print( void );

#if defined(USE_BLPC_SAMPLE)|defined(USE_GLPC_SAMPLE)
float SFLOAT2FLOAT( uint16_t sf );
#endif
#ifdef USE_BLPC_SAMPLE
void BLP_Info_Disp( RBLE_BLP_MEASUREMENTS_INFO *p );
#endif
#ifdef USE_HTPC_SAMPLE
void HTP_Info_Disp( RBLE_HTP_TEMP_INFO *p );
#endif
#if defined(USE_HGBH_SAMPLE)|defined(USE_HGRH_SAMPLE)
void HGP_Info_Disp( RBLE_HIDS_CONTENT *hids, RBLE_DIS11_CONTENT *dis, RBLE_BAS_CONTENT *bas, uint8_t hids_inst_num, uint8_t bas_inst_num );
#endif
#ifdef USE_HRPC_SAMPLE
void HRP_Info_Disp( RBLE_HRP_MEASUREMENTS_INFO *p );
#endif
#ifdef USE_CSCC_SAMPLE
void CSCP_MEASURE_Info_Disp( RBLE_CSCP_MEASUREMENTS_INFO *p );
#endif
#if defined(USE_CSCC_SAMPLE)|defined(USE_CSCS_SAMPLE)
void CSCP_SC_CP_Info_Disp( RBLE_CSCP_SC_CONTROL_POINT_INFO *p, uint8_t loc_num, uint8_t *res_param );
#endif
#if defined(USE_HTPC_SAMPLE)|defined(USE_BLPC_SAMPLE)|defined(USE_HRPC_SAMPLE)|defined(USE_CSCC_SAMPLE)|defined(USE_GLPC_SAMPLE)|defined(USE_CPPC_SAMPLE)|defined(USE_LNPC_SAMPLE)|defined(USE_RSCPC_SAMPLE)
void DIS_handle_Info_Disp(RBLE_DIS_CONTENT *dis);
#endif
#if defined(USE_CPPC_SAMPLE)|defined(USE_LNPC_SAMPLE)
void BAS_handle_Info_Disp(RBLE_BATS_CONTENT *bas);
#endif

#if defined(USE_GLPC_SAMPLE)
void GLP_MEASURE_Info_Disp( RBLE_GLP_MEASUREMENTS_INFO *meas );
void GLP_MEASURE_Context_Info_Disp( RBLE_GLP_MEASUREMENTS_CONTEXT_INFO *meas );
#endif
#if defined(USE_GLPC_SAMPLE)|defined(USE_GLPS_SAMPLE)
void GLP_RA_CP_Info_Disp( RBLE_GLP_RA_CONTROL_POINT_INFO *cp );
void GLP_RA_CP_Ind_Info_Disp( RBLE_GLP_RA_CONTROL_POINT_IND_INFO *cp );
#endif
#ifdef USE_CPPC_SAMPLE
void CPP_Meas_Info_Disp(RBLE_CPP_MEASUREMENTS_INFO *meas_info);
void CPP_Vector_Info_Disp(RBLE_CPP_VECTOR_INFO *vector_info);
void CPP_Ind_Cp_Info_Disp(RBLE_CPPC_EVENT *event);
void CPP_Broadcast_Rcv(RBLE_ADV_REPORT *adv_rep_p );
#endif
#ifdef USE_CPPS_SAMPLE
void CPP_Chg_Cp_Info_Disp(RBLE_CPP_WR_CONTROL_POINT_INFO *wr_info);
#endif
#if defined(USE_TIPC_SAMPLE)|defined(USE_LNPC_SAMPLE)
void TIP_Time_Disp(RBLE_DATE_TIME *stamp);
#if defined(USE_TIPC_SAMPLE)
void TIP_Info_Disp(uint8_t char_code, RBLE_ATT_INFO_DATA *att_data);
#endif
#endif
#ifdef USE_ANPC_SAMPLE
void ANP_Alert_Disp (RBLE_ANP_NEW_ALERT_INFO *alert_info);
#endif
int_t RBLE_Get_Random( void );

#ifdef USE_LNPC_SAMPLE
void LNP_int32_print(int32_t value);
void LNP_uint32_print(uint32_t value);

void LNP_Location_Speed_Disp (RBLE_LNP_LOCATION_SPEED_INFO *location_speed_info);
void LNP_Navigation_Disp(RBLE_LNP_NAVIGATION_INFO *navi_info);
void LNP_LN_Control_Point_Disp(RBLE_LNP_IND_CONTROL_POINT_INFO *ind_cp_info);
#endif

#ifdef USE_LNPS_SAMPLE
void LNP_Write_Value_Disp(uint8_t opcode, uint32_t value);
void LNP_Chg_LN_CP_Info_Disp(RBLE_LNP_WR_CONTROL_POINT_INFO *wr_cp_info);
#endif
#ifdef USE_RSCPC_SAMPLE
void RSCP_MEASURE_Info_Disp( RBLE_RSCP_MEASUREMENTS_INFO *p );
#endif
#if defined(USE_RSCPC_SAMPLE)|defined(USE_RSCPS_SAMPLE)
void RSCP_SC_CP_Info_Disp( RBLE_RSCP_SC_CONTROL_POINT_INFO *p, uint8_t loc_num, uint8_t *res_param );
#endif

#ifdef USE_VS_SAMPLE
void VS_GPIO_Mask_Disp( void );
void VS_GPIO_Read_Disp( void );
#endif

#ifdef USE_PTS_SAMPLE
static BOOL RBLE_PTS_L2CAP_Start( void );                                                   /* PTS L2CAP Test Case Start */
static BOOL RBLE_PTS_GAP_Start( void );                                                     /* PTS GAP Test Case Start */
static BOOL RBLE_PTS_SM_Start( void );                                                      /* PTS SM Test Case Start */
static BOOL RBLE_PTS_GATT_Start( void );                                                    /* PTS GATT Test Case Start */
static BOOL RBLE_PTS_FMP_Start( void );                                                     /* PTS FMP Test Case Start */
static BOOL RBLE_PTS_IAS_Start( void );                                                     /* PTS IAS Test Case Start */
static BOOL RBLE_PTS_PXP_Start( void );                                                     /* PTS PXP Test Case Start */
static BOOL RBLE_PTS_LLS_Start( void );                                                     /* PTS LLS Test Case Start */
static BOOL RBLE_PTS_TPS_Start( void );                                                     /* PTS TPS Test Case Start */
static BOOL RBLE_PTS_HTP_Start( void );                                                     /* PTS HTP Test Case Start */
static BOOL RBLE_PTS_HTS_Start( void );                                                     /* PTS HTS Test Case Start */
static BOOL RBLE_PTS_DIS_Start( void );                                                     /* PTS DIS Test Case Start */
static BOOL RBLE_PTS_BLP_Start( void );                                                     /* PTS BLP Test Case Start */
static BOOL RBLE_PTS_BLS_Start( void );                                                     /* PTS BLS Test Case Start */
static BOOL RBLE_PTS_HOGP_Start( void );                                                    /* PTS HOGP Test Case Start */
static BOOL RBLE_PTS_HIDS_Start( void );                                                    /* PTS HIDS Test Case Start */
static BOOL RBLE_PTS_BAS_Start( void );                                                     /* PTS BAS Test Case Start */
static BOOL RBLE_PTS_SCPP_Start( void );                                                    /* PTS ScPP Test Case Start */
static BOOL RBLE_PTS_SCPS_Start( void );                                                    /* PTS ScPS Test Case Start */
static BOOL RBLE_PTS_HRP_Start( void );                                                     /* PTS HRP/HRS Test Case Start */
static BOOL RBLE_PTS_CSCP_Start( void );                                                    /* PTS CSCP Test Case Start */
static BOOL RBLE_PTS_CSCS_Start( void );                                                    /* PTS CSCS Test Case Start */
static BOOL RBLE_PTS_GLPS_Start( void );                                                    /* PTS GLPS Test Case Start */
static BOOL RBLE_PTS_TIPS_Start( void );                                                    /* PTS TIPS Test Case Start */
static BOOL RBLE_PTS_LNPS_Start( void );                                                    /* PTS LNPS Test Case Start */
static BOOL RBLE_PTS_LNPC_Start( void );                                                    /* PTS LNPC Test Case Start */
static BOOL RBLE_PTS_CPS_Start( void );                                                     /* PTS CPS Test Case Start */
static BOOL RBLE_PTS_CPP_Start( void );                                                     /* PTS CPP Test Case Start */
static BOOL RBLE_PTS_PASS_Start( void );                                                    /* PTS PASPS Test Case Start */
static BOOL RBLE_PTS_RSCS_Start( void );                                                    /* PTS RSCPS Test Case Start */
#endif

#ifdef USE_CUSTOM_DEMO
static void send_data( void );
static void timer_int( void );
static void sw_int( void );
#endif
/**************************** PUBLIC Memory Declaration *******************************/
uint32_t            RBLE_Parameter_Arg[ RBLE_PARAMETER_MAX ];
uint_t              RBLE_Parameter_Cnt;

/**************************** PRIVATE Memory Declaration ******************************/
RBLE_BD_ADDR        Remote_Device = { 0x5F, 0xB6, 0x05, 0xDC, 0x1B, 0x00 };
//RBLE_BD_ADDR      Remote_Device = { 0xAB, 0x2F, 0x00, 0x0A, 0x09, 0x2E };
//RBLE_BD_ADDR      Remote_Device = { 0x42, 0x00, 0xDE, 0xFA, 0xFE, 0xCA };
RBLE_BD_ADDR        Remote_Device_2nd = { 0x34, 0x7A, 0x04, 0xDC, 0x1B, 0x00 };
//RBLE_BD_ADDR      Remote_Device_2nd = { 0xA5, 0xB5, 0x05, 0xDC, 0x1B, 0x00 };
RBLE_DEV_ADDR_INFO  Add_White_List_Dev_info;
uint16_t            Connection_Handle = ILLEGAL_CONNECTION_HANDLE;
uint16_t            Connection_Handle_2nd = ILLEGAL_CONNECTION_HANDLE;
uint8_t             Role_Status = RBLE_MASTER;
uint8_t             Adv_Flag = FALSE;
uint8_t             Connection_Idx = 0xff;
uint8_t             Connection_Type = 0xff;
uint16_t            Search_Attribute_Type = RBLE_CHAR_GAP_DEVICE_NAME;
RBLE_APP_KEY_DATA   RBLE_APP_Key;
uint8_t             Own_Addr_Type = RBLE_ADDR_PUBLIC;
uint8_t             Peer_Addr_Type = RBLE_ADDR_PUBLIC;
BOOL                Exit_Flg;

BOOL                Bonding_Flg = FALSE;
RBLE_BD_ADDR        Recon_Addr;
#ifdef USE_CSCC_SAMPLE
BOOL                First_Crank_Flg = TRUE;
BOOL                First_Wheel_Flg = TRUE;
#endif
#ifdef USE_VS_SAMPLE
uint8_t             GPIO_Mode = 0x00;
uint8_t             GPIO_Dir = 0x00;
uint8_t             GPIO_Mask = 0x00;
uint8_t             GPIO_Value = 0x00;
uint8_t             FlashAccessData_buf[6];
#endif
#ifdef USE_PTS_SAMPLE
RBLE_PTS_FLG        Pts_Flg;
#endif
RBLE_GATT_DATA      Gatt_Data;

uint32_t            Remote_Sign_Counter;
BOOL                Invalid_SignCnt_Flg;

char_t *Key_Code_Str[] = {
    "No Keys",
    "Encryption key",
    "IRK (ID key)",
    "",
    "CSRK(Signature key)"
};

#ifdef USE_CUSTOM_DEMO
RBLE_SCP_SAMPLE_INFO    scp_sample_info = {
    FALSE,      /* notify enable flag */
    FALSE,      /* indicate enable flag */
    FALSE,      /* timer interrupt enable flag */
    100,        /* timer interval time(100*10ms) */
    5,          /* notify data length */
    5           /* indicate data length */
};
#endif

/* --------------------------- Ganeric Access Profile --------------------------------*/
/* --------------------------- Security Manager --------------------------------------*/
static const MENU_INFO  Test_Prog_GAP_SM_GATT_Menu[] = {
    {   1,  RBLE_GAP_Reset_Test,                                    NULL,                               " 1.GAP Reset\n",                                   },
    {   2,  RBLE_GAP_Set_Name_Test,                                 NULL,                               " 2.GAP Set_Name\n",                                },
    {   3,  RBLE_GAP_Observation_Enable_Test,                       NULL,                               " 3.GAP Observation_Enable\n",                      },
    {   4,  RBLE_GAP_Observation_Disable_Test,                      NULL,                               " 4.GAP Observation_Disable\n",                     },
    {   5,  RBLE_GAP_Broadcast_Enable_Test,                         NULL,                               " 5.GAP Broadcast_Enable\n",                        },
    {   6,  RBLE_GAP_Broadcast_Disable_Test,                        NULL,                               " 6.GAP Broadcast_Disable\n",                       },
    {   7,  RBLE_GAP_Set_Bonding_Mode_Test,                         NULL,                               " 7.GAP Set_Bonding_Mode\n",                        },
    {   8,  RBLE_GAP_Set_Security_Request_Test,                     NULL,                               " 8.GAP Set_Security_Request\n",                    },
    {   9,  RBLE_GAP_Get_Device_Info_Test,                          NULL,                               " 9.GAP Get_Device_Info\n",                         },
    {  10,  RBLE_GAP_Get_White_List_Size_Test,                      NULL,                               "10.GAP Get_White_List_Size\n",                     },
    {  11,  RBLE_GAP_Add_To_White_List_Test,                        NULL,                               "11.GAP Add_To_White_List\n",                       },
    {  12,  RBLE_GAP_Del_From_White_List_Test,                      NULL,                               "12.GAP Del_From_White_List\n",                     },
    {  13,  RBLE_GAP_Get_Remote_Device_Name_Test,                   NULL,                               "13.GAP Get_Remote_Device_Name\n",                  },
    {  14,  RBLE_GAP_Get_Remote_Device_Info_Test,                   NULL,                               "14.GAP Get_Remote_Device_Info\n",                  },
    {  15,  RBLE_GAP_Device_Search_Test,                            NULL,                               "15.GAP Device_Search\n",                           },
    {  17,  RBLE_GAP_Set_Random_Address_Test,                       NULL,                               "17.GAP Set_Random_Address\n",                      },
    {  18,  RBLE_GAP_Set_Privacy_Feature_Test,                      NULL,                               "18.GAP Set_Privacy_Feature\n",                     },
    {  20,  RBLE_GAP_Create_Connection_Test,                        NULL,                               "20.GAP Create_Connection\n",                       },
    {  21,  RBLE_GAP_Connection_Cancel_Test,                        NULL,                               "21.GAP Connection_Cancel\n",                       },
    {  22,  RBLE_GAP_Disconnect_Test,                               NULL,                               "22.GAP Disconnect\n",                              },
    {  23,  RBLE_GAP_Start_Bonding_Test,                            NULL,                               "23.GAP Start_Bonding\n",                           },
    {  24,  RBLE_GAP_Bonding_Info_Ind_Test,                         NULL,                               "24.GAP Bonding_Info_Ind\n",                        },
    {  25,  RBLE_GAP_Bonding_Response_Test,                         NULL,                               "25.GAP Bonding_Response\n",                        },
    {  26,  RBLE_GAP_Change_Connection_Param_Test,                  NULL,                               "26.GAP Change_Connection_Param\n",                 },
    {  27,  RBLE_GAP_Channel_Map_Req_Test,                          NULL,                               "27.GAP Channel_Map_Req\n",                         },
    {  28,  RBLE_GAP_Read_RSSI_Test,                                NULL,                               "28.GAP Read_RSSI\n",                               },
    {  16,  RBLE_GAP_Authorized_Ind_Test,                           NULL,                               "16.GAP Authorized_Ind\n",                          },
    {  29,  RBLE_SM_Set_Key_Test,                                   NULL,                               "29.SM Set_Key\n",                                  },
    {  30,  RBLE_SM_Start_Enc_Test,                                 NULL,                               "30.SM Start_Enc\n",                                },
    {  31,  RBLE_SM_Tk_Req_Resp_Test,                               NULL,                               "31.SM Tk_Req_Resp\n",                              },
    {  32,  RBLE_SM_Ltk_Req_Resp_Test,                              NULL,                               "32.SM Ltk_Req_Resp\n",                             },
    {  33,  RBLE_SM_Irk_Req_Resp_Test,                              NULL,                               "33.SM Irk_Req_Resp\n",                             },
    {  34,  RBLE_SM_Csrk_Req_Resp_Test,                             NULL,                               "34.SM Csrk_Req_Resp\n",                            },
    {  35,  RBLE_SM_Chk_Bd_Addr_Req_Resp_Test,                      NULL,                               "35.SM Chk_Bd_Addr_Req_Resp\n",                     },
    {  36,  RBLE_GATT_Enable_Test,                                  NULL,                               "36.GATT Enable\n",                                 },
    {  37,  RBLE_GATT_Discovery_Char_Request_Test,                  NULL,                               "37.GATT Discovery_Char_Request\n",                 },
    {  38,  RBLE_GATT_Discovery_Service_Request_Test,               NULL,                               "38.GATT Discovery_Service_Request\n",              },
    {  39,  RBLE_GATT_Discovery_Char_Descriptor_Request_Test,       NULL,                               "39.GATT Discovery_Char_Descriptor_Request\n",      },
    {  40,  RBLE_GATT_Read_Char_Request_Test,                       NULL,                               "40.GATT Read_Char_Request\n",                      },
    {  41,  RBLE_GATT_Write_Char_Request_Test,                      NULL,                               "41.GATT Write_Char_Request\n",                     },
    {  42,  RBLE_GATT_Write_Reliable_Request_Test,                  NULL,                               "42.GATT Write_Reliable_Request\n",                 },
    {  43,  RBLE_GATT_Execute_Write_Char_Request_Test,              NULL,                               "43.GATT Execute_Write_Char_Request\n",             },
    {  44,  RBLE_GATT_Notify_Request_Test,                          NULL,                               "44.GATT Notify_Request\n",                         },
    {  45,  RBLE_GATT_Indicate_Request_Test,                        NULL,                               "45.GATT Indicate_Request\n",                       },
    {  47,  RBLE_GATT_Write_Response_Test,                          NULL,                               "47.GATT Write_Response\n",                         },
    {  48,  RBLE_GATT_Set_Permission_Test,                          NULL,                               "48.GATT Set_Permission\n",                         },
    {  49,  RBLE_GATT_Set_Data_Test,                                NULL,                               "49.GATT Set_Data\n",                               },
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_GAP_SM_GATT_Select_Menu = {
    "\n-- BLE Sample Program GAP & SM & GATT Test Menu --",
    Test_Prog_GAP_SM_GATT_Menu
};

/* --------------------------- Find Me Profile ---------------------------------------*/
#if defined(USE_FMPT_SAMPLE)|defined(USE_FMPL_SAMPLE)
static const MENU_INFO  Test_Prog_FMP_Menu[] = {
#ifdef  USE_FMPT_SAMPLE
    {  1,   RBLE_FMP_Target_Enable_Test,                            NULL,                               "1.FMP Target_Enable\n",                            },
    {  2,   RBLE_FMP_Target_Disable_Test,                           NULL,                               "2.FMP Target_Disable\n",                           },
#endif
#ifdef  USE_FMPL_SAMPLE
    {  3,   RBLE_FMP_Locator_Enable_Test,                           NULL,                               "3.FMP Locator_Enable\n",                           },
    {  4,   RBLE_FMP_Locator_Disable_Test,                          NULL,                               "4.FMP Locator_Disable\n",                          },
    {  5,   RBLE_FMP_Locator_Set_Alert_Test,                        NULL,                               "5.FMP Locator_Set_Alert\n",                        },
#endif
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_FMP_Select_Menu = {
    "\n-- BLE Sample Program Find Me Profile Test Menu --",
    Test_Prog_FMP_Menu
};
#endif

/* ------------------------- Health Thermometer Profile-------------------------------*/
#if defined(USE_HTPT_SAMPLE)|defined(USE_HTPC_SAMPLE)
static const MENU_INFO  Test_Prog_HTP_Menu[] = {
#ifdef USE_HTPT_SAMPLE
    {  1,   RBLE_HTP_Thermometer_Enable_Test,                       NULL,                               "1.HTP Thermometer_Enable\n",                       },
    {  2,   RBLE_HTP_Thermometer_Disable_Test,                      NULL,                               "2.HTP Thermometer_Disable\n",                      },
    {  3,   RBLE_HTP_Thermometer_Send_Temp_Test,                    NULL,                               "3.HTP Thermometer_Send_Temp\n",                    },
    {  4,   RBLE_HTP_Thermometer_Req_Measurement_Period_Ind_Test,   NULL,                               "4.HTP Thermometer_Req_Measurement_Period_Ind\n",   },
#endif
#ifdef USE_HTPC_SAMPLE
    {  5,   RBLE_HTP_Collector_Enable_Test,                         NULL,                               "5.HTP Collector_Enable\n",                         },
    {  6,   RBLE_HTP_Collector_Disable_Test,                        NULL,                               "6.HTP Collector_Disable\n",                        },
    {  7,   RBLE_HTP_Collector_Read_Char_Test,                      NULL,                               "7.HTP_Collector_Read_Char\n",                      },
    {  8,   RBLE_HTP_Collector_Write_Char_Test,                     NULL,                               "8.HTP_Collector_Write_Char\n",                     },
    {  9,   RBLE_HTP_Collector_Set_Measurement_Period_Test,         NULL,                               "9.HTP Collector_Set_Measurement_Period\n",         },
#endif
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  SELECT_MENU Test_Prog_HTP_Select_Menu = {
    "\n-- BLE Sample Program Health Thermometer Profile Test Menu --",
    Test_Prog_HTP_Menu
};
#endif

/* ------------------------- Proximity Profile----------------------------------------*/
#if defined(USE_PXPR_SAMPLE)|defined(USE_PXPM_SAMPLE)
static const MENU_INFO  Test_Prog_PXP_Menu[] = {
#ifdef  USE_PXPR_SAMPLE
    {  1,   RBLE_PXP_Reporter_Enable_Test,                          NULL,                               "1.PXP Reporter_Enable\n",                          },
    {  2,   RBLE_PXP_Reporter_Disable_Test,                         NULL,                               "2.PXP Reporter_Disable\n",                         },
#endif
#ifdef  USE_PXPM_SAMPLE
    {  3,   RBLE_PXP_Monitor_Enable_Test,                           NULL,                               "3.PXP Monitor_Enable\n",                           },
    {  4,   RBLE_PXP_Monitor_Disable_Test,                          NULL,                               "4.PXP Monitor_Disable\n",                          },
    {  5,   RBLE_PXP_Monitor_Get_Alert_Level_Test,                  NULL,                               "5.PXP Monitor_Get_Alert_Level\n",                  },
    {  6,   RBLE_PXP_Monitor_Set_Alert_Level_Test,                  NULL,                               "6.PXP Monitor_Set_Alert_Level\n",                  },
    {  7,   RBLE_PXP_Monitor_Get_Tx_Power_Test,                     NULL,                               "7.PXP Monitor_Get_Tx_Power\n",                     },
#endif
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_PXP_Select_Menu = {
    "\n-- BLE Sample Program Proximity Profile Test Menu --",
    Test_Prog_PXP_Menu
};
#endif

/* ------------------------- Blood Pressure Profile-------------------------------*/
#if defined(USE_BLPS_SAMPLE)|defined(USE_BLPC_SAMPLE)
static const MENU_INFO  Test_Prog_BLP_Menu[] = {
#ifdef  USE_BLPS_SAMPLE
    {  1,   RBLE_BLP_Sensor_Enable_Test,                            NULL,                               "1.BLP Sensor_Enable\n",                            },
    {  2,   RBLE_BLP_Sensor_Disable_Test,                           NULL,                               "2.BLP Sensor_Disable\n",                           },
    {  3,   RBLE_BLP_Sensor_Send_Measurements_Test,                 NULL,                               "3.BLP Sensor_Send_Measurements\n",                 },
#endif
#ifdef  USE_BLPC_SAMPLE
    {  4,   RBLE_BLP_Collector_Enable_Test,                         NULL,                               "4.BLP Collector_Enable\n",                         },
    {  5,   RBLE_BLP_Collector_Disable_Test,                        NULL,                               "5.BLP Collector_Disable\n",                        },
    {  6,   RBLE_BLP_Collector_Read_Char_Test,                      NULL,                               "6.BLP Collector_Read_Char\n",                      },
    {  7,   RBLE_BLP_Collector_Write_Char_Test,                     NULL,                               "7.BLP Collector_Write_Char\n",                     },
#endif
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  SELECT_MENU Test_Prog_BLP_Select_Menu = {
    "\n-- BLE Sample Program Blood Pressure Profile Test Menu --",
    Test_Prog_BLP_Menu
};
#endif


/* ------------------------- Heart Rate Profile-------------------------------*/
#if defined(USE_HRPS_SAMPLE)|defined(USE_HRPC_SAMPLE)
static const MENU_INFO  Test_Prog_HRP_Menu[] = {
#ifdef  USE_HRPS_SAMPLE
    {  1,   RBLE_HRP_Sensor_Enable_Test,                            NULL,                               "1.HRP Sensor_Enable\n",                            },
    {  2,   RBLE_HRP_Sensor_Disable_Test,                           NULL,                               "2.HRP Sensor_Disable\n",                           },
    {  3,   RBLE_HRP_Sensor_Send_Measurements_Test,                 NULL,                               "3.HRP Sensor_Send_Measurements\n",                 },
#endif
#ifdef  USE_HRPC_SAMPLE
    {  4,   RBLE_HRP_Collector_Enable_Test,                         NULL,                               "4.HRP Collector_Enable\n",                         },
    {  5,   RBLE_HRP_Collector_Disable_Test,                        NULL,                               "5.HRP Collector_Disable\n",                        },
    {  6,   RBLE_HRP_Collector_Read_Char_Test,                      NULL,                               "6.HRP Collector_Read_Char\n",                      },
    {  7,   RBLE_HRP_Collector_Write_Control_Point_Test,            NULL,                               "7.HRP Collector_Write_Control_Point\n",            },
    {  8,   RBLE_HRP_Collector_Write_Char_Test,                     NULL,                               "8.HRP Collector_Write_Char\n",                     },
#endif
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  SELECT_MENU Test_Prog_HRP_Select_Menu = {
    "\n-- BLE Sample Program Heart Rate Profile Test Menu --",
    Test_Prog_HRP_Menu
};
#endif

/* ------------------------- Cycling Speed and Cadence Profile-------------------------------*/
#if defined(USE_CSCS_SAMPLE)|defined(USE_CSCC_SAMPLE)
static const MENU_INFO  Test_Prog_CSCP_Menu[] = {
#ifdef  USE_CSCS_SAMPLE
    {  1,   RBLE_CSCP_Sensor_Enable_Test,                           NULL,                               "1.CSCP Sensor_Enable\n",                           },
    {  2,   RBLE_CSCP_Sensor_Disable_Test,                          NULL,                               "2.CSCP Sensor_Disable\n",                          },
    {  3,   RBLE_CSCP_Sensor_Send_Measurements_Test,                NULL,                               "3.CSCP Sensor_Send_Measurements\n",                },
    {  4,   RBLE_CSCP_Sensor_Send_Sc_Control_Point_Test,            NULL,                               "4.CSCP Sensor_Send_Sc_Control_Point\n",            },
#endif
#ifdef  USE_CSCC_SAMPLE
    {  5,   RBLE_CSCP_Collector_Enable_Test,                        NULL,                               "5.CSCP Collector_Enable\n",                        },
    {  6,   RBLE_CSCP_Collector_Disable_Test,                       NULL,                               "6.CSCP Collector_Disable\n",                       },
    {  7,   RBLE_CSCP_Collector_Read_Char_Test,                     NULL,                               "7.CSCP Collector_Read_Char\n",                     },
    {  8,   RBLE_CSCP_Collector_Write_SC_Control_Point_Test,        NULL,                               "8.CSCP Collector_Write_Sc_Control_Point\n",        },
    {  9,   RBLE_CSCP_Collector_Write_Char_Test,                    NULL,                               "9.CSCP Collector_Write_Char\n",                    },
#endif
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  SELECT_MENU Test_Prog_CSCP_Select_Menu = {
    "\n-- BLE Sample Program Cycling Speed and Cadence Profile Test Menu --",
    Test_Prog_CSCP_Menu
};
#endif

/* ------------------------- Glucose Profile-------------------------------*/
#if defined(USE_GLPS_SAMPLE)|defined(USE_GLPC_SAMPLE)
static const MENU_INFO  Test_Prog_GLP_Menu[] = {
#ifdef  USE_GLPS_SAMPLE
    {  1,   RBLE_GLP_Sensor_Enable_Test,                            NULL,                               "1.GLP Sensor_Enable\n",                            },
    {  2,   RBLE_GLP_Sensor_Disable_Test,                           NULL,                               "2.GLP Sensor_Disable\n",                           },
    {  3,   RBLE_GLP_Sensor_Send_Measurements_Test,                 NULL,                               "3.GLP Sensor_Send_Measurements\n",                 },
    {  4,   RBLE_GLP_Sensor_Send_Measurements_Context_Test,         NULL,                               "4.GLP Sensor_Send_Measurements_Context\n",         },
    {  5,   RBLE_GLP_Sensor_Send_RA_Control_Point_Test,             NULL,                               "5.GLP Sensor_Send_Ra_Control_Point\n",             },
#endif
#ifdef  USE_GLPC_SAMPLE
    {  6,   RBLE_GLP_Collector_Enable_Test,                         NULL,                               "6.GLP Collector_Enable\n",                         },
    {  7,   RBLE_GLP_Collector_Disable_Test,                        NULL,                               "7.GLP Collector_Disable\n",                        },
    {  8,   RBLE_GLP_Collector_Read_Char_Test,                      NULL,                               "8.GLP Collector_Read_Char\n",                      },
    {  9,   RBLE_GLP_Collector_Write_RA_Control_Point_Test,         NULL,                               "9.GLP Collector_Write_Ra_Control_Point\n",         },
    { 10,   RBLE_GLP_Collector_Write_Char_Test,                     NULL,                               "10.GLP Collector_Write_Char\n",                    },
#endif
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  SELECT_MENU Test_Prog_GLP_Select_Menu = {
    "\n-- BLE Sample Program Glucose Profile Test Menu --",
    Test_Prog_GLP_Menu
};
#endif

/* ------------------------- Cycling Power Profeils-------------------------------*/
#if defined(USE_CPPS_SAMPLE)|defined(USE_CPPC_SAMPLE)
static const MENU_INFO  Test_Prog_CPP_Menu[] = {
#ifdef  USE_CPPS_SAMPLE
    {  1,   RBLE_CPP_Sensor_Enable_Test,                            NULL,                               "1.CPP Sensor_Enable\n",                            },
    {  2,   RBLE_CPP_Sensor_Disable_Test,                           NULL,                               "2.CPP Sensor_Disable\n",                           },
    {  3,   RBLE_CPP_Sensor_Send_Measurements_Test,                 NULL,                               "3.CPP Sensor_Send_Measurements\n",                 },
    {  4,   RBLE_CPP_Sensor_Broadcast_Measurements_Test,            NULL,                               "4.CPP Sensor_Broadcast_Measurements\n",            },
    {  5,   RBLE_CPP_Sensor_Send_Vector_Test,                       NULL,                               "5.CPP Sensor_Send_Vector\n",                       },
    {  6,   RBLE_CPP_Sensor_Send_CP_Control_Point_Test,             NULL,                               "6.CPP Sensor_Send_CP_Control_Point\n",             },
    {  7,   RBLE_CPP_Sensor_Send_Battery_Level_Test,                NULL,                               "7.CPP Sensor_Send_Battery_Level\n",                },
    {  8,   RBLE_CPP_Sensor_Send_Write_Response_Test,               NULL,                               "8.CPP Sensor_Send_Write_Response\n",               },
#endif
#ifdef  USE_CPPC_SAMPLE
    {  9,   RBLE_CPP_Collector_Enable_Test,                         NULL,                               "9.CPP Collector_Enable\n",                         },
    { 10,   RBLE_CPP_Collector_Disable_Test,                        NULL,                               "10.CPP Collector_Disable\n",                       },
    { 11,   RBLE_CPP_Collector_Read_Char_Test,                      NULL,                               "11.CPP Collector_Read_Char\n",                     },
    { 12,   RBLE_CPP_Collector_Write_CP_Control_Point_Test,         NULL,                               "12.CPP Collector_Write_CP_Control_Point\n",        },
    { 13,   RBLE_CPP_Collector_Write_Char_Test,                     NULL,                               "13.CPP Collector_Write_Char\n",                    },
#endif
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_CPP_Select_Menu = {
    "\n-- BLE Sample Program Cycling Power Profile Test Menu --",
    Test_Prog_CPP_Menu
};
#endif

/* ------------------------- Time Profile-----------------------------------*/
#if defined(USE_TIPS_SAMPLE)|defined(USE_TIPC_SAMPLE)
static const MENU_INFO  Test_Prog_TIP_Menu[] = {
#ifdef USE_TIPS_SAMPLE
    {  1,   RBLE_TIP_Server_Enable_Test,                        NULL,                                   "1.TIP Server_Enable\n",                            },
    {  2,   RBLE_TIP_Server_Disable_Test,                       NULL,                                   "2.TIP Server_Disable\n",                           },
    {  3,   RBLE_TIP_Server_Send_Current_Time_Test,             NULL,                                   "3.TIP Server_Send_Current_Time\n",                 },
    {  4,   RBLE_TIP_Server_Write_Data_Test,                    NULL,                                   "4.TIP Server_Write_Data\n",                        },
#endif
#ifdef USE_TIPC_SAMPLE
    {  5,   RBLE_TIP_Client_Enable_Test,                        NULL,                                   "5.TIP Client_Enable\n",                            },
    {  6,   RBLE_TIP_Client_Disable_Test,                       NULL,                                   "6.TIP Client_Disable\n",                           },
    {  7,   RBLE_TIP_Client_Read_Char_Test,                     NULL,                                   "7.TIP Client_Read_Char\n",                         },
    {  8,   RBLE_TIP_Client_Write_Char_Test,                    NULL,                                   "8.TIP Client_Write_Char\n",                        },
    {  9,   RBLE_TIP_Client_Write_Time_Update_CP_Test,          NULL,                                   "9.TIP Client_Write_Time_Update_CP\n",              },
#endif
    {  ESC_KEY, Menu_Exit,                                      NULL,                                   "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                               NULL,                                   NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_TIP_Select_Menu = {
    "\n-- BLE Sample Program Time Profile Test Menu --",
    Test_Prog_TIP_Menu
};
#endif

/* ------------------------- ANP Profile-----------------------------------*/
#if defined(USE_ANPS_SAMPLE)|defined(USE_ANPC_SAMPLE)
static const MENU_INFO  Test_Prog_ANP_Menu[] = {
#ifdef USE_ANPS_SAMPLE
    {  1,   RBLE_ANP_Server_Enable_Test,                        NULL,                                   "1.ANP Server_Enable\n",                            },
    {  2,   RBLE_ANP_Server_Disable_Test,                       NULL,                                   "2.ANP Server_Disable\n",                           },
    {  3,   RBLE_ANP_Server_Send_New_Alert_Test,                NULL,                                   "3.ANP Server_Send_New_Alert\n",                    },
    {  4,   RBLE_ANP_Server_Send_Unread_Alert_Test,             NULL,                                   "4.ANP Server_Send_Unread_Alert\n",                 },
#endif
#ifdef USE_ANPC_SAMPLE
    {  5,   RBLE_ANP_Client_Enable_Test,                        NULL,                                   "5.ANP Client_Enable\n",                            },
    {  6,   RBLE_ANP_Client_Disable_Test,                       NULL,                                   "6.ANP Client_Disable\n",                           },
    {  7,   RBLE_ANP_Client_Read_Char_Test,                     NULL,                                   "7.ANP Client_Read_Char\n",                         },
    {  8,   RBLE_ANP_Client_Write_Alert_Notification_CP_Test,   NULL,                                   "8.ANP Client_Write_Alert_Notification_CP\n",       },
    {  9,   RBLE_ANP_Client_Write_Char_Test,                    NULL,                                   "9.ANP Client_Write_Char\n",                        },
#endif
    {  ESC_KEY, Menu_Exit,                                      NULL,                                   "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                               NULL,                                   NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_ANP_Select_Menu = {
    "\n-- BLE Sample Program ANP Profile Test Menu --",
    Test_Prog_ANP_Menu
};
#endif

/* ------------------------- LNP Profile-----------------------------------*/
#if defined(USE_LNPS_SAMPLE)|defined(USE_LNPC_SAMPLE)
static const MENU_INFO  Test_Prog_LNP_Menu[] = {
#ifdef USE_LNPS_SAMPLE
    {  1,   RBLE_LNP_Sensor_Enable_Test,                        NULL,                                   "1.LNP Sensor_Enable\n",                            },
    {  2,   RBLE_LNP_Sensor_Disable_Test,                       NULL,                                   "2.LNP Sensor_Disable\n",                           },
    {  3,   RBLE_LNP_Sensor_Send_Location_Speed_Test,           NULL,                                   "3.LNP Sensor_Send_Location_Speed\n",               },
    {  4,   RBLE_LNP_Sensor_Set_Position_Quality_Test,          NULL,                                   "4.LNP Sensor_Set_Position_Quality\n",              },
    {  5,   RBLE_LNP_Sensor_Send_LN_Control_Point_Test,         NULL,                                   "5.LNP Sensor_Send_LN_Control_Point\n",             },
    {  6,   RBLE_LNP_Sensor_Send_Navigation_Test,               NULL,                                   "6.LNP Sensor_Send_Navigation\n",                   },
    {  7,   RBLE_LNP_Sensor_Send_Battery_Level_Test,            NULL,                                   "7.LNP Sensor_Send_Battery_Level\n",                },
#endif
#ifdef USE_LNPC_SAMPLE
    {  8,   RBLE_LNP_Collector_Enable_Test,                     NULL,                                   "8.LNP Collector_Enable\n",                         },
    {  9,   RBLE_LNP_Collector_Disable_Test,                    NULL,                                   "9.LNP Collector_Disable\n",                        },
    { 10,   RBLE_LNP_Collector_Read_Char_Test,                  NULL,                                   "10.LNP Collector_Read_Char\n",                     },
    { 11,   RBLE_LNP_Collector_Write_LN_Control_Point_Test,     NULL,                                   "11.LNP Collector_Write_LN_Control_Point\n",        },
    { 12,   RBLE_LNP_Collector_Write_Char_Test,                 NULL,                                   "12.LNP Collector_Write_Char\n",                    },
#endif
    {  ESC_KEY, Menu_Exit,                                      NULL,                                   "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                               NULL,                                   NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_LNP_Select_Menu = {
    "\n-- BLE Sample Program LNP Profile Test Menu --",
    Test_Prog_LNP_Menu
};
#endif

/* ------------------------- Phone Alert Status Profile-----------------------------------*/
#if defined(USE_PASPS_SAMPLE)|defined(USE_PASPC_SAMPLE)
static const MENU_INFO  Test_Prog_PASP_Menu[] = {
#ifdef USE_PASPS_SAMPLE
    {  1,   RBLE_PASP_Server_Enable_Test,                       NULL,                                   "1.PASP Server_Enable\n",                           },
    {  2,   RBLE_PASP_Server_Disable_Test,                      NULL,                                   "2.PASP Server_Disable\n",                          },
    {  3,   RBLE_PASP_Server_Send_Alert_Status_Test,            NULL,                                   "3.PASP Server_Send_Alert_Status\n",                },
    {  4,   RBLE_PASP_Server_Send_Ringer_Setting_Test,          NULL,                                   "4.PASP Server_Send_Ringer_Setting\n",              },
#endif
#ifdef USE_PASPC_SAMPLE 
    {  5,   RBLE_PASP_Client_Enable_Test,                       NULL,                                   "5.PASP Client_Enable\n",                           },
    {  6,   RBLE_PASP_Client_Disable_Test,                      NULL,                                   "6.PASP Client_Disable\n",                          },
    {  7,   RBLE_PASP_Client_Read_Char_Test,                    NULL,                                   "7.PASP Client_Read_Char\n",                        },
    {  8,   RBLE_PASP_Client_Write_Ringer_Control_Point_Test,   NULL,                                   "8.PASP Client_Write_Ringer_Control_Point\n",       },
    {  9,   RBLE_PASP_Client_Write_Char_Test,                   NULL,                                   "9.PASP Client_Write_Char\n",                       },
#endif
    {  ESC_KEY, Menu_Exit,                                      NULL,                                   "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                               NULL,                                   NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_PASP_Select_Menu = {
    "\n-- BLE Sample Program Phone Alert Status Profile Test Menu --",
    Test_Prog_PASP_Menu
};
#endif

/* ------------------------- Running Speed and Cadence Profile-----------------------------------*/
#if defined(USE_RSCPS_SAMPLE)|defined(USE_RSCPC_SAMPLE)
static const MENU_INFO  Test_Prog_RSCP_Menu[] = {
#ifdef USE_RSCPS_SAMPLE
    {  1,   RBLE_RSCP_Sensor_Enable_Test,                       NULL,                                   "1.RSCP Sensor_Enable\n",                           },
    {  2,   RBLE_RSCP_Sensor_Disable_Test,                      NULL,                                   "2.RSCP Sensor_Disable\n",                          },
    {  3,   RBLE_RSCP_Sensor_Send_Measurements_Test,            NULL,                                   "3.RSCP Sensor_Send_Measurements\n",                },
    {  4,   RBLE_RSCP_Sensor_Send_SC_Control_Point_Test,        NULL,                                   "4.RSCP Sensor_Send_SC_Control_Point\n",            },
#endif
#ifdef USE_RSCPC_SAMPLE
    {  5,   RBLE_RSCP_Collector_Enable_Test,                    NULL,                                   "5.RSCP Collector_Enable\n",                        },
    {  6,   RBLE_RSCP_Collector_Disable_Test,                   NULL,                                   "6.RSCP Collector_Disable\n",                       },
    {  7,   RBLE_RSCP_Collector_Read_Char_Test,                 NULL,                                   "7.RSCP Collector_Read_Char\n",                     },
    {  8,   RBLE_RSCP_Collector_Write_SC_Control_Point_Test,    NULL,                                   "8.RSCP Collector_Write_SC_Control_Point\n",        },
    {  9,   RBLE_RSCP_Collector_Write_Char_Test,                NULL,                                   "9.RSCP Collector_Write_Char\n",                    },
#endif
    {  ESC_KEY, Menu_Exit,                                      NULL,                                   "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                               NULL,                                   NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_RSCP_Select_Menu = {
    "\n-- BLE Sample Program Running Speed and Cadence Profile Test Menu --",
    Test_Prog_RSCP_Menu
};
#endif

/* ------------------------- HID over GATT Profile-------------------------------*/
#if defined(USE_HGHD_SAMPLE)|defined(USE_HGBH_SAMPLE)|defined(USE_HGRH_SAMPLE)
static MENU_INFO    Test_Prog_HOGP_Menu[] = {
#ifdef USE_HGHD_SAMPLE
    {  1,   RBLE_HGP_HDevice_Enable_Test,                           NULL,                               " 1.HGP_HDevice_Enable\n",                          },
    {  2,   RBLE_HGP_HDevice_Disable_Test,                          NULL,                               " 2.HGP_HDevice_Disable\n",                         },
    {  3,   RBLE_HGP_HDevice_Send_Report_Test,                      NULL,                               " 3.HGP_HDevice_Send_Report\n",                     },
    {  4,   RBLE_HGP_HDevice_Send_Battery_Level_Test,               NULL,                               " 4.HGP_HDevice_Send_Battery_Level\n",              },
#endif
#ifdef USE_HGBH_SAMPLE
    {  5,   RBLE_HGP_BHost_Enable_Test,                             NULL,                               " 5.HGP_BHost_Enable\n",                            },
    {  6,   RBLE_HGP_BHost_Disable_Test,                            NULL,                               " 6.HGP_BHost_Disable\n",                           },
    {  7,   RBLE_HGP_BHost_Read_Char_Test,                          NULL,                               " 7.HGP_BHost_Read_Char\n",                         },
    {  8,   RBLE_HGP_BHost_Read_By_UUID_Char_Test,                  NULL,                               " 8.HGP_BHost_Read_By_UUID_Char\n",                 },
    {  9,   RBLE_HGP_BHost_Write_Char_Test,                         NULL,                               " 9.HGP_BHost_Write_Char\n",                        },
    {  10,  RBLE_HGP_BHost_Set_Report_Test,                         NULL,                               "10.HGP_BHost_Set_Report\n",                        },
    {  11,  RBLE_HGP_BHost_Write_Protocol_Mode_Test,                NULL,                               "11.HGP_BHost_Write_Protocol_Mode\n",               },
    {  12,  RBLE_HGP_BHost_Data_Output_Test,                        NULL,                               "12.HGP_BHost_Data_Output\n",                       },
#endif
#ifdef USE_HGRH_SAMPLE
    {  13,  RBLE_HGP_RHost_Enable_Test,                             NULL,                               "13.HGP_RHost_Enable\n",                            },
    {  14,  RBLE_HGP_RHost_Disable_Test,                            NULL,                               "14.HGP_RHost_Disable\n",                           },
    {  15,  RBLE_HGP_RHost_Read_Char_Test,                          NULL,                               "15.HGP_RHost_Read_Char\n",                         },
    {  16,  RBLE_HGP_RHost_Read_By_UUID_Char_Test,                  NULL,                               "16.HGP_RHost_Read_By_UUID_Char\n",                 },
    {  17,  RBLE_HGP_RHost_Read_Long_Char_Test,                     NULL,                               "17.HGP_RHost_Read_Long_Char\n",                    },
    {  18,  RBLE_HGP_RHost_Write_Char_Test,                         NULL,                               "18.HGP_RHost_Write_Char\n",                        },
    {  19,  RBLE_HGP_RHost_Set_Report_Test,                         NULL,                               "19.HGP_RHost_Set_Report\n",                        },
    {  20,  RBLE_HGP_RHost_Write_Protocol_Mode_Test,                NULL,                               "20.HGP_RHost_Write_Protocol_Mode\n",               },
    {  21,  RBLE_HGP_RHost_Data_Output_Test,                        NULL,                               "21.HGP_RHost_Data_Output\n",                       },
    {  22,  RBLE_HGP_RHost_Write_Control_Point_Test,                NULL,                               "22.HGP_RHost_Write_Control_Point\n",               },
#endif
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  SELECT_MENU Test_Prog_HOGP_Select_Menu = {
    "\n-- BLE Sample Program HID over GATT Profile Test Menu --",
    Test_Prog_HOGP_Menu
};
#endif

/* ------------------------- Scan Parameters Profeils-------------------------------*/
#if defined(USE_SCPPS_SAMPLE)|defined(USE_SCPPC_SAMPLE)
static const MENU_INFO  Test_Prog_SCPP_Menu[] = {
#ifdef  USE_SCPPS_SAMPLE
    {  1,   RBLE_SPP_Server_Enable_Test,                            NULL,                               "1.SPP_Server_Enable\n",                            },
    {  2,   RBLE_SPP_Server_Disable_Test,                           NULL,                               "2.SPP_Server_Disabel\n",                           },
    {  3,   RBLE_SPP_Server_Send_Refresh_Test,                      NULL,                               "3.SPP_Server_Send_Refresh\n",                      },
#endif
#ifdef  USE_SCPPC_SAMPLE
    {  4,   RBLE_SPP_Client_Enable_Test,                            NULL,                               "4.SPP_Client_Enable\n",                            },
    {  5,   RBLE_SPP_Client_Disable_Test,                           NULL,                               "5.SPP_Client_Disable\n",                           },
    {  6,   RBLE_SPP_Client_Write_Char_Test,                        NULL,                               "6.SPP_Client_Write_Char\n",                        },
    {  7,   RBLE_SPP_Client_Write_Interval_Test,                    NULL,                               "7.SPP_Client_Write_Interval\n",                    },
#endif
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_SCPP_Select_Menu = {
    "\n-- BLE Sample Program Scan Parameters Profile Test Menu --",
    Test_Prog_SCPP_Menu
};
#endif

/* ------------------------- Sample Custom Profile-------------------------------*/
#if defined(USE_SCPS_SAMPLE)|defined(USE_SCPC_SAMPLE)
static const MENU_INFO  Test_Prog_SCP_Menu[] = {
#ifdef  USE_SCPS_SAMPLE
    {  1,   RBLE_SCP_Server_Enable_Test,                            NULL,                               "1.SCP Server_Enable\n",                            },
    {  2,   RBLE_SCP_Server_Disable_Test,                           NULL,                               "2.SCP Server_Disable\n",                           },
    {  3,   RBLE_SCP_Server_Send_Notify_Test,                       NULL,                               "3.SCP Server_Send_Notify\n",                       },
    {  4,   RBLE_SCP_Server_Send_Indicate_Test,                     NULL,                               "4.SCP Server_Send_Indicate\n",                     },
#endif
#ifdef  USE_SCPC_SAMPLE
    {  5,   RBLE_SCP_Client_Enable_Test,                            NULL,                               "5.SCP Client_Enable\n",                            },
    {  6,   RBLE_SCP_Client_Disable_Test,                           NULL,                               "6.SCP Client_Disable\n",                           },
    {  7,   RBLE_SCP_Client_Read_Char_Test,                         NULL,                               "7.SCP Client_Read_Char\n",                         },
    {  8,   RBLE_SCP_Client_Write_Char_Test,                        NULL,                               "8.SCP Client_Write_Char\n",                        },
#endif
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  SELECT_MENU Test_Prog_SCP_Select_Menu = {
    "\n-- BLE Sample Program Sample Custom Profile Test Menu --",
    Test_Prog_SCP_Menu
};
#endif

/* ------------------------- Vendor Specific-------------------------------*/
#ifdef USE_VS_SAMPLE
static const MENU_INFO  Test_Prog_VS_Menu[] = {
    {  1,   RBLE_VS_Enable_Test,                                    NULL,                               "1.VS Enable\n",                                    },
    {  2,   RBLE_VS_Test_Rx_Start_Test,                             NULL,                               "2.VS Test_Rx_Start\n",                             },
    {  3,   RBLE_VS_Test_Tx_Start_Test,                             NULL,                               "3.VS Test_Tx_Start\n",                             },
    {  4,   RBLE_VS_Test_End_Test,                                  NULL,                               "4.VS Test_End\n",                                  },
    {  5,   RBLE_VS_Test_Set_Parameter_Test,                        NULL,                               "5.VS Test_Set_Parameter\n",                        },
    {  6,   RBLE_VS_Test_Read_RSSI_Test,                            NULL,                               "6.VS Test_Read_RSSI\n",                            },
    {  7,   RBLE_VS_Write_BdAddress_Test,                           NULL,                               "7.VS Write BdAddress\n",                           },
    {  8,   RBLE_VS_Set_Tx_Power_Test,                              NULL,                               "8.VS Set_Tx_Power\n",                              },
    {  9,   RBLE_VS_GPIO_Dir_Test,                                  NULL,                               "9.VS GPIO Dir\n",                                  },
    {  10,  RBLE_VS_GPIO_Access_Test,                               NULL,                               "10.VS GPIO Access\n",                              },
    {  11,  RBLE_VS_Flash_Management_Test,                          NULL,                               "11.VS Flash_Management\n",                         },
    {  12,  RBLE_VS_Flash_Access_Test,                              NULL,                               "12.VS Flash_Access\n",                             },
    {  13,  RBLE_VS_Flash_Operation_Test,                           NULL,                               "13.VS Flash_Operation\n",                          },
    {  14,  RBLE_VS_Flash_Get_Space_Test,                           NULL,                               "14.VS Flash_Get_Space\n",                          },
    {  15,  RBLE_VS_Flash_Get_EEL_Ver_Test,                         NULL,                               "15.VS Flash_Get_EEL_Ver\n",                        },
    {  16,  RBLE_VS_Adapt_Enable_Test,                              NULL,                               "16.VS Adapt_Enable\n",                             },
    {  17,  RBLE_VS_Set_Params_Test,                                NULL,                               "17.VS Set_Params\n",                               },
    {  18,  RBLE_VS_RF_Control_Test,                                NULL,                               "18.VS RF_Control\n",                               },
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_VS_Select_Menu = {
    "\n-- BLE Sample Program Vendor Specific Test Menu --",
    Test_Prog_VS_Menu
};
#endif

/* ------------------------- Select Profile-------------------------------*/
static const MENU_INFO  Test_Prog_Profile_Menu[] = {
#if defined(USE_FMPT_SAMPLE)|defined(USE_FMPL_SAMPLE)
    {  1,   NULL,                                                   &Test_Prog_FMP_Select_Menu,         "1.Find Me Profile\n",                              },
#endif
#if defined(USE_HTPT_SAMPLE)|defined(USE_HTPC_SAMPLE)
    {  2,   NULL,                                                   &Test_Prog_HTP_Select_Menu,         "2.Health Thermometer Profile\n",                   },
#endif
#if defined(USE_PXPR_SAMPLE)|defined(USE_PXPM_SAMPLE)
    {  3,   NULL,                                                   &Test_Prog_PXP_Select_Menu,         "3.Proximity Profile\n",                            },
#endif
#if defined(USE_BLPS_SAMPLE)|defined(USE_BLPC_SAMPLE)
    {  4,   NULL,                                                   &Test_Prog_BLP_Select_Menu,         "4.Blood Pressure Profile\n",                       },
#endif
#if defined(USE_HGHD_SAMPLE)|defined(USE_HGBH_SAMPLE)|defined(USE_HGRH_SAMPLE)
    {  5,   NULL,                                                   &Test_Prog_HOGP_Select_Menu,        "5.HID over GATT Profile\n",                        },
#endif
#if defined(USE_SCPPS_SAMPLE)|defined(USE_SCPPC_SAMPLE)
    {  6,   NULL,                                                   &Test_Prog_SCPP_Select_Menu,        "6.Scan Parameters Profile\n",                      },
#endif
#if defined(USE_HRPS_SAMPLE)|defined(USE_HRPC_SAMPLE)
    {  7,   NULL,                                                   &Test_Prog_HRP_Select_Menu,         "7.Heart Rate Profile\n",                           },
#endif
#if defined(USE_CSCS_SAMPLE)|defined(USE_CSCC_SAMPLE)
    {  8,   NULL,                                                   &Test_Prog_CSCP_Select_Menu,        "8.Cycling Speed Profile\n",                        },
#endif
#if defined(USE_GLPS_SAMPLE)|defined(USE_GLPC_SAMPLE)
    {  9,   NULL,                                                   &Test_Prog_GLP_Select_Menu,         "9.Glucose Profile\n",                              },
#endif
#if defined(USE_CPPS_SAMPLE)|defined(USE_CPPC_SAMPLE)
    { 10,   NULL,                                                   &Test_Prog_CPP_Select_Menu,         "10.Cycling Power Profile\n",                       },
#endif
#if defined(USE_SCPS_SAMPLE)|defined(USE_SCPC_SAMPLE)
    { 11,   NULL,                                                   &Test_Prog_SCP_Select_Menu,         "11.Sample Custom Profile\n",                       },
#endif
#if defined(USE_TIPS_SAMPLE)|defined(USE_TIPC_SAMPLE)
    { 12,   NULL,                                                   &Test_Prog_TIP_Select_Menu,         "12.Time Profile\n",                                },
#endif
#if defined(USE_ANPS_SAMPLE)|defined(USE_ANPC_SAMPLE)
    { 13,   NULL,                                                   &Test_Prog_ANP_Select_Menu,         "13.Alert Notification Profile\n",                  },
#endif
#if defined(USE_LNPS_SAMPLE)|defined(USE_LNPC_SAMPLE)
    { 14,   NULL,                                                   &Test_Prog_LNP_Select_Menu,         "14.Location and Navigation Profile\n",             },
#endif
#if defined(USE_PASPS_SAMPLE)|defined(USE_PASPC_SAMPLE)
    { 15,   NULL,                                                   &Test_Prog_PASP_Select_Menu,        "15.Phone Alert Status Profile\n",                  },
#endif
#if defined(USE_RSCPS_SAMPLE)|defined(USE_RSCPC_SAMPLE)
    { 16,   NULL,                                                   &Test_Prog_RSCP_Select_Menu,        "16.Running Speed and Cadence Profile\n",           },
#endif
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_Profile_Select_Menu = {
    "\n-- BLE Sample Program Profile Test Menu --",
    Test_Prog_Profile_Menu
};

/* ------------------------- PTS TC Select -------------------------------*/
#ifdef USE_PTS_SAMPLE
static const MENU_INFO  Test_Prog_PTS_Menu[] = {
    { 1,    RBLE_PTS_L2CAP_Start,                                   NULL,                               "1.L2CAP Start\n",                                  },
    { 2,    RBLE_PTS_GAP_Start,                                     NULL,                               "2.GAP Start\n",                                    },
    { 3,    RBLE_PTS_SM_Start,                                      NULL,                               "3.SM Start\n",                                     },
    { 4,    RBLE_PTS_GATT_Start,                                    NULL,                               "4.GATT Start\n",                                   },
    { 5,    RBLE_PTS_FMP_Start,                                     NULL,                               "5.FMP Start\n",                                    },
    { 6,    RBLE_PTS_IAS_Start,                                     NULL,                               "6.IAS Start\n",                                    },
    { 7,    RBLE_PTS_PXP_Start,                                     NULL,                               "7.PXP Start\n",                                    },
    { 8,    RBLE_PTS_LLS_Start,                                     NULL,                               "8.LLS Start\n",                                    },
    { 9,    RBLE_PTS_TPS_Start,                                     NULL,                               "9.TPS Start\n",                                    },
    { 10,   RBLE_PTS_HTP_Start,                                     NULL,                               "10.HTP Start\n",                                   },
    { 11,   RBLE_PTS_HTS_Start,                                     NULL,                               "11.HTS Start\n",                                   },
    { 12,   RBLE_PTS_DIS_Start,                                     NULL,                               "12.DIS Start\n",                                   },
    { 13,   RBLE_PTS_BLP_Start,                                     NULL,                               "13.BLP Start\n",                                   },
    { 14,   RBLE_PTS_BLS_Start,                                     NULL,                               "14.BLS Start\n",                                   },
    { 15,   RBLE_PTS_HOGP_Start,                                    NULL,                               "15.HOGP Start\n",                                  },
    { 16,   RBLE_PTS_HIDS_Start,                                    NULL,                               "16.HIDS Start\n",                                  },
    { 17,   RBLE_PTS_BAS_Start,                                     NULL,                               "17.BAS Start\n",                                   },
    { 18,   RBLE_PTS_SCPP_Start,                                    NULL,                               "18.ScPP Start\n",                                  },
    { 19,   RBLE_PTS_SCPS_Start,                                    NULL,                               "19.ScPS Start\n",                                  },
    { 20,   RBLE_PTS_HRP_Start,                                     NULL,                               "20.HRP Start\n",                                   },
    { 21,   RBLE_PTS_HRP_Start,                                     NULL,                               "21.HRS Start\n",                                   },
    { 22,   RBLE_PTS_CSCP_Start,                                    NULL,                               "22.CSCP Start\n",                                  },
    { 23,   RBLE_PTS_CSCS_Start,                                    NULL,                               "23.CSCS Start\n",                                  },
    { 24,   RBLE_PTS_GLPS_Start,                                    NULL,                               "24.GLPS Start\n",                                  },
    { 25,   RBLE_PTS_TIPS_Start,                                    NULL,                               "25.TIPS Start\n",                                  },
    { 27,   RBLE_PTS_LNPS_Start,                                    NULL,                               "27.LNPS Start\n",                                  },
    { 28,   RBLE_PTS_LNPC_Start,                                    NULL,                               "28.LNPC Start\n",                                  },
    { 29,   RBLE_PTS_CPS_Start,                                     NULL,                               "29.CPS Start\n",                                   },
    { 30,   RBLE_PTS_CPP_Start,                                     NULL,                               "30.CPP Start\n",                                   },
    { 31,   RBLE_PTS_PASS_Start,                                    NULL,                               "31.PASS Start\n",                                  },
    { 32,   RBLE_PTS_RSCS_Start,                                    NULL,                               "32.RSCS Start\n",                                  },
    {  ESC_KEY, Menu_Exit,                                          NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_PTS_Select_Menu = {
    "\n-- BLE Sample Program PTS Test Case Select Menu --",
    Test_Prog_PTS_Menu
};
#endif

static const MENU_INFO  Test_Prog_Menu[] = {
    {  1,   NULL,                                                   &Test_Prog_GAP_SM_GATT_Select_Menu, "1.GAP & SM & GATT Test\n",                         },
    {  2,   NULL,                                                   &Test_Prog_Profile_Select_Menu,     "2.Profile Test\n",                                 },
#ifdef USE_VS_SAMPLE
    {  3,   NULL,                                                   &Test_Prog_VS_Select_Menu,          "3.Vendor Specific Test\n",                         },
#endif
#ifdef USE_PTS_SAMPLE
    {  4,   NULL,                                                   &Test_Prog_PTS_Select_Menu,         "4.PTS Test Case Select\n",                         },
#endif
#if defined(USE_FW_UPDATE_PROFILE)&&defined(WIN32)
    {  5,   RBLE_FW_UPDATE_Test,                                    NULL,                               "5.FW Update Start\n",                              },
#endif
    {  ESC_KEY, RBLE_APP_Exit,                                      NULL,                               "ESC Key: Menu exit\n",                             },
    {  0,   NULL,                                                   NULL,                               NULL,                                               }
};

static  const SELECT_MENU   Test_Prog_Select_Menu = {
    "\n-- BLE Sample Program Menu Version 1.00.000 --",
    Test_Prog_Menu
};

/******************************* Program Area *****************************************/

#ifdef USE_CUSTOM_DEMO
static void send_data( void )
{
    RBLE_STATUS    Ret_Status;
    static uint8_t notify_count = 0;
    static uint8_t indicate_count = 0;
    
    RBLE_SCP_NOTIFY_INFO    notify_info = {
        0x05,   /* length */
        {0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,0x11,0x12,0x13}   /* data */
    };
    RBLE_SCP_IND_INFO   ind_info = {
        0x05,   /* length */
        {0x00,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,0x90,0x91,0x92,0x93}   /* data */
    };
    
    /* indicate/notify */
    if (scp_sample_info.Notify_en == TRUE) {
        notify_info.data_len = scp_sample_info.Notify_len;
        notify_info.data[0]  = notify_count;
        Ret_Status = RBLE_SCP_Server_Send_Notify( Connection_Handle, &notify_info );
        if(scp_sample_info.Timer_interval != 0) {
            printf( "Send Notify");
            RBLE_Status_Disp( Ret_Status );
        }
        notify_count++;
    }
    if (scp_sample_info.Indicate_en == TRUE) {
        ind_info.data_len = scp_sample_info.Indicate_len;
        ind_info.data[0]  = indicate_count;
        Ret_Status = RBLE_SCP_Server_Send_Indicate( Connection_Handle, &ind_info );
        if(scp_sample_info.Timer_interval != 0) {
            printf( "Send Indicate");
            RBLE_Status_Disp( Ret_Status );
        }
        indicate_count++;
    }
}

static void timer_int( void )
{
    send_data();
    
    if (scp_sample_info.Timer_en == TRUE) {
        if(scp_sample_info.Timer_interval != 0) {
            Console_Set_Timer(scp_sample_info.Timer_interval);
        }
        else {
            Console_Send_msg();
        }
    }
}

static void sw_int( void )
{
    if (scp_sample_info.Timer_en == TRUE) {
        scp_sample_info.Timer_en = FALSE;
    }
    else {
        scp_sample_info.Timer_en = TRUE;
        Console_Send_Timer_msg(&timer_int);
    }
}
#endif
/**************************************************************************************/
/**
 *  @brief rBLE  APP Initialize
 *
 *  
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *RemoteBdAddr_Str_Top        The string of Bluetooth Address of Remote Device
 *
 *  @retval
 */
/******************************************************************************************/
BOOL RBLE_App_Init( void )
{
    BOOL        Ret;
    RBLE_STATUS Ret_Status;

    Ret = Menu_Select_Init();
    if ( TRUE == Ret ) {
        Add_White_List_Dev_info.dev_addr_type = RBLE_ADDR_PUBLIC;
        Add_White_List_Dev_info.dev_addr = Remote_Device;
#ifdef USE_PTS_SAMPLE
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );
#endif
        /* Initialize rBLE */
        Ret_Status = RBLE_Init(&RBLE_APP_CallBack);
        if ( RBLE_OK != Ret_Status ) {
            Ret = FALSE;
            if ( RBLE_ERR == Ret_Status ) {
                printf( "COM Port error\n" );
            }
        }
#ifdef USE_CUSTOM_DEMO
//        push_sw2_start( &sw_int );
#endif
    }
    return( Ret );
}

/******************************************************************************************/
/**
 *  @brief rBLE  Application Test Start
 *
 *  
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval
 */
/******************************************************************************************/
void RBLE_App_Test_Start( void )
{
    Menu_Select( &Test_Prog_Select_Menu );
}

/******************************************************************************************/
/**
 *  @brief rBLE  Application Test Exit
 *
 *  
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval FALSE     Menu Exit
 */
/******************************************************************************************/
static BOOL RBLE_APP_Exit( void )
{
    Menu_Select_Terminate();
    Exit_Flg = TRUE;
    return( FALSE );
}


/********************  Call Back API ********************/

/******************************************************************************************/
/**
 *  @brief rBLE APP Call Back
 *
 *  
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] mode      RBLE Condition
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_CallBack( RBLE_MODE mode )
{
    switch(mode){
        case RBLE_MODE_INITIALIZE:
            break;
        case RBLE_MODE_ACTIVE:
            RBLE_App_Test_Start();
            // mfr RBLE_App_Test_Start();
            // reset GAP
            RBLE_GAP_Reset_Test();
            break;
        case RBLE_MODE_RESET:
            Menu_Select_Terminate();
            break;
        case RBLE_MODE_SLEEP:
            break;
        case RBLE_MODE_ERROR:
            RBLE_APP_Exit();
            break;
        default:
            break;
    }
    Console_SetTextAttribute( EVENT_COLOR );
    switch(mode){
        case RBLE_MODE_INITIALIZE:
            printf( "rBLE Mode (INITALIZE)\n" );
            break;
        case RBLE_MODE_ACTIVE:
            printf( "rBLE Mode (ACTIVE)\n" );
#ifdef USE_CUSTOM_DEMO
            /* GAP Reset */
            RBLE_GAP_Reset_Test();
#endif
            break;
        case RBLE_MODE_RESET:
            printf( "rBLE Mode (MODE RESET)\n" );
            break;
        case RBLE_MODE_SLEEP:
            printf( "rBLE Mode (SLEEP)\n" );
            break;
        case RBLE_MODE_ERROR:
            printf( "rBLE Mode (ERROR)\n" );
            break;
        default:
            break;
    }
    Prompt_Disp();
}

/******************************************************************************************/
/**
 *  @brief rBLE GAP Event and Status Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void GAP_Event_Status_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE GAP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}
/******************************************************************************************/
/**
 *  @brief rBLE GAP Event Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void GAP_Event_Disp(char_t *event_str)
{
    printf( "\nrBLE GAP EVENT (%s)\n", event_str );
}

/******************************************************************************************/
/**
 *  @brief rBLE GAP Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_GAP_CallBack( RBLE_GAP_EVENT *event )
{
    RBLE_ADV_REPORT     *Adv_Rep_p;
    RBLE_BD_NAME        *Bd_Name_p;
    RBLE_CONNECT_INFO   *Con_Info_p;

    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type ) {
        case RBLE_GAP_EVENT_RESET_RESULT:
            GAP_Event_Status_Disp( "RESET RESULT", event->param.reset_result.status);
            printf( "rBLE Version = Major(%02X),Minor(%02X)\n", event->param.reset_result.rBLE_major_ver, event->param.reset_result.rBLE_minor_ver );
            if ( RBLE_MAJOR_VERSION != event->param.reset_result.rBLE_major_ver ) {
                printf( "Warning:Please confirm a version.\n" );
            }
#ifdef USE_CUSTOM_DEMO
            // mfr - set peripheral name
            RBLE_GAP_Set_Name_Test();
#endif
            break;
        case RBLE_GAP_EVENT_SET_NAME_COMP:
            GAP_Event_Status_Disp( "SET_NAME_COMP", event->param.status);
#ifdef USE_CUSTOM_DEMO
            // start advertising after name set
            RBLE_GAP_Broadcast_Enable_Test();
#endif
            break;
        case RBLE_GAP_EVENT_OBSERVATION_ENABLE_COMP:
            GAP_Event_Status_Disp( "OBSERVATION_ENABLE_COMP", event->param.status);
            break;
        case RBLE_GAP_EVENT_OBSERVATION_DISABLE_COMP:
            GAP_Event_Status_Disp( "OBSERVATION_DISABLE_COMP", event->param.status );
            break;
        case RBLE_GAP_EVENT_BROADCAST_ENABLE_COMP:
            GAP_Event_Status_Disp( "BROADCAST_ENABLE_COMP", event->param.status);
            if ( RBLE_OK == event->param.status ) {
                Adv_Flag = TRUE;
            }
            break;
        case RBLE_GAP_EVENT_BROADCAST_DISABLE_COMP:
            GAP_Event_Status_Disp( "BROADCAST_DISABLE_COMP", event->param.status);
            if ( RBLE_OK == event->param.status ) {
                Adv_Flag = FALSE;
            }
            break;
        case RBLE_GAP_EVENT_SET_BONDING_MODE_COMP:
            GAP_Event_Status_Disp( "SET_BONDING_MODE_COMP", event->param.status);
            break;
        case RBLE_GAP_EVENT_SET_SECURITY_REQUEST_COMP:
            printf( "\nrBLE GAP EVENT (SET_SECURITY_REQUEST_COMP) Status(%s), SEC(%d)\n", Get_Status_Str( event->param.set_sec_req.status ), event->param.set_sec_req.sec );
            break;
        case RBLE_GAP_EVENT_GET_DEVICE_INFO_COMP:
            GAP_Event_Status_Disp( "GET_DEVICE_INFO_COMP", event->param.get_dev_ver.status);
            BdAddress_Disp( &event->param.get_dev_ver.addr );
            printf( "HCI  Version(0x%02x), HCI  SubVersion(0x%04x)\n", event->param.get_dev_ver.ver_info.hci_ver, event->param.get_dev_ver.ver_info.hci_subver );
            printf( "LMP  Version(0x%02x), LMP  SubVersion(0x%04x)\n", event->param.get_dev_ver.ver_info.lmp_ver, event->param.get_dev_ver.ver_info.lmp_subver );
            printf( "HOST Version(0x%02x), HOST SubVersion(0x%04x)\n", event->param.get_dev_ver.ver_info.host_ver, event->param.get_dev_ver.ver_info.host_subver );
            printf( "Manufacture Name(0x%x)\n", event->param.get_dev_ver.ver_info.company_id );
            break;
        case RBLE_GAP_EVENT_RPA_RESOLVED:
            GAP_Event_Disp("RPA_RESOLVED");
            printf( "Resolved: Type(%s), ", ((event->param.rpa_resolved.res_addr_type == RBLE_ADDR_RAND) ? "Random" : "Public") );
            BdAddress_Disp( &event->param.rpa_resolved.res_addr );
            printf( "Original: Type(%s), ", ((event->param.rpa_resolved.addr_type == RBLE_ADDR_RAND) ? "Random" : "Public") );
            BdAddress_Disp( &event->param.rpa_resolved.addr );
            break;
        case RBLE_GAP_EVENT_GET_WHITE_LIST_SIZE_COMP:
            printf( "\nrBLE GAP EVENT (GET_WHITE_LIST_SIZE_COMP) Status(%s), Size(%d)\n", Get_Status_Str( event->param.get_wlst_size.status ), event->param.get_wlst_size.wlist_size );
            break;
        case RBLE_GAP_EVENT_ADD_TO_WHITE_LIST_COMP:
            if ( RBLE_OK != event->param.status ) {
                Add_White_List_Dev_info.dev_addr.addr[ 0 ]--;
            }
            GAP_Event_Status_Disp( "ADD_TO_WHITE_LIST_COMP", event->param.status);
            break;
        case RBLE_GAP_EVENT_DEL_FROM_WHITE_LIST_COMP:
            if ( RBLE_OK != event->param.status ) {
                Add_White_List_Dev_info.dev_addr.addr[ 0 ]++;
            }
            GAP_Event_Status_Disp( "DEL_FROM_WHITE_LIST_COMP", event->param.status);
            break;
        case RBLE_GAP_EVENT_GET_REMOTE_DEVICE_NAME_COMP:
            GAP_Event_Disp("GET_REMOTE_DEVICE_NAME_COMP");
            Bd_Name_p = &event->param.get_remote_dev_name.bd_name;
            Bd_Name_p->name[ Bd_Name_p->namelen ] = '\0';
            printf( "Device Name = %s\n", Bd_Name_p->name );
            break;
        case RBLE_GAP_EVENT_GET_REMOTE_DEVICE_INFO_COMP:
            GAP_Event_Status_Disp( "GET_REMOTE_DEVICE_INFO_COMP", event->param.get_remote_dev_info.status);
            Connection_Handle_Disp( event->param.get_remote_dev_info.conhdl );
            printf( "LMP Version = 0x%04x\n", event->param.get_remote_dev_info.vers );
            printf( "LMP Sub Version = 0x%04x\n", event->param.get_remote_dev_info.subvers );
            printf( "Manufacturer = 0x%04x\n", event->param.get_remote_dev_info.compid );
            printf( "Features[%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x]\n", event->param.get_remote_dev_info.feats_used.feats[ 0 ], event->param.get_remote_dev_info.feats_used.feats[ 1 ], 
                                                                                    event->param.get_remote_dev_info.feats_used.feats[ 2 ], event->param.get_remote_dev_info.feats_used.feats[ 3 ], 
                                                                                    event->param.get_remote_dev_info.feats_used.feats[ 4 ], event->param.get_remote_dev_info.feats_used.feats[ 5 ], 
                                                                                    event->param.get_remote_dev_info.feats_used.feats[ 6 ], event->param.get_remote_dev_info.feats_used.feats[ 7 ] );
            break;
        case RBLE_GAP_EVENT_DEVICE_SEARCH_COMP:
            GAP_Event_Disp("DEVICE_SEARCH_COMP");
            break;
        case RBLE_GAP_EVENT_DEVICE_SEARCH_RESULT_IND:
            GAP_Event_Disp("DEVICE_SEARCH_RESULT_IND");
            Adv_Rep_p = &event->param.dev_search_result.adv_resp;
            Peer_Addr_Type = Adv_Rep_p->adv_addr_type;
            AdvRepot_Disp( Adv_Rep_p );
            /* The last device is saved. */
            Remote_Device = Adv_Rep_p->adv_addr;

            Add_White_List_Dev_info.dev_addr_type = Peer_Addr_Type;
            Add_White_List_Dev_info.dev_addr = Remote_Device;
            break;
        case RBLE_GAP_EVENT_SET_RANDOM_ADDRESS_COMP:
            GAP_Event_Status_Disp( "SET_RANDOM_ADDRESS_COMP", event->param.set_rand_adr.status);
            BdAddress_Disp( &event->param.set_rand_adr.addr );

            Add_White_List_Dev_info.dev_addr_type = RBLE_ADDR_RAND;
            Add_White_List_Dev_info.dev_addr = event->param.set_rand_adr.addr;

            break;
        case RBLE_GAP_EVENT_SET_PRIVACY_FEATURE_COMP:
            GAP_Event_Status_Disp( "SET_PRIVACY_FEATURE_COMP", event->param.status);
            break;
        case RBLE_GAP_EVENT_CONNECTION_COMP:
            GAP_Event_Status_Disp( "CONNECTION_COMP", event->param.conn_comp.connect_info.status);
            Con_Info_p = &event->param.conn_comp.connect_info;
#ifdef USE_PTS_SAMPLE
            if(Pts_Flg.CPP_Con_2nd == FALSE) {
                Connection_Handle = Con_Info_p->conhdl;
            }
            else {
                Connection_Handle_2nd = Con_Info_p->conhdl;
            }
#else
            Connection_Handle = Con_Info_p->conhdl;
#endif
            printf( "Connection Handle = %d,  ", Con_Info_p->conhdl );

            BdAddress_Disp( &Con_Info_p->peer_addr );
            Role_Status = RBLE_MASTER;
            if ( RBLE_OK == event->param.conn_comp.connect_info.status ) {
                if ( TRUE == Adv_Flag ) {
                    Role_Status = RBLE_SLAVE;
                }
            }
            Adv_Flag = FALSE;

#ifdef USE_PTS_SAMPLE
            if( Pts_Flg.CPP_Con_2nd == FALSE ) {
                Remote_Device = Con_Info_p->peer_addr;
            }
            else {
                Remote_Device_2nd = Con_Info_p->peer_addr;
            }
#else
            Remote_Device = Con_Info_p->peer_addr;
#endif
            Peer_Addr_Type = Con_Info_p->peer_addr_type;

#ifdef USE_CUSTOM_DEMO
            RBLE_SCP_Server_Enable_Test();
#endif
#ifdef USE_PTS_SAMPLE
            if ( TRUE == Pts_Flg.ChangeParam ) {
                Pts_Flg.ChangeParam = FALSE;
                RBLE_GAP_Change_Connection_Param_Test();
            }
            if ( TRUE == Pts_Flg.FMPT_Enable ) {
                Pts_Flg.FMPT_Enable = FALSE;
#ifdef  USE_FMPT_SAMPLE
                RBLE_FMP_Target_Enable_Test();
#endif
            }
            if ( TRUE == Pts_Flg.PXPR_Enable ) {
                Pts_Flg.PXPR_Enable = FALSE;
#ifdef  USE_PXPR_SAMPLE
                RBLE_PXP_Reporter_Enable_Test();
#endif
            }
            if ( TRUE == Pts_Flg.HTPT_Enable ) {
                Pts_Flg.HTPT_Enable = FALSE;
                if ( TRUE == Pts_Flg.Gap_Sec_Test ) {
                    RBLE_Parameter_Cnt = 1;
                    RBLE_Parameter_Arg[ 0 ] = 1;
                    if ( TRUE == Pts_Flg.Seq_Enc_Req ) {
                        RBLE_HTP_Therm_Enable_Param[ 1 ].sec_lvl = RBLE_SVC_SEC_ENC;
                    } else {
                        RBLE_HTP_Therm_Enable_Param[ 1 ].sec_lvl = RBLE_SVC_SEC_AUTH;
                    }
                    Pts_Flg.Gap_Sec_Test = FALSE;
                    Pts_Flg.Seq_Enc_Req = FALSE;
                }
#ifdef  USE_HTPT_SAMPLE
                RBLE_HTP_Thermometer_Enable_Test();
#endif
            }
            if ( TRUE == Pts_Flg.BLPS_Enable ) {
                Pts_Flg.BLPS_Enable = FALSE;
#ifdef  USE_BLPS_SAMPLE
                RBLE_BLP_Sensor_Enable_Test();
#endif
            }
            if ( TRUE == Pts_Flg.HOGPD_Enable ) {
                Pts_Flg.HOGPD_Enable = FALSE;
#ifdef  USE_HGHD_SAMPLE
                RBLE_HGP_HDevice_Enable_Test();
#endif
            }
            if ( TRUE == Pts_Flg.SCPP_Enable ) {
                Pts_Flg.SCPP_Enable = FALSE;
#ifdef  USE_SCPPS_SAMPLE
                RBLE_SPP_Server_Enable_Test();
#endif
            }
            if ( TRUE == Pts_Flg.HRPS_Enable ) {
                Pts_Flg.HRPS_Enable = FALSE;
#ifdef  USE_HRPS_SAMPLE
                RBLE_HRP_Sensor_Enable_Test();
#endif
            }
            if ( TRUE == Pts_Flg.CSCPS_Enable ) {
                Pts_Flg.CSCPS_Enable = FALSE;
#ifdef  USE_CSCS_SAMPLE
                RBLE_CSCP_Sensor_Enable_Test();
#endif
            }
            if ( TRUE == Pts_Flg.CSCP_LinkLoss ) {
#ifdef  USE_CSCC_SAMPLE
                RBLE_CSCP_Collector_Enable_Test();
#endif
            }
#ifdef  USE_GLPS_SAMPLE
            if( TRUE == Pts_Flg.GLPS_Enable) {
                RBLE_GLP_Sensor_Enable_Test();
            }
#endif
#ifdef  USE_TIPS_SAMPLE
            if( TRUE == Pts_Flg.TIPS_Enable) {
                Pts_Flg.TIPS_Enable = FALSE;
                RBLE_TIP_Server_Enable_Test();
            }
#endif
#ifdef  USE_LNPS_SAMPLE
            if( TRUE == Pts_Flg.LNPS_Enable) {
                Pts_Flg.LNPS_Enable = FALSE;
                RBLE_LNP_Sensor_Enable_Test();
            }
#endif
#ifdef  USE_CPPS_SAMPLE
            if( TRUE == Pts_Flg.CPS_Enable) {
                Pts_Flg.CPS_Enable = FALSE;
                RBLE_CPP_Sensor_Enable_Test();
            }
#endif
#ifdef  USE_CPPC_SAMPLE
            if( TRUE == Pts_Flg.CPP_Enable) {
                Pts_Flg.CPP_Enable = FALSE;
                
                RBLE_Parameter_Cnt = 2;
                RBLE_Parameter_Arg[ 0 ] = RBLE_PRF_CON_NORMAL;
                
                if(Pts_Flg.CPP_Con_2nd == FALSE) {
                    RBLE_Parameter_Arg[ 1 ] = 0;
                }
                else {
                    RBLE_Parameter_Arg[ 1 ] = 1;
                }
                RBLE_CPP_Collector_Enable_Test();
            }
#endif
#ifdef  USE_PASPS_SAMPLE
            if( TRUE == Pts_Flg.PASPS_Enable) {
//              Pts_Flg.PASPS_Enable = FALSE;
                RBLE_Parameter_Cnt = 1;
                RBLE_Parameter_Arg[ 0 ] = RBLE_PRF_CON_NORMAL;
                RBLE_PASP_Server_Enable_Test();
            }
#endif
#ifdef  USE_RSCPS_SAMPLE
            if( TRUE == Pts_Flg.RSCPS_Enable) {
//              Pts_Flg.RSCPS_Enable = FALSE;
                RBLE_Parameter_Cnt = 1;
                RBLE_Parameter_Arg[ 0 ] = RBLE_PRF_CON_NORMAL;
                RBLE_RSCP_Sensor_Enable_Test();
            }
#endif
#endif
            break;
        case RBLE_GAP_EVENT_CONNECTION_CANCEL_COMP:
            GAP_Event_Status_Disp( "CONNECTION_CANCEL_COMP", event->param.status);
            break;
        case RBLE_GAP_EVENT_DISCONNECT_COMP:
            GAP_Event_Status_Disp( "DISCONNECT_COMP", event->param.disconnect.status);
            printf( "reason = %s\n", Get_Status_Str( event->param.disconnect.reason ) );
#ifdef USE_CUSTOM_DEMO
            RBLE_SCP_Server_Disable_Test();
#endif
            break;
        case RBLE_GAP_EVENT_ADVERTISING_REPORT_IND:
#ifdef  USE_CPPC_SAMPLE
            if( TRUE == Pts_Flg.CPP_RcvAdv) {
                CPP_Broadcast_Rcv(&event->param.adv_report.evt.adv_rep );
                return;
            } else {
#endif
            GAP_Event_Disp("DEVICE_SEARCH_RESULT_IND");
            AdvRepot_Disp( &event->param.adv_report.evt.adv_rep );
#ifdef  USE_CPPC_SAMPLE
            }
#endif
            break;
        case RBLE_GAP_EVENT_BONDING_COMP:
            GAP_Event_Status_Disp( "BONDING_COMP", event->param.bonding_comp.status);
            Connection_Idx = event->param.bonding_comp.idx;
            Bonding_Flg = FALSE;
            break;
        case RBLE_GAP_EVENT_BONDING_REQ_IND:
            GAP_Event_Disp("BONDING_REQ_IND");
            BdAddress_Disp( &event->param.bonding_req.bd_addr );
            Bonding_Flg = TRUE;
            break;
        case RBLE_GAP_EVENT_CHANGE_CONNECTION_PARAM_REQ_IND:
            GAP_Event_Disp("CHANGE_CONNECTION_PARAM_REQ_IND");
#ifdef USE_PTS_SAMPLE
            if ( TRUE == Pts_Flg.ChangeParamResp ) {
                uint16_t result = 0x0000;
                if ( 500 < event->param.chg_connect_param_req.conn_param.latency ) {
                    result = 0x0001;
                }
                RBLE_GAP_Change_Connection_Param(event->param.chg_connect_param_req.conhdl, result, &event->param.chg_connect_param_req.conn_param, Role_Status);
                Pts_Flg.ChangeParamResp = FALSE;
            }
#endif
            break;
        case RBLE_GAP_EVENT_CHANGE_CONNECTION_PARAM_COMP:
            GAP_Event_Status_Disp( "CHANGE_CONNECTION_PARAM_COMP", event->param.chg_connect_param.status);
            break;
        case RBLE_GAP_EVENT_CHANGE_CONNECTION_PARAM_RESPONSE:
            GAP_Event_Status_Disp( "CHANGE_CONNECTION_PARAM_RESPONSE", event->param.chg_connect_param_resp.status);
            break;
        case RBLE_GAP_EVENT_CHANNEL_MAP_REQ_COMP:
            GAP_Event_Disp("CHANNEL_MAP_REQ_COMP");
            break;
        case RBLE_GAP_EVENT_READ_RSSI_COMP:
            GAP_Event_Status_Disp( "RBLE_GAP_EVENT_READ_RSSI_COMP", event->param.read_rssi.status);
            printf( "RSSI = %d(dBm)\n", (int8_t)(event->param.read_rssi.rssi) );
            break;
        case RBLE_GAP_EVENT_WR_CHAR_IND:
            printf( "\nrBLE GAP EVENT (RBLE_GAP_EVENT_WR_CHAR_IND) conhdl(0x%04X)\n", event->param.wr_char.conhdl );
            if (RBLE_GAP_WR_CHAR_NAME == event->param.wr_char.type) {
                printf( "Name = %s\n", event->param.wr_char.param.name.name );
            } else {
                printf( "Appearance = 0x%04X\n",  event->param.wr_char.param.appearance );
            }
            break;
        case RBLE_GAP_EVENT_COMMAND_DISALLOWED_IND:
            GAP_Event_Status_Disp( "COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            printf( "rBLE App Gap Receive 0x%x\n", event->type );
            break;
    }
    Prompt_Disp();
}

/******************************************************************************************/
/**
 *  @brief A GAP_Reset command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Reset_Test( void )
{

    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_GAP_Reset( &RBLE_APP_GAP_CallBack, &RBLE_APP_SM_CallBack );
    
    Connection_Handle = ILLEGAL_CONNECTION_HANDLE;
    
    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Set_Name command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Set_Name_Test( void )
{
    static RBLE_BD_NAME bd_name_param = {
        sizeof( "rBLE Test Device" ),   /*length for name */
        "rBLE Test Device"              /* array of bytes for name */
    };
    
    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_GAP_Set_Name( &bd_name_param );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Observation_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Observation_Enable_Test( void )
{
    static RBLE_OBSERVATION_ENABLE_PARAM    Param;
    RBLE_OBSERVATION_ENABLE_PARAM           *Parameter_p;
    int32_t                                 Parameter_No;
    RBLE_STATUS                             Ret_Status;

    Parameter_p = &Param;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }
    if ( ( ILLEGAL_NO == Parameter_No )
        || ( ( sizeof( RBLE_Observation_Enable_Param ) / sizeof( RBLE_OBSERVATION_ENABLE_PARAM ) ) <= Parameter_No ) ) {
        *Parameter_p = RBLE_Observation_Enable_Param[ 0 ];
        Select_Param_No_Disp( 0 );
    } else {
        *Parameter_p = RBLE_Observation_Enable_Param[ Parameter_No ];
        Select_Param_No_Disp( Parameter_No );
    }
    Parameter_p->scan_info.set_scan.own_addr_type = Own_Addr_Type;

    /* API Call */
    Ret_Status = RBLE_GAP_Observation_Enable( Parameter_p->mode, &Parameter_p->scan_info );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Observation_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Observation_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_GAP_Observation_Disable();

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Broadcast_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Broadcast_Enable_Test( void )
{
    static RBLE_BROADCAST_ENABLE_PARAM      Param;
    RBLE_STATUS                     Ret_Status;
    RBLE_BROADCAST_ENABLE_PARAM     *Parameter_p;
    int32_t                         Parameter_No;

    Parameter_p = &Param;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }

    if ( ( ILLEGAL_NO == Parameter_No )
        || ( ( sizeof( RBLE_Broadcast_Enable_Param ) / sizeof( RBLE_BROADCAST_ENABLE_PARAM ) ) <= Parameter_No ) ) {
        *Parameter_p = RBLE_Broadcast_Enable_Param[ 0 ];
        Select_Param_No_Disp( 0 );
    } else {
        *Parameter_p = RBLE_Broadcast_Enable_Param[ Parameter_No ];
        Select_Param_No_Disp( Parameter_No );
        switch( Parameter_No ) {
#ifdef USE_CPPS_SAMPLE
            case 2: /* Broadcaster */
                if (RBLE_Parameter_Cnt >= 2) {
                    Parameter_p->adv_info.adv_param.adv_type = RBLE_GAP_ADV_NONCONN_UNDIR;
                    Parameter_p->adv_info.adv_param.adv_intv_min = 0x640;       /* AdvIntervalMin ( 1000msec = 0x640 * 0.625msec ) Range:0x0020-0x4000 */
                    Parameter_p->adv_info.adv_param.adv_intv_max = 0x640;       /* AdvIntervalMax ( 1000msec = 0x640 * 0.625msec ) Range:0x0020-0x4000 */
                    Parameter_p->adv_info.adv_data.adv_data_len = 3+4+4+9;  /* ADV Data Length */

                    /* AD Structure: Advertising Interval */
                    Parameter_p->adv_info.adv_data.adv_data.data[3] = 3;        /* Length of this AD Structure */
                    Parameter_p->adv_info.adv_data.adv_data.data[4] = 0x1A;     /* AD Type: Advertising Interval */
                    Parameter_p->adv_info.adv_data.adv_data.data[5] = (uint8_t) (0x640 & 0x00FF);       /* advInterval value (Units: 0.625 msec) */
                    Parameter_p->adv_info.adv_data.adv_data.data[6] = (uint8_t)((0x640 & 0xFF00) >> 8); /* advInterval value (Units: 0.625 msec) */
                    /* AD Structure: Complete List of 16bit UUID */
                    Parameter_p->adv_info.adv_data.adv_data.data[7]  = 3;       /* Length of this AD Structure */
                    Parameter_p->adv_info.adv_data.adv_data.data[8]  = 0x03;    /* AD Type: Complete List of 16bit UUID */
                    Parameter_p->adv_info.adv_data.adv_data.data[9]  = (uint8_t) (RBLE_SVC_CYCLING_POWER & 0x00FF);         /* Service UUID: Cycling Power */
                    Parameter_p->adv_info.adv_data.adv_data.data[10] = (uint8_t)((RBLE_SVC_CYCLING_POWER & 0xFF00) >> 8);   /* Service UUID: Cycling Power */
                    /* AD Structure: Service Data */
                    Parameter_p->adv_info.adv_data.adv_data.data[11] = 8;       /* Length of this AD Structure */
                    Parameter_p->adv_info.adv_data.adv_data.data[12] = 0x16;    /* AD Type: Service Data - 16bit UUID */
                    Parameter_p->adv_info.adv_data.adv_data.data[13] = (uint8_t) (RBLE_SVC_CYCLING_POWER & 0x00FF);         /* Service UUID: Cycling Power */
                    Parameter_p->adv_info.adv_data.adv_data.data[14] = (uint8_t)((RBLE_SVC_CYCLING_POWER & 0xFF00) >> 8);   /* Service UUID: Cycling Power */
                    Parameter_p->adv_info.adv_data.adv_data.data[15] = 0x01;    /* Flags - Pedal Power Balance Present */
                    Parameter_p->adv_info.adv_data.adv_data.data[16] = 0x00;    /* Flags */
                    Parameter_p->adv_info.adv_data.adv_data.data[17] = (uint8_t)( 100 & 0x00FF);        /* Instantaneous Power */
                    Parameter_p->adv_info.adv_data.adv_data.data[18] = (uint8_t)((100 & 0xFF00) >> 8);  /* Instantaneous Power */
                    Parameter_p->adv_info.adv_data.adv_data.data[19] = 100;     /* Pedal Power Balance  */
                }
                break;
#endif
            case 9:
                Parameter_p->adv_info.adv_param.direct_addr = Remote_Device;
                break;
            case 13:
                if (RBLE_Parameter_Cnt >= 2) {
                    Parameter_p->adv_info.adv_data.adv_data.data[19] = 0x18;    /* Random Target Address */
                    Parameter_p->adv_info.adv_data.adv_data.data[25] |= 0xC0;
                } else {
                    Parameter_p->adv_info.adv_data.adv_data.data[19] = 0x17;    /* Public Target Address */
                    Parameter_p->adv_info.adv_data.adv_data.data[25] &= 0x3F;
                }
                break;
            case 14:
                if (Peer_Addr_Type == RBLE_ADDR_PUBLIC) {
                    memcpy( &Parameter_p->adv_info.adv_data.adv_data.data[2], Remote_Device.addr, RBLE_BD_ADDR_LEN );
                } else {
                    memcpy( &Parameter_p->adv_info.scan_rsp_data.data.data[2], Remote_Device.addr, RBLE_BD_ADDR_LEN );
                }
                break;
            case 20:
                if (Peer_Addr_Type == RBLE_ADDR_PUBLIC) {
                    Parameter_p->adv_info.adv_data.adv_data.data[23] = 0x17;
                }
                else {
                    Parameter_p->adv_info.adv_data.adv_data.data[23] = 0x18;
                }
                memcpy( &Parameter_p->adv_info.adv_data.adv_data.data[24], Remote_Device.addr, RBLE_BD_ADDR_LEN );
                break;
            default:
                break;
        }
    }

    /* API Call */
    Ret_Status = RBLE_GAP_Broadcast_Enable( Parameter_p->disc_mode, Parameter_p->conn_mode, &Parameter_p->adv_info );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Broadcast_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Broadcast_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_GAP_Broadcast_Disable();

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Set_Bonding_Mode command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Set_Bonding_Mode_Test( void )
{
    const uint16_t mode = RBLE_GAP_BONDABLE;        /* GAP_BONDABLE */

    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_GAP_Set_Bonding_Mode( mode );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Set_Security_Request command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Set_Security_Request_Test( void )
{
//  const uint8_t sec = RBLE_GAP_NO_SEC;                    /**< No security (no authentication and encryption) */
    const uint8_t sec = RBLE_GAP_SEC1_NOAUTH_PAIR_ENC;      /**< Unauthenticated pairing with encryption */
//  const uint8_t sec = RBLE_GAP_SEC1_AUTH_PAIR_ENC;        /**< Authenticated pairing with encryption */
//  const uint8_t sec = RBLE_GAP_SEC2_NOAUTH_DATA_SGN;      /**< Unauthenticated pairing with data signing */
//  const uint8_t sec = RBLE_GAP_SEC2_AUTH_DATA_SGN;        /**< Authentication pairing with data signing */

    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_GAP_Set_Security_Request( sec );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Get_Device_Info command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Get_Device_Info_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_GAP_Get_Device_Info();

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Get_White_List_Size command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Get_White_List_Size_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_GAP_Get_White_List_Size();

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Add_To_White_List command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Add_To_White_List_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_GAP_Add_To_White_List( &Add_White_List_Dev_info );

    BdAddress_Disp( &Add_White_List_Dev_info.dev_addr );

    Add_White_List_Dev_info.dev_addr.addr[ 0 ]++;
    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Del_From_White_List command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Del_From_White_List_Test( void )
{
    const BOOL all_dev = FALSE; 

    RBLE_STATUS Ret_Status;

    Add_White_List_Dev_info.dev_addr.addr[ 0 ]--;
    /* API Call */
    Ret_Status = RBLE_GAP_Del_From_White_List( all_dev, &Add_White_List_Dev_info );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Get_Remote_Device_Name command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Get_Remote_Device_Name_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_CREATE_CONNECT_PARAM param;

    /* Connection Parameter Set*/
    param.scan_intv         = 48;                               /* Scan interval    ( 30msec = 48 * 0.625msec ) Range:0x0004-0x4000 */
    param.scan_window       = 48;                               /* Scan window size ( 30msec = 48 * 0.625msec ) Range:0x0004-0x4000 */
    param.init_filt_policy  = RBLE_GAP_INIT_FILT_IGNORE_WLST;   /* Initiator filter policy */
    param.peer_addr_type    = Peer_Addr_Type;                   /* Peer address type */
    param.peer_addr         = Remote_Device;                    /* Peer BD address */
    param.own_addr_type     = Own_Addr_Type;                    /* Own address type - 0=public/1=random */
    param.con_intv_min      = 40;                               /* Minimum of connection interval ( 50msec = 40 * 1.25msec ) Range:0x0006-0x0c80 */
    param.con_intv_max      = 40;                               /* Maximum of connection interval ( 50msec = 40 * 1.25msec ) Range:0x0006-0x0c80 */
    param.con_latency       = 0x00;                             /* Connection latency Range:0x0000-0x01f4 */
    param.superv_to         = 0x1f4;                            /* Link supervision timeout ( 5.0s = 0x1f4 * 10msec ) Range:0x000a-0x0c80 */
    param.ce_len_min        = 0x00;                             /* Minimum CE length ( 00msec = 0x00 * 0.625msec ) Range:0x0000-0xffff */
    param.ce_len_max        = 80;                               /* Maximum CE length ( 50msec = 80 * 0.625msec ) Range:0x0000-0xffff */

    /* API Call */
    Ret_Status = RBLE_GAP_Get_Remote_Device_Name( &param );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Get_Remote_Device_Info command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Get_Remote_Device_Info_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        Ret_Status = RBLE_GAP_Get_Remote_Device_Info( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Device_Search command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Device_Search_Test( void )
{
    const char_t *search_type[] = { "General", "Limited", "Cancel" };

    RBLE_STATUS     Ret_Status;
    uint8_t         discovery_type;

    if ( 0 != RBLE_Parameter_Cnt ) {
        discovery_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
    } else {
        discovery_type = RBLE_GAP_GEN_DISCOVERY_TYPE;
    }

    if ( discovery_type > RBLE_GAP_CANCEL_DISCOVERY ) {
        discovery_type = RBLE_GAP_GEN_DISCOVERY_TYPE;
    }

    printf( "Execute %s Discovery\n", search_type[discovery_type] );

    /* API Call */
    Ret_Status = RBLE_GAP_Device_Search( discovery_type, Own_Addr_Type );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Set_Random_Address command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Set_Random_Address_Test( void )
{
    static RBLE_BD_ADDR bd_addr = {
        0xaa, 0x00, 0xde, 0xfa, 0xfe, 0xca,     /* BT Addresss to bond */
    };

    RBLE_STATUS     Ret_Status;
    RBLE_BD_ADDR    *bd_addr_p;

    if ( 0 != RBLE_Parameter_Cnt ) {
        bd_addr_p = &Recon_Addr;
    } else {
        bd_addr_p = &bd_addr;
    }

    /* API Call */
    Ret_Status = RBLE_GAP_Set_Random_Address( bd_addr_p );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Set_Privacy_Feature command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Set_Privacy_Feature_Test( void )
{
    const RBLE_GAP_PRIV_FEAT_PRAM       *Parameter_p;
    RBLE_STATUS                 Ret_Status;
    int32_t                     Parameter_No;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }
    if ( ( ILLEGAL_NO == Parameter_No )
        || ( ( sizeof( RBLE_GAP_Privacy_Feature_Param ) / sizeof( RBLE_GAP_PRIV_FEAT_PRAM ) ) <= Parameter_No ) ) {
        Parameter_p = &RBLE_GAP_Privacy_Feature_Param[ 0 ];
        Select_Param_No_Disp( 0 );
    } else {
        Parameter_p = &RBLE_GAP_Privacy_Feature_Param[ Parameter_No ];
        Select_Param_No_Disp( Parameter_No );
    }

    switch ( Parameter_p->priv_flag ) {
    case RBLE_CENTRAL_PRIV_ENABLE:
    case RBLE_PH_PRIV_ENABLE:
    case RBLE_BCST_PRIV_ENABLE:
    case RBLE_OBSERV_PRIV_ENABLE:
        Own_Addr_Type = RBLE_ADDR_RAND;
        break;
    case RBLE_DEVICE_PRIV_DISABLE:
    case RBLE_OBSERV_PRIV_RESOLVE:
        Own_Addr_Type = RBLE_ADDR_PUBLIC;
        break;
    default:
        break;
    }

    /* API Call */
    Ret_Status = RBLE_GAP_Set_Privacy_Feature( Parameter_p->priv_flag, Parameter_p->set_to_ll );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Create_Connection command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Create_Connection_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_CREATE_CONNECT_PARAM param;

    /* Connection Parameter Set*/
    param.scan_intv         = 48;                               /* Scan interval    ( 30msec = 48 * 0.625msec ) Range:0x0004-0x4000 */
    param.scan_window       = 48;                               /* Scan window size ( 30msec = 48 * 0.625msec ) Range:0x0004-0x4000 */
    param.init_filt_policy  = RBLE_GAP_INIT_FILT_IGNORE_WLST;   /* Initiator filter policy */
    param.peer_addr_type    = Peer_Addr_Type;                   /* Peer address type */
    
#ifdef USE_PTS_SAMPLE
    if(Pts_Flg.CPP_Con_2nd == FALSE) {
        param.peer_addr = Remote_Device;                        /* Peer BD address */
    }
    else {
        param.peer_addr = Remote_Device_2nd;                    /* Peer BD address */
    }
#else
    param.peer_addr = Remote_Device;                            /* Peer BD address */
#endif

    param.own_addr_type     = Own_Addr_Type;                    /* Own address type - 0=public/1=random */
    param.con_intv_min      = 40;                               /* Minimum of connection interval ( 50msec = 40 * 1.25msec ) Range:0x0006-0x0c80 */
    param.con_intv_max      = 40;                               /* Maximum of connection interval ( 50msec = 40 * 1.25msec ) Range:0x0006-0x0c80 */
    param.con_latency       = 0x00;                             /* Connection latency Range:0x0000-0x01f4 */
    param.superv_to         = 0x1f4;                            /* Link supervision timeout ( 5.0s = 0x1f4 * 10msec ) Range:0x000a-0x0c80 */
    param.ce_len_min        = 0x00;                             /* Minimum CE length ( 00msec = 0x00 * 0.625msec ) Range:0x0000-0xffff */
    param.ce_len_max        = 80;                               /* Maximum CE length ( 50msec = 80 * 0.625msec ) Range:0x0000-0xffff */

    if ( 0 != RBLE_Parameter_Cnt ) {
        param.init_filt_policy  = RBLE_GAP_INIT_FILT_USE_WLST;
    }

    /* API Call */
    Ret_Status = RBLE_GAP_Create_Connection(&param);

    BdAddress_Disp( &param.peer_addr );
    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Connection_Cancel command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Connection_Cancel_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_GAP_Connection_Cancel();

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Disconnect command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Disconnect_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint16_t con_hdl = Connection_Handle;

#ifdef USE_PTS_SAMPLE
    if ( 0 != RBLE_Parameter_Cnt ) {
        if( RBLE_Parameter_Arg[ 0 ] != 0 ) {
            con_hdl = Connection_Handle_2nd;
        }
    }
#endif
    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == con_hdl ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_GAP_Disconnect( con_hdl );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Start_Bonding command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Start_Bonding_Test( void )
{
    static RBLE_BOND_PARAM      Param;
    RBLE_BOND_PARAM     *Parameter_p;
    RBLE_STATUS         Ret_Status;
    int32_t             Parameter_No;
        
    Parameter_p = &Param;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }
    if ( ( ILLEGAL_NO == Parameter_No )
        || ( ( sizeof( RBLE_Start_Bond_Param ) / sizeof( RBLE_BOND_PARAM ) ) <= Parameter_No ) ) {
        *Parameter_p = RBLE_Start_Bond_Param[ 0 ];
        Select_Param_No_Disp( 0 );
    } else {
        *Parameter_p = RBLE_Start_Bond_Param[ Parameter_No ];
        Select_Param_No_Disp( Parameter_No );
    }
    Parameter_p->addr = Remote_Device;

    /* API Call */
    Ret_Status = RBLE_GAP_Start_Bonding( Parameter_p );

    if ( RBLE_OK == Ret_Status ) {
        Bonding_Flg = TRUE;
    }

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A GAP_Bonding_Info_Ind command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Bonding_Info_Ind_Test( void )
{
    RBLE_BD_ADDR        addr;

    const uint8_t bond_op = RBLE_GAP_BOND_ADDED;

    RBLE_STATUS Ret_Status;

    addr = Remote_Device;

    /* API Call */
    Ret_Status = RBLE_GAP_Bonding_Info_Ind( bond_op, &addr );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}


/******************************************************************************************/
/**
 *  @brief A GAP_Bonding_Response command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Bonding_Response_Test( void )
{
    static RBLE_BOND_RESP_PARAM Param;
    RBLE_BOND_RESP_PARAM    *Parameter_p;
    RBLE_STATUS             Ret_Status;
    int32_t             Parameter_No;

    Parameter_p = &Param;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {

        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
            || ( ( sizeof( RBLE_Bond_Resp_Param ) / sizeof( RBLE_BOND_RESP_PARAM ) ) <= Parameter_No ) ) {
            *Parameter_p = RBLE_Bond_Resp_Param[ 0 ];
            Select_Param_No_Disp( 0 );
        } else {
            *Parameter_p = RBLE_Bond_Resp_Param[ Parameter_No ];
            Select_Param_No_Disp( Parameter_No );
        }
        Parameter_p->conhdl = Connection_Handle;

        /* API Call */
        Ret_Status = RBLE_GAP_Bonding_Response( Parameter_p );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Change_Connection_Param command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Change_Connection_Param_Test( void )
{
    const uint16_t result = 0x0000;
    static RBLE_CONN_PARAM conn_param = {
        0x00c8,     /* Connection interval minimum ( 250msec = 0xc8 * 1.25msec ) Range:0x0006-0x0c80 */
        0x00f0,     /* Connection interval maximum ( 300msec = 0xf0 * 1.25msec ) Range:0x0006-0x0c80 */
        0x0000,     /* Latency Range:0x0000-0x03e8 */
        0x0320,     /* Supervision timeout ( 8.0s = 0x320 * 10msec ) Range:0x000a-0x0c80 */
    };

    uint8_t role;

    RBLE_STATUS Ret_Status;

    role = Role_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_GAP_Change_Connection_Param( Connection_Handle, result, &conn_param, role);

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Channel_Map_Req command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Channel_Map_Req_Test( void )
{
    const BOOL update_map = 0;
    static RBLE_LE_CHNL_MAP chmap = {
        0xff,
        0xff,
        0xff,
        0xff,
        0xff,
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_GAP_Channel_Map_Req(update_map, Connection_Handle, &chmap);

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Read_RSSI command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Read_RSSI_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_GAP_Read_RSSI( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GAP_Authorized_Ind command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GAP_Authorized_Ind_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_GAP_Authorized_Ind( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/* --------------------------- Security Manager -------------------------------------*/
/******************************************************************************************/
/**
 *  @brief rBLE SM Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_SM_CallBack( RBLE_SM_EVENT *event )
{
    static uint8_t  Csrl_Flag = FALSE;
    
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type ) {
        case RBLE_SM_EVENT_SET_CNF:         /* Device Key Setting Complete Event */
            printf( "\nrBLE SM EVENT(EVENT_SET_CNF) Status(%s)\n", Get_Status_Str( event->param.set_conf.status ) );
            printf( "key_code = %d\n", event->param.set_conf.key_code );
            if ( FALSE == Csrl_Flag ) {
                Csrl_Flag = TRUE;
                RBLE_SM_Set_Key_Test_Csrk();
            } else {
                Csrl_Flag = FALSE;
            }
            break;
        case RBLE_SM_ENC_START_IND:         /* Encryption Start Indicate Event */
            printf( "\nrBLE SM EVENT(ENC_START_IND) Status(%s)\n", Get_Status_Str( event->param.sec_start.status ) );
            printf( "idx = %d", event->param.sec_start.idx );
            printf( ",  key_size = %d", event->param.sec_start.key_size );
            printf( ",  sec_prop = %d", event->param.sec_start.sec_prop );
            printf( ",  bonded = %d\n", event->param.sec_start.bonded );
            break;
        case RBLE_SM_TK_REQ_IND:            /* TK Request Evetnt */
            printf( "\nrBLE SM EVENT(TK_REQ_IND)\n" );
            printf( "idx = %d", event->param.tk_req.idx );
            printf( ",  oob_en = %d", event->param.tk_req.oob_en );
            printf( ",  disp_en = %d\n", event->param.tk_req.disp_en );
            Connection_Idx = event->param.tk_req.idx;
            break;
        case RBLE_SM_LTK_REQ_IND:           /* LTK Request Evetnt */
            printf( "\nrBLE SM EVENT(LTK_REQ_IND)\n" );
            printf( "idx = %d\n", event->param.ltk_req.idx );
            Connection_Idx = event->param.ltk_req.idx;
            break;
        case RBLE_SM_IRK_REQ_IND:           /* IRK Request Evetnt */
            printf( "\nrBLE SM EVENT(IRK_REQ_IND)\n" );
            printf( "idx = %d\n", event->param.irk_req.idx );
            Connection_Idx = event->param.irk_req.idx;
            break;
        case RBLE_SM_CSRK_REQ_IND:          /* CSRK Request Evetnt */
            Connection_Idx = event->param.csrk_req.idx;
            printf( "\nrBLE SM EVENT(CSRK_REQ_IND)\n" );
            printf( "idx = %d", event->param.csrk_req.idx );
            printf( ",  signcnt = %ld,  ", event->param.csrk_req.signcnt );
            BdAddress_Disp( &event->param.csrk_req.addr );

if (Remote_Sign_Counter != event->param.csrk_req.signcnt) {
    Invalid_SignCnt_Flg = TRUE;
} else {
    Invalid_SignCnt_Flg = FALSE;
    Remote_Sign_Counter++;
}
RBLE_SM_Csrk_Req_Resp_Test();

            break;
        case RBLE_SM_KEY_IND:               /* Key Indicate Event */
            printf( "\nrBLE SM EVENT(KEY_IND)\n" );
            KeyDisp( &event->param.key_ind );
            Connection_Idx = event->param.key_ind.idx;
            if ( RBLE_SMP_KDIST_ENCKEY == event->param.key_ind.key_code ) {
                RBLE_APP_Key.EncKey = event->param.key_ind;
                RBLE_APP_Key.Key_Set_Flags |= ( 1 << RBLE_APP_ENCKEY );
            } else if ( RBLE_SMP_KDIST_IDKEY == event->param.key_ind.key_code ) {
                RBLE_APP_Key.IrKey = event->param.key_ind;
                RBLE_APP_Key.Key_Set_Flags |= ( 1 << RBLE_APP_IDKEY );
            } else if ( RBLE_SMP_KDIST_SIGNKEY == event->param.key_ind.key_code ) {
                RBLE_APP_Key.SignKey = event->param.key_ind;
                RBLE_APP_Key.Key_Set_Flags |= ( 1 << RBLE_APP_SIGNKEY );
                Remote_Sign_Counter = 0;
            }
            break;
        case RBLE_SM_CHK_BD_ADDR_REQ:       /* BD Address Check Request Event */
            printf( "\nrBLE SM EVENT(BD_ADDR_REQ_IND)\n" );
            printf( "idx = %d", event->param.chk_bdaddr.idx );
            printf( ",  type = %d,  ", event->param.chk_bdaddr.type );
            Connection_Idx = event->param.chk_bdaddr.idx;
            Connection_Type = event->param.chk_bdaddr.type;
            BdAddress_Disp( &event->param.chk_bdaddr.addr );
            /* The remote device Bluetooth Address is saved. */
            Remote_Device = event->param.chk_bdaddr.addr;
            break;
        case RBLE_SM_TIMEOUT_EVT:
            printf( "\nrBLE SM EVENT(TIMEOUT)\n" );
            printf( "idx = %d\n", event->param.timeout_evt.idx );
            break;
        case RBLE_SM_EVENT_COMMAND_DISALLOWED_IND:
            printf( "\nrBLE SM EVENT (COMMAND_DISALLOWED_IND) Status(%s)\n", Get_Status_Str( event->param.cmd_disallowed_ind.status ) );
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}

/******************************************************************************************/
/**
 *  @brief A SM_Set_Key command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SM_Set_Key_Test( void )
{
    const uint8_t Key_code = RBLE_KEY_DIST_IDKEY;       /* KeyCode */
    static RBLE_KEY_VALUE Key_Value = {
        0x01, 0x23, 0x45, 0x67, 0x89, 0xAB, 0xCD, 0xEF, 0x01, 0x23, 0x45, 0x67, 0x89, 0xAB, 0xCD, 0xEF
    };

    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_SM_Set_Key( Key_code, &Key_Value );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SM_Set_Key_Test command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SM_Set_Key_Test_Csrk( void )
{
    const uint8_t Key_code = RBLE_KEY_DIST_SIGNKEY;     /* KeyCode */
    static RBLE_KEY_VALUE Key_Value = {
        0x34, 0xd4, 0x47, 0x97, 0xea, 0xa4, 0x2c, 0xae, 0x4a, 0xd9, 0x6e, 0x2a, 0xab, 0x99, 0xbc, 0x7c      /* NewKeyCsrkKey */
    };

    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_SM_Set_Key( Key_code, &Key_Value );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SM_Start_Enc command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SM_Start_Enc_Test( void )
{
    const uint8_t auth_req = 0x01;      /* AuthReq */

    uint16_t            ediv;
    RBLE_RAND_NB        rand_nb;
    RBLE_KEY_VALUE      ltk;

    RBLE_STATUS Ret_Status;

    ediv = RBLE_APP_Key.EncKey.ediv;
    rand_nb = RBLE_APP_Key.EncKey.nb;
    ltk = RBLE_APP_Key.EncKey.ltk;
    /* API Call */
    Ret_Status = RBLE_SM_Start_Enc( Connection_Idx, auth_req, ediv, &rand_nb, &ltk );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SM_Tk_Req_Resp command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SM_Tk_Req_Resp_Test( void )
{
    const uint8_t status = RBLE_OK;
    static RBLE_KEY_VALUE tk[] = {
        {
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x12, 0x03, 0x6E, 0x5A, 0x88, 0x9F, 0x4D      /* TkKey(for OOB) */
        },

        {
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00      /* TkKey(for PassKey) */
        }
    };
    RBLE_KEY_VALUE      *Key_p;
    RBLE_STATUS         Ret_Status;
    int32_t             Parameter_No;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }

    if ( ( ILLEGAL_NO != Parameter_No ) && ( 0 != Parameter_No ) ) {
        Key_p = &tk[1];
        memset(Key_p->key, 0, RBLE_KEY_LEN);
        Key_p->key[13] = ( uint8_t )( ( Parameter_No & 0xff0000 ) >> 16 );
        Key_p->key[14] = ( uint8_t )( ( Parameter_No & 0x00ff00 ) >> 8 );
        Key_p->key[15] = ( uint8_t )( Parameter_No & 0x0000ff );
    } else {
        Key_p = &tk[0];
    }

    /* API Call */
    Ret_Status = RBLE_SM_Tk_Req_Resp( Connection_Idx, status, Key_p );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SM_Ltk_Req_Resp command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SM_Ltk_Req_Resp_Test( void )
{
    const uint8_t sec_prop = 0x01;      /* SecProp */
    static RBLE_RAND_NB     nb= {
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00      /* Rand */
    };
    static RBLE_KEY_VALUE   ltk= {
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00      /* LTK */
    };

    uint8_t         status = RBLE_OK;
    uint16_t        ediv = 0x0000;      /* Ediv */
    RBLE_STATUS     Ret_Status;
    int_t           i;

    if ( TRUE == Bonding_Flg ) {
        if ( 0u == ( RBLE_APP_Key.Key_Set_Flags & ( 1 <<  RBLE_APP_ENCKEY ) ) ) {

            for ( i = 0;i <  RBLE_RAND_NB_LEN;i++ ) {
                RBLE_APP_Key.EncKey.nb.nb[ i ] = ( uint8_t )RBLE_Get_Random();
            }
            for ( i = 0;i <  RBLE_KEY_LEN;i++ ) {
                RBLE_APP_Key.EncKey.ltk.key[ i ] = ( uint8_t )RBLE_Get_Random();
            }
            RBLE_APP_Key.EncKey.ediv = 0x1234;
            RBLE_APP_Key.Key_Set_Flags |= ( 1 << RBLE_APP_ENCKEY );
        }
        ediv = RBLE_APP_Key.EncKey.ediv;
        nb = RBLE_APP_Key.EncKey.nb;
        ltk = RBLE_APP_Key.EncKey.ltk;

    } else  if ( 0u != ( RBLE_APP_Key.Key_Set_Flags & ( 1 <<  RBLE_APP_ENCKEY ) ) ) {
        ediv = RBLE_APP_Key.EncKey.ediv;
        nb = RBLE_APP_Key.EncKey.nb;
        ltk = RBLE_APP_Key.EncKey.ltk;
    } else {
        status = RBLE_ERR;
    }

#ifdef USE_PTS_SAMPLE
    if ( TRUE == Pts_Flg.Auth_Req ) {
        Pts_Flg.Ltk_Cnt++;
        if ( 0 != ( Pts_Flg.Ltk_Cnt & 0x01 ) ) {
            status = RBLE_ERR;
        }
    }
#endif
    if ( RBLE_OK == status ) {
        RandomDataDisp( &nb );
        KeyDataDisp( &ltk );
    }

    /* API Call */
    Ret_Status = RBLE_SM_Ltk_Req_Resp( Connection_Idx, status, sec_prop, ediv, &nb, &ltk );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SM_Irk_Req_Resp command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SM_Irk_Req_Resp_Test( void )
{
    static RBLE_KEY_VALUE irk[] = {
        { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },     /* IrkKey */
        { 0x01, 0x23, 0x45, 0x67, 0x89, 0xAB, 0xCD, 0xEF, 0x01, 0x23, 0x45, 0x67, 0x89, 0xAB, 0xCD, 0xEF }
    };
    uint8_t         status = RBLE_OK;
    RBLE_KEY_VALUE  *irk_p = &irk[ 0 ];
    RBLE_STATUS     Ret_Status;
    uint8_t         lk_sec_status = RBLE_SMP_UNAUTHENTICATED | RBLE_SMP_BONDED;

    if ( 0 != RBLE_Parameter_Cnt ) {
        status = RBLE_OK;
        irk_p = &irk[ 1 ];
    } else {
        status = RBLE_ERR;
    }

    if ( 0u != ( RBLE_APP_Key.Key_Set_Flags & ( 1 <<  RBLE_APP_IDKEY ) ) ) {
        irk[ 0 ] = RBLE_APP_Key.IrKey.ltk;
        status = RBLE_OK;
    }

    /* API Call */
    Ret_Status = RBLE_SM_Irk_Req_Resp( Connection_Idx, status, &Remote_Device, irk_p, lk_sec_status );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SM_Csrk_Req_Resp command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SM_Csrk_Req_Resp_Test( void )
{
    static RBLE_KEY_VALUE csrk = {
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00      /* CSRK */
    };

    uint8_t status = RBLE_ERR;
    uint8_t lk_sec_status = RBLE_SMP_UNAUTHENTICATED | RBLE_SMP_BONDED;
    RBLE_STATUS Ret_Status;

    if ( 0u != ( RBLE_APP_Key.Key_Set_Flags & ( 1 <<  RBLE_APP_SIGNKEY ) ) ) {
        csrk = RBLE_APP_Key.SignKey.ltk;
        status = RBLE_OK;
    }
    if ( TRUE == Invalid_SignCnt_Flg ) {
        status = RBLE_ERR;
    }

    /* API Call */
    Ret_Status = RBLE_SM_Csrk_Req_Resp( Connection_Idx, status, &csrk, lk_sec_status );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SM_Chk_Bd_Addr_Req_Resp command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SM_Chk_Bd_Addr_Req_Resp_Test( void )
{
    const uint8_t found_flag = TRUE;
    const uint8_t lk_sec_status = ( RBLE_SMP_BONDED | RBLE_SMP_UNAUTHENTICATED );

    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_SM_Chk_Bd_Addr_Req_Resp( Connection_Idx, Connection_Type, found_flag, lk_sec_status, &Remote_Device );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/* ---------------------------------- GATT ------------------------------------------*/
/******************************************************************************************/
/**
 *  @brief rBLE GATT Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_GATT_CallBack( RBLE_GATT_EVENT *event )
{
    static RBLE_GATT_SET_DATA setdata;
    int_t       i;

    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_GATT_EVENT_DISC_SVC_ALL_CMP:
            printf( "\nrBLE GATT EVENT (DISC_SVC_ALL_CMP) Att_Code(%x), NbResp(%d)\n", event->param.disc_svc_all_cmp.att_code, event->param.disc_svc_all_cmp.nb_resp );
            for ( i = 0;i < event->param.disc_svc_all_cmp.nb_resp;i++ ) {
                printf( "conhdl:(%04X)\n", event->param.disc_svc_all_cmp.conhdl );
                printf( "start_hdl:(%04X)", event->param.disc_svc_all_cmp.list[ i ].start_hdl );
                printf( ", end_hdl:(%04X)", event->param.disc_svc_all_cmp.list[ i ].end_hdl );
                printf( ", attr_hdl:(%04X)\n", event->param.disc_svc_all_cmp.list[ i ].attr_hdl );
            }
            break;
        case RBLE_GATT_EVENT_DISC_SVC_ALL_128_CMP:
            printf( "\nrBLE GATT EVENT (DISC_SVC_ALL_128_CMP) Att_Code(%x), NbResp(%d)\n", event->param.disc_svc_all_128_cmp.att_code, event->param.disc_svc_all_128_cmp.nb_resp );
            printf( "conhdl:(%04X)\n", event->param.disc_svc_all_128_cmp.conhdl );
            printf( "start_hdl:(%04X)", event->param.disc_svc_all_128_cmp.list.start_hdl );
            printf( ", end_hdl:(%04X), \n", event->param.disc_svc_all_128_cmp.list.end_hdl );
            printf( "attr_hdl:(");
            Uuid128_Disp( &event->param.disc_svc_all_128_cmp.list.attr_hdl[ 0 ] );
            printf( ")\n"); 
            break;
        case RBLE_GATT_EVENT_DISC_SVC_BY_UUID_CMP:
            printf( "\nrBLE GATT EVENT (DISC_SVC_BY_UUID_CMP) Att_Code(%x), NbResp(%d)\n", event->param.disc_svc_by_uuid_cmp.att_code, event->param.disc_svc_by_uuid_cmp.nb_resp );
            for ( i = 0;i < event->param.disc_svc_by_uuid_cmp.nb_resp;i++ ) {
                printf( "conhdl:(%04X)\n", event->param.disc_svc_by_uuid_cmp.conhdl );
                printf( "start_hdl:(%04X)", event->param.disc_svc_by_uuid_cmp.list[ i ].start_hdl );
                printf( ", end_hdl:(%04X)\n", event->param.disc_svc_by_uuid_cmp.list[ i ].end_hdl );
            }
            break;
        case RBLE_GATT_EVENT_DISC_SVC_INCL_CMP:
            printf( "\nrBLE GATT EVENT (DISC_SVC_INCL_CMP) Nb_Entry(%d)\n", event->param.disc_svc_incl_cmp.nb_entry );
            printf( "conhdl:(%04X)\n", event->param.disc_svc_incl_cmp.conhdl );
            if ( RBLE_GATT_128BIT_UUID_OCTET == event->param.disc_svc_incl_cmp.entry_len ) {
                printf( "attr_hdl:(%04X),", event->param.disc_svc_incl_cmp.incl_list.incl.attr_hdl );
                printf( ", start_hdl:(%04X)", event->param.disc_svc_incl_cmp.incl_list.incl.start_hdl );
                printf( ", end_hdl:(%04X),\n", event->param.disc_svc_incl_cmp.incl_list.incl.end_hdl );
                printf( "UUID:(");
                Uuid128_Disp( &event->param.disc_svc_incl_cmp.incl_list.incl.uuid[ 0 ] );
                printf( ")\n"); 
            } else {
                for ( i = 0;i < event->param.disc_svc_incl_cmp.nb_entry;i++ ) {
                    printf( "attr_hdl:(%04X)", event->param.disc_svc_incl_cmp.incl_list.list[ i ].attr_hdl );
                    printf( ", start_hdl:(%04X)", event->param.disc_svc_incl_cmp.incl_list.list[ i ].start_hdl );
                    printf( ", end_hdl:(%04X)", event->param.disc_svc_incl_cmp.incl_list.list[ i ].end_hdl );
                    printf( ", UUID:(%04X)\n", event->param.disc_svc_incl_cmp.incl_list.list[ i ].uuid );
                }
            }
            break;
        case RBLE_GATT_EVENT_DISC_CHAR_ALL_CMP:
            printf( "\nrBLE GATT EVENT (DISC_CHAR_ALL_CMP) Att_Code(%x), NbResp(%d)\n", event->param.disc_char_all_cmp.att_code, event->param.disc_char_all_cmp.nb_entry );
            printf( "conhdl:(%04X)\n", event->param.disc_char_all_cmp.conhdl );
            for ( i = 0;i < event->param.disc_char_all_cmp.nb_entry;i++ ) {
                printf( "attribute_handle:(%04X)", event->param.disc_char_all_cmp.list[ i ].attr_hdl );
                printf( ",  prop:(%02X)", event->param.disc_char_all_cmp.list[ i ].prop );
                printf( ",  pointer_hdl:(%04X)", event->param.disc_char_all_cmp.list[ i ].pointer_hdl );
                printf( ",  uuid:(%04X)\n", event->param.disc_char_all_cmp.list[ i ].uuid );
            }
            break;
        case RBLE_GATT_EVENT_DISC_CHAR_ALL_128_CMP:
            printf( "\nrBLE GATT EVENT (DISC_CHAR_ALL_128_CMP) Att_Code(%x), NbEntry(%d)\n", event->param.disc_char_all_128_cmp.att_code, event->param.disc_char_all_128_cmp.nb_entry );
            printf( "conhdl:(%04X)\n", event->param.disc_char_all_128_cmp.conhdl );
            printf( "attribute_handle:(%04X)", event->param.disc_char_all_128_cmp.list.attr_hdl );
            printf( ",  prop:(%02X)", event->param.disc_char_all_128_cmp.list.prop );
            printf( ",  pointer_hdl:(%04X),\n", event->param.disc_char_all_128_cmp.list.pointer_hdl );
            printf( "UUID:(");
            Uuid128_Disp( &event->param.disc_char_all_128_cmp.list.uuid[ 0 ] );
            printf( ")\n"); 
            break;
        case RBLE_GATT_EVENT_DISC_CHAR_BY_UUID_CMP:
            printf( "\nrBLE GATT EVENT (DISC_CHAR_BY_UUID_CMP) Att_Code(%x), NbEntry(%d)\n", event->param.disc_char_by_uuid_cmp.att_code, event->param.disc_char_by_uuid_cmp.nb_entry );
            printf( "conhdl:(%04X)\n", event->param.disc_char_by_uuid_cmp.conhdl );
            for ( i = 0;i < event->param.disc_char_by_uuid_cmp.nb_entry;i++ ) {
                printf( "attribute_handle:(%04X)", event->param.disc_char_by_uuid_cmp.list[ i ].attr_hdl );
                printf( ",  prop:(%02X)", event->param.disc_char_by_uuid_cmp.list[ i ].prop );
                printf( ",  pointer_hdl:(%04X)", event->param.disc_char_by_uuid_cmp.list[ i ].pointer_hdl );
                printf( ",  uuid:(%04X)\n", event->param.disc_char_by_uuid_cmp.list[ i ].uuid );
            }
            break;
        case RBLE_GATT_EVENT_DISC_CHAR_BY_UUID_128_CMP:
            printf( "\nrBLE GATT EVENT (DISC_CHAR_BY_UUID_128_CMP) Att_Code(%x), NbEntry(%d)\n", event->param.disc_char_by_uuid_128_cmp.att_code, event->param.disc_char_by_uuid_128_cmp.nb_entry );
            printf( "conhdl:(%04X)\n", event->param.disc_char_by_uuid_128_cmp.conhdl );
            printf( "attribute_handle:(%04X)", event->param.disc_char_by_uuid_128_cmp.list.attr_hdl );
            printf( ",  prop:(%02X)", event->param.disc_char_by_uuid_128_cmp.list.prop );
            printf( ",  pointer_hdl:(%04X),\n", event->param.disc_char_by_uuid_128_cmp.list.pointer_hdl );
            printf( "UUID:(");
            Uuid128_Disp( &event->param.disc_char_by_uuid_128_cmp.list.uuid[ 0 ] );
            printf( ")\n"); 
            break;
        case RBLE_GATT_EVENT_DISC_CHAR_DESC_CMP:
            printf( "\nrBLE GATT EVENT (DISC_CHAR_DESC_CMP) NbEntry(%d)\n", event->param.disc_char_desc_cmp.nb_entry );
            printf( "conhdl:(%04X)\n", event->param.disc_char_desc_cmp.conhdl );
            for ( i = 0;i < event->param.disc_char_desc_cmp.nb_entry;i++ ) {
                printf( "attr_hdl:(%04X)", event->param.disc_char_desc_cmp.list[ i ].attr_hdl );
                printf( ", desc_hdl:(%04X)\n", event->param.disc_char_desc_cmp.list[ i ].desc_hdl );
            }
            break;
        case RBLE_GATT_EVENT_DISC_CHAR_DESC_128_CMP:
            printf( "\nrBLE GATT EVENT (DISC_CHAR_DESC_128_CMP) NbEntry(%d)\n", event->param.disc_char_desc_128_cmp.nb_entry );
            printf( "conhdl:(%04X)\n", event->param.disc_char_desc_128_cmp.conhdl );
            printf( "attr_hdl:(%04X),\n", event->param.disc_char_desc_128_cmp.list_128.attr_hdl );
            printf( "UUID:(");
            Uuid128_Disp( &event->param.disc_char_desc_128_cmp.list_128.uuid[ 0 ] );
            printf( ")\n"); 
            break;
        case RBLE_GATT_EVENT_READ_CHAR_RESP:
            printf( "\nrBLE GATT EVENT (READ_CHAR_RESP) Att_Code(%s)\n", Get_Att_Code_Str( event->param.read_char_resp.att_code ) );
            printf( "conhdl:(%04X)\n", event->param.read_char_resp.conhdl );
            if ( RBLE_ATT_ERR_NO_ERROR == event->param.read_char_resp.att_code ) {
                if ( 0 != event->param.read_char_resp.data.each_len ) {
                    uint16_t    handle;
                    uint8_t     *p = &event->param.read_char_resp.data.data[ 0 ];
                    uint8_t     len = event->param.read_char_resp.data.len;

                    for ( i = 1; len != 0; i++ ) {
                        handle = ( p[ 0 ] | ( p[ 1 ] << 8 ) );
                        printf( "%d) Handle = %04X\n", i, handle );
                        printf( "Value:\n");
                        Print_Dump( &p[ 2 ], event->param.read_char_resp.data.each_len - sizeof( uint16_t ) );
                        len -= event->param.read_char_resp.data.each_len;
                        p = &p[ i * event->param.read_char_resp.data.each_len ];
                    }
                } else {
                    printf( "Data:\n");
                    Print_Dump( &event->param.read_char_resp.data.data[ 0 ], event->param.read_char_resp.data.len );
                }
            }
            break;
        case RBLE_GATT_EVENT_READ_CHAR_LONG_RESP:
            printf( "\nrBLE GATT EVENT (READ_CHAR_LONG_RESP) Att_Code(%s)\n", Get_Att_Code_Str( event->param.read_char_long_resp.att_code ) );
            printf( "conhdl:(%04X)\n", event->param.read_char_long_resp.conhdl );
            if ( RBLE_ATT_ERR_NO_ERROR == event->param.read_char_long_resp.att_code ) {
                printf( "val_len:(%X)", event->param.read_char_long_resp.val_len );
                printf( ",  attr_hdl:(%04X),\n", event->param.read_char_long_resp.attr_hdl );
                printf( "Data:\n");
                Print_Dump( &event->param.read_char_long_resp.value[ 0 ], event->param.read_char_long_resp.val_len );
            }
            break;
        case RBLE_GATT_EVENT_READ_CHAR_MULT_RESP:
            printf( "\nrBLE GATT EVENT (READ_CHAR_MULT_RESP) Att_Code(%s)\n", Get_Att_Code_Str( event->param.read_char_mult_resp.att_code ) );
            printf( "conhdl:(%04X)\n", event->param.read_char_mult_resp.conhdl );
            if ( RBLE_ATT_ERR_NO_ERROR == event->param.read_char_mult_resp.att_code ) {
                uint8_t len = event->param.read_char_mult_resp.val_len;

                printf( "val_len:(%X)\n", event->param.read_char_mult_resp.val_len );
                for ( i = 0 ; ((i < RBLE_GATT_MAX_NB_HDLS) && (len != 0)); i++ ) {
                    printf("%d) val_len:(%X)\n", i+1, event->param.read_char_mult_resp.data[ i ].len );
                    printf( "Data:\n");
                    Print_Dump( &event->param.read_char_mult_resp.data[ i ].value[ 0 ], event->param.read_char_mult_resp.data[ i ].len );
                    len -= event->param.read_char_mult_resp.data[ i ].len;
                }
            }
            break;
        case RBLE_GATT_EVENT_READ_CHAR_LONG_DESC_RESP:
            printf( "\nrBLE GATT EVENT (READ_CHAR_LONG_DESC_RESP) Att_Code(%s)\n", Get_Att_Code_Str( event->param.read_char_long_desc_resp.att_code ) );
            printf( "conhdl:(%04X)\n", event->param.read_char_long_desc_resp.conhdl );
            if ( RBLE_ATT_ERR_NO_ERROR == event->param.read_char_long_desc_resp.att_code ) {
                printf( "val_len:(%X), ", event->param.read_char_long_desc_resp.val_len );
                printf( "attr_hdl:(%04X),\n", event->param.read_char_long_desc_resp.attr_hdl );
                printf( "Data:\n");
                Print_Dump( &event->param.read_char_long_desc_resp.value[ 0 ], event->param.read_char_long_desc_resp.val_len );
            }
            break;
        case RBLE_GATT_EVENT_WRITE_CHAR_RESP:
            printf( "\nrBLE GATT EVENT (WRITE_CHAR_RESP) Att_Code(%s)\n", Get_Att_Code_Str( event->param.write_char_resp.att_code ) );
            printf( "conhdl:(%04X)\n", event->param.write_char_resp.conhdl );
            break;
        case RBLE_GATT_EVENT_WRITE_CHAR_RELIABLE_RESP:
            printf( "\nrBLE GATT EVENT (WRITE_CHAR_RELIABLE_RESP) Att_Code(%s)\n", Get_Att_Code_Str( event->param.write_reliable_resp.att_code ) );
            printf( "conhdl:(%04X)\n", event->param.write_reliable_resp.conhdl );
            break;
        case RBLE_GATT_EVENT_CANCEL_WRITE_CHAR_RESP:
            printf( "\nrBLE GATT EVENT (CANCEL_WRITE_CHAR_RESP) Att_Code(%s)\n", Get_Att_Code_Str( event->param.cancel_write_resp.att_code ) );
            printf( "conhdl:(%04X)\n", event->param.cancel_write_resp.conhdl );
            break;
        case RBLE_GATT_EVENT_HANDLE_VALUE_NOTIF:
            printf( "\nrBLE GATT EVENT (HANDLE_VALUE_NOTIF)\n");
            printf( "conhdl:(%04X), ", event->param.handle_value_notif.conhdl );
            printf( "charhdl:(%04X), ", event->param.handle_value_notif.charhdl );
            printf( "size:(%X),\n", event->param.handle_value_notif.size );
            printf( "Data:\n");
            Print_Dump( &event->param.handle_value_notif.value[ 0 ], event->param.handle_value_notif.size );
            break;
        case RBLE_GATT_EVENT_HANDLE_VALUE_IND:
            printf( "\nrBLE GATT EVENT (HANDLE_VALUE_IND)\n");
            printf( "conhdl:(%04X), ", event->param.handle_value_ind.conhdl );
            printf( "charhdl:(%04X), ", event->param.handle_value_ind.charhdl );
            printf( "size:(%X),\n", event->param.handle_value_ind.size );
            printf( "Data:\n");
            Print_Dump( &event->param.handle_value_ind.value[ 0 ], event->param.handle_value_ind.size );
            break;
        case RBLE_GATT_EVENT_HANDLE_VALUE_CFM:
            printf( "\nrBLE GATT EVENT (HANDLE_VALUE_CFM) Status(%s)\n", Get_Status_Str( event->param.handle_value_cfm.status ) );
            break;
        case RBLE_GATT_EVENT_DISCOVERY_CMP:
            printf( "\nrBLE GATT EVENT (DISCOVERY_CMP) Att_Code(%s)\n", Get_Att_Code_Str( event->param.discovery_cmp.att_code ) );
            printf( "conhdl:(%04X)\n", event->param.discovery_cmp.conhdl );
            break;
        case RBLE_GATT_EVENT_COMPLETE:
            printf( "\nrBLE GATT EVENT (COMPLETE) Att_Code(%s)\n", Get_Att_Code_Str( event->param.complete.att_code ) );
            printf( "conhdl:(%04X)\n", event->param.complete.conhdl );
            break;
        case RBLE_GATT_EVENT_WRITE_CMD_IND:
            setdata.val_hdl = event->param.write_cmd_ind.elmt;
            setdata.val_len = event->param.write_cmd_ind.size + event->param.write_cmd_ind.offset;
            memcpy(&setdata.value[ event->param.write_cmd_ind.offset ], &event->param.write_cmd_ind.value[ 0 ], event->param.write_cmd_ind.size);
            RBLE_GATT_Set_Data( &setdata );

            printf( "\nrBLE GATT EVENT (WRITE_CMD_IND)\n");
            printf( "conhdl:(%04X)\n", event->param.write_cmd_ind.conhdl );
            printf( "elmt hdl:(%04X), ", event->param.write_cmd_ind.elmt );
            printf( "size:(%d), ", event->param.write_cmd_ind.size );
            printf( "offset:(%d), ", event->param.write_cmd_ind.offset );
            printf( "resp:(%s)\n", ( ( event->param.write_cmd_ind.resp == TRUE ) ? "TRUE" : "FALSE" ) );
            printf( "Data:\n");
            Print_Dump( &event->param.write_cmd_ind.value[ 0 ], event->param.write_cmd_ind.size );
            break;
        case RBLE_GATT_EVENT_RESP_TIMEOUT:
            printf( "\nrBLE GATT EVENT (RESP_TIMEOUT)\n");
            break;
        case RBLE_GATT_EVENT_SET_PERM_CMP:
            printf( "\nrBLE GATT EVENT (SET_PERM_CMP) Status(%s)\n", Get_Status_Str( event->param.set_perm_cmp.status ) );
            break;
        case RBLE_GATT_EVENT_SET_DATA_CMP:
            printf( "\nrBLE GATT EVENT (SET_DATA_CMP) Status(%s)\n", Get_Status_Str( event->param.set_data_cmp.status ) );
            break;
        case RBLE_GATT_EVENT_NOTIFY_COMP:
            printf( "\nrBLE GATT EVENT (NOTIFY_COMP) Status(%s)\n", Get_Status_Str( event->param.notify_cmp.status ) );
            printf( "conhdl:(%04X), ", event->param.notify_cmp.conhdl );
            printf( "charhdl:(%04X)\n", event->param.notify_cmp.charhdl );
            break;
        case RBLE_GATT_EVENT_COMMAND_DISALLOWED_IND:
            printf( "\nrBLE GATT EVENT (COMMAND_DISALLOWED_IND)\n");
            break;
        default:
            break;
    }
    Prompt_Disp();
}

/******************************************************************************************/
/**
 *  @brief A GATT_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GATT_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* API Call */
    Ret_Status = RBLE_GATT_Enable( RBLE_APP_GATT_CallBack );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

static BOOL RBLE_GATT_Discovery_Service_Request_Test( void )
{
    const uint8_t       Value[ RBLE_GATT_128BIT_UUID_OCTET ] = {
        0xEF, 0xCD, 0xAB, 0x89, 0x67, 0x45, 0x23, 0x01, 0x00, 0x00, 0x00, 0x00, 0x0C, 0xA0, 0x00, 0x00
    };
    static RBLE_GATT_DISC_SVC_REQ   Disc_Svc;
    RBLE_STATUS             Ret_Status;
    int32_t                 Parameter_No;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }

    switch( Parameter_No ) {
        case 1:
            Select_Param_No_Disp( 1 );
            Disc_Svc.req_type = RBLE_GATT_DISC_BY_UUID_SVC;
            Disc_Svc.start_hdl = 0x0001;
            Disc_Svc.end_hdl = 0xffff;
            if ( ( 3 == RBLE_Parameter_Cnt ) && ( 128 == RBLE_Parameter_Arg[ 1 ] ) ) {
                Disc_Svc.desired_svc.value_size = RBLE_GATT_128BIT_UUID_OCTET;
                memcpy( &Disc_Svc.desired_svc.value[ 0 ], &Value[ 0 ], RBLE_GATT_128BIT_UUID_OCTET );
                Disc_Svc.desired_svc.value[ 12 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 2 ] >> 0 ) & 0xff );
                Disc_Svc.desired_svc.value[ 13 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 2 ] >> 8 ) & 0xff );
            } else {
                Disc_Svc.desired_svc.value_size = RBLE_GATT_16BIT_UUID_OCTET;
                Disc_Svc.desired_svc.value[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 0 ) & 0xff );
                Disc_Svc.desired_svc.value[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 8 ) & 0xff );
            }
            break;
        case 2:
            Select_Param_No_Disp( 2 );
            Disc_Svc.req_type = RBLE_GATT_DISC_INCLUDED_SVC;
            if ( 3 == RBLE_Parameter_Cnt ) {
                Disc_Svc.start_hdl = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
                Disc_Svc.end_hdl   = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
            } else {
                Disc_Svc.start_hdl = 0x0001;
                Disc_Svc.end_hdl   = 0xffff;
            }
            break;
        case 0:
        default:
            Select_Param_No_Disp( 0 );
            Disc_Svc.req_type = RBLE_GATT_DISC_ALL_SVC;
            Disc_Svc.desired_svc.value_size = RBLE_GATT_16BIT_UUID_OCTET;
            Disc_Svc.desired_svc.value[ 0 ] = 0x00;
            Disc_Svc.desired_svc.value[ 1 ] = 0x00;
            break;
    }

    Disc_Svc.conhdl = Connection_Handle;

    /* API Call */
    Ret_Status = RBLE_GATT_Discovery_Service_Request( &Disc_Svc );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GATT_Discovery_Char_Request command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GATT_Discovery_Char_Request_Test( void )
{
    const uint8_t       Value[ RBLE_GATT_128BIT_UUID_OCTET ] = {
        0xEF, 0xCD, 0xAB, 0x89, 0x67, 0x45, 0x23, 0x01, 0x00, 0x00, 0x00, 0x00, 0x0C, 0xA0, 0x00, 0x00
    };
    RBLE_GATT_DISC_CHAR_REQ Request_Data;
    RBLE_STATUS             Ret_Status;
    int32_t                 Parameter_No;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }

    switch( Parameter_No ) {
        case 1:
            Request_Data.req_type = RBLE_GATT_DISC_BY_UUID_CHAR;
            Request_Data.start_hdl = 0x0001;
            Request_Data.end_hdl = 0xffff;
            if ( ( 3 <= RBLE_Parameter_Cnt ) && ( 128 == RBLE_Parameter_Arg[ 1 ] ) ) {
                Request_Data.desired_char.value_size = RBLE_GATT_128BIT_UUID_OCTET;
                memcpy( &Request_Data.desired_char.value[ 0 ], &Value[ 0 ], RBLE_GATT_128BIT_UUID_OCTET );
                Request_Data.desired_char.value[ 12 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 2 ] >> 0 ) & 0xff );
                Request_Data.desired_char.value[ 13 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 2 ] >> 8 ) & 0xff );
                if ( 5 == RBLE_Parameter_Cnt ) {
                    Request_Data.start_hdl = ( uint16_t )RBLE_Parameter_Arg[ 3 ];
                    Request_Data.end_hdl = ( uint16_t )RBLE_Parameter_Arg[ 4 ];
                }
            } else {
                Request_Data.desired_char.value_size = RBLE_GATT_16BIT_UUID_OCTET;
                Request_Data.desired_char.value[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 0 ) & 0xff );
                Request_Data.desired_char.value[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 8 ) & 0xff );
                if ( 4 == RBLE_Parameter_Cnt ) {
                    Request_Data.start_hdl = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
                    Request_Data.end_hdl = ( uint16_t )RBLE_Parameter_Arg[ 3 ];
                }
            }
            break;
        case 2:
            Request_Data.req_type = RBLE_GATT_DISC_ALL_CHAR;
            if ( 3 == RBLE_Parameter_Cnt ) {
                Request_Data.start_hdl = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
                Request_Data.end_hdl = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
            } else {
                Request_Data.start_hdl = 0x0001;
                Request_Data.end_hdl = 0xffff;
            }
            break;
        case 0:
        default:
            Request_Data.req_type = RBLE_GATT_DISC_BY_UUID_CHAR;
            Request_Data.start_hdl = 0x0001;
            Request_Data.end_hdl = 0xffff;
            Request_Data.desired_char.value_size = RBLE_GATT_16BIT_UUID_OCTET;
            Request_Data.desired_char.value[ 0 ] = ( uint8_t )( ( Search_Attribute_Type >> 0 ) & 0xff );
            Request_Data.desired_char.value[ 1 ] = ( uint8_t )( ( Search_Attribute_Type >> 8 ) & 0xff );
            break;
    }

    Request_Data.conhdl = Connection_Handle;

    /* API Call */
    Ret_Status = RBLE_GATT_Discovery_Char_Request( &Request_Data );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

static BOOL RBLE_GATT_Discovery_Char_Descriptor_Request_Test( void )
{
    RBLE_GATT_DISC_CHAR_DESC_REQ    Disc_Char_Desc;
    RBLE_STATUS                     Ret_Status;

    if ( 2 == RBLE_Parameter_Cnt ) {
        Disc_Char_Desc.start_hdl = ( uint16_t )RBLE_Parameter_Arg[ 0 ];
        Disc_Char_Desc.end_hdl   = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
    } else {
        Disc_Char_Desc.start_hdl = 0x0001;
        Disc_Char_Desc.end_hdl = 0xffff;
    }
    Disc_Char_Desc.conhdl = Connection_Handle;

    /* API Call */
    Ret_Status = RBLE_GATT_Discovery_Char_Descriptor_Request( &Disc_Char_Desc );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

static BOOL RBLE_GATT_Read_Char_Request_Test( void )
{
    const uint8_t       Value[ RBLE_GATT_128BIT_UUID_OCTET ] = {
        0xEF, 0xCD, 0xAB, 0x89, 0x67, 0x45, 0x23, 0x01, 0x00, 0x00, 0x00, 0x00, 0x0C, 0xA0, 0x00, 0x00
    };
    RBLE_GATT_READ_CHAR_REQ     Rd_Char;
    RBLE_STATUS                 Ret_Status;
    uint16_t                    Handle = 0x1234;
    int32_t                     Parameter_No;

    memset(&Rd_Char, 0, sizeof(Rd_Char));

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }

    switch( Parameter_No ) {
        case 0:
            Rd_Char.req_type = RBLE_GATT_READ_CHAR;
            /* char handle */
            Rd_Char.uuid[ 0 ].value[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 0 ) & 0xff );
            Rd_Char.uuid[ 0 ].value[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 8 ) & 0xff );
            Rd_Char.uuid[ 0 ].value_size = RBLE_GATT_16BIT_UUID_OCTET;
            Rd_Char.nb_uuid = 1;
            break;
        case 1:
            Rd_Char.req_type = RBLE_GATT_READ_BY_UUID_CHAR;
            Rd_Char.start_hdl = 0x0001;
            Rd_Char.end_hdl = 0xffff;
            if ( ( 3 <= RBLE_Parameter_Cnt ) && ( 128 == RBLE_Parameter_Arg[ 1 ] ) ) {
                Rd_Char.uuid[ 0 ].value_size = RBLE_GATT_128BIT_UUID_OCTET;
                memcpy( &Rd_Char.uuid[ 0 ].value[ 0 ], &Value[ 0 ], RBLE_GATT_128BIT_UUID_OCTET );
                Rd_Char.uuid[ 0 ].value[ 12 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 2 ] >> 0 ) & 0xff );
                Rd_Char.uuid[ 0 ].value[ 13 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 2 ] >> 8 ) & 0xff );
                if ( 5 == RBLE_Parameter_Cnt ) {
                    Rd_Char.start_hdl = ( uint16_t )RBLE_Parameter_Arg[ 3 ];
                    Rd_Char.end_hdl = ( uint16_t )RBLE_Parameter_Arg[ 4 ];
                }
            } else {
                Rd_Char.uuid[ 0 ].value_size = RBLE_GATT_16BIT_UUID_OCTET;
                Rd_Char.uuid[ 0 ].value[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 0 ) & 0xff );
                Rd_Char.uuid[ 0 ].value[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 8 ) & 0xff );
                if ( 4 == RBLE_Parameter_Cnt ) {
                    Rd_Char.start_hdl = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
                    Rd_Char.end_hdl = ( uint16_t )RBLE_Parameter_Arg[ 3 ];
                }
            }
            Rd_Char.nb_uuid = 1;
            break;
        case 2:
            Rd_Char.req_type = RBLE_GATT_READ_LONG_CHAR;
            Rd_Char.offset = 0x0000;
            /* char handle */
            Rd_Char.uuid[ 0 ].value[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 0 ) & 0xff );
            Rd_Char.uuid[ 0 ].value[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 8 ) & 0xff );
            if ( 3 == RBLE_Parameter_Cnt ) {
                Rd_Char.offset = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
            }
            Rd_Char.uuid[ 0 ].value_size = RBLE_GATT_16BIT_UUID_OCTET;
            Rd_Char.nb_uuid = 1;
            break;
        case 3:
            Rd_Char.req_type = RBLE_GATT_READ_MULT_LONG_CHAR;
            Rd_Char.uuid[ 0 ].value[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 0 ) & 0xff );
            Rd_Char.uuid[ 0 ].value[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 8 ) & 0xff );
            Rd_Char.uuid[ 1 ].value[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 2 ] >> 0 ) & 0xff );
            Rd_Char.uuid[ 1 ].value[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 2 ] >> 8 ) & 0xff );

            Rd_Char.uuid[ 0 ].expect_resp_size = 1;
            Rd_Char.uuid[ 0 ].value_size = RBLE_GATT_16BIT_UUID_OCTET;
            Rd_Char.uuid[ 1 ].expect_resp_size = RBLE_GATT_LEN_UNDEF;
            Rd_Char.uuid[ 1 ].value_size = RBLE_GATT_16BIT_UUID_OCTET;

            Rd_Char.nb_uuid = 2;
            break;
        case 4:
            Rd_Char.req_type = RBLE_GATT_READ_DESC;
            /* char handle */
            Rd_Char.uuid[ 0 ].value[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 0 ) & 0xff );
            Rd_Char.uuid[ 0 ].value[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 8 ) & 0xff );
            Rd_Char.uuid[ 0 ].value_size = RBLE_GATT_16BIT_UUID_OCTET;
            Rd_Char.nb_uuid = 1;
            break;
        case 5:
            Rd_Char.req_type = RBLE_GATT_READ_LONG_DESC;
            Rd_Char.offset = 0x0000;
            /* char handle */
            Rd_Char.uuid[ 0 ].value[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 0 ) & 0xff );
            Rd_Char.uuid[ 0 ].value[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 8 ) & 0xff );
            if ( 3 == RBLE_Parameter_Cnt ) {
                Rd_Char.offset = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
            }
            Rd_Char.uuid[ 0 ].value_size = RBLE_GATT_16BIT_UUID_OCTET;
            Rd_Char.nb_uuid = 1;
            break;
        default:
            Rd_Char.req_type = RBLE_GATT_READ_CHAR;
            /* char handle */
            Rd_Char.uuid[ 0 ].value[ 0 ] = ( uint8_t )( ( Handle >> 0 ) & 0xff );
            Rd_Char.uuid[ 0 ].value[ 1 ] = ( uint8_t )( ( Handle >> 8 ) & 0xff );
            Rd_Char.uuid[ 0 ].value_size = RBLE_GATT_16BIT_UUID_OCTET;
            Rd_Char.nb_uuid = 1;
            break;
    }

    Rd_Char.conhdl = Connection_Handle;

    /* API Call */
    Ret_Status = RBLE_GATT_Read_Char_Request( &Rd_Char );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

static BOOL RBLE_GATT_Write_Char_Request_Test( void )
{
    RBLE_GATT_WRITE_CHAR_REQ    Wr_Char;
    RBLE_STATUS                 Ret_Status;
    int32_t                     Parameter_No;
    uint8_t                     Data;
    uint16_t                    i;
    uint16_t                    len = 0;
    uint16_t                    Value = 0x1234;
    uint8_t                     Not_Use_IncData= 0;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }

    switch( Parameter_No ) {
        case 0:
            Wr_Char.req_type = RBLE_GATT_WRITE_NO_RESPONSE;
            Wr_Char.charhdl = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
            if ( 3 == RBLE_Parameter_Cnt ) {
                len = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
            } else {
                len = 1;
            }
            break;
        case 1:
            Wr_Char.req_type = RBLE_GATT_WRITE_SIGNED;
            Wr_Char.charhdl = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
            if ( 3 <= RBLE_Parameter_Cnt ) {
                len = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
                if ( 4 == RBLE_Parameter_Cnt ) {
                    Wr_Char.value[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 3 ] >> 0 ) & 0xff );
                    Wr_Char.value[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 3 ] >> 8 ) & 0xff );
                    Not_Use_IncData= 1;
                }
            } else {
                len = 1;
            }
            break;
        case 2:
            Wr_Char.req_type = RBLE_GATT_WRITE_CHAR;
            Wr_Char.charhdl = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
            if ( 3 == RBLE_Parameter_Cnt ) {
                len = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
            } else {
                len = 1;
            }
            break;
        case 3:
            Wr_Char.req_type = RBLE_GATT_WRITE_LONG_CHAR;
            Wr_Char.charhdl = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
            len = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
            Wr_Char.wr_offset = ( uint16_t )RBLE_Parameter_Arg[ 3 ];
            Wr_Char.auto_execute = ( uint8_t )RBLE_Parameter_Arg[ 4 ];
            break;
        case 4:
            Wr_Char.req_type = RBLE_GATT_WRITE_DESC;
            Wr_Char.charhdl = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
            if ( 3 <= RBLE_Parameter_Cnt ) {
                len = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
                if ( 4 == RBLE_Parameter_Cnt ) {
                    Wr_Char.value[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 3 ] >> 0 ) & 0xff );
                    Wr_Char.value[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 3 ] >> 8 ) & 0xff );
                    Not_Use_IncData= 1;
                }
            } else {
                len = 1;
            }
            break;
        case 5:
            Wr_Char.req_type = RBLE_GATT_WRITE_LONG_DESC;
            Wr_Char.charhdl = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
            len = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
            Wr_Char.wr_offset = ( uint16_t )RBLE_Parameter_Arg[ 3 ];
            Wr_Char.auto_execute = ( uint8_t )RBLE_Parameter_Arg[ 4 ];
            break;
        default:
            Wr_Char.req_type = RBLE_GATT_WRITE_NO_RESPONSE;
            Wr_Char.charhdl = 0x1234;
            break;
    }

    Wr_Char.conhdl = Connection_Handle;

    if ( 0 == len ) {
        Wr_Char.val_len = 2;
        Wr_Char.value[ 0 ] = ( uint8_t )( ( Value >> 0 ) & 0xff );
        Wr_Char.value[ 1 ] = ( uint8_t )( ( Value >> 8 ) & 0xff );
    } else {
        if ( 0 == Not_Use_IncData ) {
            for ( i = 0, Data = 0; i < len; i++, Data++ ) {
                Wr_Char.value[ i ] = Data;
            }
        }
        Wr_Char.val_len = len;
    }

    /* API Call */
    Ret_Status = RBLE_GATT_Write_Char_Request( &Wr_Char );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

static BOOL RBLE_GATT_Write_Reliable_Request_Test( void )
{
    static RBLE_GATT_WRITE_RELIABLE_REQ     Rel_Write;
    RBLE_STATUS                             Ret_Status;
    uint16_t                                Total_Size, Remain;
    uint16_t                                Handle;
    uint16_t                                i, j;
    uint8_t                                 Data = 0;

    memset( &Rel_Write, 0, sizeof( RBLE_GATT_WRITE_RELIABLE_REQ ) );

    if ( 3 == RBLE_Parameter_Cnt ) {
        Handle       = ( uint16_t )RBLE_Parameter_Arg[ 0 ];
        Total_Size   = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
        Rel_Write.auto_execute = ( uint8_t )RBLE_Parameter_Arg[ 2 ];
        Remain = Total_Size;
        Rel_Write.nb_writes = 0;

        for ( i = 0; (( i < RBLE_GATT_MAX_RELIABLE_WRITE_NUM ) && ( Remain != 0 )); i++ ) {
            if ( RBLE_GATT_MAX_RELIABLE_WRITE_CONTENTS < Remain ) {
                Rel_Write.value[ i ].size = RBLE_GATT_MAX_RELIABLE_WRITE_CONTENTS;
            } else {
                Rel_Write.value[ i ].size = Remain;
            }
            Remain -= Rel_Write.value[ i ].size;
            Rel_Write.nb_writes++;
            Rel_Write.value[ i ].elmt_hdl = Handle;
            for ( j = 0; j < Rel_Write.value[ i ].size; j++, Data++ ) {
                Rel_Write.value[ i ].value[ j ] = Data;
            }
        }
    } else {
        Rel_Write.nb_writes = 1;
        Rel_Write.auto_execute = TRUE;
        Rel_Write.value[ 0 ].elmt_hdl = 0x1234;
        Rel_Write.value[ 0 ].size = 1;
        Rel_Write.value[ 0 ].value[ 0 ] = 0x34;
        Rel_Write.value[ 0 ].value[ 1 ] = 0x12;
    }

    Rel_Write.conhdl = Connection_Handle;

    /* API Call */
    Ret_Status = RBLE_GATT_Write_Reliable_Request( &Rel_Write );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

static BOOL RBLE_GATT_Execute_Write_Char_Request_Test( void )
{
    RBLE_GATT_EXE_WR_CHAR_REQ   Exe_Wr_Char;
    RBLE_STATUS                 Ret_Status;
    int32_t                     Parameter_No;


    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }

    switch( Parameter_No ) {
        case 1:
            Exe_Wr_Char.exe_wr_ena = TRUE;
            break;
        case 0:
        default:
            Exe_Wr_Char.exe_wr_ena = FALSE;
            break;
    }

    Exe_Wr_Char.conhdl = Connection_Handle;

    /* API Call */
    Ret_Status = RBLE_GATT_Execute_Write_Char_Request( &Exe_Wr_Char );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

static BOOL RBLE_GATT_Notify_Request_Test( void )
{
    RBLE_GATT_NOTIFY_REQ    Notify;
    RBLE_STATUS             Ret_Status;
    uint16_t                hdl = 0x0001;

    if ( 0 != RBLE_Parameter_Cnt ) {
        hdl = ( uint16_t )RBLE_Parameter_Arg[ 0 ];
    }
    Notify.conhdl = Connection_Handle;
    Notify.charhdl = hdl;

    /* API Call */
    Ret_Status = RBLE_GATT_Notify_Request( &Notify );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

static BOOL RBLE_GATT_Indicate_Request_Test( void )
{
    RBLE_GATT_INDICATE_REQ  Indicate;
    RBLE_STATUS             Ret_Status;
    uint16_t                hdl = 0x0001;

    if ( 0 != RBLE_Parameter_Cnt ) {
        hdl = ( uint16_t )RBLE_Parameter_Arg[ 0 ];
    }
    Indicate.conhdl = Connection_Handle;
    Indicate.charhdl = hdl;

    /* API Call */
    Ret_Status = RBLE_GATT_Indicate_Request( &Indicate );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

static BOOL RBLE_GATT_Write_Response_Test( void )
{
    RBLE_GATT_WRITE_RESP    Wr_Resp;
    RBLE_STATUS             Ret_Status;

    if ( 2 == RBLE_Parameter_Cnt ) {
        Wr_Resp.att_hdl = ( uint16_t )RBLE_Parameter_Arg[ 0 ];
        Wr_Resp.att_code = ( uint8_t )RBLE_Parameter_Arg[ 1 ];
    } else {
        Wr_Resp.att_hdl = 0x0001;
        Wr_Resp.att_code = RBLE_ATT_ERR_NO_ERROR;
    }
    Wr_Resp.conhdl = Connection_Handle;

    /* API Call */
    Ret_Status = RBLE_GATT_Write_Response( &Wr_Resp );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

static BOOL RBLE_GATT_Set_Permission_Test( void )
{
    RBLE_GATT_SET_PERM      Set_Perm;
    RBLE_STATUS             Ret_Status;

    if ( 3 == RBLE_Parameter_Cnt ) {
        Set_Perm.start_hdl = ( uint16_t )RBLE_Parameter_Arg[ 0 ];
        Set_Perm.end_hdl = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
        Set_Perm.perm = ( uint16_t )RBLE_Parameter_Arg[ 2 ];
    } else {
        Set_Perm.start_hdl = 0x0001;
        Set_Perm.end_hdl = 0x0001;
        Set_Perm.perm = RBLE_GATT_PERM_RD;
    }

    /* API Call */
    Ret_Status = RBLE_GATT_Set_Permission( &Set_Perm );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

static BOOL RBLE_GATT_Set_Data_Test( void )
{
    RBLE_GATT_SET_DATA      Set_Data;
    RBLE_STATUS             Ret_Status;

    if ( 3 == RBLE_Parameter_Cnt ) {
        Set_Data.val_hdl = ( uint16_t )RBLE_Parameter_Arg[ 0 ];
        Set_Data.val_len = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
        Set_Data.value[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 2 ] >> 0  ) & 0xff );
        Set_Data.value[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 2 ] >> 8  ) & 0xff );
        Set_Data.value[ 2 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 2 ] >> 16 ) & 0xff );
        Set_Data.value[ 3 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 2 ] >> 24 ) & 0xff );
    } else {
        Set_Data.val_hdl = 0x0001;
        Set_Data.val_len = 0x0001;
        Set_Data.value[ 0 ] = 0x01;
    }

    /* API Call */
    Ret_Status = RBLE_GATT_Set_Data( &Set_Data );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

/* --------------------------- Find Me Profile ---------------------------------------*/
#ifdef  USE_FMPL_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE FMP(Locator) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_FMPL_CallBack( RBLE_FMPL_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_FMP_EVENT_LOCATOR_ENABLE_COMP:
            printf( "\nrBLE FMP EVENT (LOCATOR_ENABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.locator_enable.status ) );
            Connection_Handle_Disp( event->param.locator_enable.conhdl );
            printf( "* Immediate Alert service\n");
            printf( " Start Handle    = 0x%04X\n", event->param.locator_enable.ias.shdl );
            printf( " End Handle      = 0x%04X\n\n", event->param.locator_enable.ias.ehdl );
            printf( " alert_char_hdl  = 0x%04X\n", event->param.locator_enable.ias.alert_char_hdl);
            printf( " alert_val_hdl   = 0x%04X\n", event->param.locator_enable.ias.alert_val_hdl);
            printf( " alert_char_prop = 0x%02X\n\n", event->param.locator_enable.ias.alert_char_prop);
            break;
        case RBLE_FMP_EVENT_LOCATOR_DISABLE_COMP:
            printf( "\nrBLE FMP EVENT (LOCATOR_DISABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.locator_disable.status ) );
            Connection_Handle_Disp( event->param.locator_disable.conhdl );
            break;
        case RBLE_FMP_EVENT_LOCATOR_ERROR_IND:
            printf( "\nrBLE FMP EVENT (LOCATOR_ERROR_IND) Status(%s)\n", Get_Status_Str( event->param.locator_error_ind.status ) );
            Connection_Handle_Disp( event->param.locator_error_ind.conhdl );
            break;
        case RBLE_FMP_EVENT_LOCATOR_COMMAND_DISALLOWED_IND:
            printf( "\nrBLE FMP EVENT (COMMAND_DISALLOWED_IND) Status(%s)\n", Get_Status_Str( event->param.cmd_disallowed_ind.status ) );
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef  USE_FMPT_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE FMP(Target) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_FMPT_CallBack( RBLE_FMPT_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_FMP_EVENT_TARGET_ENABLE_COMP:
            printf( "\nrBLE FMP EVENT (TARGET_ENABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.target_enable.status ) );
            Connection_Handle_Disp( event->param.target_enable.conhdl );
            break;
        case RBLE_FMP_EVENT_TARGET_DISABLE_COMP:
            printf( "\nrBLE FMP EVENT (TARGET_DISABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.target_disable.status ) );
            Connection_Handle_Disp( event->param.target_disable.conhdl );
            break;
        case RBLE_FMP_EVENT_TARGET_ALERT_IND:
            printf( "\nrBLE FMP EVENT (TARGET_ALERT_IND)\n" );
            Connection_Handle_Disp( event->param.target_alert_ind.conhdl );
            printf( "alert_lvl = %d\n", event->param.target_alert_ind.alert_lvl );
            break;
        case RBLE_FMP_EVENT_TARGET_COMMAND_DISALLOWED_IND:
            printf( "\nrBLE FMP EVENT (COMMAND_DISALLOWED_IND) Status(%s)\n", Get_Status_Str( event->param.cmd_disallowed_ind.status ) );
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}

/******************************************************************************************/
/**
 *  @brief A FMP_Target_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_FMP_Target_Enable_Test( void )
{
    /* security level */
    const uint8_t sec_lvl = RBLE_SVC_SEC_NONE;

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_FMP_Target_Enable( Connection_Handle, sec_lvl, RBLE_APP_FMPT_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A FMP_Target_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_FMP_Target_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_FMP_Target_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#ifdef  USE_FMPL_SAMPLE
/******************************************************************************************/
/**
 *  @brief A FMP_Locator_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_FMP_Locator_Enable_Test( void )
{
    /* ConType */
    const uint8_t con_type = RBLE_PRF_CON_DISCOVERY;    /* Discovery type */
//  const uint8_t con_type = RBLE_PRF_CON_NORMAL;       /* Normal type */

    static RBLE_FMP_IAS_CONTENT ias = {
        0x0000,                         /* Start Handle */
        0x0000,                         /* End Handle */
        0x0000,                         /* Alert Level Characteristic handle */
        0x0000,                         /* Alert Level Characteristic value handle */
        0x00,                           /* Alert Level Characteristic properties */
        0x00,                           /* Reserved */
    };
    
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_FMP_Locator_Enable( Connection_Handle, con_type, &ias, RBLE_APP_FMPL_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A FMP_Locator_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_FMP_Locator_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_FMP_Locator_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A FMP_Locator_Set_Alert command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_FMP_Locator_Set_Alert_Test( void )
{
    int32_t                             Parameter_No;
    RBLE_FMP_LOCATOR_SET_ALERT_PARAM    *Parameter_p;

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
            || ( ( sizeof( RBLE_FMP_Locator_Set_Alert_Param ) / sizeof( RBLE_FMP_LOCATOR_SET_ALERT_PARAM ) ) <= Parameter_No ) ) {
            Parameter_p = &RBLE_FMP_Locator_Set_Alert_Param[ 0 ];
            Select_Param_No_Disp( 0 );
        } else {
            Parameter_p = &RBLE_FMP_Locator_Set_Alert_Param[ Parameter_No ];
            Select_Param_No_Disp( Parameter_No );
        }
        /* API Call */
        Ret_Status = RBLE_FMP_Locator_Set_Alert( Connection_Handle, Parameter_p->alert_lvl );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#ifdef USE_HTPC_SAMPLE
/* ------------------------- Health Thermometer Profile-------------------------------*/
/******************************************************************************************/
/**
 *  @brief rBLE HTP(Collector) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_HTPC_CallBack( RBLE_HTPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_HTP_EVENT_COLLECTOR_ENABLE_COMP:
            printf( "\nrBLE HTP EVENT (COLLECTOR_ENABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.collector_enable.status ) );
            Connection_Handle_Disp( event->param.collector_enable.conhdl );
            printf( "* Health Tehrmometer Service\n");
            printf( " Start Handle    = 0x%04X\n",   event->param.collector_enable.hts.shdl );
            printf( " End Handle      = 0x%04X\n\n", event->param.collector_enable.hts.ehdl );
            printf( " temp_meas_char_hdl = 0x%04X\n",   event->param.collector_enable.hts.temp_meas_char_hdl );
            printf( " temp_meas_val_hdl  = 0x%04X\n",   event->param.collector_enable.hts.temp_meas_val_hdl  );
            printf( " temp_meas_cfg_hdl  = 0x%04X\n",   event->param.collector_enable.hts.temp_meas_cfg_hdl  );
            printf( " temp_meas_prop     = 0x%02X\n\n", event->param.collector_enable.hts.temp_meas_prop     );
            printf( " temp_type_char_hdl = 0x%04X\n",   event->param.collector_enable.hts.temp_type_char_hdl );
            printf( " temp_type_val_hdl  = 0x%04X\n",   event->param.collector_enable.hts.temp_type_val_hdl  );
            printf( " temp_type_prop     = 0x%02X\n\n", event->param.collector_enable.hts.temp_type_prop     );
            printf( " interm_temp_char_hdl = 0x%04X\n",   event->param.collector_enable.hts.interm_temp_char_hdl );
            printf( " interm_temp_val_hdl  = 0x%04X\n",   event->param.collector_enable.hts.interm_temp_val_hdl  );
            printf( " interm_temp_cfg_hdl  = 0x%04X\n",   event->param.collector_enable.hts.interm_temp_cfg_hdl  );
            printf( " interm_temp_prop     = 0x%02X\n\n", event->param.collector_enable.hts.interm_temp_prop     );
            printf( " meas_intv_char_hdl = 0x%04X\n",   event->param.collector_enable.hts.meas_intv_char_hdl );
            printf( " meas_intv_val_hdl  = 0x%04X\n",   event->param.collector_enable.hts.meas_intv_val_hdl  );
            printf( " meas_intv_cfg_hdl  = 0x%04X\n",   event->param.collector_enable.hts.meas_intv_cfg_hdl  );
            printf( " valid_range_hdl    = 0x%04X\n",   event->param.collector_enable.hts.valid_range_hdl    );
            printf( " meas_intv_prop     = 0x%02X\n\n", event->param.collector_enable.hts.meas_intv_prop     );
            DIS_handle_Info_Disp(&event->param.collector_enable.dis);
            break;
        case RBLE_HTP_EVENT_COLLECTOR_DISABLE_COMP:
            printf( "\nrBLE HTP EVENT (COLLECTOR_DISABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.collector_disable.status ) );
            Connection_Handle_Disp( event->param.collector_disable.conhdl );
            break;
        case RBLE_HTP_EVENT_COLLECTOR_ERROR_IND:
            printf( "\nrBLE HTP EVENT (COLLECTOR_ERROR_IND) Status(%s)\n", Get_Status_Str( event->param.error_ind.status ) );
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_HTP_EVENT_COLLECTOR_TEMP_IND:
            printf( "\nrBLE HTP EVENT (COLLECTOR_TEMP_IND)\n" );
            Connection_Handle_Disp( event->param.temp_ind.conhdl );
            HTP_Info_Disp( &event->param.temp_ind.temp_info );
            break;
        case RBLE_HTP_EVENT_COLLECTOR_MEAS_INTV_IND:
            printf( "\nrBLE HTP EVENT (COLLECTOR_MEAS_INTV_IND)\n" );
            Connection_Handle_Disp( event->param.meas_intv_ind.conhdl );
            printf( "intv = %d\n", event->param.meas_intv_ind.intv );
            break;
        case RBLE_HTP_EVENT_COLLECTOR_READ_CHAR_RESPONSE:
            printf( "\nrBLE HTP EVENT (COLLECTOR_READ_CHAR_RESPONSE) Status(%s)\n", Get_Status_Str( event->param.rd_char_resp.att_code ) );
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            ATT_Info_Disp( &event->param.rd_char_resp.data );
            break;
        case RBLE_HTP_EVENT_COLLECTOR_WRITE_CHAR_RESPONSE:
            printf( "\nrBLE HTP EVENT (COLLECTOR_WRITE_CHAR_RESPONSE) Status(%s)\n", Get_Status_Str( event->param.wr_char_resp.att_code ) );
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_HTP_EVENT_COLLECTOR_COMMAND_DISALLOWED_IND:
            printf( "\nrBLE HTP EVENT (COMMAND_DISALLOWED_IND) Status(%s)\n", Get_Status_Str( event->param.cmd_disallowed_ind.status ) );
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif
#ifdef USE_HTPT_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE HTP(Thermometer) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_HTPT_CallBack( RBLE_HTPT_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_HTP_EVENT_THERMOMETER_ENABLE_COMP:
            printf( "\nrBLE HTP EVENT (THERMOMETER_ENABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.thermometer_enable.status ) );
            Connection_Handle_Disp( event->param.thermometer_enable.conhdl );
            break;
        case RBLE_HTP_EVENT_THERMOMETER_DISABLE_COMP:
            printf( "\nrBLE HTP EVENT (THERMOMETER_DISABLE_COMP)\n" );
            Connection_Handle_Disp( event->param.thermometer_disable.conhdl );
            break;
        case RBLE_HTP_EVENT_THERMOMETER_ERROR_IND:
            printf( "\nrBLE HTP EVENT (THERMOMETER_ERROR_IND) Status(%s)\n", Get_Status_Str( event->param.error_ind.status ) );
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_HTP_EVENT_THERMOMETER_SEND_TEMP_COMP:
            printf( "\nrBLE HTP EVENT (THERMOMETER_SEND_TEMP_COMP) Status(%s)\n", Get_Status_Str( event->param.send_temp.status ) );
            Connection_Handle_Disp( event->param.send_temp.conhdl );
            break;
        case RBLE_HTP_EVENT_THERMOMETER_REQ_MEASUREMENT_PERIOD_IND_COMP:
            printf( "\nrBLE HTP EVENT (THERMOMETER_REQ_MEASUREMENT_PERIOD_IND_COMP) Status(%s)\n", Get_Status_Str( event->param.send_meas_period.status ) );
            Connection_Handle_Disp( event->param.send_meas_period.conhdl );
            break;
        case RBLE_HTP_EVENT_THERMOMETER_MEAS_INTV_CHG_IND:
            printf( "\nrBLE HTP EVENT (THERMOMETER_MEAS_INTV_CHG_IND)\n" );
            Connection_Handle_Disp( event->param.meas_intv_chg_ind.conhdl );
            printf( "intv = %d\n", event->param.meas_intv_chg_ind.intv );
            break;
        case RBLE_HTP_EVENT_THERMOMETER_CFG_INDNTF_IND:
            printf( "\nrBLE HTP EVENT (THERMOMETER_CFG_INDNTF_IND)\n" );
            Connection_Handle_Disp( event->param.htpt_cfg_indntf_ind.conhdl );
            printf( "Char code = %d\n", event->param.htpt_cfg_indntf_ind.char_code );
            printf( "Cfg val   = %d\n", event->param.htpt_cfg_indntf_ind.cfg_val );
            break;
        case RBLE_HTP_EVENT_THERMOMETER_COMMAND_DISALLOWED_IND:
            printf( "\nrBLE HTP EVENT (COMMAND_DISALLOWED_IND) Status(%s)\n", Get_Status_Str( event->param.cmd_disallowed_ind.status ) );
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}

/******************************************************************************************/
/**
 *  @brief A HTP_Thermometer_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HTP_Thermometer_Enable_Test( void )
{
    RBLE_STATUS                     Ret_Status;
    RBLE_HTP_THERM_ENABLE_PARAM     *Parameter_p;
    int32_t                         Parameter_No;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
            || ( ( sizeof( RBLE_HTP_Therm_Enable_Param ) / sizeof( RBLE_HTP_THERM_ENABLE_PARAM ) ) <= Parameter_No ) ) {
            Parameter_p = &RBLE_HTP_Therm_Enable_Param[ 0 ];
            Select_Param_No_Disp( 0 );
        } else {
            Parameter_p = &RBLE_HTP_Therm_Enable_Param[ Parameter_No ];
            Select_Param_No_Disp( Parameter_No );
        }

        /* API Call */
        Ret_Status = RBLE_HTP_Thermometer_Enable( Connection_Handle, Parameter_p->sec_lvl, Parameter_p->con_type, &Parameter_p->param, RBLE_APP_HTPT_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HTP_Thermometer_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HTP_Thermometer_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HTP_Thermometer_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HTP_Thermometer_Send_Temp command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HTP_Thermometer_Send_Temp_Test( void )
{
    int32_t                         Parameter_No;
    static RBLE_HTP_TEMP_INFO temp_info[] =
    {
        {   /* 0:TC_CI_BV_01_C */
            0x01,           /* Stable or intermediary type of temperature */
            0x06,           /* flags */
            0x00000001,     /* temp value */
            {               /* time stamp */
                0x1234,     /* Year value */
                0x56,       /* Month value */
                0x78,       /* Day value */
                0x9A,       /* Hour value */
                0xBC,       /* Minute value */
                0xDE,       /* Second value */
                0xF0,       /* Reserved */
            },
            0x02,           /* type */
            0x00,           /* Reserved */
        },
        {   /* 1:TC_SP_BV_03_C */
            0x00,           /* Stable or intermediary type of temperature */
            0x06,           /* flags */
            0x00000001,     /* temp value */
            {               /* time stamp */
                0x1234,     /* Year value */
                0x56,       /* Month value */
                0x78,       /* Day value */
                0x9A,       /* Hour value */
                0xBC,       /* Minute value */
                0xDE,       /* Second value */
                0xF0,       /* Reserved */
            },
            0x02,           /* type */
            0x00,           /* Reserved */
        }
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
          || ( ( sizeof( temp_info ) / sizeof( RBLE_HTP_TEMP_INFO ) ) <= Parameter_No ) ) {
            Select_Param_No_Disp( 0 );
            /* API Call */
            Ret_Status = RBLE_HTP_Thermometer_Send_Temp( Connection_Handle, &temp_info[0] );
            printf( "Value = %d\n", temp_info[0].temp_val );
        } else {
            Select_Param_No_Disp( Parameter_No );
            /* API Call */
            Ret_Status = RBLE_HTP_Thermometer_Send_Temp( Connection_Handle, &temp_info[Parameter_No] );
            printf( "Value = %d\n", temp_info[Parameter_No].temp_val );
        }

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HTP_Thermometer_Req_Measurement_Period_Ind command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HTP_Thermometer_Req_Measurement_Period_Ind_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HTP_Thermometer_Req_Measurement_Period_Ind( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif
#ifdef USE_HTPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A HTP_Collector_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HTP_Collector_Enable_Test( void )
{
    /* Connection_Type */
    static uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
//  static uint8_t con_type = RBLE_PRF_CON_NORMAL;

    static RBLE_HTS_CONTENT hts = {
        0x0000,         /* StartHdl */
        0x0000,         /* EndHdl */
        0x0000,         /* TempMeasCharHdl */
        0x0000,         /* TempMeasValHdl */
        0x0000,         /* TempMeasCfgHdl */
        0x00,           /* TempMeasProp */
        0x00,           /* Pad */
        0x0000,         /* TempTypeCharHdl */
        0x0000,         /* TempTypeValHdl */
        0x00,           /* TempTypeProp */
        0x00,           /* Pad */
        0x0000,         /* IntermTempCharHdl */
        0x0000,         /* IntermTempValHdl */
        0x0000,         /* IntermTempCfgHdl */
        0x00,           /* IntermTempProp */
        0x00,           /* Pad */
        0x0000,         /* MeasIntvCharHdl */
        0x0000,         /* MeasIntvValHdl */
        0x0000,         /* MeasIntvCfgHdl */
        0x0000,         /* ValidRangeHdl */
        0x00,           /* MeasIntvProp */
        0x00,           /* Pad */
    };

    static RBLE_DIS_CONTENT dis = {
        0x0000,         /* StartHdl */
        0x0000,         /* EndHdl */
        0x0000,         /* SysIdCharHdl */
        0x0000,         /* SysIdValHdl */
        0x00,           /* SysIdProp */
        0x00,           /* Pad */
        0x0000,         /* ModelNbCharHdl */
        0x0000,         /* ModelNbValHdl */
        0x00,           /* ModelNbProp */
        0x00,           /* Pad */
        0x0000,         /* SerialNbCharHdl */
        0x0000,         /* SerialNbValHdl */
        0x00,           /* SerialNbProp */
        0x00,           /* Pad */
        0x0000,         /* FwRevCharHdl */
        0x0000,         /* FwRevValdl */
        0x00,           /* FwRevProp */
        0x00,           /* Pad */
        0x0000,         /* HwRevCharHdl */
        0x0000,         /* HwRevValHdl */
        0x00,           /* HwRevProp */
        0x00,           /* Pad */
        0x0000,         /* SwRevCharHdl */
        0x0000,         /* SwRevValHdl */
        0x00,           /* SwRevProp */
        0x00,           /* Pad */
        0x0000,         /* ManufNameCharHdl */
        0x0000,         /* ManufNameValHdl */
        0x00,           /* ManufNameProp */
        0x00,           /* Pad */
        0x0000,         /* IeeeCertifCharHdl */
        0x0000,         /* IeeeCertifValHdl */
        0x00,           /* IeeeCertifProp */
        0x00,           /* Pad */
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HTP_Collector_Enable( Connection_Handle, con_type, &hts, &dis, RBLE_APP_HTPC_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HTP_Collector_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HTP_Collector_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HTP_Collector_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HTP_Collector_Read_Char command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HTP_Collector_Read_Char_Test( void )
{
    uint8_t         char_code;
    RBLE_STATUS     Ret_Status;
    int32_t         Parameter_No;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }
    if ( ( ILLEGAL_NO == Parameter_No ) || ( RBLE_HTPC_RD_DIS_IEEE < Parameter_No ) ) {
        char_code = RBLE_HTPC_RD_HTS_TM_CFG;
        Select_Param_No_Disp( 0 );
    } else {
        char_code = (uint8_t)Parameter_No;
        Select_Param_No_Disp( Parameter_No );
    }

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HTP_Collector_Read_Char( Connection_Handle, char_code );
        printf( " char_code = %d\n", char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HTP_Collector_Write_Char command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HTP_Collector_Write_Char_Test( void )
{
    int32_t                         Parameter_No;
    /* CharCode */
    uint8_t char_code = RBLE_HTPC_TEMP_MEAS_CODE;       /*=1*/
//  uint8_t char_code = RBLE_HTPC_INTERM_TEMP_CODE;     /*=2*/
//  uint8_t char_code = RBLE_HTPC_MEAS_INTV_CODE;       /*=3*/
    /* CfgVal */
//  uint16_t cfg_val = RBLE_PRF_STOP_NTFIND;            /*=0*/
//  uint16_t cfg_val = RBLE_PRF_START_NTF;              /*=1*/
    uint16_t cfg_val = RBLE_PRF_START_IND;              /*=2*/

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        switch( Parameter_No ){
        case 0:
        case ILLEGAL_NO:
        default:
            Parameter_No = 0;
            char_code = RBLE_HTPC_TEMP_MEAS_CODE;       /*=1*/
            cfg_val = RBLE_PRF_START_IND;               /*=2*/
            break;
        case 1:
            char_code = RBLE_HTPC_INTERM_TEMP_CODE;     /*=2*/
            cfg_val = RBLE_PRF_START_NTF;               /*=1*/
            break;
        case 2:
            char_code = RBLE_HTPC_MEAS_INTV_CODE;       /*=3*/
            cfg_val = RBLE_PRF_START_IND;               /*=1*/
            break;
        }
        Select_Param_No_Disp( Parameter_No );
        
        /* API Call */
        Ret_Status = RBLE_HTP_Collector_Write_Char( Connection_Handle, char_code, cfg_val );
        printf( " char_code = %d, cfg_val = %d\n", char_code, cfg_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HTP_Collector_Set_Measurement_Period command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HTP_Collector_Set_Measurement_Period_Test( void )
{
    const uint16_t intv = 0x0003;           /* Interval Range:0x003 - 0x0010 */

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HTP_Collector_Set_Measurement_Period( Connection_Handle, intv );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#ifdef USE_PXPR_SAMPLE
/* ------------------------- Proximity Profile---------------------------------------*/
/******************************************************************************************/
/**
 *  @brief rBLE PXP(Reporter) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_PXPR_CallBack( RBLE_PXPR_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type ) {
        case RBLE_PXP_EVENT_REPORTER_ENABLE_COMP:
            printf( "\nrBLE PXP EVENT (REPORTER_ENABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.report_enable.status ) );
            Connection_Handle_Disp( event->param.report_enable.conhdl );
            break;
        case RBLE_PXP_EVENT_REPORTER_DISABLE_COMP:
            printf( "\nrBLE PXP EVENT (REPORTER_DISABLE_COMP)\n" );
            Connection_Handle_Disp( event->param.report_disable.conhdl );
            printf( "lls_alert_lvl = %d\n", event->param.report_disable.lls_alert_lvl );
            break;
        case RBLE_PXP_EVENT_REPORTER_ALERT_IND:
            printf( "\nrBLE PXP EVENT (REPORTER_ALERT_IND)\n" );
            Connection_Handle_Disp( event->param.report_alert_ind.conhdl );
            printf( "alert_lvl = %d\n", event->param.report_alert_ind.alert_lvl );
            break;
        case RBLE_PXP_EVENT_REPORTER_COMMAND_DISALLOWED_IND:
            printf( "\nrBLE PXP EVENT (COMMAND_DISALLOWED_IND) Status(%s)\n", Get_Status_Str( event->param.cmd_disallowed_ind.status ) );
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif
#ifdef USE_PXPM_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE PXP(Monitor) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_PXPM_CallBack( RBLE_PXPM_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type ) {
        case RBLE_PXP_EVENT_MONITOR_ENABLE_COMP:
            printf( "\nrBLE PXP EVENT (MONITOR_ENABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.monitor_enable.status ) );
            Connection_Handle_Disp( event->param.monitor_enable.conhdl );
            printf("* Link Loss Service\n");
            printf(" Start Handle    = 0x%04X\n", event->param.monitor_enable.lls.shdl );
            printf(" End Handle      = 0x%04X\n\n", event->param.monitor_enable.lls.ehdl );
            printf(" Alert level char handle = 0x%04X\n", event->param.monitor_enable.lls.alert_lvl.char_hdl);
            printf(" alert Level value handle= 0x%04X\n", event->param.monitor_enable.lls.alert_lvl.val_hdl);
            printf(" Alert level properties  = 0x%02X\n", event->param.monitor_enable.lls.alert_lvl.prop);
            printf(" Alert value             = 0x%02X\n\n", event->param.monitor_enable.lls.alert_lvl.value);
            printf("* Immediate Alert service\n");
            printf(" Start Handle    = 0x%04X\n",   event->param.monitor_enable.ias.shdl );
            printf(" End Handle      = 0x%04X\n\n", event->param.monitor_enable.ias.ehdl );
            printf(" Alert level char handle = 0x%04X\n", event->param.monitor_enable.ias.alert_lvl.char_hdl);
            printf(" alert Level value handle= 0x%04X\n", event->param.monitor_enable.ias.alert_lvl.val_hdl);
            printf(" Alert level properties  = 0x%02X\n", event->param.monitor_enable.ias.alert_lvl.prop);
            printf(" Alert value             = 0x%02X\n\n", event->param.monitor_enable.ias.alert_lvl.value);
            printf("* Tx Power Service\n");
            printf(" Start Handle    = 0x%04X\n",   event->param.monitor_enable.tps.shdl );
            printf(" End Handle      = 0x%04X\n\n", event->param.monitor_enable.tps.ehdl );
            printf(" txpw_lvl_char_hdl= 0x%04X\n",  event->param.monitor_enable.tps.txpw_lvl_char_hdl);
            printf(" txpw_lvl_val_hdl = 0x%04X\n",  event->param.monitor_enable.tps.txpw_lvl_val_hdl );
            printf(" txpw_lvl_cfg_hdl = 0x%04X\n",  event->param.monitor_enable.tps.txpw_lvl_cfg_hdl );
            printf(" txpw_lvl_prop    = 0x%02X\n",  event->param.monitor_enable.tps.txpw_lvl_prop    );
            printf(" txpw_lvl         = 0x%02X\n\n",event->param.monitor_enable.tps.txpw_lvl         );
            break;
        case RBLE_PXP_EVENT_MONITOR_DISABLE_COMP:
            printf( "\nrBLE PXP EVENT (MONITOR_DISABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.monitor_disale.status ) );
            Connection_Handle_Disp( event->param.monitor_disale.conhdl );
            break;
        case RBLE_PXP_EVENT_MONITOR_ERROR_IND:
            printf( "\nrBLE PXP EVENT (MONITOR_ERROR_IND) Status(%s)\n", Get_Status_Str( event->param.monitor_error_ind.status ) );
            Connection_Handle_Disp( event->param.monitor_error_ind.conhdl );
            break;
        case RBLE_PXP_EVENT_MONITOR_READ_CHAR_RESPONSE:
            printf( "\nrBLE PXP EVENT (MONITOR_READ_CHAR_RESPONSE) Status(%s)\n", Get_Status_Str( event->param.rd_char_resp.att_code ) );
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            ATT_Info_Disp( &event->param.rd_char_resp.data );
            break;
        case RBLE_PXP_EVENT_MONITOR_WRITE_CHAR_RESPONSE:
            printf( "\nrBLE PXP EVENT (MONITOR_WRITE_CHAR_RESPONSE) Status(%s)\n", Get_Status_Str( event->param.wr_char_resp.att_code ) );
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_PXP_EVENT_MONITOR_COMMAND_DISALLOWED_IND:
            printf( "\nrBLE PXP EVENT (COMMAND_DISALLOWED_IND) Status(%s)\n", Get_Status_Str( event->param.cmd_disallowed_ind.status ) );
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif
#ifdef USE_PXPR_SAMPLE
/******************************************************************************************/
/**
 *  @brief A PXP_Reporter_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PXP_Reporter_Enable_Test( void )
{
    /* Alert_Level */
    const uint8_t alert_lvl = RBLE_SVC_ALERT_NONE;      /* No alert */
//  const uint8_t alert_lvl = RBLE_SVC_ALERT_MILD;      /* Mild aler */
//  const uint8_t alert_lvl = RBLE_SVC_ALERT_HIGH;      /* High alert */

    /* security level */
    const uint8_t sec_lvl   = RBLE_SVC_SEC_NONE;

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_PXP_Reporter_Enable( Connection_Handle, alert_lvl, sec_lvl, RBLE_APP_PXPR_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A PXP_Reporter_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PXP_Reporter_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_PXP_Reporter_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif
#ifdef USE_PXPM_SAMPLE
/******************************************************************************************/
/**
 *  @brief A PXP_Monitor_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PXP_Monitor_Enable_Test( void )
{
    /* ConType */
    const uint8_t con_type = RBLE_PRF_CON_DISCOVERY;    /* Discovery type connection */
//  const uint8_t con_type = RBLE_PRF_CON_NORMAL;       /* Normal type connection */

    static RBLE_PROXI_MON_PARAM param = {
        0x00,       /* LlsShdl */
        0x00,       /* LlsEhdl */
        0x00,       /* LlsCharHdl */
        0x00,       /* LlsValHdl */
        0x00,       /* LlsProp */
        0x00,       /* LlsValue */
        0x00,       /* IasShdl */
        0x00,       /* IasEhdl */
        0x00,       /* IasCharHdl */
        0x00,       /* IasValHdl */
        0x00,       /* IasProp */
        0x00,       /* IasValue */
        0x00,       /* TpsShdl */
        0x00,       /* TpsEhdl */
        0x00,       /* TpsTxpwLvlChHdl */
        0x00,       /* TpsTxpwLvlValHdl */
        0x00,       /* TpsTxpwLvlCfgHdl */
        0x00,       /* TpsTxpwLvlProp */
        0x00,       /* TpsTxpwLvl */
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_PXP_Monitor_Enable( Connection_Handle, con_type, &param, RBLE_APP_PXPM_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A PXP_Monitor_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PXP_Monitor_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_PXP_Monitor_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A PXP_Monitor_Get_Alert_Level command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PXP_Monitor_Get_Alert_Level_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_PXP_Monitor_Get_Alert_Level( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A PXP_Monitor_Set_Alert_Level command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PXP_Monitor_Set_Alert_Level_Test( void )
{
    int32_t                         Parameter_No;
    /* SvcCode */
//  uint8_t svc_code = RBLE_PROXM_SET_LK_LOSS_ALERT;    /*=0 LLS Alert Level */
    uint8_t svc_code = RBLE_PROXM_SET_IMMDT_ALERT;  /*=1 IAS Alert Level */

    /* Alert_Level */
//  uint8_t lvl = RBLE_SVC_ALERT_NONE;      /*=0 No alert */
    uint8_t lvl = RBLE_SVC_ALERT_MILD;      /*=1 Mild alert */
//  uint8_t lvl = RBLE_SVC_ALERT_HIGH;      /*=2 High alert */

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        switch( Parameter_No ){
        case 0:
        case ILLEGAL_NO:
        default:
            Parameter_No = 0;
            svc_code    = RBLE_PROXM_SET_LK_LOSS_ALERT; /*=0 LLS Alert Level */
            lvl         = RBLE_SVC_ALERT_MILD;          /*=1 Mild alert */
            break;
        case 1:
            svc_code    = RBLE_PROXM_SET_IMMDT_ALERT;   /*=1 IAS Alert Level */
            lvl         = RBLE_SVC_ALERT_MILD;          /*=1 Mild alert */
            break;
        case 2:
            svc_code    = RBLE_PROXM_SET_IMMDT_ALERT;   /*=1 IAS Alert Level */
            lvl         = RBLE_SVC_ALERT_NONE;          /*=0 No alert */
            break;
        }
        Select_Param_No_Disp( Parameter_No );
        
        /* API Call */
        Ret_Status = RBLE_PXP_Monitor_Set_Alert_Level( Connection_Handle, svc_code, lvl );
        printf( " code = %d, lvl = %d\n", svc_code, lvl );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A PXP_Monitor_Get_Tx_Power command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PXP_Monitor_Get_Tx_Power_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_PXP_Monitor_Get_Tx_Power( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#ifdef USE_BLPC_SAMPLE
/* ------------------------- Blood Pressure Profile-------------------------------*/
/******************************************************************************************/
/**
 *  @brief rBLE BLP(Collector) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_BLPC_CallBack( RBLE_BLPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_BLP_EVENT_COLLECTOR_ENABLE_COMP:
            printf( "\nrBLE BLP EVENT (COLLECTOR_ENABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.collector_enable.status ) );
            Connection_Handle_Disp( event->param.collector_enable.conhdl );
            printf( "* Blood Pressure Service\n");
            printf( " Start Handle = 0x%04X\n", event->param.collector_enable.bls.shdl );
            printf( " End Handle   = 0x%04X\n\n", event->param.collector_enable.bls.ehdl );
            printf( " meas_char_hdl = 0x%04X\n", event->param.collector_enable.bls.bldprs_meas_char_hdl );
            printf( " meas_val_hdl  = 0x%04X\n", event->param.collector_enable.bls.bldprs_meas_val_hdl );
            printf( " meas_cfg_hdl  = 0x%04X\n", event->param.collector_enable.bls.bldprs_meas_cfg_hdl );
            printf( " meas_prop     = 0x%02X\n\n", event->param.collector_enable.bls.bldprs_meas_prop );
            printf( " cufprs_char_hdl = 0x%04X\n", event->param.collector_enable.bls.interm_cufprs_char_hdl );
            printf( " cufprs_val_hdl  = 0x%04X\n", event->param.collector_enable.bls.interm_cufprs_val_hdl );
            printf( " cufprs_cfg_hdl  = 0x%04X\n", event->param.collector_enable.bls.interm_cufprs_cfg_hdl );
            printf( " cufprs_prop     = 0x%02X\n\n", event->param.collector_enable.bls.interm_cufprs_prop );
            printf( " feat_char_hdl = 0x%04X\n", event->param.collector_enable.bls.bldprs_feat_char_hdl );
            printf( " feat_val_hdl  = 0x%04X\n", event->param.collector_enable.bls.bldprs_feat_val_hdl );
            printf( " feat_prop     = 0x%02X\n\n", event->param.collector_enable.bls.bldprs_feat_prop );
            DIS_handle_Info_Disp(&event->param.collector_enable.dis);
            break;
        case RBLE_BLP_EVENT_COLLECTOR_DISABLE_COMP:
            printf( "\nrBLE BLP EVENT (COLLECTOR_DISABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.collector_disable.status ) );
            Connection_Handle_Disp( event->param.collector_disable.conhdl );
            break;
        case RBLE_BLP_EVENT_COLLECTOR_ERROR_IND:
            printf( "\nrBLE BLP EVENT (COLLECTOR_ERROR_IND) Status(%s)\n", Get_Status_Str( event->param.error_ind.status ) );
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_BLP_EVENT_COLLECTOR_MEASUREMENTS_IND:
            printf( "\nrBLE BLP EVENT (COLLECTOR_MEASUREMENTS_IND)\n" );
            Connection_Handle_Disp( event->param.measurements_ind.conhdl );
            BLP_Info_Disp( &event->param.measurements_ind.measurements_info );
            break;
        case RBLE_BLP_EVENT_COLLECTOR_READ_CHAR_RESPONSE:
            printf( "\nrBLE BLP EVENT (COLLECTOR_READ_CHAR_RESPONSE) Status(%s)\n", Get_Status_Str( event->param.rd_char_resp.att_code ) );
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            ATT_Info_Disp( &event->param.rd_char_resp.data );
            break;
        case RBLE_BLP_EVENT_COLLECTOR_WRITE_CHAR_RESPONSE:
            printf( "\nrBLE BLP EVENT (COLLECTOR_WRITE_CHAR_RESPONSE) Status(%s)\n", Get_Status_Str( event->param.wr_char_resp.att_code ) );
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_BLP_EVENT_COLLECTOR_COMMAND_DISALLOWED_IND:
            printf( "\nrBLE BLP EVENT (COMMAND_DISALLOWED_IND) Status(%s)\n", Get_Status_Str( event->param.cmd_disallowed_ind.status ) );
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif
#ifdef USE_BLPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE BLP(Sensor) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_BLPS_CallBack( RBLE_BLPS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_BLP_EVENT_SENSOR_ENABLE_COMP:
            printf( "\nrBLE BLP EVENT (SENSOR_ENABLE_COMP) Status(%s)\n", Get_Status_Str( event->param.sensor_enable.status ) );
            Connection_Handle_Disp( event->param.sensor_enable.conhdl );
            break;
        case RBLE_BLP_EVENT_SENSOR_DISABLE_COMP:
            printf( "\nrBLE BLP EVENT (SENSOR_DISABLE_COMP)\n" );
            Connection_Handle_Disp( event->param.sensor_disable.conhdl );
            break;
        case RBLE_BLP_EVENT_SENSOR_ERROR_IND:
            printf( "\nrBLE BLP EVENT (SENSOR_ERROR_IND) Status(%s)\n", Get_Status_Str( event->param.error_ind.status ) );
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_BLP_EVENT_SENSOR_SEND_MEASUREMENTS_COMP:
            printf( "\nrBLE BLP EVENT (SENSOR_SEND_MEASUREMENTS_COMP) Status(%s)\n", Get_Status_Str( event->param.send_measurements.status ) );
            Connection_Handle_Disp( event->param.send_measurements.conhdl );
            break;
        case RBLE_BLP_EVENT_SENSOR_CFG_INDNTF_IND:
            printf( "\nrBLE BLP EVENT (SENSOR_CFG_INDNTF_IND)\n" );
            printf( "  Char Code = %s\n", ( event->param.blps_cfg_indntf_ind.char_code == RBLE_BLPC_BLDPRS_MEAS_CODE ) ? "BLDPRS_MEAS" :"INTERM_CUFPRS" );
            printf( "  Cfg Value = %s\n", ( event->param.blps_cfg_indntf_ind.cfg_val == RBLE_PRF_STOP_NTFIND ) ? "STOP" : "START_NTF_IND" );
            break;
        case RBLE_BLP_EVENT_SENSOR_COMMAND_DISALLOWED_IND:
            printf( "\nrBLE BLP EVENT (COMMAND_DISALLOWED_IND) Status(%s)\n", Get_Status_Str( event->param.cmd_disallowed_ind.status ) );
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}

/******************************************************************************************/
/**
 *  @brief A BLP_Sensor_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_BLP_Sensor_Enable_Test( void )
{
    /* security level */
    uint8_t sec_lvl[] = {
        RBLE_SVC_SEC_NONE,
        RBLE_SVC_SEC_UNAUTH|RBLE_SVC_SEC_AUTZ,
        RBLE_SVC_SEC_AUTH|RBLE_SVC_SEC_ENC,
    };
    /* ConType */
    static uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
//  static uint8_t con_type = RBLE_PRF_CON_NORMAL;

    static RBLE_BLP_SENSOR_PARAM    param = {
        RBLE_PRF_START_IND,     /* Blood pressure measurement indication configuration */
        RBLE_PRF_START_NTF,     /* Intermediate cuff pressure notification configuration */
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_BLP_Sensor_Enable( Connection_Handle, sec_lvl[RBLE_Parameter_Arg[ 0 ]], con_type, &param, RBLE_APP_BLPS_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A BLP_Sensor_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_BLP_Sensor_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_BLP_Sensor_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A BLP_Sensor_Send_Measurements command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_BLP_Sensor_Send_Measurements_Test( void )
{
    static RBLE_BLP_MEASUREMENTS_INFO   measurements_info = {
        0x01,           /* Stable or intermediary type of measurements */
        0x1e,           /* flags */
        0x007b,         /* blood pressure value - systolic */
        0x0055,         /* blood pressure value - diastolic */
        0x0067,         /* blood pressure value - MAP */
        {               /* time stamp */
            /* 2012/09/01 12:34:56 */
            0x07dc,       /* Year value */
            0x09,       /* Month value */
            0x01,       /* Day value */
            0x0c,       /* Hour value */
            0x22,       /* Minute value */
            0x38,       /* Second value */
            0x00,       /* Reserved */
        },
        0xF321,         /* pulse rate 80.1 */
        0x01,           /* user ID */
        0x00,           /* Reserved */
        0x0008,         /* measurement status */
    };


    RBLE_STATUS Ret_Status;
    int32_t             Parameter_No;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }

        if ( 1 != Parameter_No ) {
            measurements_info.flag_stable_meas = 0;
            printf( "Select Parameter -> Measurement is in progress\n" );
        } else {
            measurements_info.flag_stable_meas = 1;
            printf( "Select Parameter -> Stable\n" );
        }
        /* API Call */
        Ret_Status = RBLE_BLP_Sensor_Send_Measurements( Connection_Handle, &measurements_info );

        RBLE_Status_Disp( Ret_Status );
        if ( RBLE_OK == Ret_Status ) {
            measurements_info.rate++;
        }
    }
    return( TRUE );
}
#endif
#ifdef USE_BLPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A BLP_Collector_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_BLP_Collector_Enable_Test( void )
{
    /* ConType */
    static uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
//  static uint8_t con_type = RBLE_PRF_CON_NORMAL;

    static RBLE_BLS_CONTENT bls = {
        0x0000,         /* StartHdl */
        0x0000,         /* EndHdl */
        0x0000,         /* BldprsMeasCharHdl */
        0x0000,         /* BldprsMeasValHdl */
        0x0000,         /* BldprsMeasCfgHdl */
        0x00,           /* BldprsMeasProp */
        0x00,           /* Pad */
        0x0000,         /* IntermCufprsCharHdl */
        0x0000,         /* IntermCufprsValHdl */
        0x0000,         /* IntermCufprsCfgHdl */
        0x00,           /* IntermCufprsProp */
        0x00,           /* Pad */
        0x0000,         /* MeasFeatCharHdl */
        0x0000,         /* MeasFeatValHdl */
        0x00,           /* MeasFeatProp */
        0x00,           /* Pad */
    };
    static RBLE_DIS_CONTENT dis = {
        0x0000,         /* StartHdl */
        0x0000,         /* EndHdl */
        0x0000,         /* SysIdCharHdl */
        0x0000,         /* SysIdValHdl */
        0x00,           /* SysIdProp */
        0x00,           /* Pad */
        0x0000,         /* ModelNbCharHdl */
        0x0000,         /* ModelNbValHdl */
        0x00,           /* ModelNbProp */
        0x00,           /* Pad */
        0x0000,         /* SerialNbCharHdl */
        0x0000,         /* SerialNbValHdl */
        0x00,           /* SerialNbProp */
        0x00,           /* Pad */
        0x0000,         /* FwRevCharHdl */
        0x0000,         /* FwRevValdl */
        0x00,           /* FwRevProp */
        0x00,           /* Pad */
        0x0000,         /* HwRevCharHdl */
        0x0000,         /* HwRevValHdl */
        0x00,           /* HwRevProp */
        0x00,           /* Pad */
        0x0000,         /* SwRevCharHdl */
        0x0000,         /* SwRevValHdl */
        0x00,           /* SwRevProp */
        0x00,           /* Pad */
        0x0000,         /* ManufNameCharHdl */
        0x0000,         /* ManufNameValHdl */
        0x00,           /* ManufNameProp */
        0x00,           /* Pad */
        0x0000,         /* IeeeCertifCharHdl */
        0x0000,         /* IeeeCertifValHdl */
        0x00,           /* IeeeCertifProp */
        0x00,           /* Pad */
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_BLP_Collector_Enable( Connection_Handle, con_type, &bls, &dis, RBLE_APP_BLPC_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A BLP_Collector_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_BLP_Collector_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_BLP_Collector_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A BLP_Collector_Read_Char command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_BLP_Collector_Read_Char_Test( void )
{
    /* CharCode */
    uint8_t         char_code;
    RBLE_STATUS     Ret_Status;
    int32_t         Parameter_No;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }
    if ( ( ILLEGAL_NO == Parameter_No ) || ( RBLE_BLPC_RD_DIS_IEEE < Parameter_No ) ) {
        char_code = RBLE_BLPC_RD_BLS_BM_CFG;
        Select_Param_No_Disp( 0 );
    } else {
        char_code = (uint8_t)Parameter_No;
        Select_Param_No_Disp( Parameter_No );
    }

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_BLP_Collector_Read_Char( Connection_Handle, char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A BLP_Collector_Write_Char command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_BLP_Collector_Write_Char_Test( void )
{
    RBLE_BLP_WRITE_CHAR_PARAM   *Parameter_p;
    RBLE_STATUS                 Ret_Status;
    int32_t                     Parameter_No;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
            || ( ( sizeof( RBLE_BLP_Write_Char_Param ) / sizeof( RBLE_BLP_WRITE_CHAR_PARAM ) ) <= Parameter_No ) ) {
            Parameter_p = &RBLE_BLP_Write_Char_Param[ 0 ];
            Select_Param_No_Disp( 0 );
        } else {
            Parameter_p = &RBLE_BLP_Write_Char_Param[ Parameter_No ];
            Select_Param_No_Disp( Parameter_No );
        }
        /* API Call */
        Ret_Status = RBLE_BLP_Collector_Write_Char( Connection_Handle, Parameter_p->char_code, Parameter_p->cfg_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

/* ------------------------- HID over GATT Profile-------------------------------*/
#if defined(USE_HGHD_SAMPLE)|defined(USE_HGRH_SAMPLE)|defined(USE_HGBH_SAMPLE)
/******************************************************************************************/
/**
 *  @brief rBLE HOGP Event and Status Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void HGP_Event_Status_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE HGP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}
/******************************************************************************************/
/**
 *  @brief rBLE HOGP Event Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void HGP_Event_Disp(char_t *event_str)
{
    printf( "\nrBLE HGP EVENT (%s)\n", event_str );
}
#endif
#ifdef USE_HGHD_SAMPLE
/******************************************************************************************/
/**
 *  @brief HID over GATT(HGHD) Profile Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_HGHD_CallBack( RBLE_HGHD_EVENT *event )
{
    uint16_t i;
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_HGP_EVENT_HDEVICE_ENABLE_COMP:
            HGP_Event_Status_Disp("HDEVICE_ENABLE_COMP", event->param.hdevice_enable.status);
            Connection_Handle_Disp( event->param.hdevice_enable.conhdl );
            break;
        case RBLE_HGP_EVENT_HDEVICE_DISABLE_COMP:
            HGP_Event_Status_Disp("HDEVICE_DISABLE_COMP", event->param.hdevice_disable.status);
            Connection_Handle_Disp( event->param.hdevice_disable.conhdl );
            printf( "hids_inst_num     = %d\n", event->param.hdevice_disable.device_info.hids_inst_num );
            printf( "bas_inst_num      = %d\n", event->param.hdevice_disable.device_info.bas_inst_num );
            printf( "kb_report_ntf_en[RBLE_HIDS_INST_MAX(=%d)]     =", RBLE_HIDS_INST_MAX );
            for(i=0;i<RBLE_HIDS_INST_MAX;i++){
                printf( " 0x%04X", event->param.hdevice_disable.device_info.kb_report_ntf_en[i] );
            }
            printf( "\n" );
            printf( "mo_report_ntf_en[RBLE_HIDS_INST_MAX(=%d)]     =", RBLE_HIDS_INST_MAX );
            for(i=0;i<RBLE_HIDS_INST_MAX;i++){
                printf( " 0x%04X", event->param.hdevice_disable.device_info.mo_report_ntf_en[i] );
            }
            printf( "\n" );
            printf( "protocol_mode_val[RBLE_HIDS_INST_MAX(=%d)]    =", RBLE_HIDS_INST_MAX );
            for(i=0;i<RBLE_HIDS_INST_MAX;i++){
                printf( " 0x%02X", event->param.hdevice_disable.device_info.protocol_mode_val[i] );
            }
            printf( "\n" );
            printf( "battery_level_ntf_en[RBLE_HIDS_INST_MAX(=%d)] =", RBLE_HIDS_INST_MAX );
            for(i=0;i<RBLE_HIDS_INST_MAX;i++){
                printf( " 0x%04X", event->param.hdevice_disable.device_info.battery_level_ntf_en[i] );
            }
            printf( "\n" );
            break;
        case RBLE_HGP_EVENT_HDEVICE_ERROR_IND:
            HGP_Event_Disp("HDEVICE_ERROR_IND");
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_HGP_EVENT_HDEVICE_CFG_INDNTF_IND:
            HGP_Event_Disp("HDEVICE_CFG_INDNTF_IND");
            Connection_Handle_Disp( event->param.hghd_cfg_indntf_ind.conhdl );
            printf( "inst_idx          = %d\n", event->param.hghd_cfg_indntf_ind.inst_idx );
            printf( "char_code         = %d\n", event->param.hghd_cfg_indntf_ind.char_code );
            printf( "cfg_val           = %d\n", event->param.hghd_cfg_indntf_ind.cfg_val );
            break;
        case RBLE_HGP_EVENT_HDEVICE_REPORT_IND:
            HGP_Event_Disp("HDEVICE_REPORT_IND");
            Connection_Handle_Disp( event->param.report_chg_ind.conhdl );
            printf( "inst_idx          = %d\n", event->param.report_chg_ind.inst_idx );
            printf( "device_type       = %d\n", event->param.report_chg_ind.report.device_type );
            printf( "report_type       = %d\n", event->param.report_chg_ind.report.report_type );
            printf( "value_size        = %d\n", event->param.report_chg_ind.report.value_size );
            printf( "value[ %d ] =\n"         , event->param.report_chg_ind.report.value_size );
            for(i=0;i<event->param.report_chg_ind.report.value_size;i++){
                printf( " 0x%02X", event->param.report_chg_ind.report.value[i] );
            }
            printf( "\n" );
            break;
        case RBLE_HGP_EVENT_HDEVICE_PROTOCOL_MODE_CHG_EVT:
            HGP_Event_Disp("HDEVICE_PROTOCOL_MODE_CHG_EVT");
            Connection_Handle_Disp( event->param.protocol_mode_chg_evt.conhdl );
            printf( "inst_idx          = %d\n", event->param.protocol_mode_chg_evt.inst_idx );
            printf( "protocol_mode_val = %d\n", event->param.protocol_mode_chg_evt.protocol_mode_val );
            break;
        case RBLE_HGP_EVENT_HDEVICE_REPORT_EVT:
            HGP_Event_Disp("HDEVICE_REPORT_EVT");
            Connection_Handle_Disp( event->param.report_chg_evt.conhdl );
            printf( "inst_idx          = %d\n", event->param.report_chg_evt.inst_idx );
            printf( "device_type       = %d\n", event->param.report_chg_evt.report.device_type );
            printf( "report_type       = %d\n", event->param.report_chg_evt.report.report_type );
            printf( "value_size        = %d\n", event->param.report_chg_evt.report.value_size );
            printf( "value[ %d ] =\n"         , event->param.report_chg_evt.report.value_size );
            for(i=0;i<event->param.report_chg_evt.report.value_size;i++){
                printf( " 0x%02X", event->param.report_chg_evt.report.value[i] );
            }
            printf( "\n" );
            break;
        case RBLE_HGP_EVENT_HDEVICE_HID_CP_CHG_EVT:
            HGP_Event_Disp("HDEVICE_HID_CP_CHG_EVT");
            Connection_Handle_Disp( event->param.hid_cp_chg_evt.conhdl );
            printf( "inst_idx          = %d\n", event->param.hid_cp_chg_evt.inst_idx );
            printf( "control_point_val = %d\n", event->param.hid_cp_chg_evt.control_point_val );
            break;
        case RBLE_HGP_EVENT_HDEVICE_REPORT_COMP:
            HGP_Event_Status_Disp("HDEVICE_REPORT_COMP", event->param.send_report.status);
            Connection_Handle_Disp( event->param.send_report.conhdl );
            break;
        case RBLE_HGP_EVENT_HDEVICE_SEND_BATTERY_LEVEL_COMP:
            HGP_Event_Status_Disp("HDEVICE_SEND_BATTERY_LEVEL_COMP", event->param.send_battery_level.status);
            Connection_Handle_Disp( event->param.send_battery_level.conhdl );
            break;
        case RBLE_HGP_EVENT_HDEVICE_COMMAND_DISALLOWED_IND:
            HGP_Event_Status_Disp("HDEVICE_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_HGBH_SAMPLE
/******************************************************************************************/
/**
 *  @brief HID over GATT(HGBH) Profile Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_HGBH_CallBack( RBLE_HGBH_EVENT *event )
{
    uint16_t i;
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_HGP_EVENT_BHOST_ENABLE_COMP:
            HGP_Event_Status_Disp("BHOST_ENABLE_COMP", event->param.bhost_enable.status);
            printf( "ConHdl=%d, HIDS Inst=%d, BAS Inst=%d\n", event->param.bhost_enable.conhdl,
                                                              event->param.bhost_enable.hids_inst_num,
                                                              event->param.bhost_enable.bas_inst_num );
            HGP_Info_Disp(  event->param.bhost_enable.hids,
                            &event->param.bhost_enable.dis,
                            event->param.bhost_enable.bas,
                            event->param.bhost_enable.hids_inst_num,
                            event->param.bhost_enable.bas_inst_num );
            break;
        case RBLE_HGP_EVENT_BHOST_DISABLE_COMP:
            HGP_Event_Status_Disp("BHOST_DISABLE_COMP", event->param.bhost_disable.status);
            Connection_Handle_Disp( event->param.bhost_disable.conhdl );
            break;
        case RBLE_HGP_EVENT_BHOST_ERROR_IND:
            HGP_Event_Status_Disp("BHOST_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_HGP_EVENT_BHOST_READ_CHAR_RESPONSE:
            HGP_Event_Disp("BHOST_READ_CHAR_RESPONSE");
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            printf( "att_code          = %d\n", event->param.rd_char_resp.att_code );
            printf( "each_len          = %d\n", event->param.rd_char_resp.data.each_len );
            printf( "len               = %d\n", event->param.rd_char_resp.data.len );
            printf( "data[ %d ] =\n"          , event->param.rd_char_resp.data.len );
            for(i=0;i<event->param.rd_char_resp.data.len;i++){
                printf( " 0x%02X", event->param.rd_char_resp.data.data[i] );
            }
            printf( "\n" );
            break;
        case RBLE_HGP_EVENT_BHOST_WRITE_CHAR_RESPONSE:
            HGP_Event_Disp("BHOST_WRITE_CHAR_RESPONSE");
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            printf( "att_code          = %d\n", event->param.wr_char_resp.att_code );
            break;
        case RBLE_HGP_EVENT_BHOST_REPORT_NTF:
            HGP_Event_Disp("BHOST_REPORT_NTF");
            Connection_Handle_Disp( event->param.report_ntf.conhdl );
            printf( "inst_idx          = %d\n", event->param.report_ntf.inst_idx );
            printf( "device_type       = %d\n", event->param.report_ntf.report.device_type );
            printf( "report_type       = %d\n", event->param.report_ntf.report.report_type );
            printf( "value_size        = %d\n", event->param.report_ntf.report.value_size );
            printf( "value[ %d ] =\n"         , event->param.report_ntf.report.value_size );
            for(i=0;i<event->param.report_ntf.report.value_size;i++){
                printf( " 0x%02X", event->param.report_ntf.report.value[i] );
            }
            printf( "\n" );
            break;
        case RBLE_HGP_EVENT_BHOST_COMMAND_DISALLOWED_IND:
            HGP_Event_Status_Disp("BHOST_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_HGRH_SAMPLE
/******************************************************************************************/
/**
 *  @brief HID over GATT(HGRH) Profile Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_HGRH_CallBack( RBLE_HGRH_EVENT *event )
{
    uint16_t i;
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_HGP_EVENT_RHOST_ENABLE_COMP:
            HGP_Event_Status_Disp("RHOST_ENABLE_COMP", event->param.rhost_enable.status);
            printf( "ConHdl=%d, HIDS Inst=%d, BAS Inst=%d\n", event->param.rhost_enable.conhdl,
                                                              event->param.rhost_enable.hids_inst_num,
                                                              event->param.rhost_enable.bas_inst_num );
            HGP_Info_Disp(  event->param.rhost_enable.hids,
                            &event->param.rhost_enable.dis,
                            event->param.rhost_enable.bas,
                            event->param.rhost_enable.hids_inst_num,
                            event->param.rhost_enable.bas_inst_num );
            break;
        case RBLE_HGP_EVENT_RHOST_DISABLE_COMP:
            HGP_Event_Status_Disp("RHOST_DISABLE_COMP", event->param.rhost_disable.status);
            Connection_Handle_Disp( event->param.rhost_disable.conhdl );
            break;
        case RBLE_HGP_EVENT_RHOST_ERROR_IND:
            HGP_Event_Status_Disp("RHOST_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_HGP_EVENT_RHOST_READ_CHAR_RESPONSE:
            HGP_Event_Disp("RHOST_READ_CHAR_RESPONSE");
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            printf( "att_code          = %d\n", event->param.rd_char_resp.att_code );
            printf( "each_len          = %d\n", event->param.rd_char_resp.data.each_len );
            printf( "len               = %d\n", event->param.rd_char_resp.data.len );
            printf( "data[ %d ] =\n"          , event->param.rd_char_resp.data.len );
            for(i=0;i<event->param.rd_char_resp.data.len;i++){
                printf( " 0x%02X", event->param.rd_char_resp.data.data[i] );
            }
            printf( "\n" );
            break;
        case RBLE_HGP_EVENT_RHOST_READ_LONG_CHAR_RESPONSE:
            HGP_Event_Disp("RHOST_READ_LONG_CHAR_RESPONSE");
            Connection_Handle_Disp( event->param.rd_long_char_resp.conhdl );
            printf( "att_code          = %d\n", event->param.rd_long_char_resp.att_code );
            printf( "val_len           = %d\n", event->param.rd_long_char_resp.data.val_len );
            printf( "attr_hdl          = %d\n", event->param.rd_long_char_resp.data.attr_hdl );
            printf( "value[ %d ] =\n"         , event->param.rd_long_char_resp.data.val_len );
            for(i=0;i<event->param.rd_long_char_resp.data.val_len;i++){
                printf( " 0x%02X", event->param.rd_long_char_resp.data.value[i] );
            }
            printf( "\n" );
            break;
        case RBLE_HGP_EVENT_RHOST_WRITE_CHAR_RESPONSE:
            HGP_Event_Disp("RHOST_WRITE_CHAR_RESPONSE");
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            printf( "att_code          = %d\n", event->param.wr_char_resp.att_code );
            break;
        case RBLE_HGP_EVENT_RHOST_REPORT_NTF:
            HGP_Event_Disp("RHOST_REPORT_NTF");
            Connection_Handle_Disp( event->param.report_ntf.conhdl );

            printf( "inst_idx          = %d\n", event->param.report_ntf.inst_idx );
            printf( "device_type       = %d\n", event->param.report_ntf.report.device_type );
            printf( "report_type       = %d\n", event->param.report_ntf.report.report_type );
            printf( "value_size        = %d\n", event->param.report_ntf.report.value_size );
            printf( "value[ %d ] =\n"         , event->param.report_ntf.report.value_size );
            for(i=0;i<event->param.report_ntf.report.value_size;i++){
                printf( " 0x%02X", event->param.report_ntf.report.value[i] );
            }
            printf( "\n" );
            break;
        case RBLE_HGP_EVENT_RHOST_BATTERY_LEVEL_NTF:
            HGP_Event_Disp("RHOST_BATTERY_LEVEL_NTF");
            Connection_Handle_Disp( event->param.battery_level_ntf.conhdl );
            printf( "inst_idx          = %d\n", event->param.battery_level_ntf.inst_idx );
            printf( "battery_level     = %d\n", event->param.battery_level_ntf.battery_level );
            break;
        case RBLE_HGP_EVENT_RHOST_COMMAND_DISALLOWED_IND:
            HGP_Event_Status_Disp("RHOST_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_HGHD_SAMPLE
/******************************************************************************************/
/**
 *  @brief A HGP_HDevice_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_HDevice_Enable_Test( void )
{
    RBLE_STATUS  Ret_Status;
    RBLE_HGP_HDEVICE_ENABLE_PARAM   *Parameter_p;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        Parameter_p = &RBLE_HGP_HDevice_Enable_Param[ 0 ];
        Select_Param_No_Disp( 0 );

        /* API Call */
        Ret_Status = RBLE_HGP_HDevice_Enable( Connection_Handle, Parameter_p->sec_lvl, Parameter_p->con_type, &Parameter_p->param, RBLE_APP_HGHD_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_HDevice_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_HDevice_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HGP_HDevice_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_HDevice_Send_Report command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_HDevice_Send_Report_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_HGP_HDEVICE_SEND_REPORT_PARAM  *Parameter_p;
    int32_t     Parameter_No;
    uint8_t     inst_idx = 0xff;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            if ( 2 >= RBLE_Parameter_Cnt ) {
                inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 1 ];
            }
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
            || ( ( sizeof( RBLE_HGP_HDevice_Send_Report_Param ) / sizeof( RBLE_HGP_HDEVICE_SEND_REPORT_PARAM ) ) <= Parameter_No ) ) {
            Parameter_p = &RBLE_HGP_HDevice_Send_Report_Param[ 0 ];
            Select_Param_No_Disp( 0 );
        } else {
            Parameter_p = &RBLE_HGP_HDevice_Send_Report_Param[ Parameter_No ];
            Select_Param_No_Disp( Parameter_No );
        }
        
        if ( inst_idx == 0xff ) {
            inst_idx = Parameter_p->inst_idx;
        }
        /* API Call */
        Ret_Status = RBLE_HGP_HDevice_Send_Report( Connection_Handle, inst_idx, &Parameter_p->report );
        printf( " Device type = %d, Report type = %d\n", Parameter_p->report.device_type, Parameter_p->report.report_type );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_HDevice_Send_Battery_Level command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_HDevice_Send_Battery_Level_Test( void )
{
    RBLE_STATUS Ret_Status;

#if (RBLE_BAS_INST_MAX == 2)
    const uint8_t       inst_idx = 1;
#else
    const uint8_t       inst_idx = 0;
#endif
    const uint8_t       battery_level = 100;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HGP_HDevice_Send_Battery_Level( Connection_Handle, inst_idx, battery_level);
        printf( " Battery Level = %d(0x%x)\n", battery_level, battery_level );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#ifdef USE_HGBH_SAMPLE
/******************************************************************************************/
/**
 *  @brief A HGP_BHost_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_BHost_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_HGP_BHost_ENABLE_PARAM     *Parameter_p;
    int32_t                         Parameter_No;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
            || ( ( sizeof( RBLE_HGP_BHost_Enable_Param ) / sizeof( RBLE_HGP_BHost_ENABLE_PARAM ) ) <= Parameter_No ) ) {
            Parameter_p = &RBLE_HGP_BHost_Enable_Param[ 0 ];
            Select_Param_No_Disp( 0 );
        } else {
            Parameter_p = &RBLE_HGP_BHost_Enable_Param[ Parameter_No ];
            Select_Param_No_Disp( Parameter_No );
        }
        
        /* API Call */
        Ret_Status = RBLE_HGP_BHost_Enable( Connection_Handle, Parameter_p->con_type, Parameter_p->hids_inst_num, Parameter_p->bas_inst_num, &Parameter_p->hids[0], &Parameter_p->dis, &Parameter_p->bas[0], RBLE_APP_HGBH_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_BHost_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_BHost_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HGP_BHost_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_BHost_Read_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_BHost_Read_Char_Test( void )
{
    int32_t     Parameter_No;
    RBLE_STATUS Ret_Status;

#if ((RBLE_HIDS_INST_MAX == 2) && (RBLE_BAS_INST_MAX == 2))
    uint8_t         inst_idx = 1;
#else
    uint8_t         inst_idx = 0;
#endif
    uint8_t         char_code = RBLE_HGBH_RD_HIDS_PM;           /*= 0x00*//**< Read HIDS Protcol Mode Characteristic */
//  uint8_t         char_code = RBLE_HGBH_RD_HIDS_KI;           /*= 0x01*//**< Read HIDS Boot Keyboard Input Report Characteristic */
//  uint8_t         char_code = RBLE_HGBH_RD_HIDS_KI_CFG;       /*= 0x02*//**< Read HIDS Boot Keyboard Input Report Client Cfg. Desc */
//  uint8_t         char_code = RBLE_HGBH_RD_HIDS_KO;           /*= 0x03*//**< Read HIDS Boot Keyboard Output Report Characteristic */
//  uint8_t         char_code = RBLE_HGBH_RD_HIDS_MI;           /*= 0x04*//**< Read HIDS Boot Mouse Input Report Characteristic */
//  uint8_t         char_code = RBLE_HGBH_RD_HIDS_MI_CFG;       /*= 0x05*//**< Read HIDS Boot Mouse Input Report Client Cfg. Desc */
//  uint8_t         char_code = RBLE_HGBH_RD_DIS_PNPID;         /*= 0x06*//**< Read DIS PnP ID Characteristic */
//  uint8_t         char_code = RBLE_HGBH_RD_BAS_BL;            /*= 0x07*//**< Read BAS Battery Level Characteristic */

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            
            if ( 2 >= RBLE_Parameter_Cnt ) {
                inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 1 ];
            }
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        switch( Parameter_No ){
        case RBLE_HGBH_RD_HIDS_PM:           /*= 0x00*//**< Read HIDS Protcol Mode Characteristic */
        case ILLEGAL_NO:
        default:
            Parameter_No = 0;
            break;
        case RBLE_HGBH_RD_HIDS_KI:           /*= 0x01*//**< Read HIDS Boot Keyboard Input Report Characteristic */
        case RBLE_HGBH_RD_HIDS_KI_CFG:       /*= 0x02*//**< Read HIDS Boot Keyboard Input Report Client Cfg. Desc */
        case RBLE_HGBH_RD_HIDS_KO:           /*= 0x03*//**< Read HIDS Boot Keyboard Output Report Characteristic */
        case RBLE_HGBH_RD_HIDS_MI:           /*= 0x04*//**< Read HIDS Boot Mouse Input Report Characteristic */
        case RBLE_HGBH_RD_HIDS_MI_CFG:       /*= 0x05*//**< Read HIDS Boot Mouse Input Report Client Cfg. Desc */
        case RBLE_HGBH_RD_DIS_PNPID:         /*= 0x06*//**< Read DIS PnP ID Characteristic */
        case RBLE_HGBH_RD_BAS_BL:            /*= 0x07*//**< Read BAS Battery Level Characteristic */
            break;
        }
        printf( "Select Parameter No %ld, Select Instance %d\n",  Parameter_No,  inst_idx);
        
        /* API Call */
        char_code = (uint8_t)Parameter_No;
        Ret_Status = RBLE_HGP_BHost_Read_Char( Connection_Handle, inst_idx, char_code );
        printf( " char code = %d\n", char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_BHost_Read_By_UUID_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_BHost_Read_By_UUID_Char_Test( void )
{
    int32_t     Parameter_No;
    RBLE_STATUS Ret_Status;

#if ((RBLE_HIDS_INST_MAX == 2) && (RBLE_BAS_INST_MAX == 2))
    uint8_t     inst_idx = 1;
#else
    uint8_t     inst_idx = 0;
#endif
    uint8_t         char_code = RBLE_HGBH_RD_HIDS_PM;           /*= 0x00*//**< Read HIDS Protcol Mode Characteristic */
//  uint8_t         char_code = RBLE_HGBH_RD_HIDS_KI;           /*= 0x01*//**< Read HIDS Boot Keyboard Input Report Characteristic */
//  uint8_t         char_code = RBLE_HGBH_RD_HIDS_KO;           /*= 0x03*//**< Read HIDS Boot Keyboard Output Report Characteristic */
//  uint8_t         char_code = RBLE_HGBH_RD_HIDS_MI;           /*= 0x04*//**< Read HIDS Boot Mouse Input Report Characteristic */
//  uint8_t         char_code = RBLE_HGBH_RD_DIS_PNPID;         /*= 0x06*//**< Read DIS PnP ID Characteristic */
//  uint8_t         char_code = RBLE_HGBH_RD_BAS_BL;            /*= 0x07*//**< Read BAS Battery Level Characteristic */

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            if ( 2 >= RBLE_Parameter_Cnt ) {
                inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 1 ];
            }
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        switch( Parameter_No ){
        case RBLE_HGBH_RD_HIDS_PM:           /*= 0x00*//**< Read HIDS Protcol Mode Characteristic */
        case ILLEGAL_NO:
        default:
            Parameter_No = 0;
            break;
        case RBLE_HGBH_RD_HIDS_KI:           /*= 0x01*//**< Read HIDS Boot Keyboard Input Report Characteristic */
        case RBLE_HGBH_RD_HIDS_KO:           /*= 0x03*//**< Read HIDS Boot Keyboard Output Report Characteristic */
        case RBLE_HGBH_RD_HIDS_MI:           /*= 0x04*//**< Read HIDS Boot Mouse Input Report Characteristic */
        case RBLE_HGBH_RD_DIS_PNPID:         /*= 0x06*//**< Read DIS PnP ID Characteristic */
        case RBLE_HGBH_RD_BAS_BL:            /*= 0x07*//**< Read BAS Battery Level Characteristic */
            break;
        }
        printf( "Select Parameter No %ld, Select Instance %d\n",  Parameter_No,  inst_idx);
        
        /* API Call */
        char_code = (uint8_t)Parameter_No;
        Ret_Status = RBLE_HGP_BHost_Read_By_UUID_Char( Connection_Handle, inst_idx, char_code );
        printf( " char code = %d\n", char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_BHost_Write_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_BHost_Write_Char_Test( void )
{
    int32_t     Parameter_No;
    RBLE_STATUS Ret_Status;

#if ((RBLE_HIDS_INST_MAX == 2) && (RBLE_BAS_INST_MAX == 2))
    uint8_t     inst_idx = 1;
#else
    uint8_t     inst_idx = 0;
#endif
    uint8_t             char_code = RBLE_HGHD_KB_REPORT_CODE/*=1*/  /*RBLE_HGHD_MO_REPORT_CODE=2*/;
    uint16_t            cfg_val = RBLE_PRF_START_NTF;
                                //RBLE_PRF_STOP_NTFIND;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 1 <= RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            if ( 2 <= RBLE_Parameter_Cnt ) {
                if ( RBLE_Parameter_Arg[1] == 0) {
                    cfg_val = RBLE_PRF_STOP_NTFIND;
                }
                else {
                    cfg_val = RBLE_PRF_START_NTF;
                }
                if ( 3 <= RBLE_Parameter_Cnt ) {
                    inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 2 ];
                }
            }
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        switch( Parameter_No ){
        case 0:
        case 1:
        case ILLEGAL_NO:
        default:
            char_code = 1;
            break;
        case 2:
            char_code = RBLE_HGHD_KB_REPORT_CODE;
            break;
        case 3:
            char_code = RBLE_HGHD_MO_REPORT_CODE;
            break;
        }
        printf( "Select char code %d, Select NTF %d, Select Instance %d\n",  char_code,  cfg_val,  inst_idx);
        
        /* API Call */
        Ret_Status = RBLE_HGP_BHost_Write_Char( Connection_Handle, inst_idx, char_code, cfg_val );
        printf( " char_code = %d, cfg_val = %d\n", char_code, cfg_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_BHost_Set_Report command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_BHost_Set_Report_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_HGP_BHOST_SEND_REPORT_PARAM    *Parameter_p;
    int32_t     Parameter_No;
    uint8_t     inst_idx = 0xff;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            if ( 2 >= RBLE_Parameter_Cnt ) {
                inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 1 ];
            }
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
            || ( ( sizeof( RBLE_HGP_BHost_Send_Report_Param ) / sizeof( RBLE_HGP_BHOST_SEND_REPORT_PARAM ) ) <= Parameter_No ) ) {
            Parameter_p = &RBLE_HGP_BHost_Send_Report_Param[ 0 ];
            Select_Param_No_Disp( 0 );
        } else {
            Parameter_p = &RBLE_HGP_BHost_Send_Report_Param[ Parameter_No ];
            Select_Param_No_Disp( Parameter_No );
        }
        if ( inst_idx == 0xff ) {
            inst_idx = Parameter_p->inst_idx;
        }
        printf( "Select inst_idx No %d\n",  inst_idx );
        
        /* API Call */
        Ret_Status = RBLE_HGP_BHost_Set_Report( Connection_Handle, inst_idx, &Parameter_p->report );
        printf( " Device type = %d, Report type = %d\n", Parameter_p->report.device_type, Parameter_p->report.report_type );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_BHost_Write_Protocol_Mode command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_BHost_Write_Protocol_Mode_Test( void )
{
    RBLE_STATUS Ret_Status;

#if (RBLE_HIDS_INST_MAX == 2)
    uint8_t     inst_idx = 1;
#else
    uint8_t     inst_idx = 0;
#endif
    uint8_t     protocol_mode_val = RBLE_HGHD_PROTOCOL_MODE_BOOT;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 1 >= RBLE_Parameter_Cnt ) {
            inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_HGP_BHost_Write_Protocol_Mode( Connection_Handle, inst_idx, protocol_mode_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_BHost_Data_Output command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_BHost_Data_Output_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_HGP_BHOST_DATA_OUTPUT_PARAM    *Parameter_p;
    int32_t     Parameter_No;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
            || ( ( sizeof( RBLE_HGP_BHost_Data_Output_Param ) / sizeof( RBLE_HGP_BHOST_DATA_OUTPUT_PARAM ) ) <= Parameter_No ) ) {
            Parameter_p = &RBLE_HGP_BHost_Data_Output_Param[ 0 ];
            Select_Param_No_Disp( 0 );
        } else {
            Parameter_p = &RBLE_HGP_BHost_Data_Output_Param[ Parameter_No ];
            Select_Param_No_Disp( Parameter_No );
        }
        
        /* API Call */
        Ret_Status = RBLE_HGP_BHost_Data_Output( Connection_Handle, Parameter_p->inst_idx, &Parameter_p->report );
        printf( " Device type = %d, Report type = %d\n", Parameter_p->report.device_type, Parameter_p->report.report_type );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#ifdef USE_HGRH_SAMPLE
/******************************************************************************************/
/**
 *  @brief A HGP_RHost_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_RHost_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_HGP_RHost_ENABLE_PARAM     *Parameter_p;
    int32_t                         Parameter_No;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
            || ( ( sizeof( RBLE_HGP_RHost_Enable_Param ) / sizeof( RBLE_HGP_RHost_ENABLE_PARAM ) ) <= Parameter_No ) ) {
            Parameter_p = &RBLE_HGP_RHost_Enable_Param[ 0 ];
            Select_Param_No_Disp( 0 );
        } else {
            Parameter_p = &RBLE_HGP_RHost_Enable_Param[ Parameter_No ];
            Select_Param_No_Disp( Parameter_No );
        }
        
        /* API Call */
        Ret_Status = RBLE_HGP_RHost_Enable( Connection_Handle, Parameter_p->con_type, Parameter_p->hids_inst_num, Parameter_p->bas_inst_num, &Parameter_p->hids[0], &Parameter_p->dis, &Parameter_p->bas[0], RBLE_APP_HGRH_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_RHost_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_RHost_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HGP_RHost_Disable( Connection_Handle);

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_RHost_Read_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_RHost_Read_Char_Test( void )
{
    int32_t     Parameter_No;
    RBLE_STATUS Ret_Status;

#if ((RBLE_HIDS_INST_MAX == 2) && (RBLE_BAS_INST_MAX == 2))
    uint8_t         inst_idx = 1;
#else
    uint8_t         inst_idx = 0;
#endif
    uint8_t         char_code = RBLE_HGRH_RD_HIDS_PM;            /*=0x00*//**< Read HID Service Protcol Mode Characteristic */
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_RI;            /*=0x01*//**< Read HID Service Report(Input) Characteristic */
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_RI_CFG;        /*=0x02*//**< Read HID Service Report(Input) Client Cfg. Desc */
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_RI_REF;        /*=0x03*//**< Read HID Service Report(Input) Report Reference Desc */
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_RO;            /*=0x04*//**< Read HID Service Report(Output) Characteristic */
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_RO_REF;        /*=0x05*//**< Read HID Service Report(Output) Report Reference Desc */
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_RF;            /*=0x06*//**< Read HID Service Report(Feature) Characteristic */
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_RF_REF;        /*=0x07*//**< Read HID Service Report(Feature) Report Reference Desc */
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_RM;            /*=0x08*//**< Read HID Service Report MAP Characteristic */
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_ER_REF;        /*=0x09*//**< Read HID Service Report MAP Rxternal Report Reference Desc */
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_HI;            /*=0x0A*//**< Read HID Service HID Information Characteristic */
//  uint8_t         char_code = RBLE_HGRH_RD_DIS_PNPID;          /*=0x0B*//**< Read Device Information Service PnP ID Characteristic */
//  uint8_t         char_code = RBLE_HGRH_RD_BAS_BL;             /*=0x0C*//**< Read Battery Service Battery Level Characteristic */
//  uint8_t         char_code = RBLE_HGRH_RD_BAS_BL_CFG;         /*=0x0D*//**< Read Battery Service Battery Level Client Cfg. Desc */
//  uint8_t         char_code = RBLE_HGRH_RD_BAS_BL_REF;         /*=0x0E*//**< Read Battery Service Battery Level Report Reference Desc */

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            if ( 2 >= RBLE_Parameter_Cnt ) {
                inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 1 ];
            }
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        switch( Parameter_No ){
        case RBLE_HGRH_RD_HIDS_PM:           /*= 0x00*//**< Read HIDS Protcol Mode Characteristic */
        case ILLEGAL_NO:
        default:
            Parameter_No = 0;
            break;
        case RBLE_HGRH_RD_HIDS_RI:            /*=0x01*//**< Read HID Service Report(Input) Characteristic */
        case RBLE_HGRH_RD_HIDS_RI_CFG:        /*=0x02*//**< Read HID Service Report(Input) Client Cfg. Desc */
        case RBLE_HGRH_RD_HIDS_RI_REF:        /*=0x03*//**< Read HID Service Report(Input) Report Reference Desc */
        case RBLE_HGRH_RD_HIDS_RO:            /*=0x04*//**< Read HID Service Report(Output) Characteristic */
        case RBLE_HGRH_RD_HIDS_RO_REF:        /*=0x05*//**< Read HID Service Report(Output) Report Reference Desc */
        case RBLE_HGRH_RD_HIDS_RF:            /*=0x06*//**< Read HID Service Report(Feature) Characteristic */
        case RBLE_HGRH_RD_HIDS_RF_REF:        /*=0x07*//**< Read HID Service Report(Feature) Report Reference Desc */
        case RBLE_HGRH_RD_HIDS_RM:            /*=0x08*//**< Read HID Service Report MAP Characteristic */
        case RBLE_HGRH_RD_HIDS_ER_REF:        /*=0x09*//**< Read HID Service Report MAP Rxternal Report Reference Desc */
        case RBLE_HGRH_RD_HIDS_HI:            /*=0x0A*//**< Read HID Service HID Information Characteristic */
        case RBLE_HGRH_RD_DIS_PNPID:          /*=0x0B*//**< Read Device Information Service PnP ID Characteristic */
        case RBLE_HGRH_RD_BAS_BL:             /*=0x0C*//**< Read Battery Service Battery Level Characteristic */
        case RBLE_HGRH_RD_BAS_BL_CFG:         /*=0x0D*//**< Read Battery Service Battery Level Client Cfg. Desc */
        case RBLE_HGRH_RD_BAS_BL_REF:         /*=0x0E*//**< Read Battery Service Battery Level Report Reference Desc */
            break;
        }
        printf( "Select Parameter No %ld, Select Instance %d\n",  Parameter_No,  inst_idx);
        
        /* API Call */
        char_code = (uint8_t)Parameter_No;
        Ret_Status = RBLE_HGP_RHost_Read_Char( Connection_Handle, inst_idx, char_code);
        printf( " char code = %d\n", char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_RHost_Read_By_UUID_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_RHost_Read_By_UUID_Char_Test( void )
{
    int32_t     Parameter_No;
    RBLE_STATUS Ret_Status;

#if ((RBLE_HIDS_INST_MAX == 2) && (RBLE_BAS_INST_MAX == 2))
    uint8_t             inst_idx = 1;
#else
    uint8_t             inst_idx = 0;
#endif
//  uint8_t             char_code = RBLE_HGRH_RD_DIS_PNPID;          /*=0x0B*//**< Read Device Information Service PnP ID Characteristic */
    uint8_t             char_code = RBLE_HGRH_RD_BAS_BL;             /*=0x0C*//**< Read Battery Service Battery Level Characteristic */

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            if ( 2 >= RBLE_Parameter_Cnt ) {
                inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 1 ];
            }
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        switch( Parameter_No ){
        case RBLE_HGRH_RD_BAS_BL:             /*=0x0C*//**< Read Battery Service Battery Level Characteristic */
        case ILLEGAL_NO:
        default:
            Parameter_No = RBLE_HGRH_RD_BAS_BL;             /*=0x0C*//**< Read Battery Service Battery Level Characteristic */
            break;
        case RBLE_HGRH_RD_DIS_PNPID:          /*=0x0B*//**< Read Device Information Service PnP ID Characteristic */
            break;
        }
        printf( "Select Parameter No %ld, Select Instance %d\n",  Parameter_No,  inst_idx);
        
        /* API Call */
        char_code = (uint8_t)Parameter_No;
        Ret_Status = RBLE_HGP_RHost_Read_By_UUID_Char( Connection_Handle, inst_idx, char_code );
        printf( " char code = %d\n", char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_RHost_Read_Long_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_RHost_Read_Long_Char_Test( void )
{
    int32_t     Parameter_No;
    RBLE_STATUS Ret_Status;

#if ((RBLE_HIDS_INST_MAX == 2) && (RBLE_BAS_INST_MAX == 2))
    uint8_t         inst_idx = 1;
#else
    uint8_t         inst_idx = 0;
#endif
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_RI;            /*=0x01*//**< Read HID Service Report(Input) Characteristic */
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_RO;            /*=0x04*//**< Read HID Service Report(Output) Characteristic */
//  uint8_t         char_code = RBLE_HGRH_RD_HIDS_RF;            /*=0x06*//**< Read HID Service Report(Feature) Characteristic */
    uint8_t         char_code = RBLE_HGRH_RD_HIDS_RM;            /*=0x08*//**< Read HID Service Report MAP Characteristic */

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            if ( 2 >= RBLE_Parameter_Cnt ) {
                inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 1 ];
            }
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        switch( Parameter_No ){
        case RBLE_HGRH_RD_HIDS_RM:            /*=0x08*//**< Read HID Service Report MAP Characteristic */
        case ILLEGAL_NO:
        default:
            Parameter_No = RBLE_HGRH_RD_HIDS_RM;            /*=0x08*//**< Read HID Service Report MAP Characteristic */
            break;
        case RBLE_HGRH_RD_HIDS_RI:            /*=0x01*//**< Read HID Service Report(Input) Characteristic */
        case RBLE_HGRH_RD_HIDS_RO:            /*=0x04*//**< Read HID Service Report(Output) Characteristic */
        case RBLE_HGRH_RD_HIDS_RF:            /*=0x06*//**< Read HID Service Report(Feature) Characteristic */
            break;
        }
        printf( "Select Parameter No %ld, Select Instance %d\n",  Parameter_No,  inst_idx);
        
        /* API Call */
        char_code = (uint8_t)Parameter_No;
        Ret_Status = RBLE_HGP_RHost_Read_Long_Char( Connection_Handle, inst_idx, char_code );
        printf( " char code = %d\n", char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_RHost_Write_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_RHost_Write_Char_Test( void )
{
    int32_t     Parameter_No;
    RBLE_STATUS Ret_Status;

#if ((RBLE_HIDS_INST_MAX == 2) && (RBLE_BAS_INST_MAX == 2))
    uint8_t     inst_idx = 1;
#else
    uint8_t     inst_idx = 0;
#endif
    uint8_t         char_code = RBLE_HGHD_REPORT_INPUT_CODE;/*=1*/  /*RBLE_HGHD_BATTERY_LEVEL_CODE;=4*/
    uint16_t        cfg_val = RBLE_PRF_START_NTF;/*=1*/ /*RBLE_PRF_STOP_NTFIND;=0*/

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            if ( 2 <= RBLE_Parameter_Cnt ) {
                if ( RBLE_Parameter_Arg[1] == 0) {
                    cfg_val = RBLE_PRF_STOP_NTFIND;
                }
                else {
                    cfg_val = RBLE_PRF_START_NTF;
                }
                if ( 3 <= RBLE_Parameter_Cnt ) {
                    inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 2 ];
                }
            }
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        switch( Parameter_No ){
        case RBLE_HGHD_REPORT_INPUT_CODE:   /*=0*/
        case ILLEGAL_NO:
        default:
            Parameter_No = RBLE_HGHD_REPORT_INPUT_CODE;     /*=0*/
            break;
        case RBLE_HGHD_BATTERY_LEVEL_CODE:  /*=3*/
            break;
        }
        printf( "Select Parameter No %ld, Select NTF %d, Select Instance %d\n",  Parameter_No,  cfg_val,  inst_idx);
        
        /* API Call */
        char_code = (uint8_t)Parameter_No;
        Ret_Status = RBLE_HGP_RHost_Write_Char( Connection_Handle, inst_idx, char_code, cfg_val);
        printf( " char_code = %d, cfg_val = %d\n", char_code, cfg_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_RHost_Set_Report command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_RHost_Set_Report_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_HGP_RHOST_SEND_REPORT_PARAM    *Parameter_p;
    int32_t     Parameter_No;
    uint8_t     inst_idx = 0xff;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            if ( 2 >= RBLE_Parameter_Cnt ) {
                inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 1 ];
            }
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
            || ( ( sizeof( RBLE_HGP_RHost_Send_Report_Param ) / sizeof( RBLE_HGP_RHOST_SEND_REPORT_PARAM ) ) <= Parameter_No ) ) {
            Parameter_p = &RBLE_HGP_RHost_Send_Report_Param[ 0 ];
            Select_Param_No_Disp( 0 );
        } else {
            Parameter_p = &RBLE_HGP_RHost_Send_Report_Param[ Parameter_No ];
            Select_Param_No_Disp( Parameter_No );
        }
        if ( inst_idx == 0xff ) {
            inst_idx = Parameter_p->inst_idx;
        }
        printf( "Select inst_idx No %d\n",  inst_idx );
        
        /* API Call */
        Ret_Status = RBLE_HGP_RHost_Set_Report( Connection_Handle, inst_idx, &Parameter_p->report );
        printf( " Device type = %d, Report type = %d\n", Parameter_p->report.device_type, Parameter_p->report.report_type );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_RHost_Write_Protocol_Mode command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_RHost_Write_Protocol_Mode_Test( void )
{
    RBLE_STATUS Ret_Status;

#if ((RBLE_HIDS_INST_MAX == 2) && (RBLE_BAS_INST_MAX == 2))
    uint8_t     inst_idx = 1;
#else
    uint8_t     inst_idx = 0;
#endif
    const uint8_t       protocol_mode_val = RBLE_HGHD_PROTOCOL_MODE_REPORT;     /*=1*/  /**< Report Protocol mode */

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 1 >= RBLE_Parameter_Cnt ) {
            inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_HGP_RHost_Write_Protocol_Mode( Connection_Handle, inst_idx, protocol_mode_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_RHost_Data_Output command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_RHost_Data_Output_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_HGP_RHOST_DATA_OUTPUT_PARAM    *Parameter_p;
    int32_t     Parameter_No;
    uint8_t     inst_idx = 0xff;


    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            if ( 2 >= RBLE_Parameter_Cnt ) {
                inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 1 ];
            }
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
            || ( ( sizeof( RBLE_HGP_RHost_Data_Output_Param ) / sizeof( RBLE_HGP_RHOST_DATA_OUTPUT_PARAM ) ) <= Parameter_No ) ) {
            Parameter_p = &RBLE_HGP_RHost_Data_Output_Param[ 0 ];
            Select_Param_No_Disp( 0 );
        } else {
            Parameter_p = &RBLE_HGP_RHost_Data_Output_Param[ Parameter_No ];
            Select_Param_No_Disp( Parameter_No );
        }
        if ( inst_idx == 0xff ) {
            inst_idx = Parameter_p->inst_idx;
        }
        printf( "Select inst_idx No %d\n",  inst_idx );
        
        /* API Call */
        Ret_Status = RBLE_HGP_RHost_Data_Output( Connection_Handle, inst_idx, &Parameter_p->report );
        printf( " Device type = %d, Report type = %d\n", Parameter_p->report.device_type, Parameter_p->report.report_type );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HGP_RHost_Write_Control_Point command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HGP_RHost_Write_Control_Point_Test( void )
{
    RBLE_STATUS Ret_Status;

#if ((RBLE_HIDS_INST_MAX == 2) && (RBLE_BAS_INST_MAX == 2))
    uint8_t         inst_idx = 1;
#else
    uint8_t         inst_idx = 0;
#endif
    uint8_t         control_point_val = RBLE_HGHD_CTRL_POINT_SUSPEND;   /*=0*/  /**< Suspend */

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 1 <= RBLE_Parameter_Cnt ) {
            if ( RBLE_Parameter_Arg[ 0 ] == RBLE_HGHD_POINT_EXIT_SUSPEND ) {
                control_point_val = RBLE_HGHD_POINT_EXIT_SUSPEND;
            } else {
                control_point_val = RBLE_HGHD_CTRL_POINT_SUSPEND;
            }
#if ((RBLE_HIDS_INST_MAX == 2) || (RBLE_BAS_INST_MAX == 2))
            if ( 2 <= RBLE_Parameter_Cnt ) {
                inst_idx = ( uint8_t )RBLE_Parameter_Arg[ 1 ];
            }
#endif
        }
        printf( "Select Control Point %d / Select Instance %d\n", control_point_val, inst_idx);

        /* API Call */
        Ret_Status = RBLE_HGP_RHost_Write_Control_Point( Connection_Handle, inst_idx, control_point_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#if defined(USE_SCPPC_SAMPLE)|defined(USE_SCPPS_SAMPLE)
/******************************************************************************************/
/**
 *  @brief rBLE SCP Event Status Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void SPP_Event_Status_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE SPP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}
#endif
#ifdef USE_SCPPC_SAMPLE
/* ------------------------- Scan Parameters Profile-------------------------------*/
/******************************************************************************************/
/**
 *  @brief Scan Parameters(Client) Profile Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_SPPC_CallBack( RBLE_SPPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_SPP_EVENT_CLIENT_ENABLE_COMP:             /* Scan Client enable completion event */
            SPP_Event_Status_Disp("CLIENT_ENABLE_COMP", event->param.client_enable.status);
            Connection_Handle_Disp( event->param.client_enable.conhdl );
            printf("* Scan Parameters Service\n");
            printf(" Start Handle         = 0x%04X\n",   event->param.client_enable.sps.shdl );
            printf(" End Handle           = 0x%04X\n\n", event->param.client_enable.sps.ehdl );
            printf(" intv_window_char_hdl = 0x%04X\n",   event->param.client_enable.sps.intv_window_char_hdl );
            printf(" intv_window_val_hdl  = 0x%04X\n",   event->param.client_enable.sps.intv_window_val_hdl  );
            printf(" intv_window_prop     = 0x%02X\n\n", event->param.client_enable.sps.intv_window_prop     );
            printf(" refresh_char_hdl     = 0x%04X\n",   event->param.client_enable.sps.refresh_char_hdl     );
            printf(" refresh_val_hdl      = 0x%04X\n",   event->param.client_enable.sps.refresh_val_hdl      );
            printf(" refresh_cfg_hdl      = 0x%04X\n",   event->param.client_enable.sps.refresh_cfg_hdl      );
            printf(" refresh_prop         = 0x%02X\n\n", event->param.client_enable.sps.refresh_prop         );
            break;
        case RBLE_SPP_EVENT_CLIENT_DISABLE_COMP:            /* Scan Client disable completion event */
            SPP_Event_Status_Disp("CLIENT_DISABLE_COMP", event->param.client_disable.status);
            Connection_Handle_Disp( event->param.client_disable.conhdl );
            break;
        case RBLE_SPP_EVENT_CLIENT_ERROR_IND:               /* Scan Client error indication event */
            SPP_Event_Status_Disp("CLIENT_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_SPP_EVENT_CLIENT_WRITE_CHAR_RESPONSE:     /* Characteristic write request response event */
            SPP_Event_Status_Disp("CLIENT_WRITE_CHAR_RESPONSE", event->param.wr_char_resp.att_code);
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_SPP_EVENT_CLIENT_COMMAND_DISALLOWED_IND:  /* Command disallowed indication event */
            SPP_Event_Status_Disp("COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "  opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif
#ifdef USE_SCPPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief Scan Parameters(Server) Profile Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_SPPS_CallBack( RBLE_SPPS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_SPP_EVENT_SERVER_ENABLE_COMP:             /* Scan Server enable completion event */
            SPP_Event_Status_Disp("SERVER_ENABLE_COMP", event->param.server_enable.status);
            Connection_Handle_Disp( event->param.server_enable.conhdl );
            break;
        case RBLE_SPP_EVENT_SERVER_DISABLE_COMP:            /* Scan Server disable completion event */
            SPP_Event_Status_Disp("SERVER_DISABLE_COMP", event->param.server_disable.status);
            Connection_Handle_Disp( event->param.server_disable.conhdl );
            printf( "  Refresh Ntf Cfg = %04X(%s)\n", event->param.server_disable.device_info.s_refresh_ntf_en, ( event->param.server_disable.device_info.s_refresh_ntf_en == RBLE_PRF_STOP_NTFIND ) ? "STOP" : "START_NTF_IND" );
            break;
        case RBLE_SPP_EVENT_SERVER_CFG_INDNTF_IND:          /* Configured value change indication event */
            printf( "\nrBLE SPP EVENT (SERVER_CFG_INDNTF_IND)\n" );
            Connection_Handle_Disp( event->param.scans_cfg_indntf_ind.conhdl );
            printf( "  Cfg Value = %04X(%s)\n", event->param.scans_cfg_indntf_ind.cfg_val, ( event->param.scans_cfg_indntf_ind.cfg_val == RBLE_PRF_STOP_NTFIND ) ? "STOP" : "START_NTF_IND" );
            break;
        case RBLE_SPP_EVENT_SERVER_INTERVAL_CHG_EVT:        /* Scan interval window notification event */
            printf( "\nrBLE SPP EVENT (SERVER_INTERVAL_CHG_EVT)\n" );
            Connection_Handle_Disp( event->param.interval_chg_evt.conhdl );
            printf( "  interval value  = %04X\n", event->param.interval_chg_evt.scan_param.le_scan_interval );
            printf( "  window value    = %04X\n", event->param.interval_chg_evt.scan_param.le_scan_window );
            break;
        case RBLE_SPP_EVENT_SERVER_SEND_REFRESH_COMP:       /* Scan refresh request send completion event */
            SPP_Event_Status_Disp("SERVER_SEND_REFRESH_COMP", event->param.send_refresh.status);
            Connection_Handle_Disp( event->param.send_refresh.conhdl );
            break;
        case RBLE_SPP_EVENT_SERVER_COMMAND_DISALLOWED_IND:  /* Command disallowed indication event */
            SPP_Event_Status_Disp("COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "  opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}

/******************************************************************************************/
/**
 *  @brief A SPP_Server_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SPP_Server_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;

    const uint8_t                       sec_lvl = 0;
    const uint8_t                       con_type = 0;
    RBLE_SPP_SERVER_PARAM               param = { 0 };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_SPP_Server_Enable( Connection_Handle, sec_lvl, con_type, &param, RBLE_APP_SPPS_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SPP_Server_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SPP_Server_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_SPP_Server_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SPP_Server_Send_Refresh command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SPP_Server_Send_Refresh_Test( void )
{
    RBLE_STATUS     Ret_Status;
    uint8_t         s_refresh_val = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_SPP_Server_Send_Refresh( Connection_Handle, s_refresh_val );
        printf( " refresh value = %d\n", s_refresh_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif
#ifdef USE_SCPPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A SPP_Client_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SPP_Client_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;

    const uint8_t                           con_type = 0;
    RBLE_SPS_CONTENT                        sps = { 0 };
    RBLE_SCANS_INTV_WINDOW_PARAM            s_intv_window = { 0 };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_SPP_Client_Enable( Connection_Handle, con_type, &sps, &s_intv_window, RBLE_APP_SPPC_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SPP_Client_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SPP_Client_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_SPP_Client_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SPP_Client_Write_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SPP_Client_Write_Char_Test( void )
{
    int32_t     Parameter_No;
    RBLE_STATUS Ret_Status;

    uint16_t                cfg_val = RBLE_PRF_STOP_NTFIND;/*=0*/
                                    /*RBLE_PRF_START_NTF*//*=1*/
                                    /*RBLE_PRF_START_IND*//*=2*/

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        switch( Parameter_No ){
        case 0:
        case ILLEGAL_NO:
        default:
            Parameter_No = 0;
            break;
        case 1:
            cfg_val = RBLE_PRF_START_NTF;
            break;
        }
        Select_Param_No_Disp( Parameter_No );
        
        /* API Call */
        Ret_Status = RBLE_SPP_Client_Write_Char( Connection_Handle, cfg_val );
        printf( "  Cfg Value = %04X(%s)\n", cfg_val, ( cfg_val == RBLE_PRF_STOP_NTFIND ) ? "STOP" : "START_NTF_IND" );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SPP_Client_Write_Interval command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SPP_Client_Write_Interval_Test( void )
{
    int32_t     Parameter_No;
    RBLE_STATUS Ret_Status;

    RBLE_SCANS_INTV_WINDOW_PARAM        s_intv_window = { 0 };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        switch( Parameter_No ){
        case 0:
        case ILLEGAL_NO:
        default:
            Parameter_No = 0;
            break;
        case 1:
            s_intv_window.le_scan_interval = 10;               /* scan interval value */
            s_intv_window.le_scan_window   = 10;               /* scan window value */
            break;
        }
        Select_Param_No_Disp( Parameter_No );
        
        /* API Call */
        Ret_Status = RBLE_SPP_Client_Write_Interval( Connection_Handle, &s_intv_window );
        printf( "  interval value = %04X, window value = %04X\n", s_intv_window.le_scan_interval, s_intv_window.le_scan_window );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

/* ------------------------- Heart Rate Profile-------------------------------*/
#if defined(USE_HRPC_SAMPLE)|defined(USE_HRPS_SAMPLE)
/******************************************************************************************/
/**
 *  @brief rBLE HRP Event Status Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void HRP_Event_Status_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE HRP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}
/******************************************************************************************/
/**
 *  @brief rBLE HRP Event Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void HRP_Event_Disp(char_t *event_str)
{
    printf( "\nrBLE HRP EVENT (%s)\n", event_str);
}
#endif

#ifdef USE_HRPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE HRP(Collector) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_HRPC_CallBack( RBLE_HRPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_HRP_EVENT_COLLECTOR_ENABLE_COMP:
            HRP_Event_Status_Disp("COLLECTOR_ENABLE_COMP", event->param.collector_enable.status);
            Connection_Handle_Disp( event->param.collector_enable.conhdl );
            printf("* Heart Rate Service\n");
            printf(" Start Handle = 0x%04X\n", event->param.collector_enable.hrs.shdl );
            printf(" End Handle   = 0x%04X\n\n", event->param.collector_enable.hrs.ehdl );
            printf(" meas_char_hdl = 0x%04X\n", event->param.collector_enable.hrs.hrtrate_meas_char_hdl );
            printf(" meas_val_hdl  = 0x%04X\n", event->param.collector_enable.hrs.hrtrate_meas_val_hdl );
            printf(" meas_cfg_hdl  = 0x%04X\n", event->param.collector_enable.hrs.hrtrate_meas_cfg_hdl );
            printf(" meas_prop     = 0x%02X\n\n", event->param.collector_enable.hrs.hrtrate_meas_prop );
            printf(" body_sensor_loc_char_hdl = 0x%04X\n", event->param.collector_enable.hrs.body_sensor_loc_char_hdl );
            printf(" body_sensor_loc_val_hdl  = 0x%04X\n", event->param.collector_enable.hrs.body_sensor_loc_val_hdl );
            printf(" body_sensor_loc_prop     = 0x%02X\n\n", event->param.collector_enable.hrs.body_sensor_loc_prop );
            printf(" control_point_char_hdl = 0x%04X\n", event->param.collector_enable.hrs.hrtrate_cp_char_hdl );
            printf(" control_point_val_hdl  = 0x%04X\n", event->param.collector_enable.hrs.hrtrate_cp_val_hdl );
            printf(" control_point_prop     = 0x%02X\n\n", event->param.collector_enable.hrs.hrtrate_cp_prop );
            DIS_handle_Info_Disp(&event->param.collector_enable.dis);
            break;
        case RBLE_HRP_EVENT_COLLECTOR_DISABLE_COMP:
            HRP_Event_Status_Disp("COLLECTOR_DISABLE_COMP", event->param.collector_disable.status);
            Connection_Handle_Disp( event->param.collector_disable.conhdl );
            break;
        case RBLE_HRP_EVENT_COLLECTOR_ERROR_IND:
            HRP_Event_Status_Disp("COLLECTOR_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_HRP_EVENT_COLLECTOR_MEASUREMENTS_NTF:
            HRP_Event_Disp("COLLECTOR_MEASUREMENTS_NTF");
            HRP_Info_Disp( &event->param.measurements_ntf.measurements_info );
            break;
        case RBLE_HRP_EVENT_COLLECTOR_READ_CHAR_RESPONSE:
            HRP_Event_Status_Disp("COLLECTOR_READ_CHAR_RESPONSE", event->param.rd_char_resp.att_code);
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            ATT_Info_Disp( &event->param.rd_char_resp.data );
            event->param.rd_char_resp.data.data[event->param.rd_char_resp.data.len] = '\0';
            printf("(%s)\n", event->param.rd_char_resp.data.data);
            break;
        case RBLE_HRP_EVENT_COLLECTOR_WRITE_CHAR_RESPONSE:
            HRP_Event_Status_Disp("COLLECTOR_WRITE_CHAR_RESPONSE", event->param.wr_char_resp.att_code);
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_HRP_EVENT_COLLECTOR_COMMAND_DISALLOWED_IND:
            HRP_Event_Status_Disp("COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_HRPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE HRP(Sensor) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_HRPS_CallBack( RBLE_HRPS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_HRP_EVENT_SENSOR_ENABLE_COMP:
            HRP_Event_Status_Disp("SENSOR_ENABLE_COMP", event->param.sensor_enable.status);
            Connection_Handle_Disp( event->param.sensor_enable.conhdl );
            break;
        case RBLE_HRP_EVENT_SENSOR_DISABLE_COMP:
            HRP_Event_Disp("SENSOR_DISABLE_COMP");
            Connection_Handle_Disp( event->param.sensor_disable.conhdl );
            break;
        case RBLE_HRP_EVENT_SENSOR_ERROR_IND:
            HRP_Event_Status_Disp("SENSOR_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_HRP_EVENT_SENSOR_SEND_MEASUREMENTS_COMP:
            HRP_Event_Status_Disp("SENSOR_SEND_MEASUREMENTS_COMP", event->param.send_measurements.status);
            Connection_Handle_Disp( event->param.send_measurements.conhdl );
            break;
        case RBLE_HRP_EVENT_SENSOR_CHG_CP_IND:
            HRP_Event_Disp("SENSOR_CHG_CP_IND");
            printf( "  CP Value = %s\n", ( event->param.hrps_chg_cp_ind.cp_val == RBLE_HRPC_HRTRATE_CTRL_POINT_RESET ) ? "RESET" : "OTHER" );
            break;
        case RBLE_HRP_EVENT_SENSOR_CFG_NTF_IND:
            HRP_Event_Disp("SENSOR_CFG_NTF_IND");
            printf( "  Cfg Value = %s\n", ( event->param.hrps_cfg_ntf_ind.cfg_val == RBLE_PRF_STOP_NTFIND ) ? "STOP" : "START_NTFD" );
            break;
        case RBLE_HRP_EVENT_SENSOR_COMMAND_DISALLOWED_IND:
            HRP_Event_Status_Disp("COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_HRPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief A HRP_Sensor_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HRP_Sensor_Enable_Test( void )
{
    /* security level */
    const uint8_t sec_lvl = RBLE_SVC_SEC_NONE;
    /* ConType */
    static uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
//  static uint8_t con_type = RBLE_PRF_CON_NORMAL;

    static RBLE_HRP_SENSOR_PARAM    param = {
        RBLE_PRF_START_NTF      /* Heart Rate measurement notification configuration */
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HRP_Sensor_Enable( Connection_Handle, sec_lvl, con_type, &param, RBLE_APP_HRPS_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HRP_Sensor_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HRP_Sensor_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HRP_Sensor_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HRP_Sensor_Send_Measurements command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HRP_Sensor_Send_Measurements_Test( void )
{
    static RBLE_HRP_MEASUREMENTS_INFO   measurements_info[] = 
    {
        {
            0x18,           /* flags */
            0x01,           /* rr interval num */
            0x00ff,         /* heart rate measurements */
            0x0010,         /* energy expended */
            {0x000a}        /* rr interval */
        },
        {
            0x01,           /* flags */
            0x01,           /* rr interval num */
            0x1234,         /* heart rate measurements */
            0x0000,         /* energy expended */
            {0x0000}        /* rr interval */
        },
        {
            0x08,           /* flags */
            0x00,           /* rr interval num */
            0x0000,         /* heart rate measurements */
            0x0000,         /* energy expended */
            {0}             /* rr interval */
        },
        {
            0x10,           /* flags */
            0x01,           /* rr interval num */
            0x0000,         /* heart rate measurements */
            0x0000,         /* energy expended */
            {0x0080}        /* rr interval */
        },                  
        {
            0x10,           /* flags */
            0x02,           /* rr interval num */
            0x0000,         /* heart rate measurements */
            0x0000,         /* energy expended */
            {0x0080,0x000a} /* rr interval */
        },                  
        {
            0x06,           /* flags */
            0x00,           /* rr interval num */
            0x0000,         /* heart rate measurements */
            0x0000,         /* energy expended */
            {0x0080,0x000a} /* rr interval */
        },                  
        {
            0x04,           /* flags */
            0x00,           /* rr interval num */
            0x0000,         /* heart rate measurements */
            0x0000,         /* energy expended */
            {0x0080,0x000a} /* rr interval */
        },                  
        {
            0x02,           /* flags */
            0x00,           /* rr interval num */
            0x0000,         /* heart rate measurements */
            0x0000,         /* energy expended */
            {0x0080,0x000a} /* rr interval */
        },                  
    };

    RBLE_STATUS Ret_Status;
    int32_t Parameter_No;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = 0;
        }
        if (Parameter_No >= (sizeof(measurements_info) / sizeof(RBLE_HRP_MEASUREMENTS_INFO))) {
            Parameter_No = 0;
        }
        
        /* API Call */
        Ret_Status = RBLE_HRP_Sensor_Send_Measurements( Connection_Handle, &(measurements_info[Parameter_No]) );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#ifdef USE_HRPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A HRP_Collector_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HRP_Collector_Enable_Test( void )
{
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
//  uint8_t con_type = RBLE_PRF_CON_NORMAL;

    RBLE_HRS_CONTENT    hrs = {
        0x0000,     /* StartHdl */
        0x0000,     /* EndHdl */
        0x0000,     /* HrtRateMeasCharHdl */
        0x0000,     /* HrtRateMeasValHdl */
        0x0000,     /* HrtRateMeasCfgHdl */
        0x00,       /* HrtRateMeasProp */
        0x00,       /* Pad */
        0x0000,     /* BodySensorLocCharHdl */
        0x0000,     /* BodySensorLocValHdl */
        0x00,       /* BodySensorLocProp */
        0x00,       /* Pad */
        0x0000,     /* HrtRateCpCharHdl */
        0x0000,     /* HrtRateCpValHdl */
        0x00,       /* HrtRateCpProp */
        0x00        /* Pad */
    };
    RBLE_DIS_CONTENT dis = {
        0x0000,     /* StartHdl */
        0x0000,     /* EndHdl */
        0x0000,     /* SysIdCharHdl */
        0x0000,     /* SysIdValHdl */
        0x00,       /* SysIdProp */
        0x00,       /* Pad */
        0x0000,     /* ModelNbCharHdl */
        0x0000,     /* ModelNbValHdl */
        0x00,       /* ModelNbProp */
        0x00,       /* Pad */
        0x0000,     /* SerialNbCharHdl */
        0x0000,     /* SerialNbValHdl */
        0x00,       /* SerialNbProp */
        0x00,       /* Pad */
        0x0000,     /* FwRevCharHdl */
        0x0000,     /* FwRevValdl */
        0x00,       /* FwRevProp */
        0x00,       /* Pad */
        0x0000,     /* HwRevCharHdl */
        0x0000,     /* HwRevValHdl */
        0x00,       /* HwRevProp */
        0x00,       /* Pad */
        0x0000,     /* SwRevCharHdl */
        0x0000,     /* SwRevValHdl */
        0x00,       /* SwRevProp */
        0x00,       /* Pad */
        0x0000,     /* ManufNameCharHdl */
        0x0000,     /* ManufNameValHdl */
        0x00,       /* ManufNameProp */
        0x00,       /* Pad */
        0x0000,     /* IeeeCertifCharHdl */
        0x0000,     /* IeeeCertifValHdl */
        0x00,       /* IeeeCertifProp */
        0x00,       /* Pad */
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_HRP_Collector_Enable( Connection_Handle, con_type, &hrs, &dis, RBLE_APP_HRPC_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HRP_Collector_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HRP_Collector_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HRP_Collector_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HRP_Collector_Read_Char command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HRP_Collector_Read_Char_Test( void )
{
    /* CharCode */
    uint8_t         char_code;
    RBLE_STATUS     Ret_Status;
    int32_t         Parameter_No;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }
    if ( ( ILLEGAL_NO == Parameter_No ) || ( RBLE_HRPC_RD_DIS_IEEE < Parameter_No ) ) {
        char_code = RBLE_HRPC_RD_HRS_HM_CFG;
        Select_Param_No_Disp( 0 );
    } else {
        char_code = (uint8_t)Parameter_No;
        Select_Param_No_Disp( Parameter_No );
    }

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HRP_Collector_Read_Char( Connection_Handle, char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A RBLE_HRP_Collector_Write_Control_Point_Test command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HRP_Collector_Write_Control_Point_Test( void )
{
    RBLE_STATUS                 Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_HRP_Collector_Write_Control_Point( Connection_Handle, RBLE_HRPC_HRTRATE_CTRL_POINT_RESET );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A HRP_Collector_Write_Char command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_HRP_Collector_Write_Char_Test( void )
{
    RBLE_STATUS                 Ret_Status;
    int32_t                     Parameter;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter = 0;
        }
        if ( Parameter == RBLE_PRF_START_NTF) {
            printf( "Start Ntf(1)\n" );
        } else {
            Parameter = RBLE_PRF_STOP_NTFIND;
            printf( "Stop Ntf(0)\n" );
        }
        /* API Call */
        Ret_Status = RBLE_HRP_Collector_Write_Char( Connection_Handle, (uint16_t)Parameter );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

/* ------------------------- Cycling Speed and Cadence Profile-------------------------------*/
#if defined(USE_CSCC_SAMPLE)|defined(USE_CSCS_SAMPLE)
/******************************************************************************************/
/**
 *  @brief rBLE CSCP Event and Status Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void CSCP_Event_Status_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE CSCP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}
/******************************************************************************************/
/**
 *  @brief rBLE CSCP Event Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *
 *  @retval
 */
/******************************************************************************************/
static void CSCP_Event_Disp(char_t *event_str)
{
    printf( "\nrBLE CSCP EVENT (%s)\n", event_str);
}
#endif

#ifdef USE_CSCC_SAMPLE

#ifdef USE_PTS_SAMPLE
static RBLE_CSCS_CONTENT    g_cscs;
static RBLE_DIS_CONTENT     g_cscp_dis;
#endif
/******************************************************************************************/
/**
 *  @brief rBLE CSCP(Collector) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_CSCPC_CallBack( RBLE_CSCPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_CSCP_EVENT_COLLECTOR_ENABLE_COMP:
            CSCP_Event_Status_Disp("COLLECTOR_ENABLE_COMP", event->param.collector_enable.status);
            if (Pts_Flg.CSCP_LinkLoss == FALSE) {
                Connection_Handle_Disp( event->param.collector_enable.conhdl );
                printf("* Cycling Speed and Cadence Service\n");
                printf(" Start Handle = 0x%04X\n", event->param.collector_enable.cscs.shdl );
                printf(" End Handle   = 0x%04X\n\n", event->param.collector_enable.cscs.ehdl );
                printf(" meas_char_hdl       = 0x%04X\n",   event->param.collector_enable.cscs.cycspd_meas_char_hdl );
                printf(" meas_val_hdl        = 0x%04X\n",   event->param.collector_enable.cscs.cycspd_meas_val_hdl );
                printf(" meas_cfg_hdl        = 0x%04X\n",   event->param.collector_enable.cscs.cycspd_meas_cfg_hdl );
                printf(" meas_prop           = 0x%02X\n\n",event->param.collector_enable.cscs.cycspd_meas_prop );
                printf(" feature_char_hdl    = 0x%04X\n",   event->param.collector_enable.cscs.csc_feature_char_hdl );
                printf(" feature_val_hdl     = 0x%04X\n",   event->param.collector_enable.cscs.csc_feature_val_hdl );
                printf(" feature_prop        = 0x%04X\n\n",event->param.collector_enable.cscs.csc_feature_prop );
                printf(" sensor_loc_char_hdl = 0x%04X\n",   event->param.collector_enable.cscs.sensor_loc_char_hdl );
                printf(" sensor_loc_val_hdl  = 0x%04X\n",   event->param.collector_enable.cscs.sensor_loc_val_hdl );
                printf(" sensor_loc_prop     = 0x%04X\n\n",event->param.collector_enable.cscs.sensor_loc_prop );
                printf(" sc_control_point_char_hdl = 0x%04X\n", event->param.collector_enable.cscs.sc_cp_char_hdl );
                printf(" sc_control_point_val_hdl  = 0x%04X\n", event->param.collector_enable.cscs.sc_cp_val_hdl );
                printf(" sc_control_point_cfg_hdl  = 0x%04X\n", event->param.collector_enable.cscs.sc_cp_cfg_hdl );
                printf(" sc_control_point_prop     = 0x%02X\n\n",event->param.collector_enable.cscs.sc_cp_prop );
                DIS_handle_Info_Disp(&event->param.collector_enable.dis);

#ifdef USE_PTS_SAMPLE
                g_cscs = event->param.collector_enable.cscs;
                g_cscp_dis = event->param.collector_enable.dis;
#endif

            }
            break;
        case RBLE_CSCP_EVENT_COLLECTOR_DISABLE_COMP:
            CSCP_Event_Status_Disp("COLLECTOR_DISABLE_COMP", event->param.collector_disable.status);
            Connection_Handle_Disp( event->param.collector_disable.conhdl );
            break;
        case RBLE_CSCP_EVENT_COLLECTOR_ERROR_IND:
            CSCP_Event_Status_Disp("COLLECTOR_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_CSCP_EVENT_COLLECTOR_MEASUREMENTS_NTF:
            CSCP_Event_Disp("COLLECTOR_MEASUREMENTS_NTF");
            CSCP_MEASURE_Info_Disp( &event->param.measurements_ntf.measure_info );
            break;
        case RBLE_CSCP_EVENT_COLLECTOR_SC_CP_IND:
            CSCP_Event_Disp("COLLECTOR_SC_CP_IND");
            CSCP_SC_CP_Info_Disp( &event->param.sc_cp_ind.sc_cp_info, event->param.sc_cp_ind.location_num, &event->param.sc_cp_ind.response_param[0] );
            break;
        case RBLE_CSCP_EVENT_COLLECTOR_READ_CHAR_RESPONSE:
            CSCP_Event_Status_Disp("COLLECTOR_READ_CHAR_RESPONSE", event->param.rd_char_resp.att_code);
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            ATT_Info_Disp( &event->param.rd_char_resp.data );
            event->param.rd_char_resp.data.data[event->param.rd_char_resp.data.len] = '\0';
            printf("(%s)\n", event->param.rd_char_resp.data.data);
            break;
        case RBLE_CSCP_EVENT_COLLECTOR_WRITE_CHAR_RESPONSE:
            CSCP_Event_Status_Disp("COLLECTOR_WRITE_CHAR_RESPONSE", event->param.wr_char_resp.att_code);
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_CSCP_EVENT_COLLECTOR_COMMAND_DISALLOWED_IND:
            CSCP_Event_Status_Disp("COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_CSCS_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE CSCP(Sensor) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_CSCPS_CallBack( RBLE_CSCPS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_CSCP_EVENT_SENSOR_ENABLE_COMP:
            CSCP_Event_Status_Disp("SENSOR_ENABLE_COMP", event->param.sensor_enable.status);
            Connection_Handle_Disp( event->param.sensor_enable.conhdl );
            break;
        case RBLE_CSCP_EVENT_SENSOR_DISABLE_COMP:
            CSCP_Event_Disp("SENSOR_DISABLE_COMP");
            Connection_Handle_Disp( event->param.sensor_disable.conhdl );
            break;
        case RBLE_CSCP_EVENT_SENSOR_ERROR_IND:
            CSCP_Event_Status_Disp("SENSOR_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_CSCP_EVENT_SENSOR_SEND_MEASUREMENTS_COMP:
            CSCP_Event_Status_Disp("SENSOR_SEND_MEASUREMENTS_COMP", event->param.send_measurements.status);
            Connection_Handle_Disp( event->param.send_measurements.conhdl );
            break;
        case RBLE_CSCP_EVENT_SENSOR_SEND_SC_CP_COMP:
            CSCP_Event_Status_Disp("SENSOR_SEND_SC_CP_COMP", event->param.send_sc_cp.status);
            Connection_Handle_Disp( event->param.send_sc_cp.conhdl );
            break;
        case RBLE_CSCP_EVENT_SENSOR_CHG_SC_CP_IND:
            CSCP_Event_Disp("SENSOR_CHG_SC_CP_IND");
            CSCP_SC_CP_Info_Disp( &event->param.cscps_chg_sc_cp_ind.sc_cp_info, 0, NULL  );
            break;
        case RBLE_CSCP_EVENT_SENSOR_CFG_INDNTF_IND:
            CSCP_Event_Disp("SENSOR_CFG_INDNTF_IND");
            printf( "  char_code = %s Cfg Value = %s\n", ( event->param.cscps_cfg_indntf_ind.char_code == RBLE_CSCPC_CYCSPD_MEAS_CODE ) ? "MEAS" : "SC_CP"
                                                       , ( event->param.cscps_cfg_indntf_ind.cfg_val == RBLE_PRF_STOP_NTFIND ) ? "STOP" : "START_NTF/IND" );
            break;
        case RBLE_CSCP_EVENT_SENSOR_COMMAND_DISALLOWED_IND:
            CSCP_Event_Status_Disp("COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_CSCS_SAMPLE
/******************************************************************************************/
/**
 *  @brief A BLP_Sensor_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CSCP_Sensor_Enable_Test( void )
{
    /* security level */
    const uint8_t sec_lvl = RBLE_SVC_SEC_NONE;
    /* ConType */
    static uint8_t con_type = RBLE_PRF_CON_DISCOVERY;

    static RBLE_CSCP_SENSOR_PARAM   param = {
        RBLE_PRF_START_NTF,         /* Cycling Speed measurement notification configuration */
        RBLE_PRF_START_IND,         /* Cycling Speed SC control point indication configuration */
        RBLE_CSCPC_SENSOR_TOP_OF_SHOE,  /* sensor location */
        0                               /* reserved */
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            if(RBLE_Parameter_Arg[0] == 1) {
                con_type = RBLE_PRF_CON_NORMAL;
            }
        }
        
        /* API Call */
        Ret_Status = RBLE_CSCP_Sensor_Enable( Connection_Handle, sec_lvl, con_type, &param, RBLE_APP_CSCPS_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CSCP_Sensor_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CSCP_Sensor_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_CSCP_Sensor_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CSCP_Sensor_Send_Measurements command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CSCP_Sensor_Send_Measurements_Test( void )
{
    static RBLE_CSCP_MEASUREMENTS_INFO  measurements_info[] = 
    {
        {
            0x03,           /* flags */
            0x00,           /* reserved */
            0x00ff00ff,     /* wheel revolutions */
            0x0010,         /* wheel event time */
            0x0200,         /* crank revolutions */
            0x0030          /* crank event time */
        },
        {
            0x01,           /* flags */
            0x00,           /* reserved */
            0x00000005,     /* wheel revolutions */
            0x0005,         /* wheel event time */
            0x0300,         /* crank revolutions */
            0x0040          /* crank event time */
        },
        {
            0x02,           /* flags */
            0x00,           /* reserved */
            0x00ff00ff,     /* wheel revolutions */
            0x0030,         /* wheel event time */
            0x0400,         /* crank revolutions */
            0x0050          /* crank event time */
        }
    };

    RBLE_STATUS Ret_Status;
    int32_t Parameter_No;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = 0;
        }
        if (Parameter_No >= (sizeof(measurements_info) / sizeof(RBLE_CSCP_MEASUREMENTS_INFO))) {
            Parameter_No = 0;
        }
        if ( 3 <= RBLE_Parameter_Cnt) {
            if (Parameter_No == 1) {
                measurements_info[1].wheel_revolutions = (uint32_t)RBLE_Parameter_Arg[ 1 ];
                measurements_info[1].wheel_event_time  = (uint16_t)RBLE_Parameter_Arg[ 2 ];
                printf("wheel = %d event = %d\n",measurements_info[1].wheel_revolutions,measurements_info[1].wheel_event_time);
            }
            else if(Parameter_No == 2) {
                measurements_info[2].crank_revolutions = (uint16_t)RBLE_Parameter_Arg[ 1 ];
                measurements_info[2].crank_event_time  = (uint16_t)RBLE_Parameter_Arg[ 2 ];
                printf("crank = %d event = %d\n",measurements_info[1].crank_revolutions,measurements_info[1].crank_event_time);
            }
        }
        
        /* API Call */
        Ret_Status = RBLE_CSCP_Sensor_Send_Measurements( Connection_Handle, &(measurements_info[Parameter_No]) );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CSCP_Sensor_Send_SC_Control_Point command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CSCP_Sensor_Send_Sc_Control_Point_Test( void )
{
    static RBLE_CSCP_SC_CONTROL_POINT_INFO  sc_cp_info[] = 
    {
        {
            RBLE_CSCP_OP_RESPONSE_CODE,         /* operation code */
            0x00,                               /* reserved */
            0x00000000,                         /* cumulative value */
            0x00,                               /* sensor location */
            RBLE_CSCP_OP_SET_CUMULATIVE_CODE,   /* request op code */
            RBLE_CSCP_RES_SUCCESS_CODE          /* response value */
        },
        {
            RBLE_CSCP_OP_RESPONSE_CODE,     /* operation code */
            0x00,                           /* reserved */
            0x00000000,                     /* cumulative value */
            0x00,                           /* sensor location */
            RBLE_CSCP_OP_START_SC_CODE,     /* request op code */
            RBLE_CSCP_RES_SUCCESS_CODE      /* response value */
        },
        {
            RBLE_CSCP_OP_RESPONSE_CODE,     /* operation code */
            0x00,                           /* reserved */
            0x00000000,                     /* cumulative value */
            0x00,                           /* sensor location */
            RBLE_CSCP_OP_UPDATE_SL_CODE,    /* request op code */
            RBLE_CSCP_RES_SUCCESS_CODE      /* response value */
        },
        {
            RBLE_CSCP_OP_RESPONSE_CODE,             /* operation code */
            0x00,                                   /* reserved */
            0x00000000,                             /* cumulative value */
            0x00,                                   /* sensor location */
            RBLE_CSCP_OP_REQ_SUPPORTED_SL_CODE,     /* request op code */
            RBLE_CSCP_RES_SUCCESS_CODE              /* response value */
        },
        {
            RBLE_CSCP_OP_RESPONSE_CODE,             /* operation code */
            0x00,                                   /* reserved */
            0x00000000,                             /* cumulative value */
            0x00,                                   /* sensor location */
            RBLE_CSCP_OP_REQ_SUPPORTED_SL_CODE,     /* request op code */
            RBLE_CSCP_RES_SUCCESS_CODE              /* response value */
        }
    };

    RBLE_STATUS Ret_Status;
    int32_t Parameter_No;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if (Parameter_No >= (sizeof(sc_cp_info) / sizeof(RBLE_CSCP_SC_CONTROL_POINT_INFO))) {
            Parameter_No = 0;
        }
        if ((Parameter_No == 4) && (RBLE_Parameter_Cnt >= 3)) {
            sc_cp_info[4].request_op_code = (uint8_t)RBLE_Parameter_Arg[1];
            sc_cp_info[4].response_value  = (uint8_t)RBLE_Parameter_Arg[2];
        }
        
        /* API Call */
        Ret_Status = RBLE_CSCP_Sensor_Send_SC_Control_Point( Connection_Handle, &(sc_cp_info[Parameter_No]) );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#ifdef USE_CSCC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A CSCP_Collector_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CSCP_Collector_Enable_Test( void )
{

    RBLE_STATUS Ret_Status;
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
    RBLE_CSCS_CONTENT   cscs = {0};
    RBLE_DIS_CONTENT    dis  = {0};


    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        
        if (FALSE == Pts_Flg.CSCP_LinkLoss) {
            /* API Call */
            Ret_Status = RBLE_CSCP_Collector_Enable( Connection_Handle, con_type, &cscs, &dis, RBLE_APP_CSCPC_CallBack );
            
            /* set first measurement flang */
            First_Wheel_Flg = TRUE;
            First_Crank_Flg = TRUE;
        }
        else {
            Ret_Status = RBLE_CSCP_Collector_Enable( Connection_Handle, RBLE_PRF_CON_NORMAL, &g_cscs, &g_cscp_dis, RBLE_APP_CSCPC_CallBack );
        }

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CSCP_Collector_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CSCP_Collector_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_CSCP_Collector_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CSCP_Collector_Read_Char command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CSCP_Collector_Read_Char_Test( void )
{
    /* CharCode */
    uint8_t         char_code;
    RBLE_STATUS     Ret_Status;
    int32_t         Parameter_No;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }
    if ( ( ILLEGAL_NO == Parameter_No ) || ( RBLE_CSCPC_RD_DIS_IEEE < Parameter_No ) ) {
        char_code = RBLE_CSCPC_RD_CSCS_CM_CFG;
        Select_Param_No_Disp( 0 );
    } else {
        char_code = (uint8_t)Parameter_No;
        Select_Param_No_Disp( Parameter_No );
    }

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_CSCP_Collector_Read_Char( Connection_Handle, char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A RBLE_CSCP_Collector_Write_SC_Control_Point_Test command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CSCP_Collector_Write_SC_Control_Point_Test( void )
{
    RBLE_STATUS     Ret_Status;
    int32_t         Parameter_No;

    static RBLE_CSCP_SC_CONTROL_POINT_INFO  sc_cp_info[] = 
    {
        {
            RBLE_CSCP_OP_SET_CUMULATIVE_CODE,   /* operation code */
            0x00,           /* reserved */
            0x00ff00ff,     /* cumulative value */
            0x00,           /* sensor location */
            0x00,           /* request op code */
            0x00            /* response value */
        },
        {
            RBLE_CSCP_OP_START_SC_CODE, /* operation code */
            0x00,           /* reserved */
            0x00000000,     /* cumulative value */
            0x00,           /* sensor location */
            0x00,           /* request op code */
            0x00            /* response value */
        },
        {
            RBLE_CSCP_OP_UPDATE_SL_CODE,    /* operation code */
            0x00,           /* reserved */
            0x00000000,     /* cumulative value */
            RBLE_CSCPC_SENSOR_FRONT_WHEEL,  /* sensor location */
            0x00,           /* request op code */
            0x00            /* response value */
        },
        {
            RBLE_CSCP_OP_REQ_SUPPORTED_SL_CODE, /* operation code */
            0x00,           /* reserved */
            0x00000000,     /* cumulative value */
            0x00,           /* sensor location */
            0x00,           /* request op code */
            0x00            /* response value */
        }
    };
    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if (Parameter_No >= (sizeof(sc_cp_info) / sizeof(RBLE_CSCP_SC_CONTROL_POINT_INFO))) {
            Parameter_No = 0;
        }
        if (1 < RBLE_Parameter_Cnt) {
            switch(sc_cp_info[Parameter_No].OpCode)
            {
                case RBLE_CSCP_OP_SET_CUMULATIVE_CODE:
                    sc_cp_info[Parameter_No].cumulative_value = RBLE_Parameter_Arg[1];
                    break;
                case RBLE_CSCP_OP_UPDATE_SL_CODE:
                    sc_cp_info[Parameter_No].sensor_location = (uint8_t)RBLE_Parameter_Arg[1];
                    break;
                default:
                    break;
            }
        }
        /* API Call */
        Ret_Status = RBLE_CSCP_Collector_Write_SC_Control_Point( Connection_Handle, &sc_cp_info[Parameter_No] );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CSCP_Collector_Write_Char command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CSCP_Collector_Write_Char_Test( void )
{
    RBLE_STATUS                 Ret_Status;
    uint32_t                    Parameter;
    uint32_t                    char_code = RBLE_CSCPC_CYCSPD_MEAS_CODE;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter = 0;
        }
        if ( Parameter == RBLE_PRF_START_NTF) {
            printf( "Start Ntf\n" );
        } else if( Parameter == RBLE_PRF_START_IND) {
            printf( "Start Ind\n" );
        } else {
            Parameter = RBLE_PRF_STOP_NTFIND;
            printf( "Stop Ind/Ntf\n" );
        }
        if (1 < RBLE_Parameter_Cnt) {
            char_code = RBLE_Parameter_Arg[ 1 ];
        }

        /* API Call */
        Ret_Status = RBLE_CSCP_Collector_Write_Char( Connection_Handle, (uint8_t)char_code, (uint16_t)Parameter );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

/* ------------------------- Glucose Profile-------------------------------*/
#if defined(USE_GLPC_SAMPLE)|defined(USE_GLPS_SAMPLE)
/******************************************************************************************/
/**
 *  @brief rBLE GLP Event and Status Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void GLP_Event_Status_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE GLP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}
/******************************************************************************************/
/**
 *  @brief rBLE GLP Event Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *
 *  @retval
 */
/******************************************************************************************/
static void GLP_Event_Disp(char_t *event_str)
{
    printf( "\nrBLE GLP EVENT (%s)\n", event_str );
}
#endif

#ifdef USE_GLPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE GLP(Collector) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_GLPC_CallBack( RBLE_GLPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_GLP_EVENT_COLLECTOR_ENABLE_COMP:
            GLP_Event_Status_Disp("COLLECTOR_ENABLE_COMP", event->param.collector_enable.status);
            Connection_Handle_Disp( event->param.collector_enable.conhdl );
            printf("* Glucose Service\n");
            printf(" Start Handle = 0x%04X\n", event->param.collector_enable.gls.shdl );
            printf(" End Handle   = 0x%04X\n\n", event->param.collector_enable.gls.ehdl );
            printf(" meas_char_hdl             = 0x%04X\n", event->param.collector_enable.gls.glucose_meas_char_hdl );
            printf(" meas_val_hdl              = 0x%04X\n", event->param.collector_enable.gls.glucose_meas_val_hdl );
            printf(" meas_cfg_hdl              = 0x%04X\n", event->param.collector_enable.gls.glucose_meas_cfg_hdl );
            printf(" meas_prop                 = 0x%02X\n\n",   event->param.collector_enable.gls.glucose_meas_prop );
            printf(" meas_context_char_hdl     = 0x%04X\n", event->param.collector_enable.gls.glucose_meas_context_char_hdl );
            printf(" meas_context_val_hdl      = 0x%04X\n", event->param.collector_enable.gls.glucose_meas_context_val_hdl );
            printf(" meas_context_cfg_hdl      = 0x%04X\n", event->param.collector_enable.gls.glucose_meas_context_cfg_hdl );
            printf(" meas_context_prop         = 0x%02X\n\n",   event->param.collector_enable.gls.glucose_meas_context_prop );
            printf(" feature_char_hdl          = 0x%04X\n", event->param.collector_enable.gls.glucose_feature_char_hdl );
            printf(" feature_val_hdl           = 0x%04X\n", event->param.collector_enable.gls.glucose_feature_val_hdl );
            printf(" feature_prop              = 0x%04X\n\n",   event->param.collector_enable.gls.glucose_feature_prop );
            printf(" ra_control_point_char_hdl = 0x%04X\n", event->param.collector_enable.gls.glucose_ra_cp_char_hdl );
            printf(" ra_control_point_val_hdl  = 0x%04X\n", event->param.collector_enable.gls.glucose_ra_cp_val_hdl );
            printf(" ra_control_point_cfg_hdl  = 0x%04X\n", event->param.collector_enable.gls.glucose_ra_cp_cfg_hdl );
            printf(" ra_control_point_prop     = 0x%02X\n\n",event->param.collector_enable.gls.glucose_ra_cp_prop );
            DIS_handle_Info_Disp(&event->param.collector_enable.dis);
            break;
        case RBLE_GLP_EVENT_COLLECTOR_DISABLE_COMP:
            GLP_Event_Status_Disp("COLLECTOR_DISABLE_COMP", event->param.collector_disable.status);
            Connection_Handle_Disp( event->param.collector_disable.conhdl );
            break;
        case RBLE_GLP_EVENT_COLLECTOR_ERROR_IND:
            GLP_Event_Status_Disp("COLLECTOR_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_GLP_EVENT_COLLECTOR_MEASUREMENTS_NTF:
            GLP_Event_Disp("COLLECTOR_MEASUREMENTS_NTF");
            GLP_MEASURE_Info_Disp( &event->param.measurements_ntf.measure_info );
            break;
        case RBLE_GLP_EVENT_COLLECTOR_MEASUREMENTS_CONTEXT_NTF:
            GLP_Event_Disp("COLLECTOR_MEASUREMENTS_CONTEXT_NTF");
            GLP_MEASURE_Context_Info_Disp( &event->param.measurements_context_ntf.measure_context_info );
            break;
        case RBLE_GLP_EVENT_COLLECTOR_RA_CP_IND:
            GLP_Event_Disp("COLLECTOR_RA_CP_IND");
            GLP_RA_CP_Ind_Info_Disp( &event->param.ra_cp_ind.ra_cp_ind_info);
            break;
        case RBLE_GLP_EVENT_COLLECTOR_READ_CHAR_RESPONSE:
            GLP_Event_Status_Disp("COLLECTOR_READ_CHAR_RESPONSE", event->param.rd_char_resp.att_code);
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            ATT_Info_Disp( &event->param.rd_char_resp.data );
            event->param.rd_char_resp.data.data[event->param.rd_char_resp.data.len] = '\0';
            printf("(%s)\n", event->param.rd_char_resp.data.data);
            break;
        case RBLE_GLP_EVENT_COLLECTOR_WRITE_CHAR_RESPONSE:
            GLP_Event_Status_Disp("COLLECTOR_WRITE_CHAR_RESPONSE", event->param.wr_char_resp.att_code);
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_GLP_EVENT_COLLECTOR_COMMAND_DISALLOWED_IND:
            GLP_Event_Status_Disp("COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_GLPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE GLP(Sensor) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_GLPS_CallBack( RBLE_GLPS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_GLP_EVENT_SENSOR_ENABLE_COMP:
            GLP_Event_Status_Disp("SENSOR_ENABLE_COMP", event->param.sensor_enable.status);
            Connection_Handle_Disp( event->param.sensor_enable.conhdl );
            break;
        case RBLE_GLP_EVENT_SENSOR_DISABLE_COMP:
            GLP_Event_Disp("SENSOR_DISABLE_COMP");
            Connection_Handle_Disp( event->param.sensor_disable.conhdl );
            break;
        case RBLE_GLP_EVENT_SENSOR_ERROR_IND:
            GLP_Event_Status_Disp("SENSOR_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_GLP_EVENT_SENSOR_SEND_MEASUREMENTS_COMP:
            GLP_Event_Status_Disp("SENSOR_SEND_MEASUREMENTS_COMP", event->param.send_measurements.status);
            Connection_Handle_Disp( event->param.send_measurements.conhdl );
            break;
        case RBLE_GLP_EVENT_SENSOR_SEND_MEASUREMENTS_CONTEXT_COMP:
            GLP_Event_Status_Disp("SENSOR_SEND_MEASUREMENTS_CONTEXT_COMP", event->param.send_measurements_context.status);
            Connection_Handle_Disp( event->param.send_measurements_context.conhdl );
            break;
        case RBLE_GLP_EVENT_SENSOR_SEND_RA_CP_COMP:
            GLP_Event_Status_Disp("SENSOR_SEND_RA_CP_COMP", event->param.send_ra_cp.status);
            Connection_Handle_Disp( event->param.send_ra_cp.conhdl );
            break;
        case RBLE_GLP_EVENT_SENSOR_CHG_RA_CP_IND:
            GLP_Event_Disp("SENSOR_CHG_RA_CP_IND");
            GLP_RA_CP_Info_Disp( &event->param.glps_chg_ra_cp_ind.ra_cp_info );
            break;
        case RBLE_GLP_EVENT_SENSOR_CFG_INDNTF_IND:
            GLP_Event_Disp("SENSOR_CFG_INDNTF_IND");
            printf( "  char_code = %d Cfg Value = %s\n", event->param.glps_cfg_indntf_ind.char_code, ( event->param.glps_cfg_indntf_ind.cfg_val == RBLE_PRF_STOP_NTFIND ) ? "STOP" : "START" );
            break;
        case RBLE_GLP_EVENT_SENSOR_COMMAND_DISALLOWED_IND:
            GLP_Event_Status_Disp("COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_GLPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief A BLP_Sensor_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GLP_Sensor_Enable_Test( void )
{
    /* security level */
    uint8_t sec_lvl = RBLE_SVC_SEC_NONE;
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;

    RBLE_GLP_SENSOR_PARAM   param = {
        RBLE_PRF_START_NTF,         /* Glucose measurement notification configuration */
        RBLE_PRF_START_NTF,         /* Glucose measurement context notification configuration */
        RBLE_PRF_START_IND,         /* Glucose ra control point indication configuration */
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            if(RBLE_Parameter_Arg[0] == 1) {
                con_type = RBLE_PRF_CON_NORMAL;
            }
        }
        
        /* API Call */
        Ret_Status = RBLE_GLP_Sensor_Enable( Connection_Handle, sec_lvl, con_type, &param, RBLE_APP_GLPS_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GLP_Sensor_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GLP_Sensor_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_GLP_Sensor_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GLP_Sensor_Send_Measurements command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GLP_Sensor_Send_Measurements_Test( void )
{
    static uint16_t seq_num = 1;
    
    RBLE_GLP_MEASUREMENTS_INFO  measurements_info[] = 
    {
        {
            0x01,           /* flags */
            0x00,           /* reserved */
            0,              /* seq_num */
            {               /* stamp */
                2013,       /* year */
                3,          /* month */
                28,         /* day */
                15,         /* hour */
                27,         /* min */
                41          /* sec */
            },
            0,              /* time offset */
            0xb321,         /* concentration 801*10^-5*/
            RBLE_GLP_TYPE_VENOUS_WHOLE_BLOOD,   /* type */
            RBLE_GLP_SAMPLELOC_EARLOBE,         /* sample location */
            RBLE_GLP_SENSORSTATUS_RESULT_HIGH   /* sensor status annun */
        },
        {
            0x01,           /* flags */
            0x00,           /* reserved */
            0,              /* seq_num */
            {               /* stamp */
                2013,       /* year */
                3,          /* month */
                28,         /* day */
                15,         /* hour */
                27,         /* min */
                41          /* sec */
            },
            0,              /* time offset */
            0xd321,         /* concentration 801*10^-3 */
            RBLE_GLP_TYPE_VENOUS_WHOLE_BLOOD,   /* type */
            RBLE_GLP_SAMPLELOC_EARLOBE,         /* sample location */
            RBLE_GLP_SENSORSTATUS_RESULT_HIGH   /* sensor status annun */
        }
    };

    RBLE_STATUS Ret_Status;
    uint8_t Parameter_No = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if(1 <RBLE_Parameter_Cnt) {
                measurements_info[Parameter_No].flags = (uint8_t)RBLE_Parameter_Arg[ 1 ];
                if(2 < RBLE_Parameter_Cnt) {
                    seq_num = (uint8_t)RBLE_Parameter_Arg[ 2 ];
                    if(3 < RBLE_Parameter_Cnt) {
                        measurements_info[Parameter_No].stamp.hour += (uint8_t)RBLE_Parameter_Arg[ 3 ];
                        measurements_info[Parameter_No].time_offset += (uint16_t)RBLE_Parameter_Arg[ 3 ] * 60;
                    }
                }
            }
        }
        
        measurements_info[Parameter_No].seq_num = seq_num;
        printf( "flags = %02x  seq_num = %d\n", measurements_info[Parameter_No].flags, seq_num);
        /* API Call */
        Ret_Status = RBLE_GLP_Sensor_Send_Measurements( Connection_Handle, &measurements_info[Parameter_No] );

        seq_num++;
        
        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GLP_Sensor_Send_Measurements_Context command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GLP_Sensor_Send_Measurements_Context_Test( void )
{
    RBLE_GLP_MEASUREMENTS_CONTEXT_INFO  measurements_context_info = 
    {
        0x00,           /* flags */
        0x00,           /* reserved */
        0x0008,         /* seq_num */
        0xff,           /* ex_flags */
        RBLE_GLP_CARBOHYDRATEID_DINNER,         /* carbohydrate_id */
        0xd111,         /* carbohydrate_kg */
        RBLE_GLP_MEAL_POSTPRANDIAL,             /* meal */
        RBLE_GLP_TESTER_SELF,                   /* tester */
        RBLE_GLP_HEALTH_NO_ISSUE,               /* health */
        0x00,           /* reserved */
        0x2000,         /* exercise_duration */
        0x11,           /* exercise_intensity */
        RBLE_GLP_MEDICATIONID_RAPID_INSULIN,    /* medication_id */
        0xa321,         /* medication */
        0x0021          /* HbA1c */
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            measurements_context_info.flags = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if(measurements_context_info.flags & 0x20)
            {
                measurements_context_info.medication = 0xd321;
            }
            if(RBLE_Parameter_Cnt>1) {
                measurements_context_info.seq_num = (uint16_t)RBLE_Parameter_Arg[ 1 ];
            }
        }
        
        /* API Call */
        Ret_Status = RBLE_GLP_Sensor_Send_Measurements_Context( Connection_Handle, &measurements_context_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GLP_Sensor_Send_Ra_Control_Point command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GLP_Sensor_Send_RA_Control_Point_Test( void )
{
    RBLE_GLP_RA_CONTROL_POINT_IND_INFO  ra_cp_ind_info[] = 
    {
        {
            RBLE_GLP_OPCODE_RESPONSE_CODE,      /* operation code */
            RBLE_GLP_OPERATOR_NULL,             /* operator */
            0x0003,                             /* number of records */
            RBLE_GLP_OPCODE_REPORT_RECORDS,     /* Request Op Code */
            RBLE_GLP_OPERAND_SUCCESS,           /* Response Code Value */
        },
        {
            RBLE_GLP_OPCODE_NUMBER_RECORDS_RESPONSE,    /* operation code */
            RBLE_GLP_OPERATOR_NULL,             /* operator */
            0x0002,                             /* number of records */
            RBLE_GLP_OPCODE_REPORT_RECORDS_NUMBER,      /* Request Op Code */
            RBLE_GLP_OPERAND_SUCCESS,           /* Response Code Value */
        },
        {
            RBLE_GLP_OPCODE_NUMBER_RECORDS_RESPONSE,    /* operation code */
            RBLE_GLP_OPERATOR_NULL,             /* operator */
            0x0000,                             /* number of records */
            RBLE_GLP_OPCODE_REPORT_RECORDS_NUMBER,      /* Request Op Code */
            RBLE_GLP_OPERAND_SUCCESS,           /* Response Code Value */
        }
    };

    RBLE_STATUS Ret_Status;
    uint32_t    Parameter_No = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            if (Parameter_No >= (sizeof(ra_cp_ind_info) / sizeof(RBLE_GLP_RA_CONTROL_POINT_IND_INFO))) {
                Parameter_No = 0;
            }
            if( 1 < RBLE_Parameter_Cnt ) {
                ra_cp_ind_info[Parameter_No].request_op_code = (uint8_t)RBLE_Parameter_Arg[ 1 ];
                if(ra_cp_ind_info[Parameter_No].request_op_code == RBLE_GLP_OPCODE_REPORT_RECORDS_NUMBER) {
                    ra_cp_ind_info[Parameter_No].OpCode = RBLE_GLP_OPCODE_NUMBER_RECORDS_RESPONSE;
                }
                if( 2 < RBLE_Parameter_Cnt) {
                    ra_cp_ind_info[Parameter_No].response_code_value = (uint8_t)RBLE_Parameter_Arg[ 2 ];
                    if( 3 < RBLE_Parameter_Cnt) {
                        ra_cp_ind_info[Parameter_No].num_of_records = (uint8_t)RBLE_Parameter_Arg[ 3 ];
                    }
                }
            }
        }
        
        /* API Call */
        Ret_Status = RBLE_GLP_Sensor_Send_RA_Control_Point( Connection_Handle, &(ra_cp_ind_info[Parameter_No]) );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#ifdef USE_GLPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A GLP_Collector_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GLP_Collector_Enable_Test( void )
{

    RBLE_STATUS Ret_Status;
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
    RBLE_GLS_CONTENT    glp_gls = {0};
    RBLE_DIS_CONTENT    glp_dis = {0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        
        /* API Call */
        Ret_Status = RBLE_GLP_Collector_Enable( Connection_Handle, con_type, &glp_gls, &glp_dis, RBLE_APP_GLPC_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GLP_Collector_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GLP_Collector_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_GLP_Collector_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GLP_Collector_Read_Char command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GLP_Collector_Read_Char_Test( void )
{
    /* CharCode */
    uint8_t         char_code;
    RBLE_STATUS     Ret_Status;
    int32_t         Parameter_No;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }
    if ( ( ILLEGAL_NO == Parameter_No ) || ( RBLE_GLPC_RD_DIS_IEEE < Parameter_No ) ) {
        char_code = RBLE_GLPC_RD_MEASUREMENT_CFG;
        Select_Param_No_Disp( 0 );
    } else {
        char_code = (uint8_t)Parameter_No;
        Select_Param_No_Disp( Parameter_No );
    }

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_GLP_Collector_Read_Char( Connection_Handle, char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A RBLE_GLP_Collector_Write_RA_Control_Point_Test command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GLP_Collector_Write_RA_Control_Point_Test( void )
{
    RBLE_STATUS     Ret_Status;

    static RBLE_GLP_RA_CONTROL_POINT_INFO   ra_cp_info = 
    {
        RBLE_GLP_OPCODE_REPORT_RECORDS,     /* operation code */
        RBLE_GLP_OPERATOR_ALL_RECORDS,      /* oprator */
        0x00,           /* operand value */
        0x00,           /* min sequence */
        0x50,           /* max sequence */
        0x00,
        {               /* min_stamp */
            2013,
            3,
            29,
            14,
            23,
            45
        },
        {               /* max_stamp */
            2013,
            3,
            29,
            14,
            25,
            36
        }
    };
    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            ra_cp_info.OpCode = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if(RBLE_Parameter_Cnt > 1) {
                ra_cp_info.racp_operator = (uint8_t)RBLE_Parameter_Arg[ 1 ];
                if(RBLE_Parameter_Cnt > 2) {
                    ra_cp_info.operand_value = (uint8_t)RBLE_Parameter_Arg[ 2 ];
                    if(ra_cp_info.operand_value == 1) {
                        if(RBLE_Parameter_Cnt > 3) {
                            ra_cp_info.min_sequence_num = (uint16_t)RBLE_Parameter_Arg[ 3 ];
                            if(RBLE_Parameter_Cnt > 4) {
                                ra_cp_info.max_sequence_num = (uint16_t)RBLE_Parameter_Arg[ 4 ];
                            }
                        }
                    }
                    else {
                        ra_cp_info.min_stamp.year  = (uint16_t)(RBLE_Parameter_Arg[ 3 ] / 10000);
                        ra_cp_info.min_stamp.day   = (uint8_t)((RBLE_Parameter_Arg[ 3 ] / 100) % 100);
                        ra_cp_info.min_stamp.month = (uint8_t)(RBLE_Parameter_Arg[ 3 ] % 100);
                        if(RBLE_Parameter_Cnt > 4) {
                            ra_cp_info.min_stamp.hour = (uint8_t)(RBLE_Parameter_Arg[ 4 ] / 10000);
                            ra_cp_info.min_stamp.min  = (uint8_t)((RBLE_Parameter_Arg[ 4 ] / 100) % 100);
                            ra_cp_info.min_stamp.sec  = (uint8_t)(RBLE_Parameter_Arg[ 4 ] % 100);
                            if(RBLE_Parameter_Cnt > 5) { 
                                ra_cp_info.max_stamp.year  = (uint16_t)(RBLE_Parameter_Arg[ 5 ] / 10000);
                                ra_cp_info.max_stamp.day   = (uint8_t)((RBLE_Parameter_Arg[ 5 ] / 100) % 100);
                                ra_cp_info.max_stamp.month = (uint8_t)(RBLE_Parameter_Arg[ 5 ] % 100);
                                if(RBLE_Parameter_Cnt > 6) { 
                                    ra_cp_info.max_stamp.hour = (uint8_t)(RBLE_Parameter_Arg[ 6 ] / 10000);
                                    ra_cp_info.max_stamp.min  = (uint8_t)((RBLE_Parameter_Arg[ 6 ] / 100) % 100);
                                    ra_cp_info.max_stamp.sec  = (uint8_t)(RBLE_Parameter_Arg[ 6 ] % 100);
                                }
                            }
                        }
                    }
                }
            }
        }
        /* API Call */
        Ret_Status = RBLE_GLP_Collector_Write_RA_Control_Point( Connection_Handle, &ra_cp_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A GLP_Collector_Write_Char command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_GLP_Collector_Write_Char_Test( void )
{
    RBLE_STATUS                 Ret_Status;
    uint32_t                    Parameter;
    uint32_t                    char_code = RBLE_GLPC_WR_MEASUREMENT_CODE;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            char_code = RBLE_Parameter_Arg[ 0 ];
        }
        if (1 < RBLE_Parameter_Cnt) {
            Parameter = RBLE_Parameter_Arg[ 1 ];
        } else {
            Parameter = 0;
        }
        if ( Parameter == RBLE_PRF_START_NTF) {
            printf( "Start Ntf\n" );
        } else if( Parameter == RBLE_PRF_START_IND) {
            printf( "Start Ind\n" );
        } else {
            Parameter = RBLE_PRF_STOP_NTFIND;
            printf( "Stop Ind/Ntf\n" );
        }

        /* API Call */
        Ret_Status = RBLE_GLP_Collector_Write_Char( Connection_Handle, (uint8_t)char_code, (uint16_t)Parameter );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

/* ------------------------- Cycling Power Specific-------------------------------*/
#if defined(USE_CPPC_SAMPLE)|defined(USE_CPPS_SAMPLE)
/******************************************************************************************/
/**
 *  @brief rBLE CPP Event and Status Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void CPP_Event_Status_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE CPP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}
/******************************************************************************************/
/**
 *  @brief rBLE CPP Event Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *
 *  @retval
 */
/******************************************************************************************/
static void CPP_Event_Disp(char_t *event_str)
{
    printf( "\nrBLE CPP EVENT (%s)\n", event_str );
}
#endif

#ifdef USE_CPPC_SAMPLE

#ifdef USE_PTS_SAMPLE
static RBLE_CPS_CONTENT     g_cps[2] = {{0x0},{0x0}};
static RBLE_DIS_CONTENT     g_cpp_dis[2] = {{0x0},{0x0}};
static RBLE_BATS_CONTENT    g_cpp_bas[2] = {{0x0},{0x0}};
static uint8_t  cpp_hdl_idx = 0;
static uint16_t cpp_con_hdl = ILLEGAL_CONNECTION_HANDLE;
#endif
/******************************************************************************************/
/**
 *  @brief Cycling Power(Collector) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_CPPC_CallBack( RBLE_CPPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_CPP_EVENT_COLLECTOR_ENABLE_COMP:
            CPP_Event_Status_Disp("COLLECTOR_ENABLE_COMP", event->param.collector_enable.status);
            Connection_Handle_Disp( event->param.collector_enable.conhdl );
            printf( "* Cycling Power Service\n");
            printf( " Start Handle = 0x%04X\n", event->param.collector_enable.cps.shdl );
            printf( " End Handle   = 0x%04X\n\n",   event->param.collector_enable.cps.ehdl );
            printf( " meas_char_hdl       = 0x%04X\n",  event->param.collector_enable.cps.cp_meas_char_hdl );
            printf( " meas_val_hdl        = 0x%04X\n",  event->param.collector_enable.cps.cp_meas_val_hdl );
            printf( " meas_cfg_hdl        = 0x%04X\n",  event->param.collector_enable.cps.cp_meas_cfg_hdl );
            printf( " meas_brd_cfg_hdl    = 0x%04X\n",  event->param.collector_enable.cps.cp_meas_brd_cfg_hdl );
            printf( " meas_prop           = 0x%02X\n\n",    event->param.collector_enable.cps.cp_meas_prop );
            printf( " feature_char_hdl    = 0x%04X\n",  event->param.collector_enable.cps.cp_feature_char_hdl );
            printf( " feature_val_hdl     = 0x%04X\n",  event->param.collector_enable.cps.cp_feature_val_hdl );
            printf( " feature_prop        = 0x%02X\n\n",    event->param.collector_enable.cps.cp_feature_prop );
            printf( " sensor_loc_char_hdl = 0x%04X\n",  event->param.collector_enable.cps.sensor_loc_char_hdl );
            printf( " sensor_loc_val_hdl  = 0x%04X\n",  event->param.collector_enable.cps.sensor_loc_val_hdl );
            printf( " sensor_loc_prop     = 0x%02X\n\n",    event->param.collector_enable.cps.sensor_loc_prop );
            printf( " vector_char_hdl     = 0x%04X\n",  event->param.collector_enable.cps.cp_vector_char_hdl );
            printf( " vector_val_hdl      = 0x%04X\n",  event->param.collector_enable.cps.cp_vector_val_hdl );
            printf( " vector_cfg_hdl      = 0x%04X\n",  event->param.collector_enable.cps.cp_vector_cfg_hdl );
            printf( " vector_prop         = 0x%02X\n\n",    event->param.collector_enable.cps.cp_vector_prop );
            printf( " cp_cp_char_hdl      = 0x%04X\n",  event->param.collector_enable.cps.cp_cp_char_hdl );
            printf( " cp_cp_val_hdl       = 0x%04X\n",  event->param.collector_enable.cps.cp_cp_val_hdl );
            printf( " cp_cp_cfg_hdl       = 0x%04X\n",  event->param.collector_enable.cps.cp_cp_cfg_hdl );
            printf( " cp_cp_prop          = 0x%02X\n\n",    event->param.collector_enable.cps.cp_cp_prop );
            
            DIS_handle_Info_Disp(&event->param.collector_enable.dis);
            
            BAS_handle_Info_Disp(&event->param.collector_enable.bas);
            
#ifdef USE_PTS_SAMPLE
            g_cps[cpp_hdl_idx]      = event->param.collector_enable.cps;
            g_cpp_dis[cpp_hdl_idx]  = event->param.collector_enable.dis;
            g_cpp_bas[cpp_hdl_idx]  = event->param.collector_enable.bas;
#endif
            break;
        case RBLE_CPP_EVENT_COLLECTOR_DISABLE_COMP:
            CPP_Event_Status_Disp("COLLECTOR_DISABLE_COMP", event->param.collector_disable.status);
            Connection_Handle_Disp( event->param.collector_disable.conhdl );
            break;
        case RBLE_CPP_EVENT_COLLECTOR_ERROR_IND:
            CPP_Event_Status_Disp("COLLECTOR_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_CPP_EVENT_COLLECTOR_MEASUREMENTS_NTF:
            CPP_Event_Disp("COLLECTOR_MEASUREMENTS_NTF");
            Connection_Handle_Disp( event->param.measurements_ntf.conhdl );
            CPP_Meas_Info_Disp( &event->param.measurements_ntf.measurements_info );
            break;
        case RBLE_CPP_EVENT_COLLECTOR_VECTOR_NTF:
            CPP_Event_Disp("COLLECTOR_VECTOR_NTF");
            Connection_Handle_Disp( event->param.vector_ntf.conhdl );
            CPP_Vector_Info_Disp( &event->param.vector_ntf.vector_info );
            break;
        case RBLE_CPP_EVENT_COLLECTOR_CP_CP_IND:
            CPP_Event_Disp("COLLECTOR_CP_CP_IND");
            Connection_Handle_Disp( event->param.cp_cp_ind.conhdl );
            CPP_Ind_Cp_Info_Disp( event );
            break;
        case RBLE_CPP_EVENT_COLLECTOR_BATTERY_LEVEL_NTF:
            CPP_Event_Disp("COLLECTOR_BATTERY_LEVEL_NTF");
            Connection_Handle_Disp( event->param.battery_level_ntf.conhdl );
            printf( "Battery Level = %d\n", event->param.battery_level_ntf.battery_level );
            break;
        case RBLE_CPP_EVENT_COLLECTOR_READ_CHAR_RESPONSE:
            CPP_Event_Status_Disp("COLLECTOR_READ_CHAR_RESPONSE", event->param.rd_char_resp.att_code);
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            ATT_Info_Disp( &event->param.rd_char_resp.data );
            event->param.rd_char_resp.data.data[event->param.rd_char_resp.data.len] = '\0';
            printf("(%s)\n", event->param.rd_char_resp.data.data);
            break;
        case RBLE_CPP_EVENT_COLLECTOR_WRITE_CHAR_RESPONSE:
            CPP_Event_Status_Disp("COLLECTOR_WRITE_CHAR_RESPONSE", event->param.wr_char_resp.att_code);
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_CPP_EVENT_COLLECTOR_COMMAND_DISALLOWED_IND:
            CPP_Event_Status_Disp("COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_CPPS_SAMPLE
/* ------------------------- Cycling Power Specific-------------------------------*/
/******************************************************************************************/
/**
 *  @brief Cycling Power(Collector) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_CPPS_CallBack( RBLE_CPPS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_CPP_EVENT_SENSOR_ENABLE_COMP:
            CPP_Event_Status_Disp("SENSOR_ENABLE_COMP", event->param.sensor_enable.status);
            Connection_Handle_Disp( event->param.sensor_enable.conhdl );
            break;
        case RBLE_CPP_EVENT_SENSOR_DISABLE_COMP:
            CPP_Event_Disp("SENSOR_DISABLE_COMP");
            Connection_Handle_Disp( event->param.sensor_disable.conhdl );
            break;
        case RBLE_CPP_EVENT_SENSOR_ERROR_IND:
            CPP_Event_Status_Disp("SENSOR_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_CPP_EVENT_SENSOR_SEND_MEASUREMENTS_COMP:
            CPP_Event_Status_Disp("SENSOR_SEND_MEASUREMENTS_COMP", event->param.send_measurements.status);
            Connection_Handle_Disp( event->param.send_measurements.conhdl );
            break;
        case RBLE_CPP_EVENT_SENSOR_BROADCAST_MEASUREMENTS_COMP:
            CPP_Event_Status_Disp("SENSOR_BROADCAST_MEASUREMENTS_COMP", event->param.broadcast_measurements.status);
            Connection_Handle_Disp( event->param.broadcast_measurements.conhdl );
            break;
        case RBLE_CPP_EVENT_SENSOR_SEND_VECTOR_COMP:
            CPP_Event_Status_Disp("SENSOR_SEND_VECTOR_COMP", event->param.send_vector.status);
            Connection_Handle_Disp( event->param.send_vector.conhdl );
            break;
        case RBLE_CPP_EVENT_SENSOR_SEND_CP_CP_COMP:
            CPP_Event_Status_Disp("SENSOR_SEND_CP_CP_COMP", event->param.send_cp_cp.status);
            Connection_Handle_Disp( event->param.send_cp_cp.conhdl );
            break;
        case RBLE_CPP_EVENT_SENSOR_SEND_BATTERY_LEVEL_COMP:
            CPP_Event_Status_Disp("SENSOR_SEND_BATTERY_LEVEL_COMP", event->param.send_battery_level.status);
            Connection_Handle_Disp( event->param.send_battery_level.conhdl );
            break;
        case RBLE_CPP_EVENT_SENSOR_CHG_CP_CP_IND:
            Connection_Handle_Disp( event->param.chg_cp_cp_ind.conhdl );
            CPP_Chg_Cp_Info_Disp( &event->param.chg_cp_cp_ind.wr_cp_info );
            break;
        case RBLE_CPP_EVENT_SENSOR_CFG_INDNTFBRD_IND:
            CPP_Event_Disp("SENSOR_CFG_INDNTFBRD_IND");
            printf( "  Char Code = %d\n", event->param.cfg_indntfbrd_ind.char_code );
            printf( "  Cfg Value = %s\n", ( event->param.cfg_indntfbrd_ind.cfg_val == RBLE_PRF_STOP_NTFIND ) ? "STOP" : "START" );
            if((event->param.cfg_indntfbrd_ind.char_code == RBLE_CPPC_CYCPWR_VCTR_CODE) && (Pts_Flg.CPS_Manual_Res == FALSE)) {
                RBLE_Parameter_Cnt = 0;
                RBLE_CPP_Sensor_Send_Write_Response_Test();
            }
            else {
                Pts_Flg.CPS_Manual_Res = FALSE;
            }
            break;
        case RBLE_CPP_EVENT_SENSOR_COMMAND_DISALLOWED_IND:
            CPP_Event_Status_Disp("COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
    }
    Prompt_Disp();
}

/******************************************************************************************/
/**
 *  @brief A CPP_Sensor_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Sensor_Enable_Test( void )
{
    /* security level */
    const uint8_t sec_lvl = RBLE_SVC_SEC_NONE;
    /* ConType */
    static uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
//  static uint8_t con_type = RBLE_PRF_CON_NORMAL;

    static RBLE_CPP_SENSOR_PARAM    param = {
        RBLE_PRF_START_NTF,         /* Cycling Power measurement notification configuration */
        RBLE_PRF_START_BRD,         /* Cycling Power measurement broadcast configuration */
        RBLE_PRF_START_NTF,         /* Cycling Power vector notification configuration */
        RBLE_PRF_START_IND,         /* Cycling Power control point indication configuration */
        RBLE_PRF_START_NTF,         /* Battery Level notification configuration */
        RBLE_CPPC_SENSOR_REAR_WHEEL /* Sensor Location Info */
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_CPP_Sensor_Enable( Connection_Handle, sec_lvl, con_type, &param, RBLE_APP_CPPS_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CPP_Sensor_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Sensor_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_CPP_Sensor_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CPP_Sensor_Send_Measurements command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Sensor_Send_Measurements_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t param;
    RBLE_CPP_MEASUREMENTS_INFO meas_info[] = {
        {
            0x0000,         /* flags */
            100,            /* instant_power */
            170,            /* pedal_balance */
            0x00,           /* reserved */
            0x1000,         /* accumulated_torque */
            0x22223333,     /* wheel_revolutions */
            0x0111,         /* wheel_event */
            0x0222,         /* crank_revolutions */
            0x0333,         /* crank_event */
            300,            /* max_force_magnitude */
            400,            /* min_force_magnitude */
            800,            /* max_torque_magnitude */
            999,            /* min_torque_magnitude */
            0x0888,         /* max_angle */
            0x0999,         /* min_angle */
            0x0aaa,         /* top_dead_spot */
            0x0bbb,         /* bottom_dead_spot */
            0x0ccc          /* accumulated_energy */
        },
        {
            0x0000,         /* flags */
            200,            /* instant_power */
            250,            /* pedal_balance */
            0x00,           /* reserved */
            0x1234,         /* accumulated_torque */
            0x12345678,     /* wheel_revolutions */
            0x1987,         /* wheel_event */
            0x2654,         /* crank_revolutions */
            0xed32,         /* crank_event */
            6300,           /* max_force_magnitude */
            7400,           /* min_force_magnitude */
            8800,           /* max_torque_magnitude */
            9999,           /* min_torque_magnitude */
            0xf888,         /* max_angle */
            0xf999,         /* min_angle */
            0xfaaa,         /* top_dead_spot */
            0xfbbb,         /* bottom_dead_spot */
            0xfccc          /* accumulated_energy */
        }
    };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            param = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if (1 < RBLE_Parameter_Cnt) {
                meas_info[param].flags = (uint16_t)RBLE_Parameter_Arg[ 1 ];
                if( 2 < RBLE_Parameter_Cnt) {
                    meas_info[param].wheel_revolutions = (uint32_t)RBLE_Parameter_Arg[ 2 ];
                    if( 3 < RBLE_Parameter_Cnt) {
                        meas_info[param].wheel_event = (uint16_t)RBLE_Parameter_Arg[ 3 ];
                    }
                }
            }
        }
        else {
            param = 0;
        }
        /* API Call */
        Ret_Status = RBLE_CPP_Sensor_Send_Measurements( Connection_Handle, &meas_info[param] );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CPP_Sensor_Broadcast_Measurements command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Sensor_Broadcast_Measurements_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_CPP_MEASUREMENTS_INFO meas_info = {
        0x0000,         /* flags */
        100,            /* instant_power */
        170,            /* pedal_balance */
        0x00,           /* reserved */
        0x1000,         /* accumulated_torque */
        0x22222222,     /* wheel_revolutions */
        0x0111,         /* wheel_event */
        0x0222,         /* crank_revolutions */
        0x0333,         /* crank_event */
        300,            /* max_force_magnitude */
        400,            /* min_force_magnitude */
        1800,           /* max_torque_magnitude */
        9999,           /* min_torque_magnitude */
        0x0888,         /* max_angle */
        0x0999,         /* min_angle */
        0x0aaa,         /* top_dead_spot */
        0x0bbb,         /* bottom_dead_spot */
        0x0ccc          /* accumulated_energy */
    };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            meas_info.flags = (uint16_t)RBLE_Parameter_Arg[ 0 ];
        }
        
        /* API Call */
        Ret_Status = RBLE_CPP_Sensor_Broadcast_Measurements( Connection_Handle, &meas_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CPP_Sensor_Send_Vector command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Sensor_Send_Vector_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t param = 0;
    RBLE_CPP_VECTOR_INFO vector_info[2] = {
        {
            0x00,           /* flags */
            0x00,           /* pad */
            0x1111,         /* crank_revolutions */
            0x2222,         /* crank_event */
            0x3333,         /* first_crank_angle */
            0x09,           /* array_num */
            0x00,           /* pad */
            /* magnitude array */
            {0x0001, 0x0012, 0x0123, 0x1234, 0x2345, 0x3456, 0x4567, 0x5678, 0x6789}
        },
        {
            0x00,           /* flags */
            0x00,           /* pad */
            0x9999,         /* crank_revolutions */
            0xaaaa,         /* crank_event */
            0xbbbb,         /* first_crank_angle */
            0x01,           /* array_num */
            0x00,           /* pad */
            /* magnitude array */
            {0x6789,0,0,0,0,0,0,0,0}
        }
    };
    
    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            param = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if( RBLE_Parameter_Cnt > 1 ) {
                vector_info[param].flags = (uint8_t)RBLE_Parameter_Arg[ 1 ];
            }
        }
        
        /* API Call */
        Ret_Status = RBLE_CPP_Sensor_Send_Vector( Connection_Handle, &vector_info[param] );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CPP_Sensor_Send_CP_Control_Point command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Sensor_Send_CP_Control_Point_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_CPP_IND_CONTROL_POINT_INFO cp_info = {0};
    
    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        cp_info.OpCode = RBLE_CPP_OP_RESPONSE_CODE;
        if ( 0 != RBLE_Parameter_Cnt ) {
            cp_info.request_op_code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if (RBLE_Parameter_Cnt > 1) {
                cp_info.response_value = (uint8_t)RBLE_Parameter_Arg[ 1 ];
                if (RBLE_Parameter_Cnt > 2) {
                    switch(cp_info.request_op_code) {
                        case RBLE_CPP_OP_REQ_CRANK_LEN_CODE:
                            cp_info.crank_length = (uint16_t)RBLE_Parameter_Arg[2];
                            break;
                        case RBLE_CPP_OP_REQ_CHAIN_LEN_CODE:
                            cp_info.chain_length = (uint16_t)RBLE_Parameter_Arg[2];
                            break;
                        case RBLE_CPP_OP_REQ_CHAIN_WEI_CODE:
                            cp_info.chain_weight = (uint16_t)RBLE_Parameter_Arg[2];
                            break;
                        case RBLE_CPP_OP_REQ_SPAN_LEN_CODE:
                            cp_info.span_length = (uint16_t)RBLE_Parameter_Arg[2];
                            break;
                        case RBLE_CPP_OP_START_OFFSET_COMPENSATION_CODE:
                            cp_info.offset_compensation = (int16_t)RBLE_Parameter_Arg[2];
                            break;
                        case RBLE_CPP_OP_REQ_SAMPL_RATE_CODE:
                            cp_info.sampling_rate = (uint8_t)RBLE_Parameter_Arg[2];
                            break;
                        default:
                            break;
                    }
                }
            } else {
                cp_info.response_value = 1;
            }
        }
        else {
            cp_info.request_op_code     = 1;
            cp_info.response_value      = 1;
            cp_info.crank_length    = 1;
        }
        printf("Req OpCode = %d\n",cp_info.request_op_code);
        if(cp_info.request_op_code == RBLE_CPP_OP_REQ_FACTORY_CALIB_DATE_CODE) {
            cp_info.stamp.year  = 2013;
            cp_info.stamp.month = 3;
            cp_info.stamp.day   = 31;
            cp_info.stamp.hour  = 18;
            cp_info.stamp.min   = 12;
            cp_info.stamp.sec   = 14;
        }
        /* API Call */
        Ret_Status = RBLE_CPP_Sensor_Send_CP_Control_Point( Connection_Handle, &cp_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CPP_Sensor_Send_Battery_Level command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Sensor_Send_Battery_Level_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t battery_level = 0;
    
    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            battery_level = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        printf("battery_level = %d\n",battery_level);
        /* API Call */
        Ret_Status = RBLE_CPP_Sensor_Send_Battery_Level( Connection_Handle, battery_level );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CPP_Sensor_Send_Write_Response command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Sensor_Send_Write_Response_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t res_code = RBLE_ATT_ERR_NO_ERROR;
    
    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            res_code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_CPP_Sensor_Send_Write_Response( Connection_Handle, res_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

#endif
#ifdef USE_CPPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A CPP_Collector_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Collector_Enable_Test( void )
{
    /* ConType */
    static uint8_t con_type = RBLE_PRF_CON_DISCOVERY;

#ifdef USE_PTS_SAMPLE
    RBLE_CPS_CONTENT    *cps = &g_cps[0];
    RBLE_DIS_CONTENT    *dis = &g_cpp_dis[0];
    RBLE_BATS_CONTENT   *bas = &g_cpp_bas[0];
#else
    RBLE_CPS_CONTENT    cps = {0x0};
    RBLE_DIS_CONTENT    dis = {0x0};
    RBLE_BATS_CONTENT   bas = {0x0};
#endif

    RBLE_STATUS Ret_Status;
    
    cpp_con_hdl = Connection_Handle;
    if ( 0 != RBLE_Parameter_Cnt ) {
        con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
#ifdef USE_PTS_SAMPLE
        if ( 1 < RBLE_Parameter_Cnt ) {
            cpp_hdl_idx = (uint8_t)RBLE_Parameter_Arg[ 1 ];
            if(cpp_hdl_idx == 0) {
                cps = &g_cps[cpp_hdl_idx];
                dis = &g_cpp_dis[cpp_hdl_idx];
                bas = &g_cpp_bas[cpp_hdl_idx];
            }
            else {
                cpp_hdl_idx = 1;
                cpp_con_hdl = Connection_Handle_2nd;
                cps = &g_cps[cpp_hdl_idx];
                dis = &g_cpp_dis[cpp_hdl_idx];
                bas = &g_cpp_bas[cpp_hdl_idx];
            }
        }
#endif
    }

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == cpp_con_hdl ) {
        Illegal_Connection_Print();
    } else {
        
        /* API Call */
#ifdef USE_PTS_SAMPLE
        Ret_Status = RBLE_CPP_Collector_Enable( cpp_con_hdl, con_type, cps, dis, bas, RBLE_APP_CPPC_CallBack );
#else
        Ret_Status = RBLE_CPP_Collector_Enable( cpp_con_hdl, con_type, &cps, &dis, &bas, RBLE_APP_CPPC_CallBack );
#endif

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CPP_Collector_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Collector_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == cpp_con_hdl ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_CPP_Collector_Disable( cpp_con_hdl );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CPP_Collector_Read_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Collector_Read_Char_Test( void )
{
    /* CharCode */
    uint8_t         char_code;
    RBLE_STATUS     Ret_Status;
    int32_t         Parameter_No;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }
    if ( ( ILLEGAL_NO == Parameter_No ) || ( RBLE_CPPC_RD_BAS_BL_CFG < Parameter_No ) ) {
        char_code = RBLE_CPPC_RD_CPS_CM_CFG;
        Select_Param_No_Disp(0);
    } else {
        char_code = (uint8_t)Parameter_No;
        Select_Param_No_Disp(Parameter_No);
    }

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == cpp_con_hdl ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_CPP_Collector_Read_Char( cpp_con_hdl, char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CPP_Collector_Write_CP_Control_Point command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Collector_Write_CP_Control_Point_Test( void )
{
    RBLE_STATUS     Ret_Status;
    RBLE_CPP_WR_CONTROL_POINT_INFO cp_info = {0};
    int32_t  tmp_value = 0;
    
    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == cpp_con_hdl ) {
        Illegal_Connection_Print();
    } else {
        cp_info.OpCode = RBLE_CPP_OP_RESPONSE_CODE;
        if ( 0 != RBLE_Parameter_Cnt ) {
            cp_info.OpCode = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if (RBLE_Parameter_Cnt > 1) {
                tmp_value = RBLE_Parameter_Arg[1];
            }
        }
        else {
            cp_info.OpCode  = 1;
            tmp_value       = 1;
        }
        switch(cp_info.OpCode)
        {
            case RBLE_CPP_OP_SET_CUMULATIVE_CODE:
                cp_info.cumulative_value    = (uint32_t)tmp_value;
                break;
            case RBLE_CPP_OP_UPDATE_SL_CODE:
                cp_info.sensor_location     = (uint8_t)tmp_value;
                break;
            case RBLE_CPP_OP_SET_CRANK_LEN_CODE:
                cp_info.crank_length        = (uint16_t)tmp_value;
                break;
            case RBLE_CPP_OP_SET_CHAIN_LEN_CODE:
                cp_info.chain_length        = (uint16_t)tmp_value;
                break;
            case RBLE_CPP_OP_SET_CHAIN_WEI_CODE:
                cp_info.chain_weight        = (uint16_t)tmp_value;
                break;
            case RBLE_CPP_OP_SET_SPAN_LEN_CODE:
                cp_info.span_length         = (uint16_t)tmp_value;
                break;
            case RBLE_CPP_OP_MASK_CP_MEAS_CONTENT_CODE:
                cp_info.mask_meas_content   = (uint16_t)tmp_value;
                break;
            default:
                break;
        }
        printf( "OpCode :%d, value:%d(%x)\n",cp_info.OpCode, tmp_value, tmp_value);
        /* API Call */
        Ret_Status = RBLE_CPP_Collector_Write_CP_Control_Point( cpp_con_hdl, &cp_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A CPP_Collector_Write_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_CPP_Collector_Write_Char_Test( void )
{
    RBLE_STATUS                 Ret_Status;
    int32_t                     Parameter_No;
    uint16_t                    cfg_val = 0;
    uint8_t                     char_code;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == cpp_con_hdl ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
            if(RBLE_Parameter_Cnt > 1)
            {
                cfg_val = (uint16_t)RBLE_Parameter_Arg[ 1 ];
            }
        } else {
            Parameter_No = ILLEGAL_NO;
        }
        if ( ( ILLEGAL_NO == Parameter_No )
            || ( ( sizeof( CPP_Wr_Char_Code ) / sizeof( uint8_t ) ) <= Parameter_No ) ) {
            char_code = CPP_Wr_Char_Code[ 0 ];
        } else {
            char_code = CPP_Wr_Char_Code[ Parameter_No ];
        }
        printf( "Select char:%d, cfg:%d\n",char_code, cfg_val);
            
        /* API Call */
        Ret_Status = RBLE_CPP_Collector_Write_Char( cpp_con_hdl, char_code, cfg_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

/* ------------------------- Time Profile-------------------------------*/
#if defined(USE_TIPS_SAMPLE)|defined(USE_TIPC_SAMPLE)
static uint8_t Tip_Read_Char_Code;

/******************************************************************************************/
/**
 *  @brief rBLE TIP Event and Status Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void TIP_Event_Status_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE TIP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}

/******************************************************************************************/
/**
 *  @brief rBLE TIP Event Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *
 *  @retval
 */
/******************************************************************************************/
static void TIP_Event_Disp(char_t *event_str)
{
    printf( "\nrBLE TIP EVENT (%s)\n", event_str);
}
#endif

#ifdef USE_TIPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE TIPS(Server) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_TIPS_CallBack( RBLE_TIPS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_TIP_EVENT_SERVER_ENABLE_COMP:
            TIP_Event_Status_Disp("SERVER_ENABLE_COMP", event->param.server_enable.status);
            Connection_Handle_Disp( event->param.server_enable.conhdl );
            break;
        case RBLE_TIP_EVENT_SERVER_DISABLE_COMP:
            TIP_Event_Disp("SERVER_DISABLE_COMP");
            Connection_Handle_Disp( event->param.server_disable.conhdl );
            break;
        case RBLE_TIP_EVENT_SERVER_ERROR_IND:
            TIP_Event_Status_Disp("SERVER_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_TIP_EVENT_SERVER_SEND_CURRENT_TIME_COMP:
            TIP_Event_Status_Disp("SERVER_SEND_CURRENT_TIME_COMP", event->param.send_current_time.status);
            Connection_Handle_Disp( event->param.send_current_time.conhdl );
            break;
        case RBLE_TIP_EVENT_SERVER_WRITE_DATA_COMP:
            TIP_Event_Status_Disp("SERVER_WRITE_DATA_COMP", event->param.write_data.status);
            break;
        case RBLE_TIP_EVENT_SERVER_CHG_TIME_UPDATE_CP_IND:
            TIP_Event_Disp("SERVER_CHG_TIME_UPDATE_CP_IND");
            Connection_Handle_Disp( event->param.chg_cp_ind.conhdl );
            printf("update cp:%d\n", event->param.chg_cp_ind.update_cp);
            break;
        case RBLE_TIP_EVENT_SERVER_CFG_NTF_IND:
            TIP_Event_Disp("SERVER_CFG_NTF_IND");
            Connection_Handle_Disp( event->param.cfg_ntf_ind.conhdl );
            printf("cfg:%d\n", event->param.cfg_ntf_ind.cfg_val);
            break;
        case RBLE_TIP_EVENT_SERVER_COMMAND_DISALLOWED_IND:
            TIP_Event_Status_Disp("SERVER_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_TIPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE TIPC(Client) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_TIPC_CallBack( RBLE_TIPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    
    switch( event->type){
        case RBLE_TIP_EVENT_CLIENT_ENABLE_COMP:
            TIP_Event_Status_Disp("CLIENT_ENABLE_COMP", event->param.client_enable.status);
            Connection_Handle_Disp( event->param.client_enable.conhdl );
            printf("\n*Current Time Service\n");
            printf(" Start Handle = 0x%04X\n",  event->param.client_enable.cts.shdl );
            printf(" End Handle   = 0x%04X\n",  event->param.client_enable.cts.ehdl );
            printf(" current_time_char_hdl = 0x%04x\n", event->param.client_enable.cts.current_time_char_hdl);
            printf(" current_time_val_hdl  = 0x%04x\n", event->param.client_enable.cts.current_time_val_hdl);
            printf(" current_time_cfg_hdl  = 0x%04x\n", event->param.client_enable.cts.current_time_cfg_hdl);
            printf(" current_time_prop     = 0x%02x\n", event->param.client_enable.cts.current_time_prop);
            printf(" local_time_char_hdl   = 0x%04x\n", event->param.client_enable.cts.local_time_info_char_hdl);
            printf(" local_time_val_hdl    = 0x%04x\n", event->param.client_enable.cts.local_time_info_val_hdl);
            printf(" local_time_prop       = 0x%02x\n", event->param.client_enable.cts.local_time_info_prop);
            printf(" ref_time_char_hdl     = 0x%04x\n", event->param.client_enable.cts.ref_time_info_char_hdl);
            printf(" ref_time_val_hdl      = 0x%04x\n", event->param.client_enable.cts.ref_time_info_val_hdl);
            printf(" ref_time_prop         = 0x%02x\n", event->param.client_enable.cts.ref_time_info_prop);
            printf("\n*Next DST Change Service\n");
            printf(" Start Handle = 0x%04X\n",  event->param.client_enable.ndcs.shdl );
            printf(" End Handle   = 0x%04X\n",  event->param.client_enable.ndcs.ehdl );
            printf(" time_dst_char_hdl     = 0x%04x\n", event->param.client_enable.ndcs.time_dst_char_hdl);
            printf(" time_dst_val_hdl      = 0x%04x\n", event->param.client_enable.ndcs.time_dst_val_hdl);
            printf(" time_dst_prop         = 0x%02x\n", event->param.client_enable.ndcs.time_dst_prop);
            printf("\n*Reference Time Update Service\n");
            printf(" Start Handle = 0x%04X\n",  event->param.client_enable.rtus.shdl );
            printf(" End Handle   = 0x%04X\n",  event->param.client_enable.rtus.ehdl );
            printf(" update_cp_char_hdl    = 0x%04x\n", event->param.client_enable.rtus.update_cp_char_hdl);
            printf(" update_cp_val_hdl     = 0x%04x\n", event->param.client_enable.rtus.update_cp_val_hdl);
            printf(" update_cp_prop        = 0x%02x\n", event->param.client_enable.rtus.update_cp_prop);
            printf(" update_state_char_hdl = 0x%04x\n", event->param.client_enable.rtus.update_state_char_hdl);
            printf(" update_state_val_hdl  = 0x%04x\n", event->param.client_enable.rtus.update_state_val_hdl);
            printf(" update_state_prop     = 0x%02x\n", event->param.client_enable.rtus.update_state_prop);
            break;
        case RBLE_TIP_EVENT_CLIENT_DISABLE_COMP:
            TIP_Event_Status_Disp("CLIENT_DISABLE_COMP", event->param.client_disable.status);
            Connection_Handle_Disp( event->param.client_disable.conhdl );
            break;
        case RBLE_TIP_EVENT_CLIENT_ERROR_IND:
            TIP_Event_Status_Disp("CLIENT_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_TIP_EVENT_CLIENT_CURRENT_TIME_NTF:
            TIP_Event_Disp("CLIENT_CURRENT_TIME_NTF");
            Connection_Handle_Disp( event->param.current_time_ntf.conhdl );
            TIP_Time_Disp(&event->param.current_time_ntf.current_time.stamp);
            printf("day of week   = %d\n", event->param.current_time_ntf.current_time.day_of_week);
            printf("fractions256  = %d\n", event->param.current_time_ntf.current_time.fractions256);
            printf("adjust reason = %x\n", event->param.current_time_ntf.current_time.adjust_reason);
            break;
        case RBLE_TIP_EVENT_CLIENT_READ_CHAR_RESPONSE:
            TIP_Event_Status_Disp("CLIENT_READ_CHAR_RESPONSE", event->param.rd_char_resp.att_code);
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            TIP_Info_Disp(Tip_Read_Char_Code, &event->param.rd_char_resp.data);
            break;
        case RBLE_TIP_EVENT_CLIENT_WRITE_CHAR_RESPONSE:
            TIP_Event_Status_Disp("CLIENT_WRITE_CHAR_RESPONSE", event->param.wr_char_resp.att_code);
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_TIP_EVENT_CLIENT_COMMAND_DISALLOWED_IND:
            TIP_Event_Status_Disp("CLIENT_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_TIPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief A TIP_Server_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_TIP_Server_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;
    /* security level */
    uint8_t sec_lvl = RBLE_SVC_SEC_NONE;
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
    uint16_t current_time_ntf_en = 1;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_TIP_Server_Enable( Connection_Handle, sec_lvl, con_type, current_time_ntf_en, RBLE_APP_TIPS_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A TIP_Server_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_TIP_Server_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_TIP_Server_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A TIP_Server_Send_Current_Time command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_TIP_Server_Send_Current_Time_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_TIP_CURRENT_TIME current_time = 
    {{2013,5,29,13,40, 20},0,0,0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            current_time.adjust_reason = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_TIP_Server_Send_Current_Time( Connection_Handle, &current_time );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A TIP_Server_Write_Data command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_TIP_Server_Write_Data_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t char_code = 0;
    RBLE_TIPS_WR_DATA wr_data = {0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            char_code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        switch(char_code)
        {
            case RBLE_TIPS_WR_CTS_CRNT_TIME:
                wr_data.param.current_time.stamp.year   = 2013;
                wr_data.param.current_time.stamp.month  = 5;
                wr_data.param.current_time.stamp.day    = 29;
                wr_data.param.current_time.stamp.hour   = 11;
                wr_data.param.current_time.stamp.min    = 20;
                wr_data.param.current_time.stamp.sec    = 15;
                wr_data.param.current_time.day_of_week = RBLE_TIP_TIME_WEDNESDAY;
                wr_data.param.current_time.fractions256 = 0xff;
                wr_data.param.current_time.adjust_reason = 4;
                break;
            case RBLE_TIPS_WR_CTS_LOCAL_TIME:
                wr_data.param.local_time.time_zone  = 32;
                wr_data.param.next_dst.dst_offset = RBLE_TIP_DST_DAYLIGHT;
                break;
            case RBLE_TIPS_WR_CTS_REF_TIME:
                wr_data.param.ref_time.time_source  = RBLE_TIP_TIME_SOURCE_GPS;
                wr_data.param.ref_time.accuracy     = 10;
                wr_data.param.ref_time.days_since_update    = 10;
                wr_data.param.ref_time.hours_since_update   = 5;
                break;
            case RBLE_TIPS_WR_NDCS_TIME_DST:
#if 1
            wr_data.param.next_dst.stamp.year   = 2013;
                wr_data.param.next_dst.stamp.month  = 10;
                wr_data.param.next_dst.stamp.day    = 27;
                wr_data.param.next_dst.stamp.hour   = 1;
                wr_data.param.next_dst.stamp.min    = 0;
                wr_data.param.next_dst.stamp.sec    = 0;
                wr_data.param.next_dst.dst_offset = RBLE_TIP_DST_STANDARD;
#else
            wr_data.param.next_dst.stamp.year   = 0;
                wr_data.param.next_dst.stamp.month  = 0;
                wr_data.param.next_dst.stamp.day    = 0;
                wr_data.param.next_dst.stamp.hour   = 0;
                wr_data.param.next_dst.stamp.min    = 0;
                wr_data.param.next_dst.stamp.sec    = 0;
                wr_data.param.next_dst.dst_offset = 0xff;
#endif
                break;
            case RBLE_TIPS_WR_RTUS_UPDATE_STATUS:
                wr_data.param.update_state.current_state    = RBLE_TIP_TIME_UPDATE_PENDING;
                wr_data.param.update_state.update_result    = RBLE_TIP_TIME_UPDATE_NOT_ATTEMPTED;
                break;
            default:
                break;
        }
        
        Ret_Status = RBLE_TIP_Server_Write_Data( char_code, &wr_data );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif
#ifdef USE_TIPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A TIP_Client_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_TIP_Client_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
    RBLE_CTS_CONTENT cts = {0};
    RBLE_NDCS_CONTENT ndcs = {0};
    RBLE_RTUS_CONTENT rtus = {0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_TIP_Client_Enable( Connection_Handle, con_type, &cts, &ndcs, &rtus, RBLE_APP_TIPC_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A TIP_Client_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_TIP_Client_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_TIP_Client_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A TIP_Client_Read_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_TIP_Client_Read_Char_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Tip_Read_Char_Code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        else {
            Tip_Read_Char_Code = 0;
        }
        /* API Call */
        Ret_Status = RBLE_TIP_Client_Read_Char( Connection_Handle, Tip_Read_Char_Code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A TIP_Client_Write_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_TIP_Client_Write_Char_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint16_t cfg_val = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            cfg_val = (uint16_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_TIP_Client_Write_Char( Connection_Handle, cfg_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A TIP_Client_Write_Time_Update_CP command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_TIP_Client_Write_Time_Update_CP_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t time_update_cp = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            time_update_cp = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_TIP_Client_Write_Time_Update_CP( Connection_Handle, time_update_cp );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

/* ------------------------- ANP Profile-------------------------------*/
#if defined(USE_ANPS_SAMPLE)|defined(USE_ANPC_SAMPLE)
/******************************************************************************************/
/**
 *  @brief rBLE ANP Event Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void ANP_Event_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE ANP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}
#endif

#ifdef USE_ANPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE ANPS(Server) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_ANPS_CallBack( RBLE_ANPS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_ANP_EVENT_SERVER_ENABLE_COMP:
            ANP_Event_Disp("SERVER_ENABLE_COMP", event->param.server_enable.status);
            Connection_Handle_Disp( event->param.server_enable.conhdl );
            break;
        case RBLE_ANP_EVENT_SERVER_DISABLE_COMP:
            printf("\nrBLE ANP EVENT (SERVER_DISABLE_COMP)\n" );
            Connection_Handle_Disp( event->param.server_disable.conhdl );
            break;
        case RBLE_ANP_EVENT_SERVER_ERROR_IND:
            ANP_Event_Disp("SERVER_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_ANP_EVENT_SERVER_SEND_NEW_ALERT_COMP:
            ANP_Event_Disp("SERVER_SEND_NEW_ALERT_COMP", event->param.send_new_alert.status);
            Connection_Handle_Disp( event->param.send_new_alert.conhdl );
            break;
        case RBLE_ANP_EVENT_SERVER_SEND_UNREAD_ALERT_COMP:
            ANP_Event_Disp("SERVER_SEND_UNREAD_ALERT_COMP", event->param.send_unread_alert.status);
            Connection_Handle_Disp( event->param.send_unread_alert.conhdl );
            break;
        case RBLE_ANP_EVENT_SERVER_CHG_ALERT_NTF_CP_IND:
            printf("\nrBLE ANP EVENT (SERVER_CHG_ALERT_NTF_CP_IND)\n" );
            Connection_Handle_Disp( event->param.chg_cp_ind.conhdl );
            printf("Command ID:%d  Category ID:%d\n", event->param.chg_cp_ind.cp_info.command_id, event->param.chg_cp_ind.cp_info.category_id);
            break;
        case RBLE_ANP_EVENT_SERVER_CFG_NTF_IND:
            printf("\nrBLE ANP EVENT (SERVER_CFG_NTF_IND)\n" );
            Connection_Handle_Disp( event->param.cfg_ntf_ind.conhdl );
            printf("char:%d  cfg:%d\n", event->param.cfg_ntf_ind.char_code, event->param.cfg_ntf_ind.cfg_val);
            break;
        case RBLE_ANP_EVENT_SERVER_COMMAND_DISALLOWED_IND:
            ANP_Event_Disp("SERVER_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_ANPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE ANPC(Client) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_ANPC_CallBack( RBLE_ANPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_ANP_EVENT_CLIENT_ENABLE_COMP:
            ANP_Event_Disp("CLIENT_ENABLE_COMP", event->param.client_enable.status);
            Connection_Handle_Disp( event->param.client_enable.conhdl );
            printf("\nAlert Notification Service\n" );
            printf(" Start Handle = 0x%04x\n", event->param.client_enable.ans.shdl);
            printf(" End Handle   = 0x%04x\n", event->param.client_enable.ans.ehdl);
            printf(" supp_new_alert_char_hdl    = 0x%04x\n", event->param.client_enable.ans.supp_new_alert_char_hdl);
            printf(" supp_new_alert_val_hdl     = 0x%04x\n", event->param.client_enable.ans.supp_new_alert_val_hdl);
            printf(" supp_new_alert_prop        = 0x%04x\n", event->param.client_enable.ans.supp_new_alert_prop);
            printf(" new_alert_char_hdl         = 0x%04x\n", event->param.client_enable.ans.new_alert_char_hdl);
            printf(" new_alert_val_hdl          = 0x%04x\n", event->param.client_enable.ans.new_alert_val_hdl);
            printf(" new_alert_cfg_hdl          = 0x%04x\n", event->param.client_enable.ans.new_alert_cfg_hdl);
            printf(" new_alert_prop             = 0x%04x\n", event->param.client_enable.ans.new_alert_prop);
            printf(" supp_unread_alert_char_hdl = 0x%04x\n", event->param.client_enable.ans.supp_unread_alert_char_hdl);
            printf(" supp_unread_alert_val_hdl  = 0x%04x\n", event->param.client_enable.ans.supp_unread_alert_val_hdl);
            printf(" supp_unread_alert_prop     = 0x%04x\n", event->param.client_enable.ans.supp_unread_alert_prop);
            printf(" unread_alert_char_hdl      = 0x%04x\n", event->param.client_enable.ans.unread_alert_char_hdl);
            printf(" unread_alert_val_hdl       = 0x%04x\n", event->param.client_enable.ans.unread_alert_val_hdl);
            printf(" unread_alert_cfg_hdl       = 0x%04x\n", event->param.client_enable.ans.unread_alert_cfg_hdl);
            printf(" unread_alert_prop          = 0x%04x\n", event->param.client_enable.ans.unread_alert_prop);
            printf(" alert_ntf_cp_char_hdl      = 0x%04x\n", event->param.client_enable.ans.alert_ntf_cp_char_hdl);
            printf(" alert_ntf_cp_val_hdl       = 0x%04x\n", event->param.client_enable.ans.alert_ntf_cp_val_hdl);
            printf(" alert_ntf_cp_prop          = 0x%04x\n", event->param.client_enable.ans.alert_ntf_cp_prop);
            break;
        case RBLE_ANP_EVENT_CLIENT_DISABLE_COMP:
            ANP_Event_Disp("CLIENT_DISABLE_COMP", event->param.client_disable.status);
            Connection_Handle_Disp( event->param.client_disable.conhdl );
            break;
        case RBLE_ANP_EVENT_CLIENT_ERROR_IND:
            ANP_Event_Disp("CLIENT_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_ANP_EVENT_CLIENT_NEW_ALERT_NTF:
            printf("\nrBLE ANP EVENT (CLIENT_NEW_ALERT_NTF)\n" );
            Connection_Handle_Disp( event->param.new_alert_ntf.conhdl );
            ANP_Alert_Disp( &event->param.new_alert_ntf.new_alert );
            break;
        case RBLE_ANP_EVENT_CLIENT_UNREAD_ALERT_NTF:
            printf("\nrBLE ANP EVENT (CLIENT_UNREAD_ALERT_NTF)\n" );
            Connection_Handle_Disp( event->param.unread_alert_ntf.conhdl );
            printf("Category ID:%d  Unread Count:%d\n", event->param.unread_alert_ntf.unread_alert.category_id, event->param.unread_alert_ntf.unread_alert.unread_count);
            break;
        case RBLE_ANP_EVENT_CLIENT_READ_CHAR_RESPONSE:
            ANP_Event_Disp("CLIENT_READ_CHAR_RESPONSE", event->param.rd_char_resp.att_code);
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            ATT_Info_Disp( &event->param.rd_char_resp.data );
            event->param.rd_char_resp.data.data[event->param.rd_char_resp.data.len] = '\0';
            printf("(%s)\n", event->param.rd_char_resp.data.data);
            break;
        case RBLE_ANP_EVENT_CLIENT_WRITE_CHAR_RESPONSE:
            ANP_Event_Disp("CLIENT_WRITE_CHAR_RESPONSE", event->param.wr_char_resp.att_code);
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_ANP_EVENT_CLIENT_COMMAND_DISALLOWED_IND:
            ANP_Event_Disp("CLIENT_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_ANPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief A ANP_Server_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_ANP_Server_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;
    /* security level */
    uint8_t sec_lvl = RBLE_SVC_SEC_NONE;
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
    RBLE_ANP_SERVER_PARAM param = {0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_ANP_Server_Enable( Connection_Handle, sec_lvl, con_type, &param, RBLE_APP_ANPS_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A ANP_Server_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_ANP_Server_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_ANP_Server_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A ANP_Server_Send_New_Alert command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_ANP_Server_Send_New_Alert_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_ANP_NEW_ALERT_INFO alert_info = {
        0,
        2,
        12,
        "from Renesas"
    };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            alert_info.category_id = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if( RBLE_Parameter_Cnt > 1 ) {
                alert_info.alert_num = (uint8_t)RBLE_Parameter_Arg[ 1 ];
            }
        }
        /* API Call */
        Ret_Status = RBLE_ANP_Server_Send_New_Alert( Connection_Handle, &alert_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A ANP_Server_Send_Unread_Alert command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_ANP_Server_Send_Unread_Alert_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_ANP_UNREAD_ALERT_INFO alert_status = {0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            alert_status.category_id = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if( RBLE_Parameter_Cnt > 1 ) {
                alert_status.unread_count = (uint8_t)RBLE_Parameter_Arg[ 1 ];
            }
        }
        /* API Call */
        Ret_Status = RBLE_ANP_Server_Send_Unread_Alert( Connection_Handle, &alert_status );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif
#ifdef USE_ANPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A ANP_Client_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_ANP_Client_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
    RBLE_ANS_CONTENT ans = {0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_ANP_Client_Enable( Connection_Handle, con_type, &ans, RBLE_APP_ANPC_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A ANP_Client_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_ANP_Client_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_ANP_Client_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A ANP_Client_Read_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_ANP_Client_Read_Char_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t char_code = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            char_code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_ANP_Client_Read_Char( Connection_Handle, char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A ANP_Client_Write_Alert_Notification_CP command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_ANP_Client_Write_Alert_Notification_CP_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_ANP_ALERT_NTF_CP alert_ntf_cp = {0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            alert_ntf_cp.command_id = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if( RBLE_Parameter_Cnt > 1 ) {
                alert_ntf_cp.category_id = (uint8_t)RBLE_Parameter_Arg[ 1 ];
            }
        }
        /* API Call */
        Ret_Status = RBLE_ANP_Client_Write_Alert_Notification_CP( Connection_Handle, &alert_ntf_cp );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A ANP_Client_Write_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_ANP_Client_Write_Char_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t char_code = 0;
    uint16_t cfg_val = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            char_code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if( RBLE_Parameter_Cnt > 1 ) {
                cfg_val = (uint8_t)RBLE_Parameter_Arg[ 1 ];
            }
        }
        /* API Call */
        Ret_Status = RBLE_ANP_Client_Write_Char( Connection_Handle, char_code, cfg_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

/* ------------------------- LNP Profile-------------------------------*/
#if defined(USE_LNPS_SAMPLE)|defined(USE_LNPC_SAMPLE)
/******************************************************************************************/
/**
 *  @brief rBLE LNP Event and Status Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void LNP_Event_Status_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE LNP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}
/******************************************************************************************/
/**
 *  @brief rBLE LNP Event Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void LNP_Event_Disp(char_t *event_str)
{
    printf( "\nrBLE LNP EVENT (%s)\n", event_str );
}
#endif

#ifdef USE_LNPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE LNPS(Sensor) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_LNPS_CallBack( RBLE_LNPS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_LNP_EVENT_SENSOR_ENABLE_COMP:
            LNP_Event_Status_Disp("SENSOR_ENABLE_COMP", event->param.sensor_enable.status);
            Connection_Handle_Disp( event->param.sensor_enable.conhdl );
#ifdef USE_PTS_SAMPLE
            if (TRUE == Pts_Flg.LNPS_PosQual ) {
                Pts_Flg.LNPS_PosQual = FALSE;
                RBLE_Parameter_Cnt = 1;
                RBLE_Parameter_Arg[ 0 ] = Pts_Flg.LNPS_PosQual_Flags;
                RBLE_LNP_Sensor_Set_Position_Quality_Test();
            }
#endif
            break;
        case RBLE_LNP_EVENT_SENSOR_DISABLE_COMP:
            LNP_Event_Disp("SENSOR_DISABLE_COMP");
            Connection_Handle_Disp( event->param.sensor_disable.conhdl );
            break;
        case RBLE_LNP_EVENT_SENSOR_ERROR_IND:
            LNP_Event_Status_Disp("SENSOR_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_LNP_EVENT_SENSOR_SEND_LOCATION_SPEED_COMP:
            LNP_Event_Status_Disp("SENSOR_SEND_LOCATION_SPEED_COMP", event->param.send_location_speed.status);
            Connection_Handle_Disp( event->param.send_location_speed.conhdl );
            break;
        case RBLE_LNP_EVENT_SENSOR_SET_POSITION_QUALITY_COMP:
            LNP_Event_Status_Disp("SENSOR_SET_POSITION_QUALITY_COMP", event->param.set_position_quality.status);
            break;
        case RBLE_LNP_EVENT_SENSOR_SEND_LN_CP_COMP:
            LNP_Event_Status_Disp("SENSOR_SEND_LN_CP_COMP", event->param.send_ln_cp.status);
            Connection_Handle_Disp( event->param.send_ln_cp.conhdl );
            break;
        case RBLE_LNP_EVENT_SENSOR_SEND_NAVIGATION_COMP:
            LNP_Event_Status_Disp("SENSOR_SEND_NAVIGATION_COMP", event->param.send_navigation.status);
            Connection_Handle_Disp( event->param.send_navigation.conhdl );
            break;
        case RBLE_LNP_EVENT_SENSOR_SEND_BATTERY_LEVEL_COMP:
            LNP_Event_Status_Disp("SENSOR_SEND_BATTERY_LEVEL_COMP", event->param.send_battery_level.status);
            Connection_Handle_Disp( event->param.send_battery_level.conhdl );
            break;
        case RBLE_LNP_EVENT_SENSOR_CHG_LN_CP_IND:
            LNP_Event_Disp("SENSOR_CHG_LN_CP_IND");
            Connection_Handle_Disp( event->param.chg_ln_cp_ind.conhdl );
            LNP_Chg_LN_CP_Info_Disp( &event->param.chg_ln_cp_ind.wr_cp_info );
            break;
        case RBLE_LNP_EVENT_SENSOR_CFG_INDNTF_IND:
            LNP_Event_Disp("SENSOR_CFG_INDNTF_IND");
            Connection_Handle_Disp( event->param.cfg_indntf_ind.conhdl );
            printf("char:%d  cfg:%d\n", event->param.cfg_indntf_ind.char_code, event->param.cfg_indntf_ind.cfg_val);
            break;
        case RBLE_LNP_EVENT_SENSOR_COMMAND_DISALLOWED_IND:
            LNP_Event_Status_Disp("SENSOR_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_LNPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE LNPC(Collector) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_LNPC_CallBack( RBLE_LNPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_LNP_EVENT_COLLECTOR_ENABLE_COMP:
            LNP_Event_Status_Disp("COLLECTOR_ENABLE_COMP", event->param.collector_enable.status);
            Connection_Handle_Disp( event->param.collector_enable.conhdl );
            printf("\nLocation and Navigation Service\n" );
            printf("   Start Handle = 0x%04x\n", event->param.collector_enable.lns.shdl);
            printf("   End Handle   = 0x%04x\n", event->param.collector_enable.lns.ehdl);
            printf("   ln_feature_char_hdl       = 0x%04x\n", event->param.collector_enable.lns.ln_feature_char_hdl);
            printf("   ln_feature_val_hdl        = 0x%04x\n", event->param.collector_enable.lns.ln_feature_val_hdl);
            printf("   ln_feature_prop           = 0x%04x\n", event->param.collector_enable.lns.ln_feature_prop);
            printf("   location_speed_char_hdl   = 0x%04x\n", event->param.collector_enable.lns.location_speed_char_hdl);
            printf("   location_speed_val_hdl    = 0x%04x\n", event->param.collector_enable.lns.location_speed_val_hdl);
            printf("   location_speed_cfg_hdl    = 0x%04x\n", event->param.collector_enable.lns.location_speed_cfg_hdl);
            printf("   location_speed_prop       = 0x%04x\n", event->param.collector_enable.lns.location_speed_prop);
            printf("   position_quality_char_hdl = 0x%04x\n", event->param.collector_enable.lns.position_quality_char_hdl);
            printf("   position_quality_val_hdl  = 0x%04x\n", event->param.collector_enable.lns.position_quality_val_hdl);
            printf("   position_quality_prop     = 0x%04x\n", event->param.collector_enable.lns.position_quality_prop);
            printf("   ln_cp_char_hdl            = 0x%04x\n", event->param.collector_enable.lns.ln_cp_char_hdl);
            printf("   ln_cp_val_hdl             = 0x%04x\n", event->param.collector_enable.lns.ln_cp_val_hdl);
            printf("   ln_cp_cfg_hdl             = 0x%04x\n", event->param.collector_enable.lns.ln_cp_cfg_hdl);
            printf("   ln_cp_prop                = 0x%04x\n", event->param.collector_enable.lns.ln_cp_prop);
            printf("   navigation_char_hdl       = 0x%04x\n", event->param.collector_enable.lns.navigation_char_hdl);
            printf("   navigation_val_hdl        = 0x%04x\n", event->param.collector_enable.lns.navigation_val_hdl);
            printf("   navigation_cfg_hdl        = 0x%04x\n", event->param.collector_enable.lns.navigation_cfg_hdl);
            printf("   navigation_prop           = 0x%04x\n", event->param.collector_enable.lns.navigation_prop);
            DIS_handle_Info_Disp(&event->param.collector_enable.dis);
            
            BAS_handle_Info_Disp(&event->param.collector_enable.bas);
            break;
        case RBLE_LNP_EVENT_COLLECTOR_DISABLE_COMP:
            LNP_Event_Status_Disp("COLLECTOR_DISABLE_COMP", event->param.collector_disable.status);
            Connection_Handle_Disp( event->param.collector_disable.conhdl );
            break;
        case RBLE_LNP_EVENT_COLLECTOR_ERROR_IND:
            LNP_Event_Status_Disp("COLLECTOR_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_LNP_EVENT_COLLECTOR_LOCATION_SPEED_NTF:
            LNP_Event_Disp("COLLECTOR_LOCATION_SPEED_NTF");
            Connection_Handle_Disp( event->param.location_speed_ntf.conhdl );
            LNP_Location_Speed_Disp( &event->param.location_speed_ntf.location_speed_info );
            break;
        case RBLE_LNP_EVENT_COLLECTOR_LN_CP_IND:
            LNP_Event_Disp("COLLECTOR_LN_CP_IND");
            Connection_Handle_Disp( event->param.ln_cp_ind.conhdl );
            LNP_LN_Control_Point_Disp( &event->param.ln_cp_ind.ind_cp_info );
#ifdef USE_PTS_SAMPLE
            if (TRUE == Pts_Flg.LNPC_AutoRouteSet) {
                if( event->param.ln_cp_ind.ind_cp_info.request_op_code == RBLE_LNP_OP_REQ_NUM_OF_ROUTE_CODE ) {
                    RBLE_Parameter_Cnt = 2;
                    RBLE_Parameter_Arg[0] = RBLE_LNP_OP_REQ_NAME_OF_ROUTE_CODE;
                    RBLE_Parameter_Arg[1] = 1;
                    RBLE_LNP_Collector_Write_LN_Control_Point_Test();
                }
                if( event->param.ln_cp_ind.ind_cp_info.request_op_code == RBLE_LNP_OP_REQ_NAME_OF_ROUTE_CODE ) {
                    RBLE_Parameter_Cnt = 2;
                    RBLE_Parameter_Arg[0] = RBLE_LNP_OP_SELECT_ROUTE_CODE;
                    RBLE_Parameter_Arg[1] = 1;
                    RBLE_LNP_Collector_Write_LN_Control_Point_Test();
                    Pts_Flg.LNPC_AutoRouteSet = FALSE;
                }
            }
#endif
            break;
        case RBLE_LNP_EVENT_COLLECTOR_NAVIGATION_NTF:
            LNP_Event_Disp("COLLECTOR_NAVIGATION_NTF");
            Connection_Handle_Disp( event->param.navigation_ntf.conhdl );
            LNP_Navigation_Disp( &event->param.navigation_ntf.navigation_info);
            break;
        case RBLE_LNP_EVENT_COLLECTOR_BATTERY_LEVEL_NTF:
            LNP_Event_Disp("COLLECTOR_BATTERY_LEVEL_NTF");
            Connection_Handle_Disp( event->param.battery_level_ntf.conhdl );
            printf( "Battery Level = %d\n", event->param.battery_level_ntf.battery_level );
            break;
        case RBLE_LNP_EVENT_COLLECTOR_READ_CHAR_RESPONSE:
            LNP_Event_Status_Disp("CLIENT_READ_CHAR_RESPONSE", event->param.rd_char_resp.att_code);
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            ATT_Info_Disp( &event->param.rd_char_resp.data );
            event->param.rd_char_resp.data.data[event->param.rd_char_resp.data.len] = '\0';
            printf("(%s)\n", event->param.rd_char_resp.data.data);
            break;
        case RBLE_LNP_EVENT_COLLECTOR_WRITE_CHAR_RESPONSE:
            LNP_Event_Status_Disp("COLLECTOR_WRITE_CHAR_RESPONSE", event->param.wr_char_resp.att_code);
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_LNP_EVENT_COLLECTOR_COMMAND_DISALLOWED_IND:
            LNP_Event_Status_Disp("COLLECTOR_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_LNPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief A LNP_Sensor_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_LNP_Sensor_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;
    /* security level */
    uint8_t sec_lvl = RBLE_SVC_SEC_NONE;
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
    RBLE_LNP_SENSOR_PARAM param = {
        RBLE_PRF_START_NTF,
        RBLE_PRF_START_IND,
        RBLE_PRF_START_NTF,
        RBLE_PRF_START_NTF
    };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_LNP_Sensor_Enable( Connection_Handle, sec_lvl, con_type, &param, RBLE_APP_LNPS_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A LNP_Sensor_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_LNP_Sensor_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_LNP_Sensor_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A LNP_Sensor_Send_Location_Speed command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_LNP_Sensor_Send_Location_Speed_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_LNP_LOCATION_SPEED_INFO location_speed_info = {
        0x0000,         /* flags */
        0x3333,         /* instant_speed */
        200000,         /* total_distance */
        1050000000,     /* latitude */
        1430000000,     /* longitude */
        -59,            /* elevation */
        344,            /* heading */
        0x02,           /* rolling_time */
        0x00,           /* reserved */
        {2013,8,22,19,13,42,0}      /* utc_time(2013/8/22 19:13:42) */
    };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            location_speed_info.flags = (uint16_t)RBLE_Parameter_Arg[ 0 ];
            if ( 1 < RBLE_Parameter_Cnt ) {
                location_speed_info.total_distance = RBLE_Parameter_Arg[ 1 ];
            }
        }
        /* API Call */
        Ret_Status = RBLE_LNP_Sensor_Send_Location_Speed( Connection_Handle, &location_speed_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A LNP_Sensor_Set_Position_Quality command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_LNP_Sensor_Set_Position_Quality_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_LNP_POSITION_QUALITY_INFO quality_info = 
    {
        0x0000,         /* flags */
        5,              /* Number of Beacons in Solution */
        4,              /* Number of Beacons in View */
        0x0030,         /* Time to First Fix */
        0xff00ff00,     /* EHPE */
        0xccff00ff,     /* EVPE */
        0x08,           /* HDOP */
        0x09            /* VDOP */
    };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            quality_info.flags = (uint16_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_LNP_Sensor_Set_Position_Quality( &quality_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A LNP_Sensor_Send_LN_Control_Point command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_LNP_Sensor_Send_LN_Control_Point_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_LNP_IND_CONTROL_POINT_INFO ind_cp_info = 
    {
        RBLE_LNP_OP_RESPONSE_CODE,      /* OpCode */
        RBLE_LNP_OP_SET_CUMULATIVE_CODE,/* request op code */
        RBLE_LNP_RES_SUCCESS_CODE,      /* response_value */
        0,                              /* reserved */
        5,                              /* route_num */
        17,                             /* name_sie */
        { 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q' } /* route_name */
    };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            ind_cp_info.request_op_code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            
            if( RBLE_Parameter_Cnt > 1 ) {
                ind_cp_info.response_value = (uint8_t)RBLE_Parameter_Arg[ 1 ];
                
                if( RBLE_Parameter_Cnt > 2 ) {
                    switch(ind_cp_info.request_op_code)
                    {
                        case RBLE_LNP_OP_REQ_NUM_OF_ROUTE_CODE:
                            ind_cp_info.route_num = (uint16_t)RBLE_Parameter_Arg[ 2 ];
                            break;
                        case RBLE_LNP_OP_REQ_NAME_OF_ROUTE_CODE:
                            ind_cp_info.name_size = (uint8_t)RBLE_Parameter_Arg[ 2 ];
                            break;
                        case RBLE_LNP_OP_SET_FIX_RATE_CODE:
                        case RBLE_LNP_OP_SET_ELEVATION_CODE:
                        case RBLE_LNP_OP_SELECT_ROUTE_CODE:
                        case RBLE_LNP_OP_SET_CUMULATIVE_CODE:
                        case RBLE_LNP_OP_MASK_LS_CONTENTS_CODE:
                        case RBLE_LNP_OP_NAVIGATION_CONTROL_CODE:
                        default:
                            break;
                    }
                }
            }
        }
        /* API Call */
        Ret_Status = RBLE_LNP_Sensor_Send_LN_Control_Point( Connection_Handle, &ind_cp_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A LNP_Sensor_Send_Navigation command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_LNP_Sensor_Send_Navigation_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_LNP_NAVIGATION_INFO navigation_info = 
    {
        0x03,                   /* flags */
        18000,                  /* Bearing(180) */
        3000,                   /* Heading(30) */
        40000,                  /* Remaining Distance(4000m) */
        800,                    /* Remaining V Distance(8m) */
        {2013,8,23,16,22,10,0}, /* Estimated time of arrival (2013/8/23 16:22:10) */
    };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            navigation_info.flags = (uint16_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_LNP_Sensor_Send_Navigation( Connection_Handle, &navigation_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A LNP_Sensor_Send_Battery_Level command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_LNP_Sensor_Send_Battery_Level_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t battery_level = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            battery_level = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_LNP_Sensor_Send_Battery_Level( Connection_Handle, battery_level );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif
#ifdef USE_LNPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A LNP_Collector_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_LNP_Collector_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
    RBLE_LNS_CONTENT lns = {0};
    RBLE_DIS_CONTENT dis = {0};
    RBLE_BATS_CONTENT bas = {0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_LNP_Collector_Enable( Connection_Handle, con_type, &lns, &dis, &bas, RBLE_APP_LNPC_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A LNP_Collector_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_LNP_Collector_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_LNP_Collector_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A LNP_Collector_Read_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_LNP_Collector_Read_Char_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t char_code = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            char_code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_LNP_Collector_Read_Char( Connection_Handle, char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A LNP_Collector_Write_LN_Control_Point command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_LNP_Collector_Write_LN_Control_Point_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_LNP_WR_CONTROL_POINT_INFO wr_cp_info = 
    {
        RBLE_LNP_OP_SET_CUMULATIVE_CODE,    /* OpCode */
        0,                                  /* reserved */
        80000,                              /* cumulative value */
        0x007f,                             /* content_mask */
        5,                                  /* route_num */
        RBLE_LNP_CNTL_NAVI_START,           /* control_val */
        2,                                  /* fix_rate */
        -10                                 /* elevation */
    };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        wr_cp_info.OpCode = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        if( RBLE_Parameter_Cnt > 1 ) {
            switch(wr_cp_info.OpCode)
            {
                case RBLE_LNP_OP_SET_CUMULATIVE_CODE:
                    wr_cp_info.cumulative_value = (uint32_t)RBLE_Parameter_Arg[ 1 ];
                    break;
                case RBLE_LNP_OP_MASK_LS_CONTENTS_CODE:
                    wr_cp_info.content_mask = (uint16_t)RBLE_Parameter_Arg[ 1 ];
                    break;
                case RBLE_LNP_OP_NAVIGATION_CONTROL_CODE:
                    wr_cp_info.control_val =(uint8_t) RBLE_Parameter_Arg[ 1 ];
                    break;
                case RBLE_LNP_OP_REQ_NAME_OF_ROUTE_CODE:
                case RBLE_LNP_OP_SELECT_ROUTE_CODE:
                    wr_cp_info.route_num =(uint16_t) RBLE_Parameter_Arg[ 1 ];
                    break;
                case RBLE_LNP_OP_SET_FIX_RATE_CODE:
                    wr_cp_info.fix_rate = (uint8_t)RBLE_Parameter_Arg[ 1 ];
                    break;
                case RBLE_LNP_OP_SET_ELEVATION_CODE:
                    wr_cp_info.elevation = (int32_t)RBLE_Parameter_Arg[ 1 ];
                    break;
                case RBLE_LNP_OP_REQ_NUM_OF_ROUTE_CODE:
                default:
                    break;
            }
        }
        /* API Call */
        Ret_Status = RBLE_LNP_Collector_Write_LN_Control_Point( Connection_Handle, &wr_cp_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A LNP_Collector_Write_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_LNP_Collector_Write_Char_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t char_code = 0;
    uint16_t cfg_val = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            char_code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if ( 1 < RBLE_Parameter_Cnt ) {
                cfg_val = (uint16_t)RBLE_Parameter_Arg[ 1 ];
            }
        }
        /* API Call */
        Ret_Status = RBLE_LNP_Collector_Write_Char( Connection_Handle, char_code, cfg_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

/* ------------------------- Phone Alert Status Profile-------------------------------*/
#if defined(USE_PASPS_SAMPLE)|defined(USE_PASPC_SAMPLE)
/******************************************************************************************/
/**
 *  @brief rBLE PASP Event Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void PASP_Event_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE PASP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}
#endif

#ifdef USE_PASPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE PASPS(Server) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_PASPS_CallBack( RBLE_PASPS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_PASP_EVENT_SERVER_ENABLE_COMP:
            PASP_Event_Disp("SERVER_ENABLE_COMP", event->param.server_enable.status);
            Connection_Handle_Disp( event->param.server_enable.conhdl );
            break;
        case RBLE_PASP_EVENT_SERVER_DISABLE_COMP:
            printf("\nrBLE PASP EVENT (SERVER_DISABLE_COMP)\n" );
            Connection_Handle_Disp( event->param.server_disable.conhdl );
            printf("alert cfg:%d ringer cfg:%d\n", event->param.server_disable.server_info.alert_status_ntf_en, event->param.server_disable.server_info.ringer_setting_ntf_en);
            break;
        case RBLE_PASP_EVENT_SERVER_ERROR_IND:
            PASP_Event_Disp("SERVER_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_PASP_EVENT_SERVER_SEND_ALERT_STATUS_COMP:
            PASP_Event_Disp("SERVER_SEND_ALERT_STATUS_COMP", event->param.send_alert.status);
            Connection_Handle_Disp( event->param.send_alert.conhdl );
            break;
        case RBLE_PASP_EVENT_SERVER_SEND_RINGER_SETTING_COMP:
            PASP_Event_Disp("SERVER_SEND_RINGER_SETTING_COMP", event->param.send_ringer.status);
            Connection_Handle_Disp( event->param.send_ringer.conhdl );
            break;
        case RBLE_PASP_EVENT_SERVER_CHG_RINGER_CP_IND:
            printf("\nrBLE PASP EVENT (SERVER_CHG_RINGER_CP_IND)\n" );
            Connection_Handle_Disp( event->param.chg_ringer_cp_ind.conhdl );
            printf("cp val:%d\n", event->param.chg_ringer_cp_ind.cp_val);
            break;
        case RBLE_PASP_EVENT_SERVER_CFG_NTF_IND:
            printf("\nrBLE PASP EVENT (SERVER_CFG_NTF_IND)\n" );
            Connection_Handle_Disp( event->param.cfg_ntf_ind.conhdl );
            printf("char:%d  cfg:%d\n", event->param.cfg_ntf_ind.char_code, event->param.cfg_ntf_ind.cfg_val);
            break;
        case RBLE_PASP_EVENT_SERVER_COMMAND_DISALLOWED_IND:
            PASP_Event_Disp("SERVER_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_PASPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE PASPC(Client) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_PASPC_CallBack( RBLE_PASPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_PASP_EVENT_CLIENT_ENABLE_COMP:
            PASP_Event_Disp("CLIENT_ENABLE_COMP", event->param.client_enable.status);
            Connection_Handle_Disp( event->param.client_enable.conhdl );
            printf("\nPhone Alert Status Service\n" );
            printf("   Start Handle = 0x%04x\n", event->param.client_enable.pass.shdl);
            printf("   End Handle   = 0x%04x\n", event->param.client_enable.pass.ehdl);
            printf("   alert_status_char_hdl     = 0x%04x\n", event->param.client_enable.pass.alert_status_char_hdl);
            printf("   alert_status_val_hdl      = 0x%04x\n", event->param.client_enable.pass.alert_status_val_hdl);
            printf("   alert_status_cfg_hdl      = 0x%04x\n", event->param.client_enable.pass.alert_status_cfg_hdl);
            printf("   alert_status_prop         = 0x%04x\n", event->param.client_enable.pass.alert_status_prop);
            printf("   ringer_setting_char_hdl   = 0x%04x\n", event->param.client_enable.pass.ringer_setting_char_hdl);
            printf("   ringer_setting_val_hdl    = 0x%04x\n", event->param.client_enable.pass.ringer_setting_val_hdl);
            printf("   ringer_setting_cfg_hdl    = 0x%04x\n", event->param.client_enable.pass.ringer_setting_cfg_hdl);
            printf("   ringer_setting_prop       = 0x%04x\n", event->param.client_enable.pass.ringer_setting_prop);
            printf("   ringer_cp_char_hdl        = 0x%04x\n", event->param.client_enable.pass.ringer_cp_char_hdl);
            printf("   ringer_cp_val_hdl         = 0x%04x\n", event->param.client_enable.pass.ringer_cp_val_hdl);
            printf("   ringer_cp_prop            = 0x%04x\n", event->param.client_enable.pass.ringer_cp_prop);
            break;
        case RBLE_PASP_EVENT_CLIENT_DISABLE_COMP:
            PASP_Event_Disp("CLIENT_DISABLE_COMP", event->param.client_disable.status);
            Connection_Handle_Disp( event->param.client_disable.conhdl );
            break;
        case RBLE_PASP_EVENT_CLIENT_ERROR_IND:
            PASP_Event_Disp("CLIENT_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_PASP_EVENT_CLIENT_ALERT_STATUS_NTF:
            printf("\nrBLE PASP EVENT (CLIENT_ALERT_STATUS_NTF)\n" );
            Connection_Handle_Disp( event->param.alert_ntf.conhdl );
            printf( "Alert Status = 0x%x\n", event->param.alert_ntf.alert_status );
            break;
        case RBLE_PASP_EVENT_CLIENT_RINGER_SETTING_NTF:
            printf("\nrBLE PASP EVENT (CLIENT_RINGER_SETTING_NTF)\n" );
            Connection_Handle_Disp( event->param.ringer_ntf.conhdl );
            printf( "Ringer Setting = 0x%x\n", event->param.ringer_ntf.ringer_setting );
            break;
        case RBLE_PASP_EVENT_CLIENT_READ_CHAR_RESPONSE:
            PASP_Event_Disp("CLIENT_READ_CHAR_RESPONSE", event->param.rd_char_resp.att_code);
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            ATT_Info_Disp( &event->param.rd_char_resp.data );
            event->param.rd_char_resp.data.data[event->param.rd_char_resp.data.len] = '\0';
            printf("(%s)\n", event->param.rd_char_resp.data.data);
            break;
        case RBLE_PASP_EVENT_CLIENT_WRITE_CHAR_RESPONSE:
            PASP_Event_Disp("CLIENT_WRITE_CHAR_RESPONSE", event->param.wr_char_resp.att_code);
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_PASP_EVENT_CLIENT_COMMAND_DISALLOWED_IND:
            PASP_Event_Disp("CLIENT_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_PASPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief A PASP_Server_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PASP_Server_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;
    /* security level */
    uint8_t sec_lvl = RBLE_SVC_SEC_NONE;
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
    RBLE_PASP_SERVER_PARAM param = {0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_PASP_Server_Enable( Connection_Handle, sec_lvl, con_type, &param, RBLE_APP_PASPS_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A PASP_Server_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PASP_Server_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_PASP_Server_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A PASP_Server_Send_Alert_Status command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PASP_Server_Send_Alert_Status_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t alert_status = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            alert_status = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_PASP_Server_Send_Alert_Status( Connection_Handle, alert_status );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A PASP_Server_Send_Ringer_Setting command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PASP_Server_Send_Ringer_Setting_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t ringer_setting = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            ringer_setting = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_PASP_Server_Send_Ringer_Setting( Connection_Handle, ringer_setting );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif
#ifdef USE_PASPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A PASP_Client_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PASP_Client_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
    RBLE_PASS_CONTENT pass = {0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_PASP_Client_Enable( Connection_Handle, con_type, &pass, RBLE_APP_PASPC_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A PASP_Client_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PASP_Client_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_PASP_Client_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A PASP_Client_Read_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PASP_Client_Read_Char_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t char_code = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            char_code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_PASP_Client_Read_Char( Connection_Handle, char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A PASP_Client_Write_Ringer_Control_Point command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PASP_Client_Write_Ringer_Control_Point_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t cp_val = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            cp_val = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_PASP_Client_Write_Ringer_Control_Point( Connection_Handle, cp_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A PASP_Client_Write_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_PASP_Client_Write_Char_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t char_code = 0;
    uint16_t cfg_val = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            char_code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if ( 1 < RBLE_Parameter_Cnt ) {
                cfg_val = (uint8_t)RBLE_Parameter_Arg[ 1 ];
            }
        }
        /* API Call */
        Ret_Status = RBLE_PASP_Client_Write_Char( Connection_Handle, char_code, cfg_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

/* ------------------------- Running Speed and Cadence Profile-------------------------------*/
#if defined(USE_RSCPS_SAMPLE)|defined(USE_RSCPC_SAMPLE)
/******************************************************************************************/
/**
 *  @brief rBLE RSCP Event Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void RSCP_Event_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE RSCP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}
#endif

#ifdef USE_RSCPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE RSCPS(Sensor) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_RSCPS_CallBack( RBLE_RSCPS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_RSCP_EVENT_SENSOR_ENABLE_COMP:
            RSCP_Event_Disp("SENSOR_ENABLE_COMP", event->param.sensor_enable.status);
            Connection_Handle_Disp( event->param.sensor_enable.conhdl );
            break;
        case RBLE_RSCP_EVENT_SENSOR_DISABLE_COMP:
            printf("\nrBLE RSCP EVENT (SENSOR_DISABLE_COMP)\n" );
            Connection_Handle_Disp( event->param.sensor_disable.conhdl );
            printf("meas cfg:%d sc cp cfg:%d\n", event->param.sensor_disable.sensor_info.rsc_meas_ntf_en, event->param.sensor_disable.sensor_info.sc_cp_ind_en);
            printf("sensor location:%d\n", event->param.sensor_disable.sensor_info.sensor_location);
            break;
        case RBLE_RSCP_EVENT_SENSOR_ERROR_IND:
            RSCP_Event_Disp("SENSOR_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_RSCP_EVENT_SENSOR_SEND_MEASUREMENTS_COMP:
            RSCP_Event_Disp("SENSOR_SEND_MEASUREMENTS_COMP", event->param.send_measurements.status);
            Connection_Handle_Disp( event->param.send_measurements.conhdl );
            break;
        case RBLE_RSCP_EVENT_SENSOR_SEND_SC_CP_COMP:
            RSCP_Event_Disp("SENSOR_SEND_SC_CP_COMP", event->param.send_sc_cp.status);
            Connection_Handle_Disp( event->param.send_sc_cp.conhdl );
            break;
        case RBLE_RSCP_EVENT_SENSOR_CHG_SC_CP_IND:
            printf("\nrBLE RSCP EVENT (SENSOR_CHG_SC_CP_IND)\n" );
            Connection_Handle_Disp( event->param.chg_sc_cp_ind.conhdl );
            RSCP_SC_CP_Info_Disp( &event->param.chg_sc_cp_ind.sc_cp_info, 0, NULL );
            break;
        case RBLE_RSCP_EVENT_SENSOR_CFG_INDNTF_IND:
            printf("\nrBLE RSCP EVENT (SENSOR_CFG_INDNTF_IND)\n" );
            Connection_Handle_Disp( event->param.cfg_indntf_ind.conhdl );
            printf("char:%d  cfg:%d\n", event->param.cfg_indntf_ind.char_code, event->param.cfg_indntf_ind.cfg_val);
            break;
        case RBLE_RSCP_EVENT_SENSOR_COMMAND_DISALLOWED_IND:
            RSCP_Event_Disp("SENSOR_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_RSCPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE RSCPC(Collector) Call Back *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_RSCPC_CallBack( RBLE_RSCPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_RSCP_EVENT_COLLECTOR_ENABLE_COMP:
            RSCP_Event_Disp("COLLECTOR_ENABLE_COMP", event->param.collector_enable.status);
            Connection_Handle_Disp( event->param.collector_enable.conhdl );
            printf("\nRunning Speed and Cadence Service\n" );
            printf("   Start Handle = 0x%04x\n", event->param.collector_enable.rscs.shdl);
            printf("   End Handle   = 0x%04x\n", event->param.collector_enable.rscs.ehdl);
            printf("   rsc_meas_char_hdl         = 0x%04x\n", event->param.collector_enable.rscs.rsc_meas_char_hdl);
            printf("   rsc_meas_val_hdl          = 0x%04x\n", event->param.collector_enable.rscs.rsc_meas_val_hdl);
            printf("   rsc_meas_cfg_hdl          = 0x%04x\n", event->param.collector_enable.rscs.rsc_meas_cfg_hdl);
            printf("   rsc_meas_prop             = 0x%04x\n", event->param.collector_enable.rscs.rsc_meas_prop);
            printf("   rsc_feature_char_hdl      = 0x%04x\n", event->param.collector_enable.rscs.rsc_feature_char_hdl);
            printf("   rsc_feature_val_hdl       = 0x%04x\n", event->param.collector_enable.rscs.rsc_feature_val_hdl);
            printf("   rsc_feature_prop          = 0x%04x\n", event->param.collector_enable.rscs.rsc_feature_prop);
            printf("   sensor_loc_char_hdl       = 0x%04x\n", event->param.collector_enable.rscs.sensor_loc_char_hdl);
            printf("   sensor_loc_val_hdl        = 0x%04x\n", event->param.collector_enable.rscs.sensor_loc_val_hdl);
            printf("   sensor_loc_prop           = 0x%04x\n", event->param.collector_enable.rscs.sensor_loc_prop);
            printf("   sc_cp_char_hdl            = 0x%04x\n", event->param.collector_enable.rscs.sc_cp_char_hdl);
            printf("   sc_cp_val_hdl             = 0x%04x\n", event->param.collector_enable.rscs.sc_cp_val_hdl);
            printf("   sc_cp_cfg_hdl             = 0x%04x\n", event->param.collector_enable.rscs.sc_cp_cfg_hdl);
            printf("   sc_cp_prop                = 0x%04x\n", event->param.collector_enable.rscs.sc_cp_prop);
            DIS_handle_Info_Disp(&event->param.collector_enable.dis);
            break;
        case RBLE_RSCP_EVENT_COLLECTOR_DISABLE_COMP:
            RSCP_Event_Disp("COLLECTOR_DISABLE_COMP", event->param.collector_disable.status);
            Connection_Handle_Disp( event->param.collector_disable.conhdl );
            break;
        case RBLE_RSCP_EVENT_COLLECTOR_ERROR_IND:
            RSCP_Event_Disp("COLLECTOR_ERROR_IND", event->param.error_ind.status);
            Connection_Handle_Disp( event->param.error_ind.conhdl );
            break;
        case RBLE_RSCP_EVENT_COLLECTOR_MEASUREMENTS_NTF:
            printf("\nrBLE RSCP EVENT (COLLECTOR_MEASUREMENTS_NTF)\n" );
            Connection_Handle_Disp( event->param.measurements_ntf.conhdl );
            RSCP_MEASURE_Info_Disp( &event->param.measurements_ntf.measure_info );
            break;
        case RBLE_RSCP_EVENT_COLLECTOR_SC_CP_IND:
            printf("\nrBLE RSCP EVENT (COLLECTOR_SC_CP_IND)\n" );
            Connection_Handle_Disp( event->param.sc_cp_ind.conhdl );
            RSCP_SC_CP_Info_Disp( &event->param.sc_cp_ind.sc_cp_info, event->param.sc_cp_ind.location_num, event->param.sc_cp_ind.response_param );
            break;
        case RBLE_RSCP_EVENT_COLLECTOR_READ_CHAR_RESPONSE:
            RSCP_Event_Disp("COLLECTOR_READ_CHAR_RESPONSE", event->param.rd_char_resp.att_code);
            Connection_Handle_Disp( event->param.rd_char_resp.conhdl );
            ATT_Info_Disp( &event->param.rd_char_resp.data );
            event->param.rd_char_resp.data.data[event->param.rd_char_resp.data.len] = '\0';
            printf("(%s)\n", event->param.rd_char_resp.data.data);
            break;
        case RBLE_RSCP_EVENT_COLLECTOR_WRITE_CHAR_RESPONSE:
            RSCP_Event_Disp("COLLECTOR_WRITE_CHAR_RESPONSE", event->param.wr_char_resp.att_code);
            Connection_Handle_Disp( event->param.wr_char_resp.conhdl );
            break;
        case RBLE_RSCP_EVENT_COLLECTOR_COMMAND_DISALLOWED_IND:
            RSCP_Event_Disp("COLLECTOR_COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_RSCPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief A RSCP_Sensor_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_RSCP_Sensor_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;
    /* security level */
    uint8_t sec_lvl = RBLE_SVC_SEC_NONE;
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
    RBLE_RSCP_SENSOR_PARAM param = {0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_RSCP_Sensor_Enable( Connection_Handle, sec_lvl, con_type, &param, RBLE_APP_RSCPS_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A RSCP_Sensor_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_RSCP_Sensor_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_RSCP_Sensor_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A RSCP_Sensor_Send_Measurements command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_RSCP_Sensor_Send_Measurements_Test( void )
{
    RBLE_STATUS Ret_Status;
    int32_t Parameter_No;
    RBLE_RSCP_MEASUREMENTS_INFO measurements_info[] = 
    {
        {
            0x03,           /* flags */
            0x12,           /* Instantaneous Cadence */
            0x0034,         /* Instantaneous speed */
            0x0056,         /* Instantaneous stride length */
            0x12345678      /* Total Distance */
        },
        {
            0x03,           /* flags */
            0x30,           /* Instantaneous Cadence */
            0x0060,         /* Instantaneous speed */
            0x0045,         /* Instantaneous stride length */
            0x00004565      /* Total Distance */
        }
    };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 < RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = 0;
        }
        if (Parameter_No >= (sizeof(measurements_info) / sizeof(RBLE_RSCP_MEASUREMENTS_INFO))) {
            Parameter_No = 0;
        }
        if ( 1 < RBLE_Parameter_Cnt ) {
            measurements_info[Parameter_No].flags = (uint8_t)RBLE_Parameter_Arg[1];
            if ( 2 < RBLE_Parameter_Cnt ) {
                measurements_info[Parameter_No].total_distance = (uint32_t)RBLE_Parameter_Arg[2];
            }
        }
        /* API Call */
        Ret_Status = RBLE_RSCP_Sensor_Send_Measurements( Connection_Handle, &measurements_info[Parameter_No] );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A RSCP_Sensor_Send_SC_Control_Point command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_RSCP_Sensor_Send_SC_Control_Point_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_RSCP_SC_CONTROL_POINT_INFO sc_cp_info =
    {
        RBLE_RSCP_OP_RESPONSE_CODE,
        0x00,                                   /* reserved */
        0x00000000,                             /* cumulative value */
        0x00,                                   /* sensor location */
        RBLE_RSCP_OP_REQ_SUPPORTED_SL_CODE,     /* request op code */
        RBLE_RSCP_RES_SUCCESS_CODE              /* response value */
    };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 < RBLE_Parameter_Cnt ) {
            sc_cp_info.request_op_code = (uint8_t)RBLE_Parameter_Arg[0];
            if ( 1 < RBLE_Parameter_Cnt ) {
                sc_cp_info.response_value  = (uint8_t)RBLE_Parameter_Arg[1];
            }
        }
        /* API Call */
        Ret_Status = RBLE_RSCP_Sensor_Send_SC_Control_Point( Connection_Handle, &sc_cp_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif
#ifdef USE_RSCPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A RSCP_Collector_Enable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_RSCP_Collector_Enable_Test( void )
{
    RBLE_STATUS Ret_Status;
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
    RBLE_RSCS_CONTENT rscs = {0};
    RBLE_DIS_CONTENT dis = {0};

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_RSCP_Collector_Enable( Connection_Handle, con_type, &rscs, &dis, RBLE_APP_RSCPC_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A RSCP_Collector_Disable command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_RSCP_Collector_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_RSCP_Collector_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A RSCP_Collector_Read_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_RSCP_Collector_Read_Char_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t char_code = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            char_code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }
        /* API Call */
        Ret_Status = RBLE_RSCP_Collector_Read_Char( Connection_Handle, char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A RSCP_Collector_Write_SC_Control_Point command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_RSCP_Collector_Write_SC_Control_Point_Test( void )
{
    RBLE_STATUS Ret_Status;
    RBLE_RSCP_SC_CONTROL_POINT_INFO wr_cp_info = 
    {
        RBLE_RSCP_OP_SET_CUMULATIVE_CODE,   /* operation code */
        0x00,           /* reserved */
        0x00ff00ff,     /* cumulative value */
        0x02,           /* sensor location */
        0x00,           /* request op code */
        0x00,           /* response value */
        0x00            /* reserved */
    };

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            wr_cp_info.OpCode = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if (1 < RBLE_Parameter_Cnt) {
                switch(wr_cp_info.OpCode)
                {
                    case RBLE_RSCP_OP_SET_CUMULATIVE_CODE:
                        wr_cp_info.cumulative_value = RBLE_Parameter_Arg[1];
                        break;
                    case RBLE_RSCP_OP_UPDATE_SL_CODE:
                        wr_cp_info.sensor_location = (uint8_t)RBLE_Parameter_Arg[1];
                        break;
                    default:
                        break;
                }
            }
        }
        /* API Call */
        Ret_Status = RBLE_RSCP_Collector_Write_SC_Control_Point( Connection_Handle, &wr_cp_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
/******************************************************************************************/
/**
 *  @brief A RSCP_Collector_Write_Char command is executed.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_RSCP_Collector_Write_Char_Test( void )
{
    RBLE_STATUS Ret_Status;
    uint8_t char_code = 0;
    uint16_t cfg_val = 0;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            char_code = (uint8_t)RBLE_Parameter_Arg[ 0 ];
            if ( 1 < RBLE_Parameter_Cnt ) {
                cfg_val = (uint8_t)RBLE_Parameter_Arg[ 1 ];
            }
        }
        /* API Call */
        Ret_Status = RBLE_RSCP_Collector_Write_Char( Connection_Handle, char_code, cfg_val );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#if defined(USE_SCPC_SAMPLE)|defined(USE_SCPS_SAMPLE)
/******************************************************************************************/
/**
 *  @brief rBLE SCP Event Disp
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event_str      event strings
 *  @param[in] status          status
 *
 *  @retval
 */
/******************************************************************************************/
static void SCP_Event_Disp(char_t *event_str, RBLE_STATUS status)
{
    printf( "\nrBLE SCP EVENT (%s) Status(%s)\n", event_str, Get_Status_Str( status ) );
}
#endif
#ifdef USE_SCPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief rBLE SCP(Server) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_SCPS_CallBack( RBLE_SCPS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_SCP_EVENT_SERVER_ENABLE_COMP:
            SCP_Event_Disp("SERVER_ENABLE_COMP", event->param.server_enable.status);
            printf( "Connect Handle = %d\n", event->param.server_enable.conhdl );
            break;
        case RBLE_SCP_EVENT_SERVER_DISABLE_COMP:
            printf( "\nrBLE SCP EVENT (SERVER_DISABLE_COMP)\n" );
            printf( "Connect Handle = %d\n", event->param.server_disable.conhdl );
#ifdef USE_CUSTOM_DEMO
            // restart advertising for reconnection
            RBLE_GAP_Broadcast_Enable_Test();
#endif
            break;
        case RBLE_SCP_EVENT_SERVER_ERROR_IND:
            SCP_Event_Disp("SERVER_ERROR_IND", event->param.error_ind.status);
            printf( "Connect Handle = %d\n", event->param.error_ind.conhdl );
            break;
        case RBLE_SCP_EVENT_SERVER_SEND_NOTIFY_COMP:
            SCP_Event_Disp("SERVER_SEND_NOTIFY_COMP", event->param.send_notify.status);
            printf( "Connect Handle = %d\n", event->param.send_notify.conhdl );
            break;
        case RBLE_SCP_EVENT_SERVER_SEND_IND_COMP:
            SCP_Event_Disp("SERVER_SEND_IND_COMP", event->param.send_ind.status);
            printf( "Connect Handle = %d\n", event->param.send_ind.conhdl );
            break;
        case RBLE_SCP_EVENT_SERVER_CHG_INDNTF_IND:
            printf( "\nrBLE SCP EVENT (SERVER_CFG_INDNTF_IND)\n" );
            printf( " Char Code = %s\n", ( event->param.cfg_indntf.char_code == RBLE_SCP_SCS_NTF_CFG ) ? "NOTIFY" :"INDICATE" );
            printf( " Cfg Value = %s\n", ( event->param.cfg_indntf.cfg_val == RBLE_SCP_STOP_NTFIND ) ? "STOP" : "START_NTF/IND" );
#ifdef USE_CUSTOM_DEMO
            /* update info */
            if (event->param.cfg_indntf.char_code == RBLE_SCP_SCS_NTF_CFG) {
                if(event->param.cfg_indntf.cfg_val & RBLE_SCP_START_NTF) {
                    scp_sample_info.Notify_en = TRUE;
                }
                else {
                    scp_sample_info.Notify_en = FALSE;
                }
            }
            else if (event->param.cfg_indntf.char_code == RBLE_SCP_SCS_IND_CFG) {
                if(event->param.cfg_indntf.cfg_val & RBLE_SCP_START_IND) {
                    scp_sample_info.Indicate_en = TRUE;
                }
                else {
                    scp_sample_info.Indicate_en = FALSE;
                }
            }
#endif
            break;
        case RBLE_SCP_EVENT_SERVER_CHG_CHAR_IND:
            printf( "\nrBLE SCP EVENT (SERVER_CHG_CHAR_IND)\n" );
            printf( " Char Code   = %d\n", event->param.write_char.char_code);
            if(event->param.write_char.char_code == RBLE_SCP_SCS_INTERVAL) {
                printf( " Write Value = 0x%02x, 0x%02x\n", event->param.write_char.value[0], event->param.write_char.value[1]);
#ifdef USE_CUSTOM_DEMO
                /* update info */
                scp_sample_info.Timer_interval = event->param.write_char.value[0] | (uint16_t)(event->param.write_char.value[1] << 8);
                printf( " Timer Interval = %d\n", scp_sample_info.Timer_interval);
#endif
            }
            else {
                printf( " Write Value = 0x%02x\n", event->param.write_char.value[0]);
#ifdef USE_CUSTOM_DEMO
                if(event->param.write_char.char_code == RBLE_SCP_SCS_NTF_LEN) {
                    scp_sample_info.Notify_len = event->param.write_char.value[0];
                    printf( " Notify Length = %d\n", scp_sample_info.Notify_len);
                }
                else if(event->param.write_char.char_code == RBLE_SCP_SCS_IND_LEN) {
                    scp_sample_info.Indicate_len = event->param.write_char.value[0];
                    printf( " Indicate Length = %d\n", scp_sample_info.Indicate_len);
                }
#endif
            }
            break;
        case RBLE_SCP_EVENT_SERVER_COMMAND_DISALLOWED_IND:
            SCP_Event_Disp("COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_SCPC_SAMPLE
/* ------------------------- Sample Custom Profile-------------------------------*/
/******************************************************************************************/
/**
 *  @brief rBLE SCP(Client) Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_SCPC_CallBack( RBLE_SCPC_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_SCP_EVENT_CLIENT_ENABLE_COMP:
            SCP_Event_Disp("CLIENT_ENABLE_COMP", event->param.client_enable.status);
            printf( "Connect Handle = %d\n", event->param.client_enable.conhdl );
            printf( "* Sample Custom Service\n");
            printf( "   Start Handle = 0x%04X\n", event->param.client_enable.scs.shdl );
            printf( "   End Handle   = 0x%04X\n\n", event->param.client_enable.scs.ehdl );
            printf( "   ntf_char_hdl = 0x%04X\n", event->param.client_enable.scs.ntf_char_hdl );
            printf( "   ntf_val_hdl  = 0x%04X\n", event->param.client_enable.scs.ntf_val_hdl );
            printf( "   ntf_cfg_hdl  = 0x%04X\n", event->param.client_enable.scs.ntf_cfg_hdl );
            printf( "   ntf_prop     = 0x%02X\n\n", event->param.client_enable.scs.ntf_prop );
            
            printf( "   ind_char_hdl = 0x%04X\n", event->param.client_enable.scs.ind_char_hdl );
            printf( "   ind_val_hdl  = 0x%04X\n", event->param.client_enable.scs.ind_val_hdl );
            printf( "   ind_cfg_hdl  = 0x%04X\n", event->param.client_enable.scs.ind_cfg_hdl );
            printf( "   ind_prop     = 0x%02X\n\n", event->param.client_enable.scs.ind_prop );
            
            printf( "   interval_char_hdl = 0x%04X\n", event->param.client_enable.scs.interval_char_hdl );
            printf( "   interval_val_hdl  = 0x%04X\n", event->param.client_enable.scs.interval_val_hdl );
            printf( "   interval_prop     = 0x%02X\n\n", event->param.client_enable.scs.interval_prop );
            
            printf( "   ntf_len_char_hdl  = 0x%04X\n", event->param.client_enable.scs.ntf_len_char_hdl );
            printf( "   ntf_len_val_hdl   = 0x%04X\n", event->param.client_enable.scs.ntf_len_val_hdl );
            printf( "   ntf_len_prop      = 0x%02X\n\n", event->param.client_enable.scs.ntf_len_prop );
            
            printf( "   ind_len_char_hdl  = 0x%04X\n", event->param.client_enable.scs.ind_len_char_hdl );
            printf( "   ind_len_val_hdl   = 0x%04X\n", event->param.client_enable.scs.ind_len_val_hdl );
            printf( "   ind_len_prop      = 0x%02X\n\n", event->param.client_enable.scs.ind_len_prop );
            break;
        case RBLE_SCP_EVENT_CLIENT_DISABLE_COMP:
            SCP_Event_Disp("CLIENT_DISABLE_COMP", event->param.client_disable.status);
            printf( "Connect Handle = %d\n", event->param.client_disable.conhdl );
            break;
        case RBLE_SCP_EVENT_CLIENT_ERROR_IND:
            SCP_Event_Disp("CLIENT_ERROR_IND", event->param.error_ind.status);
            printf( "Connect Handle = %d\n", event->param.error_ind.conhdl );
            break;
        case RBLE_SCP_EVENT_CLIENT_NOTIFY:
            printf( "\nrBLE SCP EVENT (CLIENT_NOTIFY)\n" );
            printf( "Connect Handle = %d\n", event->param.notify.conhdl );
            Print_Dump( event->param.notify.data, (uint16_t)event->param.notify.data_len );
            break;
        case RBLE_SCP_EVENT_CLIENT_INDICATE:
            printf( "\nrBLE SCP EVENT (CLIENT_INDICATE)\n" );
            printf( "Connect Handle = %d\n", event->param.ind.conhdl );
            Print_Dump( event->param.ind.data, (uint16_t)event->param.ind.data_len );
            break;
        case RBLE_SCP_EVENT_CLIENT_READ_CHAR_RESPONSE:
            SCP_Event_Disp("CLIENT_READ_CHAR_RES", event->param.rd_char_resp.att_code);
            printf( "Connect Handle = %d\n", event->param.rd_char_resp.conhdl );
            ATT_Info_Disp( &event->param.rd_char_resp.data );
            break;
        case RBLE_SCP_EVENT_CLIENT_WRITE_CHAR_RESPONSE:
            SCP_Event_Disp("CLIENT_WRITE_CHAR_RES", event->param.wr_char_resp.att_code);
            printf( "Connect Handle = %d\n", event->param.wr_char_resp.conhdl );
            break;
        case RBLE_SCP_EVENT_CLIENT_COMMAND_DISALLOWED_IND:
            SCP_Event_Disp("COMMAND_DISALLOWED_IND", event->param.cmd_disallowed_ind.status);
            printf( "opcode = 0x%04x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        default:
            break;
    }
    Prompt_Disp();
}
#endif

#ifdef USE_SCPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief A SCP_Server_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SCP_Server_Enable_Test( void )
{
    /* ConType */
    static uint8_t con_type = RBLE_SCP_CON_CFG;
//  static uint8_t con_type = RBLE_SCP_CON_NORMAL;

    static RBLE_SCP_SERVER_PARAM    param = {
        RBLE_SCP_START_NTF,
        RBLE_SCP_START_IND,
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_SCP_Server_Enable( Connection_Handle, con_type, &param, RBLE_APP_SCPS_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SCP_Server_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SCP_Server_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

#ifdef USE_CUSTOM_DEMO
    scp_sample_info.Timer_en = FALSE;
    scp_sample_info.Notify_en = FALSE;
    scp_sample_info.Indicate_en = FALSE;
#endif

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_SCP_Server_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SCP_Server_Send_Notify command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SCP_Server_Send_Notify_Test( void )
{
    static RBLE_SCP_NOTIFY_INFO     notify_info = {
        0x05,                       /* length */
        {0x01,0x02,0xff,0xfe,0xfd}  /* data */
    };

    RBLE_STATUS Ret_Status;
    int32_t     Parameter_No;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }

        /* API Call */
        Ret_Status = RBLE_SCP_Server_Send_Notify( Connection_Handle, &notify_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SCP_Server_Send_Indicate command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SCP_Server_Send_Indicate_Test( void )
{
    static RBLE_SCP_IND_INFO    ind_info = {
        0x18,                       /* length */
        {0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,
         0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18}   /* data */
    };

    RBLE_STATUS Ret_Status;
    int32_t     Parameter_No;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            Parameter_No = RBLE_Parameter_Arg[ 0 ];
        } else {
            Parameter_No = ILLEGAL_NO;
        }

        /* API Call */
        Ret_Status = RBLE_SCP_Server_Send_Indicate( Connection_Handle, &ind_info );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#ifdef USE_SCPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief A SCP_Client_Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SCP_Client_Enable_Test( void )
{
    /* ConType */
    uint8_t con_type = RBLE_PRF_CON_DISCOVERY;
//  uint8_t con_type = RBLE_PRF_CON_NORMAL;

    RBLE_SCS_CONTENT    scs = {
        0x0000,         /* StartHdl */
        0x0000,         /* EndHdl */
        0x0000,         /* NotifyCharHdl */
        0x0000,         /* NotifyValHdl */
        0x0000,         /* NotifyCfgHdl */
        0x00,           /* NotifyProp */
        0x00,           /* Pad */
        0x0000,         /* IndicateCharHdl */
        0x0000,         /* IndicateValHdl */
        0x0000,         /* IndicateCfgHdl */
        0x00,           /* IndicateProp */
        0x00,           /* Pad */
        0x0000,         /* IntervalCharHdl */
        0x0000,         /* IntervalValHdl */
        0x00,           /* IntervalProp */
        0x00,           /* Pad */
        0x0000,         /* NotifyLengthCharHdl */
        0x0000,         /* NotifyLengthValHdl */
        0x00,           /* NotifyLengthProp */
        0x00,           /* Pad */
        0x0000,         /* IndicateLengthCharHdl */
        0x0000,         /* IndicateLengthValHdl */
        0x00,           /* IndicateLengthProp */
        0x00           /* Pad */
    };

    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            con_type = (uint8_t)RBLE_Parameter_Arg[ 0 ];
        }

        /* API Call */
        Ret_Status = RBLE_SCP_Client_Enable( Connection_Handle, con_type, &scs, RBLE_APP_SCPC_CallBack );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SCP_Client_Disable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SCP_Client_Disable_Test( void )
{
    RBLE_STATUS Ret_Status;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_SCP_Client_Disable( Connection_Handle );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SCP_Client_Read_Char command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SCP_Client_Read_Char_Test( void )
{
    /* CharCode */
    uint8_t         char_code;
    RBLE_STATUS     Ret_Status;
    int32_t         Parameter_No;

    if ( 0 != RBLE_Parameter_Cnt ) {
        Parameter_No = RBLE_Parameter_Arg[ 0 ];
    } else {
        Parameter_No = ILLEGAL_NO;
    }
    if ( ( ILLEGAL_NO == Parameter_No ) || ( ( sizeof( SCP_Char_Code ) / sizeof( uint8_t ) ) <= Parameter_No ) ) {
        char_code = SCP_Char_Code[ 0 ];
    } else {
        char_code = SCP_Char_Code[ Parameter_No ];
    }
    printf( "Select Char:%d\n",  char_code );

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        /* API Call */
        Ret_Status = RBLE_SCP_Client_Read_Char( Connection_Handle, char_code );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A SCP_Client_Write_Char command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_SCP_Client_Write_Char_Test( void )
{
    RBLE_STATUS                 Ret_Status;
    uint8_t                     write_value[2] = {0};
    uint8_t                     char_code;

    /* Valid Connection Handle ? */
    if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
        Illegal_Connection_Print();
    } else {
        if ( 0 != RBLE_Parameter_Cnt ) {
            if ( ( ( sizeof( SCP_Char_Code ) / sizeof( uint8_t ) ) <= RBLE_Parameter_Arg[ 0 ] ) ) {
                char_code = SCP_Char_Code[ 0 ];
            } else {
                char_code = SCP_Char_Code[ RBLE_Parameter_Arg[ 0 ] ];
            }
            
            if (RBLE_Parameter_Cnt > 1) {
                write_value[0] = (uint8_t)(RBLE_Parameter_Arg[ 1 ] & 0xff);
                write_value[1] = (uint8_t)((RBLE_Parameter_Arg[ 1 ] >> 8) & 0xff);
            }
        } else {
            char_code = SCP_Char_Code[ 0 ];
        }
        printf( "Select Char:%d\n", char_code );
        
        /* API Call */
        Ret_Status = RBLE_SCP_Client_Write_Char( Connection_Handle, char_code, &write_value[0] );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}
#endif

#ifdef USE_VS_SAMPLE
/* ------------------------- Vendor Specific-------------------------------*/
/******************************************************************************************/
/**
 *  @brief Vendor Specific Call Back
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *event          event parameter
 *
 *  @retval
 */
/******************************************************************************************/
static void RBLE_APP_VS_CallBack( RBLE_VS_EVENT *event )
{
    Console_SetTextAttribute( EVENT_COLOR );
    switch( event->type){
        case RBLE_VS_EVENT_TEST_RX_START_COMP:
            printf( "\nrBLE VS EVENT (TEST_RX_START_COMP) Status(%s)\n", Get_Status_Str( event->param.status ) );
            break;
        case RBLE_VS_EVENT_TEST_TX_START_COMP:
            printf( "\nrBLE VS EVENT (TEST_TX_START_COMP) Status(%s)\n", Get_Status_Str( event->param.status ) );
            break;
        case RBLE_VS_EVENT_TEST_END_COMP:
            printf( "\nrBLE VS EVENT (TEST_END_COMP) Status(%s)\n", Get_Status_Str( event->param.test_end_cmp.status ) );
            printf( "ReceivedPacketsCnt = %d\n", event->param.test_end_cmp.nb_packet_received );
            break;
        case RBLE_VS_EVENT_WR_BD_ADDR_COMP:
            printf( "\nrBLE VS EVENT (Write BD Address Complete) Status(%s)\n", Get_Status_Str( event->param.status ) );
            break;
        case RBLE_VS_EVENT_SET_TEST_PARAM_COMP:
            printf( "\nrBLE VS EVENT (Set Test Parameters Complete) Status(%s)\n", Get_Status_Str( event->param.status ) );
            break;
        case RBLE_VS_EVENT_READ_TEST_RSSI_COMP:
            printf( "\nrBLE VS EVENT (Read Test RSSI Complete) Status(%s)\n", Get_Status_Str( event->param.test_rssi_cmp.status ) );
            printf( "RSSI = %d(dBm)\n", (int8_t)(event->param.test_rssi_cmp.rssi) );
            break;
        case RBLE_VS_EVENT_GPIO_DIR_COMP:
            printf( "\nrBLE VS EVENT (GPIO Dir Complete) Status(%s)\n", Get_Status_Str( event->param.gpio_dir_cmp.status ) );
            GPIO_Mask = event->param.gpio_dir_cmp.mask;
            VS_GPIO_Mask_Disp();
            break;
        case RBLE_VS_EVENT_GPIO_ACCESS_COMP:
            printf( "\nrBLE VS EVENT (GPIO Access Complete) Status(%s)\n", Get_Status_Str( event->param.gpio_access_cmp.status ) );
            GPIO_Value = event->param.gpio_access_cmp.value;
            VS_GPIO_Read_Disp();
            break;
        case RBLE_VS_EVENT_FLASH_MANAGEMENT_COMP:
            printf( "\nrBLE VS EVENT (Data Flash Management Complete) Status(%s)\n", Get_Status_Str( event->param.management_comp.status ) );
            if ( RBLE_OK == event->param.management_comp.status ) {
                (RBLE_VS_FLASH_CMD_START==event->param.management_comp.cmd)?printf( "Started.\n" ):printf( "Stopped.\n" );
            }
            break;
        case RBLE_VS_EVENT_FLASH_ACCESS_COMP:
            printf( "\nrBLE VS EVENT (Data Flash Access Complete) Status(%s)\n", Get_Status_Str( event->param.access_comp.status ) );
            if (RBLE_OK == event->param.access_comp.status) {
                (RBLE_VS_FLASH_CMD_WRITE == event->param.access_comp.cmd) ? printf("Command: Write\n") : printf("Command: Read\n");
                printf("ID: %d\n", event->param.access_comp.id);
                printf("Data Size: %d\n", event->param.access_comp.size);
                printf("Data: [%02x:%02x:%02x:%02x:%02x:%02x]\n", event->param.access_comp.addr[0], event->param.access_comp.addr[1], event->param.access_comp.addr[2], event->param.access_comp.addr[3], event->param.access_comp.addr[4], event->param.access_comp.addr[5]);
            }
            break;
        case RBLE_VS_EVENT_FLASH_OPERATION_COMP:
            printf( "\nrBLE VS EVENT (Data Flash Operation Complete) Status(%s)\n", Get_Status_Str( event->param.operation_comp.status ) );
            if ( RBLE_OK == event->param.operation_comp.status ) {
                (RBLE_VS_FLASH_CMD_START==event->param.operation_comp.cmd)?printf( "Cleaned up.\n" ):printf( "Formatted.\n" );
            }
            break;
        case RBLE_VS_EVENT_FLASH_GET_SPACE_COMP:
            printf( "\nrBLE VS EVENT (Data Flash Get Space Complete) Status(%s)\n", Get_Status_Str( event->param.get_space.status ) );
            printf( "Amount of Space: %d word\n", event->param.get_space.size );
            break;
        case RBLE_VS_EVENT_FLASH_GET_EEL_VER_COMP:
            printf( "\nrBLE VS EVENT (Data Flash Get EEL Version Complete) Status(%s)\n", Get_Status_Str( event->param.get_eel_ver.status ) );
            printf( "EEL Version: [%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c]\n",
                 event->param.get_eel_ver.version[0], event->param.get_eel_ver.version[1], event->param.get_eel_ver.version[2], event->param.get_eel_ver.version[3],
                 event->param.get_eel_ver.version[4], event->param.get_eel_ver.version[5], event->param.get_eel_ver.version[6], event->param.get_eel_ver.version[7],
                 event->param.get_eel_ver.version[8], event->param.get_eel_ver.version[9], event->param.get_eel_ver.version[10], event->param.get_eel_ver.version[11],
                 event->param.get_eel_ver.version[12], event->param.get_eel_ver.version[13], event->param.get_eel_ver.version[14], event->param.get_eel_ver.version[15],
                 event->param.get_eel_ver.version[16], event->param.get_eel_ver.version[17], event->param.get_eel_ver.version[18], event->param.get_eel_ver.version[19],
                 event->param.get_eel_ver.version[20], event->param.get_eel_ver.version[21], event->param.get_eel_ver.version[22], event->param.get_eel_ver.version[23] );
            break;
        case RBLE_VS_EVENT_ADAPT_ENABLE_COMP:
            printf( "\nrBLE VS EVENT (Adaptable Function Enable Complete) Status(%s)\n", Get_Status_Str( event->param.adapt_enable_cmp.status ) );
            printf( "Spacified Command: 0x%02x\n", event->param.adapt_enable_cmp.cmd );
            break;
        case RBLE_VS_EVENT_ADAPT_STATE_IND:
            printf( "\nrBLE VS EVENT (Adaptable Function State Notification)\n" );
            if ( RBLE_VS_ADAPT_MODE_NEAR   == event->param.adapt_state_ind.state )  printf( "Current State: NEAR\n" );
            if ( RBLE_VS_ADAPT_MODE_MIDDLE == event->param.adapt_state_ind.state )  printf( "Current State: MIDDLE\n" );
            if ( RBLE_VS_ADAPT_MODE_FAR    == event->param.adapt_state_ind.state )  printf( "Current State: FAR\n" );
            break;
        case RBLE_VS_EVENT_RF_CONTROL_COMP:
            printf( "\nrBLE VS EVENT (RF Control Complete) Status(%s)\n", Get_Status_Str( event->param.rf_control_cmp.status ) );
            break;
        case RBLE_EVT_VS_CMD_DISALLOWED_IND:
            printf( "\nrBLE VS EVENT (VS_ERROR) Status(%s)\n", Get_Status_Str( event->param.cmd_disallowed_ind.status ) );
            printf( "Cpecode = %x\n", event->param.cmd_disallowed_ind.opcode );
            break;
        case RBLE_VS_EVENT_SET_TX_POWER_COMP:
            printf( "\nrBLE VS EVENT (Set Tx Power Complete) Status(%s)\n", Get_Status_Str( event->param.status ) );
            break;
        case RBLE_VS_EVENT_SET_PARAMS_COMP:
            printf( "\nrBLE VS EVENT (Set Params Complete) Status(%s)\n", Get_Status_Str( event->param.status ) );
            break;
        default:
            break;
    }
    Prompt_Disp();
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Enable_Test( void )
{

    RBLE_STATUS     Ret_Status;

    /* API Call */
    Ret_Status = RBLE_VS_Enable( RBLE_APP_VS_CallBack );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Test Rx Start command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Test_Rx_Start_Test( void )
{
    RBLE_STATUS     Ret_Status;
    bool            Use_Message_Flag = TRUE;

    if ( 1 == RBLE_Parameter_Cnt ) {
        if ( 39 >= RBLE_Parameter_Arg[ 0 ] ) {
            Use_Message_Flag = FALSE;
        }
    }
    if ( TRUE == Use_Message_Flag ) {
        Console_SetTextAttribute( MESSAGE_COLOR );
        printf( "VS_Test_Rx_Start Useage:TestNo RxFreq(0-39)\n" );
        Console_SetTextAttribute( COMMAND_COLOR );
    } else {
        /* API Call */
        Ret_Status = RBLE_VS_Test_Rx_Start( ( uint8_t )RBLE_Parameter_Arg[ 0 ] );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Test Tx Start command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Test_Tx_Start_Test( void )
{
    RBLE_STATUS     Ret_Status;
    bool            Use_Message_Flag = TRUE;

    if ( 3 == RBLE_Parameter_Cnt ) {
        if ( ( ( 39 >= RBLE_Parameter_Arg[ 0 ] )
            && ( ( 1 <= RBLE_Parameter_Arg[ 1 ] ) && ( 37 >= RBLE_Parameter_Arg[ 1 ] ) ) )
            && ( 7 >= RBLE_Parameter_Arg[ 2 ] ) ) {
            Use_Message_Flag = FALSE;
        }
    }
    if ( TRUE == Use_Message_Flag ) {
        Console_SetTextAttribute( MESSAGE_COLOR );
        printf( "VS_Test_Tx_Start Useage:TestNo TxFreq(0-39) DataLen(1-37) PayloadType(0-7)\n" );
        printf( "[PayloadType]\n" );
        printf( "0: Pseudo-Random bit sequence 9\n" );
        printf( "1: Pattern of alternating bits '11110000'\n" );
        printf( "2: Pattern of alternating bits '10101010'\n" );
        printf( "3: Pseudo-Random bit sequence 15\n" );
        printf( "4: Pattern of All '1' bits\n" );
        printf( "5: Pattern of All '0' bits\n" );
        printf( "6: Pattern of alternating bits '00001111'\n" );
        printf( "7: Pattern of alternating bits '0101'\n" );
        Console_SetTextAttribute( COMMAND_COLOR );
    } else {
        /* API Call */
        Ret_Status = RBLE_VS_Test_Tx_Start( ( uint8_t )RBLE_Parameter_Arg[ 0 ], ( uint8_t )RBLE_Parameter_Arg[ 1 ], ( uint8_t )RBLE_Parameter_Arg[ 2 ] );
    
        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Test End command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Test_End_Test( void )
{
    RBLE_STATUS     Ret_Status;

    /* API Call */
    Ret_Status = RBLE_VS_Test_End();

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Set Direct Test Parameter is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Test_Set_Parameter_Test( void )
{
    RBLE_STATUS     Ret_Status;
    bool            Use_Message_Flag = TRUE;

    if ( 3 == RBLE_Parameter_Cnt ) {
        if ( 2 >= RBLE_Parameter_Arg[ 2 ] ) {
            Use_Message_Flag = FALSE;
        }
    }
    if ( TRUE == Use_Message_Flag ) {
        Console_SetTextAttribute( MESSAGE_COLOR );
        printf( "VS_Test_Set_Parameter Useage:TestNo" );
        printf( "rx_max(0-65535) tx_max(0-65535) infinite_setting(0/1/2)\n" );
        Console_SetTextAttribute( COMMAND_COLOR );
    } else {
        /* API Call */
        Ret_Status = RBLE_VS_Set_Test_Parameter( ( uint16_t )RBLE_Parameter_Arg[ 0 ], ( uint16_t )RBLE_Parameter_Arg[ 1 ], ( uint8_t )RBLE_Parameter_Arg[ 2 ] );

        RBLE_Status_Disp( Ret_Status );
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Read RSSI is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Test_Read_RSSI_Test( void )
{
    RBLE_STATUS     Ret_Status;

    /* API Call */
    Ret_Status = RBLE_VS_Read_Test_RSSI();

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic write Bluetooth Address command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Write_BdAddress_Test( void )
{
    static RBLE_BD_ADDR BdAddress = { 0x45, 0x00, 0xDE, 0xFA, 0xFE, 0xCA };
    RBLE_STATUS     Ret_Status;

#if 1
    if ( 2 == RBLE_Parameter_Cnt ) {
        BdAddress.addr[ 0 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 0 ) & 0xff );
        BdAddress.addr[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 8 ) & 0xff );
        BdAddress.addr[ 2 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 16 ) & 0xff );
        BdAddress.addr[ 3 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 0 ] >> 0 ) & 0xff );
        BdAddress.addr[ 4 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 0 ] >> 8 ) & 0xff );
        BdAddress.addr[ 5 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 0 ] >> 16 ) & 0xff );
    }
#endif

    /* API Call */
    Ret_Status = RBLE_VS_Write_Bd_Address( &BdAddress );

    BdAddress_Disp( &BdAddress );
    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Set Tx Power command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Set_Tx_Power_Test( void )
{
    RBLE_STATUS     Ret_Status;
    uint8_t         Tx_Power_Lvl;
    uint8_t         Adapt_State;

    if ( 0x10 == RBLE_Parameter_Arg[0] && 2 <= RBLE_Parameter_Cnt ) {
        Tx_Power_Lvl = (uint8_t)RBLE_Parameter_Arg[1];
        if ( RBLE_VS_TXPW_LV1 > Tx_Power_Lvl ) Tx_Power_Lvl = RBLE_VS_TXPW_LV1;
        if ( RBLE_VS_TXPW_LV9 < Tx_Power_Lvl ) Tx_Power_Lvl = RBLE_VS_TXPW_LV9;

        printf( "Set to level 0x%02x w/o connection\n", Tx_Power_Lvl );
        /* API Call */
        Ret_Status = RBLE_VS_Set_Tx_Power( 0x10, Tx_Power_Lvl, RBLE_VS_TXPW_MODE_NORMAL );

        RBLE_Status_Disp( Ret_Status );
    } else {
        /* Valid Connection Handle ? */
        if ( ILLEGAL_CONNECTION_HANDLE == Connection_Handle ) {
            Illegal_Connection_Print();
        } else {
            if ( 2 >= RBLE_Parameter_Cnt ) {
                Adapt_State = RBLE_VS_TXPW_MODE_NORMAL;
            } else {
                Adapt_State = (uint8_t)RBLE_Parameter_Arg[2];
            }
            if ( 1 >= RBLE_Parameter_Cnt ) {
                Tx_Power_Lvl = RBLE_VS_TXPW_LV1;
            } else {
                Tx_Power_Lvl = (uint8_t)RBLE_Parameter_Arg[1];
                if ( RBLE_VS_TXPW_LV1 > Tx_Power_Lvl ) Tx_Power_Lvl = RBLE_VS_TXPW_LV1;
                if ( RBLE_VS_TXPW_LV9 < Tx_Power_Lvl ) Tx_Power_Lvl = RBLE_VS_TXPW_LV9;
            }
            printf( "Level: 0x%02x, State: 0x%02x\n", Tx_Power_Lvl, Adapt_State );
            /* API Call */
            Ret_Status = RBLE_VS_Set_Tx_Power( Connection_Handle, Tx_Power_Lvl, Adapt_State );
    
            RBLE_Status_Disp( Ret_Status );
        }
    }
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic GPIO Dir command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_GPIO_Dir_Test( void )
{
    RBLE_STATUS     Ret_Status;

    /* Set GPIO direction */
    if ( 0 == RBLE_Parameter_Cnt ) {
        RBLE_VS_GPIO_DIR_SETTING(GPIO_Dir, RBLE_VS_GPIO_BIT_0, RBLE_VS_GPIO_INPUT);
        RBLE_VS_GPIO_DIR_SETTING(GPIO_Dir, RBLE_VS_GPIO_BIT_1, RBLE_VS_GPIO_OUTPUT);
        RBLE_VS_GPIO_DIR_SETTING(GPIO_Dir, RBLE_VS_GPIO_BIT_2, RBLE_VS_GPIO_INPUT);
        RBLE_VS_GPIO_DIR_SETTING(GPIO_Dir, RBLE_VS_GPIO_BIT_3, RBLE_VS_GPIO_OUTPUT);
    }
    else {
        GPIO_Dir = (uint8_t)RBLE_Parameter_Arg[0];
    }

    printf( "Direction: 0x%02x\n", GPIO_Dir );

    /* API Call */
    Ret_Status = RBLE_VS_GPIO_Dir( GPIO_Dir );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic GPIO Access command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_GPIO_Access_Test( void )
{
    RBLE_STATUS     Ret_Status;

    if ( 0 == RBLE_Parameter_Cnt ) {
        GPIO_Mode = RBLE_VS_GPIO_OUTPUT_MD;
//      GPIO_Mode = RBLE_VS_GPIO_INPUT_MD;
    }
    else {
        if ( RBLE_VS_GPIO_OUTPUT_MD == RBLE_Parameter_Arg[0] ) {
            GPIO_Mode = RBLE_VS_GPIO_OUTPUT_MD;
        }
        else {
            GPIO_Mode = RBLE_VS_GPIO_INPUT_MD;
        }
    }

    if ( RBLE_VS_GPIO_OUTPUT_MD == GPIO_Mode )
    {
        /* Set GPIO output value */
        if ( 2 <= RBLE_Parameter_Cnt ) {
            GPIO_Value = (uint8_t)RBLE_Parameter_Arg[1];
        }
        else {
            RBLE_VS_GPIO_OUTPUT_SETTING(GPIO_Value, RBLE_VS_GPIO_BIT_0, RBLE_VS_GPIO_LOW);
            RBLE_VS_GPIO_OUTPUT_SETTING(GPIO_Value, RBLE_VS_GPIO_BIT_1, RBLE_VS_GPIO_HIGH);
            RBLE_VS_GPIO_OUTPUT_SETTING(GPIO_Value, RBLE_VS_GPIO_BIT_2, RBLE_VS_GPIO_LOW);
            RBLE_VS_GPIO_OUTPUT_SETTING(GPIO_Value, RBLE_VS_GPIO_BIT_3, RBLE_VS_GPIO_HIGH);
        }
    }
    else
    {
        GPIO_Value = 0x00;
    }

    printf( "Mode: " );
    (RBLE_VS_GPIO_OUTPUT_MD==GPIO_Mode)?printf( "Output Mode\n" ):printf( "Input Mode\n" );
    printf( "Value: 0x%02x\n", GPIO_Value );

    /* API Call */
    Ret_Status = RBLE_VS_GPIO_Access( GPIO_Mode, GPIO_Value );

    RBLE_Status_Disp( Ret_Status );
    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Data Flash Management command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Flash_Management_Test( void )
{
    RBLE_STATUS     Ret_Status;
    uint8_t         Flash_cmd;

    if ( 0 == RBLE_Parameter_Cnt ) {
        Flash_cmd = RBLE_VS_FLASH_CMD_START;
    }
    else {
        Flash_cmd = (uint8_t)RBLE_Parameter_Arg[0];
    }

    printf( "Command: %d\n", Flash_cmd );

    if ( ( Flash_cmd == RBLE_VS_FLASH_CMD_START ) || ( Flash_cmd == RBLE_VS_FLASH_CMD_STOP ) ) {
        /* API Call */
        Ret_Status = RBLE_VS_Flash_Management( Flash_cmd );
    }
    else {
        printf( "You should specify a parameter: %d (Start) or %d (Stop)\n", RBLE_VS_FLASH_CMD_START, RBLE_VS_FLASH_CMD_STOP );
        Ret_Status = RBLE_PARAM_ERR;
    }
    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Data Flash Access command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Flash_Access_Test( void )
{
    RBLE_STATUS     Ret_Status;
    RBLE_VS_FLASH_ACCESS_PARAM param;
    uint8_t         bda[6] = { 0x45, 0x00, 0xDE, 0xFA, 0xFE, 0xCA };

    param.id   = 0x01;
    param.size = 6;

    if ( 0 == RBLE_Parameter_Cnt ) {
        param.cmd  = RBLE_VS_FLASH_CMD_WRITE;
        memcpy( FlashAccessData_buf, bda, 6 );
    }
    else if ( 1 <= RBLE_Parameter_Cnt ) {
        if ( 0 == RBLE_Parameter_Arg[0] ) {
            param.cmd  = RBLE_VS_FLASH_CMD_WRITE;
            memcpy( FlashAccessData_buf, bda, 6 );
        }
        else {
            param.cmd  = RBLE_VS_FLASH_CMD_READ;
            memset( FlashAccessData_buf, 0, 6 );
        }
    }

    param.addr = FlashAccessData_buf;

    /* API Call */
    Ret_Status = RBLE_VS_Flash_Access( &param );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Data Flash Operation command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Flash_Operation_Test( void )
{
    RBLE_STATUS     Ret_Status;
    uint8_t         Flash_cmd;

    if ( 0 == RBLE_Parameter_Cnt ) {
        Flash_cmd = RBLE_VS_FLASH_CMD_CLEANUP;
    }
    else {
        Flash_cmd = (uint8_t)RBLE_Parameter_Arg[0];
    }

    printf( "Command: %d\n", Flash_cmd );

    if ( ( Flash_cmd == RBLE_VS_FLASH_CMD_CLEANUP ) || ( Flash_cmd == RBLE_VS_FLASH_CMD_FORMAT ) ) {
        /* API Call */
        Ret_Status = RBLE_VS_Flash_Operation( Flash_cmd );
    }
    else {
        printf( "You should specify a parameter: %d (Clean up) or %d (Format)\n", RBLE_VS_FLASH_CMD_CLEANUP, RBLE_VS_FLASH_CMD_FORMAT );
        Ret_Status = RBLE_PARAM_ERR;
    }
    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Data Flash Get Space command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Flash_Get_Space_Test( void )
{
    RBLE_STATUS     Ret_Status;

    /* API Call */
    Ret_Status = RBLE_VS_Flash_Get_Space();
    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Data Flash Get EEL Version command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Flash_Get_EEL_Ver_Test( void )
{
    RBLE_STATUS     Ret_Status;

    /* API Call */
    Ret_Status = RBLE_VS_Flash_Get_EEL_Ver();
    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic Adaptable Function Enable command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Adapt_Enable_Test( void )
{
    RBLE_STATUS     Ret_Status;
    uint8_t         Adapt_cmd;

    if ( 0 == RBLE_Parameter_Cnt ) {
        Adapt_cmd = RBLE_VS_ADAPT_CMD_ENABLE;
    }
    else {
        Adapt_cmd = (uint8_t)RBLE_Parameter_Arg[0];
    }

    printf( "Command: 0x%02x  ", Adapt_cmd );
    switch (Adapt_cmd) {
    case RBLE_VS_ADAPT_CMD_DISABLE:
        printf( "(Disable)\n" );
        break;
    case RBLE_VS_ADAPT_CMD_ENABLE:
        printf( "(Enable)\n" );
        break;
    case RBLE_VS_ADAPT_CMD_ENABLE_WO_IND:
        printf( "(Enable Without State Indication)\n" );
        break;
    default:
        printf( "(Not Supported)\n" );
        break;
    }

    /* API Call */
    Ret_Status = RBLE_VS_Adapt_Enable( Adapt_cmd );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic RF Control command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_RF_Control_Test( void )
{
    RBLE_STATUS     Ret_Status;
    uint8_t         rf_ctrl_cmd;

    if ( 0 == RBLE_Parameter_Cnt ) {
        rf_ctrl_cmd = RBLE_VS_RFCNTL_CMD_POWDOWN;
    }
    else {
        rf_ctrl_cmd = (uint8_t)RBLE_Parameter_Arg[0];
    }

    printf( "Command: 0x%02x  ", rf_ctrl_cmd );
    switch (rf_ctrl_cmd) {
    case RBLE_VS_RFCNTL_CMD_POWDOWN:
        printf( "(Pow-down)\n" );
        break;
    case RBLE_VS_RFCNTL_CMD_POWUP_DDCON:
        printf( "(Pow-up:ddcon)\n" );
        break;
    case RBLE_VS_RFCNTL_CMD_POWUP_DDCOFF:
        printf( "(Pow-up:ddcoff)\n" );
        break;
    default:
        printf( "(Not Supported)\n" );
        break;
    }

    /* API Call */
    Ret_Status = RBLE_VS_RF_Control( rf_ctrl_cmd );

    RBLE_Status_Disp( Ret_Status );

    return( TRUE );
}

/******************************************************************************************/
/**
 *  @brief A Vendor Specfic set parameters command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_VS_Set_Params_Test( void )
{
    RBLE_STATUS     Ret_Status;
    uint8_t         data[2];

    if ( 2 == RBLE_Parameter_Cnt ) {
        /* API Call */
        data[ 0 ] = ( uint8_t )( RBLE_Parameter_Arg[ 1 ] & 0xff );
        data[ 1 ] = ( uint8_t )( ( RBLE_Parameter_Arg[ 1 ] >> 8 ) & 0xff );

        Ret_Status = RBLE_VS_Set_Params( (uint8_t)RBLE_Parameter_Arg[ 0 ], 2, data );

        RBLE_Status_Disp( Ret_Status );
    } else {
        Console_SetTextAttribute( MESSAGE_COLOR );
        printf( "VS_Set_Params Usage:\n" );
        printf( "param_id(0-12) param_data(0-65535)\n" );
        Console_SetTextAttribute( COMMAND_COLOR );
    }

    return( TRUE );
}
#endif


#if defined(USE_FW_UPDATE_PROFILE)&&defined(WIN32)
/******************************************************************************************/
/**
 *  @brief Firmware Update start command is executed. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval TRUE     Menu Continue
 */
/******************************************************************************************/
static BOOL RBLE_FW_UPDATE_Test()
{
    uint8_t file_num = 0;
    uint8_t start_area = 0;
    
    if ( 0 < RBLE_Parameter_Cnt ) {
        if ( 1 < RBLE_Parameter_Cnt ) {
            start_area = (uint8_t)RBLE_Parameter_Arg[ 1 ];
        }
        file_num = (uint8_t)RBLE_Parameter_Arg[ 0 ];
    }
            
    /* start fw update */
    FW_Update_Sender_Start(file_num, start_area);
    
    return( TRUE );
}
#endif


/******************************************************************************************/
/**
 *  @brief A Bluetooth address is displayed on a monitor. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *Addr_p     Pointer to Bluetooth Address 
 *
 *  @retval
 */
/******************************************************************************************/
void BdAddress_Disp( RBLE_BD_ADDR *Addr_p )
{

    printf( "Addr[%02x:%02x:%02x:%02x:%02x:%02x]\n", Addr_p->addr[ 5 ], Addr_p->addr[ 4 ], Addr_p->addr[ 3 ], Addr_p->addr[ 2 ], Addr_p->addr[ 1 ], Addr_p->addr[ 0 ] );
}

/******************************************************************************************/
/**
 *  @brief An Advertising report is displayed on a monitor.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *Report_p     Pointer to Advertising report
 *
 *  @retval
 */
/******************************************************************************************/
void AdvRepot_Disp( RBLE_ADV_REPORT *Report_p )
{
    int_t       i;

    printf( "EventType(0x%x), AddressType(0x%x)\n", Report_p->evt_type, Report_p->adv_addr_type );
    BdAddress_Disp( &Report_p->adv_addr );
    printf( "Data(0x%x)\n", Report_p->data_len );
    for ( i = 0;i <  Report_p->data_len;i++ ) {
        if ( 0 != i ) {
            if ( 0 == ( i % 8 ) ) {
                printf( "\n" );
            } else {
                printf( "," );
            }
        }
        printf( "0x%02x", Report_p->data[ i ] );
    }
    printf( "\nRSSI(%d)\n", (int8_t)(Report_p->rssi) );
}


void Uuid128_Disp( uint8_t *p )
{
    int_t       i;

    for ( i = RBLE_GATT_128BIT_UUID_OCTET - 1 ;i >= 0;i-- ) {
        printf( "%02X", p[ i ] );
    }
}

/******************************************************************************************/
/**
 *  @brief A rBLE Status is displayed on a monitor.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] Status     rBLE Status
 *
 *  @retval
 */
/******************************************************************************************/
void RBLE_Status_Disp( RBLE_STATUS Status )
{
    printf( "Status(%s)\n",Get_Status_Str( Status ) );
}

/******************************************************************************************/
/**
 *  @brief Key Indicate Event Parameter is displayed on a monitor.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *Key_p     Pointer to Key Indicate Event Parameter
 *
 *  @retval
 */
/******************************************************************************************/
void KeyDisp( struct RBLE_EVT_SM_Key_t *Key_p )
{
    printf( "idx = %d", Key_p->idx );
    printf( ",  ediv = %d", Key_p->ediv );
    printf( ",  key_code = %s\n", Key_Code_Str[ Key_p->key_code ] );
    RandomDataDisp( &Key_p->nb );
    KeyDataDisp( &Key_p->ltk );
}

/******************************************************************************************/
/**
 *  @brief Random Data is displayed on a monitor.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *p     Pointer to Random Data
 *
 *  @retval
 */
/******************************************************************************************/
void RandomDataDisp( RBLE_RAND_NB *p )
{
    int32_t         i;

    printf( "RandamData:" );
    for ( i = 0;i <  RBLE_RAND_NB_LEN;i++ ) {
        if ( 0 != i ) {
            if ( 0 == ( i % 16 ) ) {
                printf( "\n" );
            } else {
                printf( "," );
            }
        }
        printf( "%02x", p->nb[ i ] );
    }
    printf( "\n" );
}

/******************************************************************************************/
/**
 *  @brief Key Data is displayed on a monitor.
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] *p     Pointer to Key Data
 *
 *  @retval
 */
/******************************************************************************************/
void KeyDataDisp( RBLE_KEY_VALUE *p )
{
    int32_t         i;
    printf( "\nKeyData:" );
    for ( i = 0;i <  RBLE_KEY_LEN;i++ ) {
        if ( 0 != i ) {
            if ( 0 == ( i % 16 ) ) {
                printf( "\n" );
            } else {
                printf( "," );
            }
        }
        printf( "%02x", p->key[ i ] );
    }
    printf( "\n" );
}

/******************************************************************************************/
/**
 *  @brief rBLE Status is changed into a character string. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] Status      rBLE Status
 *
 *  @retval Pointer to character string
 */
/******************************************************************************************/
char_t  *Get_Status_Str( RBLE_STATUS Status )
{
typedef struct Status_Message_Info_t {
    RBLE_STATUS     Status;
    char_t          *Message_Top;
} STATUS_MESSAGE_INFO;

    static const STATUS_MESSAGE_INFO Message[] = {
        { RBLE_OK,                              "RBLE_OK" },
        { RBLE_UNKNOWN_HCI_COMMAND,             "UNKNOWN_HCI_COMMAND" },
        { RBLE_UNKNOWN_CONNECTION_ID,           "UNKNOWN_CONNECTION_ID" },
        { RBLE_HARDWARE_FAILURE,                "HARDWARE_FAILURE" },
        { RBLE_PAGE_TIMEOUT,                    "PAGE_TIMEOUT" },
        { RBLE_AUTH_FAILURE,                    "AUTH_FAILURE" },
        { RBLE_PIN_MISSING,                     "PIN_MISSING" },
        { RBLE_MEMORY_CAPA_EXCEED,              "MEMORY_CAPA_EXCEED" },
        { RBLE_CON_TIMEOUT,                     "CON_TIMEOUT" },
        { RBLE_CON_LIMIT_EXCEED,                "CON_LIMIT_EXCEED" },
        { RBLE_COMMAND_DISALLOWED,              "COMMAND_DISALLOWED" },
        { RBLE_CONN_REJ_LIMITED_RESOURCES,      "CONN_REJ_LIMITED_RESOURCES" },
        { RBLE_CONN_REJ_SECURITY_REASONS,       "CONN_REJ_SECURITY_REASONS" },
        { RBLE_CONN_REJ_UNACCEPTABLE_BDADDR,    "CONN_REJ_UNACCEPTABLE_BDADDR" },
        { RBLE_CONN_ACCEPT_TIMEOUT_EXCEED,      "CONN_ACCEPT_TIMEOUT_EXCEED" },
        { RBLE_UNSUPPORTED,                     "UNSUPPORTED" },
        { RBLE_INVALID_HCI_PARAM,               "INVALID_HCI_PARAM" },
        { RBLE_REMOTE_USER_TERM_CON,            "REMOTE_USER_TERM_CON" },
        { RBLE_REMOTE_DEV_TERM_LOW_RESOURCES,   "REMOTE_DEV_TERM_LOW_RESOURCES" },
        { RBLE_REMOTE_DEV_POWER_OFF,            "REMOTE_DEV_POWER_OFF" },
        { RBLE_CON_TERM_BY_LOCAL_HOST,          "CON_TERM_BY_LOCAL_HOST" },
        { RBLE_REPEATED_ATTEMPTS,               "REPEATED_ATTEMPTS" },
        { RBLE_PAIRING_NOT_ALLOWED,             "PAIRING_NOT_ALLOWED" },
        { RBLE_UNSUPPORTED_REMOTE_FEATURE,      "UNSUPPORTED_REMOTE_FEATURE" },
        { RBLE_UNSPECIFIED_ERROR,               "UNSPECIFIED_ERROR" },
        { RBLE_LMP_RSP_TIMEOUT,                 "LMP_RSP_TIMEOUT" },
        { RBLE_ENC_MODE_NOT_ACCEPT,             "ENC_MODE_NOT_ACCEPT" },
        { RBLE_LINK_KEY_CANT_CHANGE,            "LINK_KEY_CANT_CHANGE" },
        { RBLE_INSTANT_PASSED,                  "INSTANT_PASSED" },
        { RBLE_PAIRING_WITH_UNIT_KEY_NOT_SUP,   "PAIRING_WITH_UNIT_KEY_NOT_SUP" },
        { RBLE_DIFF_TRANSACTION_COLLISION,      "DIFF_TRANSACTION_COLLISION" },
        { RBLE_CHANNEL_CLASS_NOT_SUP,           "CHANNEL_CLASS_NOT_SUP" },
        { RBLE_INSUFFICIENT_SECURITY,           "INSUFFICIENT_SECURITY" },
        { RBLE_PARAM_OUT_OF_MAND_RANGE,         "PARAM_OUT_OF_MAND_RANGE" },
        { RBLE_SP_NOT_SUPPORTED_HOST,           "SP_NOT_SUPPORTED_HOST" },
        { RBLE_HOST_BUSY_PAIRING,               "HOST_BUSY_PAIRING" },
        { RBLE_CONTROLLER_BUSY,                 "CONTROLLER_BUSY" },
        { RBLE_UNACCEPTABLE_CONN_INT,           "UNACCEPTABLE_CONN_INT" },
        { RBLE_DIRECT_ADV_TO,                   "DIRECT_ADV_TO" },
        { RBLE_TERMINATED_MIC_FAILURE,          "TERMINATED_MIC_FAILURE" },
        { RBLE_CONN_FAILED_TO_BE_ES,            "CONN_FAILED_TO_BE_ES" },
        { RBLE_GAP_INVALID_PARAM_ERR,           "GAP_INVALID_PARAM_ERR" },
        { RBLE_GAP_AUTO_EST_ERR,                "GAP_AUTO_EST_ERR" },
        { RBLE_GAP_SELECT_EST_ERR,              "GAP_SELECT_EST_ERR" },
        { RBLE_GAP_SET_RECON_ADDR_ERR,          "GAP_SET_RECON_ADDR_ERR" },
        { RBLE_GAP_SET_PRIVACY_FEAT_ERR,        "GAP_SET_PRIVACY_FEAT_ERR" },
        { RBLE_GATT_INVALID_PARAM_ERR,          "GATT_INVALID_PARAM_ERR" },
        { RBLE_GATT_INDICATE_NOT_ALLOWED,       "GATT_INDICATE_NOT_ALLOWED" },
        { RBLE_GATT_NOTIFY_NOT_ALLOWED,         "GATT_NOTIFY_NOT_ALLOWED" },
        { RBLE_ATT_INVALID_PARAM_ERR,           "ATT_INVALID_PARAM_ERR" },
        { RBLE_SM_INVALID_PARAM_ERR,            "SM_INVALID_PARAM_ERR" },
        { RBLE_SM_PAIR_ERR_PASSKEY_ENTRY_FAILED,"SM_PAIR_ERR_PASSKEY_ENTRY_FAILED" },
        { RBLE_SM_PAIR_ERR_OOB_NOT_AVAILABLE,   "SM_PAIR_ERR_OOB_NOT_AVAILABLE" },
        { RBLE_SM_PAIR_ERR_AUTH_REQUIREMENTS,   "SM_PAIR_ERR_AUTH_REQUIREMENTS" },
        { RBLE_SM_PAIR_ERR_CFM_VAL_FAILED,      "SM_PAIR_ERR_CFM_VAL_FAILED" },
        { RBLE_SM_PAIR_ERR_PAIRING_NOT_SUPPORTED,"SM_PAIR_ERR_PAIRING_NOT_SUPPORTED" },
        { RBLE_SM_PAIR_ERR_ENCRYPTION_KEY_SIZE, "SM_PAIR_ERR_ENCRYPTION_KEY_SIZE" },
        { RBLE_SM_PAIR_ERR_CMD_NOT_SUPPORTED,   "SM_PAIR_ERR_CMD_NOT_SUPPORTED" },
        { RBLE_SM_PAIR_ERR_UNSPECIFIED_REASON,  "SM_PAIR_ERR_UNSPECIFIED_REASON" },
        { RBLE_SM_PAIR_ERR_REPEATED_ATTEMPTS,   "SM_PAIR_ERR_REPEATED_ATTEMPTS" },
        { RBLE_SM_PAIR_ERR_INVALID_PARAMS,      "SM_PAIR_ERR_INVALID_PARAMS" },
        { RBLE_L2C_INVALID_PARAM_ERR,           "L2C_INVALID_PARAM_ERR" },
        { RBLE_PRF_ERR_INVALID_PARAM,           "PRF_ERR_INVALID_PARAM" },
        { RBLE_PRF_ERR_INEXISTENT_HDL,          "PRF_ERR_INEXISTENT_HDL" },
        { RBLE_PRF_ERR_STOP_DISC_CHAR_MISSING,  "PRF_ERR_INEXISTENT_HDL" },
        { RBLE_PRF_ERR_MULTIPLE_IAS,            "PRF_ERR_MULTIPLE_IAS" },
        { RBLE_PRF_ERR_INCORRECT_PROP,          "PRF_ERR_INCORRECT_PROP" },
        { RBLE_PRF_ERR_MULTIPLE_CHAR,           "PRF_ERR_MULTIPLE_CHAR" },
        { RBLE_PRF_ERR_NOT_WRITABLE,            "PRF_ERR_NOT_WRITABLE" },
        { RBLE_PRF_ERR_NOT_READABLE,            "PRF_ERR_NOT_READABLE" },
        { RBLE_PRF_ERR_REQ_DISALLOWED,          "PRF_ERR_REQ_DISALLOWED" },
        { RBLE_PRF_ERR_NTF_DISABLED,            "PRF_ERR_NTF_DISABLED" },
        { RBLE_PRF_ERR_IND_DISABLED,            "PRF_ERR_IND_DISABLED" },
        { RBLE_PRF_ERR_ATT_NOT_SUPPORTED,       "PRF_ERR_ATT_NOT_SUPPORTED" },

/*------ When adding it, it's added in after a while. -----*/
        { RBLE_TRANS_ERR,                       "TRANS_ERR" },
        { RBLE_STATUS_ERROR,                    "STATUS_ERROR" },
        { RBLE_PARAM_ERR,                       "PARAM_ERR" },
        { RBLE_BUSY,                            "BUSY" },
        { RBLE_SHORTAGE_OF_RESOURCE,            "SHORTAGE_OF_RESOURCE" },
        { RBLE_VERSION_FAIL,                    "VERSION FAIL" },
        { RBLE_TEST_VERSION,                    "TEST VERSION" },
        { RBLE_ERR,                             "UNKNOWN STATUS" },
    };

    const STATUS_MESSAGE_INFO   *p;
    char_t                      *Ret_p;

    for ( Ret_p = NULL, p = Message; RBLE_ERR != p->Status;p++ ) {
        if ( Status == p->Status ) {
            Ret_p = p->Message_Top;
            break;
        }
    }
    if ( NULL == Ret_p ) {
        Ret_p = p->Message_Top;
    }
    return( Ret_p );
}


char_t  *Get_Att_Code_Str( uint8_t att_code )
{
    char_t  *p;

    switch ( att_code ) {
    case RBLE_ATT_ERR_NO_ERROR:
        p = "NO_ERROR";
        break;
    case RBLE_ATT_ERR_INVALID_HANDLE:
        p = "INVALID_HANDLE";
        break;
    case RBLE_ATT_ERR_READ_NOT_PERMITTED:
        p = "RD_NOT_PERMITTED";
        break;
    case RBLE_ATT_ERR_WRITE_NOT_PERMITTED:
        p = "WR_NOT_PERMITTED";
        break;
    case RBLE_ATT_ERR_INVALID_PDU:
        p = "INVALID_PDU";
        break;
    case RBLE_ATT_ERR_INSUFF_AUTHEN:
        p = "INSUFF_AUTHEN";
        break;
    case RBLE_ATT_ERR_REQUEST_NOT_SUPPORTED:
        p = "REQUEST_NOT_SUPPORTED";
        break;
    case RBLE_ATT_ERR_INVALID_OFFSET:
        p = "INVALID_OFFSET";
        break;
    case RBLE_ATT_ERR_INSUFF_AUTHOR:
        p = "INSUFF_AUTHOR";
        break;
    case RBLE_ATT_ERR_PREPARE_QUEUE_FULL:
        p = "PREPARE_QUEUE_FULL";
        break;
    case RBLE_ATT_ERR_ATTRIBUTE_NOT_FOUND:
        p = "ATTRIBUTE_NOT_FOUND";
        break;
    case RBLE_ATT_ERR_ATTRIBUTE_NOT_LONG:
        p = "ATTRIBUTE_NOT_LONG";
        break;
    case RBLE_ATT_ERR_INSUFF_ENC_KEY_SIZE:
        p = "INSUFF_ENC_KEY_SIZE";
        break;
    case RBLE_ATT_ERR_INVALID_ATTRIBUTE_VAL_LEN:
        p = "INVALID_ATTRIBUTE_VAL_LEN";
        break;
    case RBLE_ATT_ERR_UNLIKELY_ERR:
        p = "UNLIKELY_ERR";
        break;
    case RBLE_ATT_ERR_INSUFF_ENC:
        p = "INSUFF_ENC";
        break;
    case RBLE_ATT_UNSUPP_GRP_TYPE:
        p = "UNSUPP_GRP_TYPE";
        break;
    case RBLE_ATT_INSUFF_RESOURCE:
        p = "INSUFF_RESOURCE";
        break;
    case RBLE_ATT_ERR_APP_ERROR:
        p = "APP_ERROR";
        break;
    default:
        p = "UNKNOWN";
        break;
    }
    return( p );
}

/******************************************************************************************/
/**
 *  @brief rBLE Status is changed into a character string. 
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] Status      rBLE Status
 *
 *  @retval Pointer to character string
 */
/******************************************************************************************/
void ATT_Info_Disp( RBLE_ATT_INFO_DATA *p )
{
    printf( "\nATT_Information each_len = %d\n", p->each_len );
    printf( "Value = " );
    Print_Dump( p->data, p->len );
}

void Print_Dump( uint8_t *p, uint16_t len )
{
    uint16_t    i;
    int8_t      c;

    for ( i = 0; i < len; i++ ) {
        if ( 0 != i ) {
            if ( 0 == ( i % 16 ) ) {
                printf( "\n" );
            } else {
                printf( " " );
            }
        }
        printf( "%02X", p[ i ] );
    }
    printf( "\n--\n" );

    for ( i = 0; i < len; i++ ) {
        if ( 0 != i ) {
            if ( 0 == ( i % 16 ) ) {
                printf( "\n" );
            }
        }
        c = p[ i ];
        printf("%c", ( ((c>=32)&&(c<=126)) ? c : '.' ) );
    }
    printf( "\n" );
}

/******************************************************************************************/
/**
 *  @brief Disp select parameter NO
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @param[in] Status      rBLE Status
 *
 *  @retval Pointer to character string
 */
/******************************************************************************************/
void Select_Param_No_Disp( uint32_t no )
{
    printf( "Select Parameter No %ld\n",  no );
}

/******************************************************************************************/
/**
 *  @brief Disp Connection handle
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @retval Pointer to character string
 */
/******************************************************************************************/
void Connection_Handle_Disp( uint16_t conhdl )
{
    printf( "Connection Handle = %d\n", conhdl );
}

/******************************************************************************************/
/**
 *  @brief Disp Illegal Connection handle message
 *
 *
 *  @attention
 *  
 *  @b Contents of management:
 *
 *  @retval Pointer to character string
 */
/******************************************************************************************/
void Illegal_Connection_Print( void )
{
    printf( "Illegal Connection Handle\n" );
}

#if defined(USE_BLPC_SAMPLE)|defined(USE_GLPC_SAMPLE)
/******************************************************************************************/
/**
 *  @brief SFLOAT to float
 *
 *  @b Contents of management:
 *
 *  @param[in] sf      SFLOAT value
 *
 *  @retval float value
 */
/******************************************************************************************/
float SFLOAT2FLOAT( uint16_t sf )
{
    int16_t a, i, n;
    float   b, ret;

    a = ( sf & 0xFFF );
    if ( 0 != ( a & 0x800 ) ) {
        a |= 0xF000;
    }
    n = (( sf & 0xF000 ) >> 12);
    if ( 0 != ( n & 0x8 ) ) {
        n |= 0xFFF0;
    }
    b = 1;
    if ( 0 <= n ) {
        for (i = 0; i < n;  i++ ) {
            b = (float)(b * 10);
        }
    } else {
        for (i = n; i != 0;  i++ ) {
            b = (float)(b * 0.1);
        }
    }
    ret = ( float )( a * b );
    return( ret );
}

/******************************************************************************************/
/**
 *  @brief Display BLP  Measurements Info
 *
 *  @b Contents of management:
 *
 *  @param[in] *p      BLP Measurements Info
 *
 *  @retval none
 */
/******************************************************************************************/
void BLP_Info_Disp( RBLE_BLP_MEASUREMENTS_INFO *p )
{
    const char *unit[] = { "mmHg", "kPa" };
    float p1, p2, p3;

    if ( 0 != p->flag_stable_meas ) {
        p1 = SFLOAT2FLOAT( p->press_val_field1 );
        p2 = SFLOAT2FLOAT( p->press_val_field2 );
        p3 = SFLOAT2FLOAT( p->press_val_field3 );
        printf("S:%3.1f, D:%3.1f, M:%3.1f (%s)\n",p1,p2,p3, unit[(p->flags & 0x01)]);
    } else {
        p1 = SFLOAT2FLOAT( p->press_val_field1 );
        printf("  Cuff      : %3.1f (%s)\n", p1, unit[(p->flags & 0x01)]);
    }
    
    /* Timestamp Present ? */
    if ( 0 != (p->flags & 0x02) ) {
        printf("TS: %d/%02d/%02d %02d:%02d:%02d\n",  p->stamp.year,
                                                     p->stamp.month,
                                                     p->stamp.day,
                                                     p->stamp.hour,
                                                     p->stamp.min,
                                                     p->stamp.sec);
    }

    /* Pulse Rate Present ? */
    if ( 0 != (p->flags & 0x04) ) {
        p1 = SFLOAT2FLOAT( p->rate );
        printf("Rate:%3.1f\n", p1);
    }

    /* User ID Present ? */
    if ( 0 != (p->flags & 0x08) ) {
        printf("UserID:%d\n", p->id);
    }

    /* Measurement Status Present ? */
    if ( 0 != (p->flags & 0x10) ) {
        printf("M.Sts:%04X\n", p->meas_sts);
    }
}
#endif

/******************************************************************************************/
/**
 *  @brief Display HTP TEMP Info
 *
 *  @b Contents of management:
 *
 *  @param[in] *p      HTP TEMP Info
 *
 *  @retval none
 */
/******************************************************************************************/
#ifdef USE_HTPC_SAMPLE
void HTP_Info_Disp( RBLE_HTP_TEMP_INFO *p )
{
    uint8_t l_cnt,i;
    uint8_t l_val[16] ={0};
    uint8_t *p_l_val = &l_val[0];
    float   f_val;
    int8_t  exponent;
    const char  *unit[] = { "C", "F" };
    const char  *type_chr[] =
    {
        "Reserved                ",
        "Armpit                  ",
        "Body (general)          ",
        "Ear (usually ear lobe)  ",
        "Finger                  ",
        "Gastro-intestinal Tract ",
        "Mouth                   ",
        "Rectum                  ",
        "Toe                     ",
        "Tympanum (ear drum)     "
    };
    
    printf("flag_stable_meas = %d\n", p->flag_stable_meas );
    printf("flags            = %d\n\n", p->flags );
    *p_l_val++ = p->flags;
    
    {
        exponent = (int8_t)((p->temp_val>>24)&0x000000FF);
        f_val = (float)(p->temp_val&0x00FFFFFF);
        if(0 <= exponent){
            for(i=0 ; i<exponent ; i++){
                f_val *= (float)10;
            }
        }else{
            for(i=exponent ; i !=0 ; i++){
                f_val *= (float)0.1;
            }
        }
        printf("  Temperature      : %3.1f (%s)\n", f_val, unit[(p->flags & 0x01)]);
        *p_l_val++ = (uint8_t)((p->temp_val    )&0x000000FF);
        *p_l_val++ = (uint8_t)((p->temp_val>> 8)&0x000000FF);
        *p_l_val++ = (uint8_t)((p->temp_val>>16)&0x000000FF);
        *p_l_val++ = (uint8_t)((p->temp_val>>24)&0x000000FF);
        l_cnt = 5;
    }
    /* Timestamp Present ? */
    if ( 0 != (p->flags & 0x02) ) {
        printf("  Time Stamp       : %d/%02d/%02d %02d:%02d:%02d\n",    p->stamp.year,
                                                                        p->stamp.month,
                                                                        p->stamp.day,
                                                                        p->stamp.hour,
                                                                        p->stamp.min,
                                                                        p->stamp.sec);
        *p_l_val++ = (uint8_t)((p->stamp.year    )&0x00FF);
        *p_l_val++ = (uint8_t)((p->stamp.year>> 8)&0x00FF);
        *p_l_val++ = p->stamp.month;
        *p_l_val++ = p->stamp.day;
        *p_l_val++ = p->stamp.hour;
        *p_l_val++ = p->stamp.min;
        *p_l_val++ = p->stamp.sec;
        l_cnt += 7;
    }
    /* Temperature Type Present ? */
    if ( 0 != (p->flags & 0x04) ) {
        if(10 > p->type){
            printf("  Temperature Type : %d -> %s\n", p->type, type_chr[p->type] );
        }else{
            printf("  Temperature Type : %d -> %s\n", p->type, type_chr[0] );
        }
        *p_l_val++ = p->type;
        l_cnt += 1;
    }
    printf("  Value            : 0x");
    for(i=0 ; i<l_cnt ; i++){
        printf("%02X", l_val[i] );
    }
    printf("\n");
}
#endif

#if defined(USE_HGBH_SAMPLE)|defined(USE_HGRH_SAMPLE)
/******************************************************************************************/
/**
 *  @brief Display HGP CONTENT Info
 *
 *  @b Contents of management:
 *
 *  @param[in] 
 *
 *  @retval none
 */
/******************************************************************************************/
void HGP_Info_Disp( RBLE_HIDS_CONTENT *hids, RBLE_DIS11_CONTENT *dis, RBLE_BAS_CONTENT *bas, uint8_t hids_inst_num, uint8_t bas_inst_num )
{
    uint8_t i;
    
    for(i=0 ; i<hids_inst_num ; i++){
    printf( "* HIDS(Inst:%d), Start=%X, End=%X \n", i, hids->shdl, hids->ehdl );
    printf( " Prtcl Md AttHdl=%X, Prop=%X, Hdl=%X\n", hids->protocol_md_char_hdl, hids->protocol_md_prop, hids->protocol_md_val_hdl );
    printf( " Rep.In AttHdl=%X, Prop=%X, Hdl=%X, Cfg=%X, Ref=%X\n", hids->report_input_char_hdl, hids->report_input_prop, hids->report_input_val_hdl,
                                                                      hids->report_input_cfg_hdl, hids->input_rep_ref_hdl);
    printf( " Rep.Out AttHdl=%X, Prop=%X, Hdl=%X, Ref=%X\n", hids->report_output_char_hdl, hids->report_output_prop, hids->report_output_val_hdl,
                                                               hids->output_rep_ref_hdl );
    printf( " Rep.Feat AttHdl=%X, Prop=%X, Hdl=%X, Ref=%X\n", hids->report_feature_char_hdl, hids->report_feature_prop, hids->report_feature_val_hdl,
                                                              hids->feature_rep_ref_hdl );
    printf( " Rep.Map AttHdl=%X, Prop=%X, Hdl=%X, Ref=%X\n", hids->report_map_char_hdl, hids->report_map_prop, hids->report_map_val_hdl,
                                                             hids->external_rep_ref_hdl );
    printf( " BKB In AttHdl=%X, Prop=%X, Hdl=%X, Cfg=%X\n", hids->bootkb_input_char_hdl, hids->bootkb_input_prop, hids->bootkb_input_val_hdl,
                                                                 hids->bootkb_input_cfg_hdl );
    printf( " BKB Out AttHdl=%X, Prop=%X, Hdl=%X\n", hids->bootkb_output_char_hdl, hids->bootkb_output_prop, hids->bootkb_output_val_hdl);
    printf( " BMO In AttHdl=%X, Prop=%X, Hdl=%X, Cfg=%X\n", hids->bootmo_input_char_hdl, hids->bootmo_input_prop, hids->bootmo_input_val_hdl,
                                                                 hids->bootmo_input_cfg_hdl );
    printf( " HID Info AttHdl=%X, Prop=%X, Hdl=%X\n", hids->hid_info_char_hdl, hids->hid_info_prop, hids->hid_info_val_hdl );
    printf( " HID CtrlPt AttHdl=%X, Prop=%X, Hdl=%X\n", hids->hid_cp_char_hdl, hids->hid_cp_prop, hids->hid_cp_val_hdl );
    printf( " InclSvc AttHdl=%X, UUID=%X, Start=%X, End=%X\n", hids->include_svc_hdl, hids->include_svc_uuid, hids->incl_shdl, hids->incl_ehdl );
    hids++;     //Pointer Increase
    }

    printf( "* DIS: Start=%X, End=%X, PnP ID AttHdl=%X, Prop=%X, Hdl=%X\n",
                                                            dis->shdl, dis->ehdl, dis->pnp_id_char_hdl, dis->pnp_id_prop, dis->pnp_id_val_hdl);

    for(i=0 ; i<bas_inst_num ; i++){
    printf( "* BAS(Inst:%d), Start=%X, End=%X\n", i, bas->shdl, bas->ehdl );
    printf( " Batt.Lvl AttHdl=%X, Prop=%X, Hdl=%X, Cfg=%X, Ref=%X\n", bas->battery_lvl_char_hdl, bas->battery_lvl_prop,
                                                                     bas->battery_lvl_val_hdl, bas->battery_lvl_cfg_hdl,
                                                                     bas->battery_lvl_rep_ref_hdl);
    bas++;      //Pointer Increase
    }

}
#endif

#ifdef USE_HRPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief Display HRP  Measurements Info
 *
 *  @b Contents of management:
 *
 *  @param[in] *p      HRP Measurements Info
 *
 *  @retval none
 */
/******************************************************************************************/
void HRP_Info_Disp( RBLE_HRP_MEASUREMENTS_INFO *p )
{
    uint8_t i;
    
    /* mesurement is 16bit? */
    if ( 0 != (p->flags & 0x01) ) {
        printf("Measure:%04x(%d)\n", p->heart_rate_measure, p->heart_rate_measure);
    }
    else {
        printf("Measure:%02x(%d)\n", p->heart_rate_measure, p->heart_rate_measure);
    }

    /* Energy Exended Present ? */
    if ( 0 != (p->flags & 0x08) ) {
        printf("Energy:%04x(%d)\n", p->energy_expended, p->energy_expended);
    }

    /* interval value Present ? */
    if ( 0 != (p->flags & 0x10) ) {
        for(i=0; i < p->rr_interval_num;i++) {
            printf("RR Interval%02d:%04x(%d)\n", i, p->rr_interval[i], p->rr_interval[i]);
        }
    }
}
#endif

#ifdef USE_CSCC_SAMPLE
/******************************************************************************************/
/**
 *  @brief Display CSCP  Measurements Info
 *
 *  @b Contents of management:
 *
 *  @param[in] *p      CSCP Measurements Info
 *
 *  @retval none
 */
/******************************************************************************************/
void CSCP_MEASURE_Info_Disp( RBLE_CSCP_MEASUREMENTS_INFO *p )
{
    uint16_t timeDiff;
    uint32_t paramDiff;
    static RBLE_CSCP_MEASUREMENTS_INFO prevMeasureInfo = {0};
    const char  *type_chr[] =
    {
        "Speed",
        "Cadence"
    };
    printf("Flag    :%02x\n", p->flags);
    /* Wheel Info Present ? */
    if ( 0 != (p->flags & 0x01) ) {
        printf("Wheel Rev    :0x%04x%04x(%lu)\n", (uint16_t)((p->wheel_revolutions & 0xffff0000)>>16), (uint16_t)(p->wheel_revolutions & 0xffff), p->wheel_revolutions);
        printf("Wheel Ev Time:0x%04x(%u)\n", p->wheel_event_time, p->wheel_event_time);
        if ( First_Wheel_Flg == FALSE ) {
            /* caluculate speed */
            if( prevMeasureInfo.wheel_revolutions >= p->wheel_revolutions ) {
                printf("%s:-- (wheel back)\n", type_chr[0]);
            }
            else {
                float speed;
                if (p->wheel_event_time >= prevMeasureInfo.wheel_event_time) {
                    timeDiff = p->wheel_event_time - prevMeasureInfo.wheel_event_time;
                }
                else {
                    timeDiff = (uint16_t)(0x10000 - prevMeasureInfo.wheel_event_time + p->wheel_event_time);
                }
                if (timeDiff != 0) {
                    paramDiff = p->wheel_revolutions - prevMeasureInfo.wheel_revolutions;
                    /* wheel is 210cm(2.1) */
                    speed = (float)paramDiff / 1000 * 1024 * 60 * 60 / timeDiff * (float)2.1;
                    printf("%s:%f[km/s]  (wheel is 210cm)\n", type_chr[0],speed);
                }
                else {
                    printf("%s:--  (same time)\n", type_chr[0]);
                }
            }
        }
        else {
            printf("%s:--  (first event)\n", type_chr[0]);
            First_Wheel_Flg = FALSE;
        }
        prevMeasureInfo.wheel_revolutions = p->wheel_revolutions;
        prevMeasureInfo.wheel_event_time  = p->wheel_event_time;
    }
    
    /* Crank Info Present ? */
    if ( 0 != (p->flags & 0x02) ) {
        printf("Crank Rev    :0x%04x(%u)\n", p->crank_revolutions, p->crank_revolutions);
        printf("Crank Ev Time:0x%04x(%u)\n", p->crank_event_time, p->crank_event_time);
        if ( First_Crank_Flg == FALSE ) {
            /* caluculate cadence */
            uint16_t cadence;
            if (p->crank_revolutions >= prevMeasureInfo.crank_revolutions) {
                paramDiff = p->crank_revolutions - prevMeasureInfo.crank_revolutions;
            }
            else {
                paramDiff = 0x10000 - prevMeasureInfo.crank_revolutions + p->crank_revolutions;
            }
            if (p->crank_event_time >= prevMeasureInfo.crank_event_time) {
                timeDiff = p->crank_event_time - prevMeasureInfo.crank_event_time;
            }
            else {
                timeDiff = (uint16_t)(0x10000 - prevMeasureInfo.crank_event_time + p->crank_event_time);
            }
            if (timeDiff != 0) {
                cadence = (uint16_t)(paramDiff * 1024 * 60 / timeDiff);
                printf("%s:%u[rpm]\n", type_chr[1], cadence);
            }
            else {
                printf("%s:--  (same time)\n", type_chr[1]);
            }
        }
        else {
            printf("%s:--  (first event)\n", type_chr[1]);
            First_Crank_Flg = FALSE;
        }
        prevMeasureInfo.crank_revolutions = p->crank_revolutions;
        prevMeasureInfo.crank_event_time  = p->crank_event_time;
    }
}
#endif

#if defined(USE_CSCC_SAMPLE)|defined(USE_CSCS_SAMPLE)
/******************************************************************************************/
/**
 *  @brief Display CSCP SC Control Point Info
 *
 *  @b Contents of management:
 *
 *  @param[in] *p      CSCP Measurements Info
 *
 *  @retval none
 */
/******************************************************************************************/
void CSCP_SC_CP_Info_Disp( RBLE_CSCP_SC_CONTROL_POINT_INFO *p, uint8_t loc_num, uint8_t *res_param )
{
    uint8_t i;
    
    printf("OpCode:%02x\n", p->OpCode);
    
    switch(p->OpCode)
    {
        case RBLE_CSCP_OP_SET_CUMULATIVE_CODE:
            printf("cumulative value :%08x(%lu)\n",p->cumulative_value, p->cumulative_value);
            break;
        case RBLE_CSCP_OP_START_SC_CODE:
            printf("start sc\n");
            break;
        case RBLE_CSCP_OP_UPDATE_SL_CODE:
            printf("sensor location :%02d\n",p->sensor_location);
            break;
        case RBLE_CSCP_OP_REQ_SUPPORTED_SL_CODE:
            printf("req support sensor location\n");
            break;
        case RBLE_CSCP_OP_RESPONSE_CODE:
            switch(p->request_op_code)
            {
                case RBLE_CSCP_OP_SET_CUMULATIVE_CODE:
                    printf("Set Cumulative res\n");
                    break;
                case RBLE_CSCP_OP_START_SC_CODE:
                    printf("Start SC res\n");
                    break;
                case RBLE_CSCP_OP_UPDATE_SL_CODE:
                    printf("Update Sensor Location res\n");
                    break;
                case RBLE_CSCP_OP_REQ_SUPPORTED_SL_CODE:
                    printf("Req Supported Sensor Location res\n");
                    break;
                default:
                    printf("Invalid req op code(%d)\n",p->request_op_code);
                    break;
            }
            printf("res value:%d\n",p->response_value);
            if((p->request_op_code == RBLE_CSCP_OP_REQ_SUPPORTED_SL_CODE) && (res_param != NULL))
            {
                printf("location num:%d\n",loc_num);
                for(i=0;i<RBLE_CSCP_SENSORE_LOCATION_MAX;i++) {
                    printf("%02d ",res_param[i]);
                }
                printf("\n");
            }
            break;
        default:
            break;
    }
}
#endif

#if defined(USE_GLPC_SAMPLE)
/******************************************************************************************/
/**
 *  @brief Display GLP Measurement Info
 *
 *  @b Contents of management:
 *
 *  @param[in] *meas      GLP Measurement Info
 *
 *  @retval none
 */
/******************************************************************************************/
void GLP_MEASURE_Info_Disp( RBLE_GLP_MEASUREMENTS_INFO *meas )
{
    float tmp_value;
    const char *unit[] = { "kg", "mol" };
    
    printf("Flag:%02x  Seq Num:%04x\n", meas->flags, meas->seq_num);
    printf("Base Time  :%04d/%02d/%02d %02d:%02d:%02d\n", meas->stamp.year, meas->stamp.month, meas->stamp.day, meas->stamp.hour, meas->stamp.min, meas->stamp.sec );
    
    if ( 0 != (meas->flags & 0x01) ) {
        printf("Time offset:%d\n", meas->time_offset);
    }
    if ( 0 != (meas->flags & 0x02) ) {
        tmp_value = SFLOAT2FLOAT(meas->concentration);
        printf("concentrate:%x %f(%s/l)\n", (uint16_t)meas->concentration, tmp_value, unit[((meas->flags & 0x04) >> 2)] );
        printf("Type       :%d\n", meas->type);
        printf("Location   :%d\n", meas->sample_location);
    }
    if ( 0 != (meas->flags & 0x08) ) {
        printf("status Annun:%d\n", meas->sensor_status_annun);
    }
}

/******************************************************************************************/
/**
 *  @brief Display GLP Measurement Context Info
 *
 *  @b Contents of management:
 *
 *  @param[in] *meas      GLP Measurement Context Info
 *
 *  @retval none
 */
/******************************************************************************************/
void GLP_MEASURE_Context_Info_Disp( RBLE_GLP_MEASUREMENTS_CONTEXT_INFO *meas )
{
    const char *unit[] = { "kg", "l" };
    float tmp_value;
    
    printf("Flag:%02x Seq Num:%04x\n", meas->flags, meas->seq_num);
    
    if ( 0 != (meas->flags & 0x80) ) {
        printf("Ext Flags    :%04x\n", meas->ex_flags);
    }
    if ( 0 != (meas->flags & 0x01) ) {
        printf("CarboHyd ID  :%04x\n", meas->carbohydrate_id);
        tmp_value = SFLOAT2FLOAT(meas->carbohydrate_kg);
        printf("CarboHyd     :%04x %f(kg)\n", (uint16_t)meas->carbohydrate_kg, tmp_value);
    }
    if ( 0 != (meas->flags & 0x02) ) {
        printf("Meal         :%02d\n", meas->meal);
    }
    if ( 0 != (meas->flags & 0x04) ) {
        printf("Tester       :%02d\n", meas->tester);
        printf("Health       :%02d\n", meas->health);
    }
    if ( 0 != (meas->flags & 0x08) ) {
        printf("Exercise Duration :%04x\n", meas->exercise_duration);
        printf("Exercise Intensity:%02x\n", meas->exercise_intensity);
    }
    if ( 0 != (meas->flags & 0x10) ) {
        tmp_value = SFLOAT2FLOAT(meas->medication);
        printf("Medication ID:%02d\n", meas->medication_id);
        printf("Medication   :%x %f(%s)\n", (uint16_t)meas->medication, tmp_value, unit[((meas->flags & 0x20)>>5)] );
    }
    if ( 0 != (meas->flags & 0x40) ) {
        tmp_value = SFLOAT2FLOAT(meas->HbA1c);
        printf("HbA1c        :%x %f\n", meas->HbA1c, tmp_value);
    }
}
#endif

#if defined(USE_GLPC_SAMPLE)|defined(USE_GLPS_SAMPLE)
/******************************************************************************************/
/**
 *  @brief Display GLP RA Control Point Info
 *
 *  @b Contents of management:
 *
 *  @param[in] *cp      GLP RA Control Point Info
 *
 *  @retval none
 */
/******************************************************************************************/
void GLP_RA_CP_Info_Disp( RBLE_GLP_RA_CONTROL_POINT_INFO *cp )
{
    char *opcode[] = { "", "Report stored records", "Delete stored records", "Abort operation",
                       "Report num of stored records", "Num of stored records rese", "Res Code",  };
    char *racp_operator[] = { "--", "All records", "Less or equal", "Greater or equal", "Within range",
                              "First record", "Last record" };
    
    printf("OpCode:%s (%d)\n", opcode[cp->OpCode],cp->OpCode);
    printf("Operator:%s (%d)\n", racp_operator[cp->racp_operator],cp->racp_operator);
    printf("seq_num min:%d  max:%d\n", cp->min_sequence_num, cp->max_sequence_num);
    printf("min:%04d/%02d/%02d %02d:%02d:%02d  max:%04d/%02d/%02d %02d:%02d:%02d\n",
            cp->min_stamp.year,cp->min_stamp.month,cp->min_stamp.day,cp->min_stamp.hour,cp->min_stamp.min,cp->min_stamp.sec,
            cp->max_stamp.year,cp->max_stamp.month,cp->max_stamp.day,cp->max_stamp.hour,cp->max_stamp.min,cp->max_stamp.sec);
}
/******************************************************************************************/
/**
 *  @brief Display GLP RA Control Point Info
 *
 *  @b Contents of management:
 *
 *  @param[in] *cp      GLP RA Control Point Info
 *
 *  @retval none
 */
/******************************************************************************************/
void GLP_RA_CP_Ind_Info_Disp( RBLE_GLP_RA_CONTROL_POINT_IND_INFO *cp )
{
    char *opcode[] = { "", "Report stored records", "Delete stored records", "Abort operation",
                       "Report num of stored records", "Num of stored records rese", "Res Code",  };
    char *racp_operator[] = { "--", "All records", "Less or equal", "Greater or equal", "Within range",
                              "First record", "Last record" };
    
    printf("OpCode:%s\n", opcode[cp->OpCode]);
    printf("Operator:%s\n", racp_operator[cp->racp_operator]);
    printf("Num of Records:%d\n", cp->num_of_records);
    printf("Req OpCode:%s\n", opcode[cp->request_op_code]);
    printf("Res Code:%d\n", cp->response_code_value);
}

#endif
#ifdef USE_CPPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief Display CP Measurements Info
 *
 *  @b Contents of management:
 *
 *  @param[in] *p      CP Measurements Info
 *
 *  @retval none
 */
/******************************************************************************************/
void CPP_Meas_Info_Disp(RBLE_CPP_MEASUREMENTS_INFO *meas_info)
{
    printf("flags :%04x\n", meas_info->flags);
    printf("Instant Power      :%d(0x%04x)\n", meas_info->instant_power, meas_info->instant_power);
    
    if(meas_info->flags & 0x0001) {
        /* Pedal Power Balance */
        printf("Pedal Power Balance:%u(0x%02x)\n", meas_info->pedal_balance, meas_info->pedal_balance);
    }
    if(meas_info->flags & 0x0004) {
        /* Accumulated Torque */
        printf("Accumulated Torque :%u(0x%04x)\n", meas_info->accumulated_torque, meas_info->accumulated_torque);
    }
    if(meas_info->flags & 0x0010) {
        /* Wheel Revolution Data */
        printf("Wheel Revolution   :%lu(0x%04x%04x)\n", meas_info->wheel_revolutions, (uint16_t)((meas_info->wheel_revolutions & 0xffff0000)>>16), (uint16_t)(meas_info->wheel_revolutions & 0xffff));
        printf("Wheel Event Time   :%u(0x%04x)\n", meas_info->wheel_event, meas_info->wheel_event);
    }
    if(meas_info->flags & 0x0020) {
        /* Crank Revolution Data */
        printf("Crank Revolution   :%u(0x%04x)\n", meas_info->crank_revolutions, meas_info->crank_revolutions);
        printf("Crank Event Time   :%u(0x%04x)\n", meas_info->crank_event, meas_info->crank_event);
    }
    if(meas_info->flags & 0x0040) {
        /* Extreme Force Magnitudes */
        printf("Max Force Mag      :%d(0x%04x)\n", meas_info->max_force_magnitude, meas_info->max_force_magnitude);
        printf("Min Force Mag      :%d(0x%04x)\n", meas_info->min_force_magnitude, meas_info->min_force_magnitude);
    }
    if(meas_info->flags & 0x0080) {
        /* Extreme Torque Magnitudes */
        printf("Max Torque Mag     :%d(0x%04x)\n", meas_info->max_torque_magnitude, meas_info->max_torque_magnitude);
        printf("Min Torque Mag     :%d(0x%04x)\n", meas_info->min_torque_magnitude, meas_info->min_torque_magnitude);
    }
    if(meas_info->flags & 0x0100) {
        /* Extreme Angles */
        printf("Max Ext Angles     :%u(0x%04x)\n", meas_info->max_angle, meas_info->max_angle);
        printf("Min Ext Angles     :%u(0x%04x)\n", meas_info->min_angle, meas_info->min_angle);
    }
    if(meas_info->flags & 0x0200) {
        /* Top Dead Spot Angle */
        printf("Top Dead Angle     :%u(0x%04x)\n", meas_info->top_dead_spot, meas_info->top_dead_spot);
    }
    if(meas_info->flags & 0x0400) {
        /* Bottom Dead Spot */
        printf("Btm Dead Angle     :%u(0x%04x)\n", meas_info->bottom_dead_spot, meas_info->bottom_dead_spot);
    }
    if(meas_info->flags & 0x0800) {
        /* Accumulated Energy */
        printf("Accumulated Energy :%u(0x%04x)\n", meas_info->accumulated_energy, meas_info->accumulated_energy);
    }
}

/******************************************************************************************/
/**
 *  @brief Display CP Vector Info
 *
 *  @b Contents of vector:
 *
 *  @param[in] *p      CP Vector Info
 *
 *  @retval none
 */
/******************************************************************************************/
void CPP_Vector_Info_Disp(RBLE_CPP_VECTOR_INFO *vector_info)
{
    uint8_t i;
    
    printf("flags :%02x\n", vector_info->flags);
    if(vector_info->flags & 0x01) {
        /* Crank Revolution Data */
        printf("Crank Rev   :0x%x(%u)\n", vector_info->crank_revolutions, vector_info->crank_revolutions);
        printf("Crank Event :0x%x(%u)\n", vector_info->crank_event, vector_info->crank_event);
    }
    
    if(vector_info->flags & 0x02) {
        /* First Crank Measurement Angle Data */
        printf("first crank angle  :%u\n", vector_info->first_crank_angle);
    }
    
    if((vector_info->flags & 0x04) || (vector_info->flags & 0x08)) {
        /* Instantaneous Force/Torque Magnitude Array  Data */
        if(vector_info->flags & 0x04) {
            printf("instant force mag  :");
        }
        else {
            printf("instant torque mag :");
        }
        for(i = 0; i < vector_info->array_num; i++)
        {
            printf("0x%04x(%d) ",vector_info->magnitude[i],vector_info->magnitude[i]);
        }
        printf("\n");
    }
}

/******************************************************************************************/
/**
 *  @brief Display Control Point Response value and Parameter value disp
 *
 *  @b Contents of control point Indication:
 *
 *  @param[in] req_opcode   request operation code
 *  @param[in] res_value    response value
 *  @param[in] value        parameter value
 *
 *  @retval none
 */
/******************************************************************************************/
void CPP_Res_Value_Disp(uint8_t req_opcode, uint8_t res_value, int32_t value)
{
    printf("%s :RES = %d, Value = %d\n", CPP_Control_Point_Disp_Info[req_opcode], res_value, value);
}

/******************************************************************************************/
/**
 *  @brief Display CP Control Point Indication Info
 *
 *  @b Contents of control point Indication:
 *
 *  @param[in] *event   CP Control Point Info(Indication)
 *
 *  @retval none
 */
/******************************************************************************************/
void CPP_Ind_Cp_Info_Disp(RBLE_CPPC_EVENT *event)
{
    RBLE_CPP_IND_CONTROL_POINT_INFO *ind_cp_info = &event->param.cp_cp_ind.ind_cp_info;
    
    if(ind_cp_info->OpCode == RBLE_CPP_OP_RESPONSE_CODE) {
        printf("OpCode = RESPONSE\n");
    }
    else {
        printf("Illegal OpCode = %02x\n", ind_cp_info->OpCode);
    }
    switch(ind_cp_info->request_op_code)
    {
        case RBLE_CPP_OP_SET_CUMULATIVE_CODE:
        case RBLE_CPP_OP_SET_CRANK_LEN_CODE:
        case RBLE_CPP_OP_UPDATE_SL_CODE:
        case RBLE_CPP_OP_SET_CHAIN_LEN_CODE:
        case RBLE_CPP_OP_SET_CHAIN_WEI_CODE:
        case RBLE_CPP_OP_SET_SPAN_LEN_CODE:
        case RBLE_CPP_OP_MASK_CP_MEAS_CONTENT_CODE:
        case RBLE_CPP_OP_REQ_SUPPORTED_SL_CODE:
        case RBLE_CPP_OP_REQ_FACTORY_CALIB_DATE_CODE:
            printf("%s :RES = %d\n", CPP_Control_Point_Disp_Info[ind_cp_info->request_op_code], ind_cp_info->response_value);
            if(ind_cp_info->response_value == RBLE_CPP_RES_SUCCESS_CODE) {
                if(ind_cp_info->request_op_code == RBLE_CPP_OP_REQ_SUPPORTED_SL_CODE) {
                    printf("location num%d\n", event->param.cp_cp_ind.location_num);
                    Print_Dump( &event->param.cp_cp_ind.supported_location[0] ,event->param.cp_cp_ind.location_num );
                }
                else if(ind_cp_info->request_op_code == RBLE_CPP_OP_REQ_FACTORY_CALIB_DATE_CODE) {
                    RBLE_DATE_TIME *stamp = &ind_cp_info->stamp;
                    printf("%04d/%02d/%02d %02d:%02d:%02d\n", stamp->year, stamp->month, stamp->day, stamp->hour, stamp->min, stamp->sec);
                }
            }
            break;
        case RBLE_CPP_OP_REQ_CRANK_LEN_CODE:
            CPP_Res_Value_Disp(ind_cp_info->request_op_code,ind_cp_info->response_value, ind_cp_info->crank_length);
            break;
        case RBLE_CPP_OP_REQ_CHAIN_LEN_CODE:
            CPP_Res_Value_Disp(ind_cp_info->request_op_code,ind_cp_info->response_value, ind_cp_info->chain_length);
            break;
        case RBLE_CPP_OP_REQ_CHAIN_WEI_CODE:
            CPP_Res_Value_Disp(ind_cp_info->request_op_code,ind_cp_info->response_value, ind_cp_info->chain_weight);
            break;
        case RBLE_CPP_OP_REQ_SPAN_LEN_CODE:
            CPP_Res_Value_Disp(ind_cp_info->request_op_code,ind_cp_info->response_value, ind_cp_info->span_length);
            break;
        case RBLE_CPP_OP_START_OFFSET_COMPENSATION_CODE:
            CPP_Res_Value_Disp(ind_cp_info->request_op_code,ind_cp_info->response_value, ind_cp_info->offset_compensation);
            break;
        case RBLE_CPP_OP_REQ_SAMPL_RATE_CODE:
            CPP_Res_Value_Disp(ind_cp_info->request_op_code,ind_cp_info->response_value, ind_cp_info->sampling_rate);
            break;
        default:
            break;
    }
}

/******************************************************************************************/
/**
 *  @brief Display Broadcast data
 *
 *  @b Contents of management:
 *
 *  @param[in] *adv_rep_p   Advertising report
 *
 *  @retval none
 */
/******************************************************************************************/
void CPP_Broadcast_Rcv(RBLE_ADV_REPORT *adv_rep_p )
{
    uint8_t     len, ad_struct_len;
    uint16_t    uuid;
    uint8_t     *p;
    RBLE_CPP_MEASUREMENTS_INFO meas_info;

    len = adv_rep_p->data_len;
    p = &adv_rep_p->data[0];
    for (; 0 != len;) {
        ad_struct_len = *p;
        /* ServiceData? */
        if (0x16 == *(p+1)) {
            printf("Received Measurements Broadcast -- ");
            BdAddress_Disp( &adv_rep_p->adv_addr );
            p+=2;   /* Length + Type */
            uuid = (uint16_t)( *p | (*(p+1) << 8) );
            p+=2;   /* uuid */
            if ((RBLE_SVC_CYCLING_POWER == uuid) || (RBLE_CHAR_CYCLING_POWER_MEAS == uuid/* for PTS bug */)) {
                memset(&meas_info, 0, sizeof(meas_info));
                meas_info.flags = (uint16_t)( *p | (*(p+1) << 8) );
                p+=2;
                meas_info.instant_power = (int16_t)( *p | (*(p+1) << 8) );
                p+=2;
                if(meas_info.flags & 0x0001) {
                    /* Pedal Power Balance */
                    meas_info.pedal_balance = *p;
                    p++;
                }
                if(meas_info.flags & 0x0004) {
                    /* Accumulated Torque */
                    meas_info.accumulated_torque = (uint16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                }
                if(meas_info.flags & 0x0010) {
                    /* Wheel Revolution Data */
                    meas_info.wheel_revolutions = (uint32_t)( *p | (*(p+1) << 8)  | ((uint32_t)*(p+2) << 16) | ((uint32_t)*(p+3) << 24));
                    p+=4;
                    meas_info.wheel_event = (uint16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                }
                if(meas_info.flags & 0x0020) {
                    /* Crank Revolution Data */
                    meas_info.crank_revolutions = (uint16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                    meas_info.crank_event = (uint16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                }
                if(meas_info.flags & 0x0040) {
                    /* Extreme Force Magnitudes */
                    meas_info.max_force_magnitude = (int16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                    meas_info.min_force_magnitude = (int16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                }
                if(meas_info.flags & 0x0080) {
                    /* Extreme Torque Magnitudes */
                    meas_info.max_torque_magnitude = (int16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                    meas_info.min_torque_magnitude = (int16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                }
                if(meas_info.flags & 0x0100) {
                    /* Extreme Angles */
                    meas_info.max_angle = (uint16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                    meas_info.min_angle = (uint16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                }
                if(meas_info.flags & 0x0200) {
                    /* Top Dead Spot Angle */
                    meas_info.top_dead_spot = (uint16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                }
                if(meas_info.flags & 0x0400) {
                    /* Bottom Dead Spot */
                    meas_info.bottom_dead_spot = (uint16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                }
                if(meas_info.flags & 0x0800) {
                    /* Accumulated Energy */
                    meas_info.accumulated_energy = (uint16_t)( *p | (*(p+1) << 8) );
                    p+=2;
                }
                CPP_Meas_Info_Disp(&meas_info);
            } else {
                Print_Dump(p, ad_struct_len-2);
                p = p + (ad_struct_len - 2);
            }
        } else {
            p = p + (ad_struct_len + 1);
        }

        if (len >= (ad_struct_len + 1)) {
            len = len - (ad_struct_len + 1);
        } else {
            len = 0;
        }
    }
}
#endif
#ifdef USE_CPPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief Display Control Point Write value and Parameter value disp
 *
 *  @b Contents of control point Indication:
 *
 *  @param[in] opcode   request operation code
 *  @param[in] value    parameter value
 *
 *  @retval none
 */
/******************************************************************************************/
void CPP_Write_Value_Disp(uint8_t opcode, int32_t value)
{
    printf("%s :Value = %d\n", CPP_Control_Point_Disp_Info[opcode], value);
}

/******************************************************************************************/
/**
 *  @brief Display CP Control Point Info
 *
 *  @b Contents of control point(Write):
 *
 *  @param[in] *p      CP Control Point Info(Write)
 *
 *  @retval none
 */
/******************************************************************************************/
void CPP_Chg_Cp_Info_Disp(RBLE_CPP_WR_CONTROL_POINT_INFO *wr_info)
{
    switch(wr_info->OpCode)
    {
        case RBLE_CPP_OP_REQ_SUPPORTED_SL_CODE:
        case RBLE_CPP_OP_REQ_CRANK_LEN_CODE:
        case RBLE_CPP_OP_REQ_CHAIN_LEN_CODE:
        case RBLE_CPP_OP_REQ_CHAIN_WEI_CODE:
        case RBLE_CPP_OP_REQ_SPAN_LEN_CODE:
        case RBLE_CPP_OP_START_OFFSET_COMPENSATION_CODE:
        case RBLE_CPP_OP_REQ_SAMPL_RATE_CODE:
        case RBLE_CPP_OP_REQ_FACTORY_CALIB_DATE_CODE:
            printf("%s\n", CPP_Control_Point_Disp_Info[wr_info->OpCode]);
            break;      
        case RBLE_CPP_OP_SET_CUMULATIVE_CODE:
            CPP_Write_Value_Disp(wr_info->OpCode, wr_info->cumulative_value);
            break;
        case RBLE_CPP_OP_UPDATE_SL_CODE:
            CPP_Write_Value_Disp(wr_info->OpCode, wr_info->sensor_location);
            break;
        case RBLE_CPP_OP_SET_CRANK_LEN_CODE:
            CPP_Write_Value_Disp(wr_info->OpCode, wr_info->crank_length);
            break;
        case RBLE_CPP_OP_SET_CHAIN_LEN_CODE:
            CPP_Write_Value_Disp(wr_info->OpCode, wr_info->chain_length);
            break;
        case RBLE_CPP_OP_SET_CHAIN_WEI_CODE:
            CPP_Write_Value_Disp(wr_info->OpCode, wr_info->chain_weight);
            break;
        case RBLE_CPP_OP_SET_SPAN_LEN_CODE:
            CPP_Write_Value_Disp(wr_info->OpCode, wr_info->span_length);
            break;
        case RBLE_CPP_OP_MASK_CP_MEAS_CONTENT_CODE:
            CPP_Write_Value_Disp(wr_info->OpCode, wr_info->mask_meas_content);
            break;
        default:
            printf("Illegal OpCode %d\n",wr_info->OpCode);
            break;
    }
}
#endif

#if defined(USE_HTPC_SAMPLE)|defined(USE_BLPC_SAMPLE)|defined(USE_HRPC_SAMPLE)|defined(USE_CSCC_SAMPLE)|defined(USE_GLPC_SAMPLE)|defined(USE_CPPC_SAMPLE)|defined(USE_LNPC_SAMPLE)|defined(USE_RSCPC_SAMPLE)
/******************************************************************************************/
/**
 *  @brief Display DIS handle
 *
 *  @b Contents of management:
 *
 *  @param[in] *p      DIS handle Info
 *
 *  @retval none
 */
/******************************************************************************************/
void DIS_handle_Info_Disp(RBLE_DIS_CONTENT *dis)
{
    printf( "* Device Information Service\n");
    printf( "  Start Handle    = 0x%04X\n",        dis->shdl );
    printf( "  End Handle      = 0x%04X\n\n",      dis->ehdl );
    printf( "  sys_id_char_hdl      = 0x%04X\n",   dis->sys_id_char_hdl      );
    printf( "  sys_id_val_hdl       = 0x%04X\n",   dis->sys_id_val_hdl       );
    printf( "  sys_id_prop          = 0x%02X\n\n", dis->sys_id_prop          );
    printf( "  model_nb_char_hdl    = 0x%04X\n",   dis->model_nb_char_hdl    );
    printf( "  model_nb_val_hdl     = 0x%04X\n",   dis->model_nb_val_hdl     );
    printf( "  model_nb_prop        = 0x%02X\n\n", dis->model_nb_prop        );
    printf( "  serial_nb_char_hdl   = 0x%04X\n",   dis->serial_nb_char_hdl   );
    printf( "  serial_nb_val_hdl    = 0x%04X\n",   dis->serial_nb_val_hdl    );
    printf( "  serial_nb_prop       = 0x%02X\n\n", dis->serial_nb_prop       );
    printf( "  fw_rev_char_hdl      = 0x%04X\n",   dis->fw_rev_char_hdl      );
    printf( "  fw_rev_val_hdl       = 0x%04X\n",   dis->fw_rev_val_hdl       );
    printf( "  fw_rev_prop          = 0x%02X\n\n", dis->fw_rev_prop          );
    printf( "  hw_rev_char_hdl      = 0x%04X\n",   dis->hw_rev_char_hdl      );
    printf( "  hw_rev_val_hdl       = 0x%04X\n",   dis->hw_rev_val_hdl       );
    printf( "  hw_rev_prop          = 0x%02X\n\n", dis->hw_rev_prop          );
    printf( "  sw_rev_char_hdl      = 0x%04X\n",   dis->sw_rev_char_hdl      );
    printf( "  sw_rev_val_hdl       = 0x%04X\n",   dis->sw_rev_val_hdl       );
    printf( "  sw_rev_prop          = 0x%02X\n\n", dis->sw_rev_prop          );
    printf( "  manuf_name_char_hdl  = 0x%04X\n",   dis->manuf_name_char_hdl  );
    printf( "  manuf_name_val_hdl   = 0x%04X\n",   dis->manuf_name_val_hdl   );
    printf( "  manuf_name_prop      = 0x%02X\n\n", dis->manuf_name_prop      );
    printf( "  ieee_certif_char_hdl = 0x%04X\n",   dis->ieee_certif_char_hdl );
    printf( "  ieee_certif_val_hdl  = 0x%04X\n",   dis->ieee_certif_val_hdl  );
    printf( "  ieee_certif_prop     = 0x%02X\n\n", dis->ieee_certif_prop     );
}
#endif

#if defined(USE_CPPC_SAMPLE)|defined(USE_LNPC_SAMPLE)
/******************************************************************************************/
/**
 *  @brief Display BAS handle
 *
 *  @b Contents of management:
 *
 *  @param[in] *p      DIS handle Info
 *
 *  @retval none
 */
/******************************************************************************************/
void BAS_handle_Info_Disp(RBLE_BATS_CONTENT *bas)
{
    printf( "* Battery Service\n");
    printf( "   Start Handle = 0x%04X\n",   bas->shdl );
    printf( "   End Handle   = 0x%04X\n\n", bas->ehdl );
    printf( "   battery_lvl_char_hdl = 0x%04X\n",   bas->battery_lvl_char_hdl );
    printf( "   battery_lvl_val_hdl  = 0x%04X\n",   bas->battery_lvl_val_hdl );
    printf( "   battery_lvl_cfg_hdl  = 0x%04X\n",   bas->battery_lvl_cfg_hdl );
    printf( "   battery_lvl_prop     = 0x%02X\n",   bas->battery_lvl_prop );
}
#endif

#if defined(USE_TIPC_SAMPLE)|defined(USE_LNPC_SAMPLE)
/******************************************************************************************/
/**
 *  @brief Display Time
 *
 *  @b Contents of management:
 *
 *  @param[in] *stamp     Time Information
 *
 *  @retval none
 */
/******************************************************************************************/
void TIP_Time_Disp(RBLE_DATE_TIME *stamp)
{
    printf("%4d/%2d/%2d %2d:%2d:%2d\n", stamp->year, stamp->month, stamp->day, stamp->hour, stamp->min, stamp->sec);
}

#if defined(USE_TIPC_SAMPLE)
/******************************************************************************************/
/**
 *  @brief Display Time Profile reading charcteristic value
 *
 *  @b Contents of management:
 *
 *  @param[in] char_code     read characteristic code
 *  @param[in] att_data      read data
 *
 *  @retval none
 */
/******************************************************************************************/
void TIP_Info_Disp(uint8_t char_code, RBLE_ATT_INFO_DATA *att_data)
{
    switch(char_code)
    {
        case RBLE_TIPC_RD_CTS_CRNT_TIME:
            printf("Read Current Time\n");
            {
                RBLE_DATE_TIME stamp;
                stamp.year  = att_data->data[0] | (att_data->data[1] << 8);
                stamp.month = att_data->data[2];
                stamp.day   = att_data->data[3];
                stamp.hour  = att_data->data[4];
                stamp.min   = att_data->data[5];
                stamp.sec   = att_data->data[6];
                TIP_Time_Disp(&stamp);
                printf("day of week   = %d\n", att_data->data[7]);
                printf("fractions256  = %d\n", att_data->data[8]);
                printf("adjust reason = %x\n", att_data->data[9]);
            }
            break;
        case RBLE_TIPC_RD_CTS_CRNT_TIME_CFG:
            printf("Read Current Time Client Config %d\n", att_data->data[0] | (att_data->data[1] << 8));
            break;
        case RBLE_TIPC_RD_CTS_LOCAL_TIME:
            printf("Read Local Time Info\n");
            printf("time zone:%d  DST_offset:%d\n", (int8_t)(att_data->data[0]), att_data->data[1] );
            break;
        case RBLE_TIPC_RD_CTS_REF_TIME:
            printf("Read Reference Time Info\n");
            printf("time source      :%d  accuracy          :%d\n", att_data->data[0], att_data->data[1] );
            printf("days_since_update:%d  hours_since_update:%d\n", att_data->data[2], att_data->data[3] );
            break;
        case RBLE_TIPC_RD_NDCS_TIME_DST:
            printf("Read Next Update DST Time Info\n");
            {
                RBLE_DATE_TIME stamp;
                stamp.year  = att_data->data[0] | (att_data->data[1] << 8);
                stamp.month = att_data->data[2];
                stamp.day   = att_data->data[3];
                stamp.hour  = att_data->data[4];
                stamp.min   = att_data->data[5];
                stamp.sec   = att_data->data[6];
                TIP_Time_Disp(&stamp);
                printf("dst offset = %d\n", att_data->data[7]);
            }
            break;
        case RBLE_TIPC_RD_RTUS_UPDATE_STATUS:
            printf("Read Time Update Status\n");
            printf("current state:%d  update_result:%d\n", att_data->data[0], att_data->data[1] );
            break;
        default:
            break;
    }
}
#endif
#endif

#ifdef USE_ANPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief Display Alert Notify
 *
 *  @b Contents of management:
 *
 *  @param[in] alert_info     alert information
 *
 *  @retval none
 */
/******************************************************************************************/
void ANP_Alert_Disp (RBLE_ANP_NEW_ALERT_INFO *alert_info)
{
    uint8_t i;
    
    printf("Category Id:%d\n", alert_info->category_id);
    printf("Alert Num  :%d\n", alert_info->alert_num);
    
    printf("Text:");
    for(i = 0; alert_info->text_size > i ; i++ )
    {
        printf("%c",alert_info->text[i]);
    }
    printf("\n");
}
#endif

#ifdef USE_LNPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief print int 32 bit
 *
 *  @b Contents of management:
 *
 *  @param[in] 
 *
 *  @retval none
 */
/******************************************************************************************/
void LNP_int32_print(int32_t value)
{
    int32_t tmp_value;
    
    if(value < 0) {
        tmp_value = value * (-1);
        printf("-");
    }
    else {
        tmp_value = value;
    }
    LNP_uint32_print(tmp_value);
}

/******************************************************************************************/
/**
 *  @brief print unsigned int 32 bit
 *
 *  @b Contents of management:
 *
 *  @param[in] 
 *
 *  @retval none
 */
/******************************************************************************************/
void LNP_uint32_print(uint32_t value)
{
    uint16_t tmp_value1,tmp_value2,tmp_value3;
    
    tmp_value1 = (uint16_t)(value%10000);
    tmp_value2 = (uint16_t)((value/10000)%1000);
    tmp_value3 = (uint16_t)(value/10000000);
    
    if( tmp_value3 > 0 ){
        printf("%d%03d%04d",tmp_value3,tmp_value2,tmp_value1);
    }
    else if(tmp_value2 > 0){
        printf("%d%04d",tmp_value2,tmp_value1);
    }
    else { 
        printf("%d",tmp_value1);
    }
}

/******************************************************************************************/
/**
 *  @brief Display Location and Speed
 *
 *  @b Contents of management:
 *
 *  @param[in] location_speed_info     location and speed information
 *
 *  @retval none
 */
/******************************************************************************************/
void LNP_Location_Speed_Disp(RBLE_LNP_LOCATION_SPEED_INFO *location_speed_info)
{
    printf("flags:0x%04x\n",location_speed_info->flags);
    
    if(location_speed_info->flags & 0x01)
    {
        printf("instant_speed :0x%04x\n",location_speed_info->instant_speed);
    }
    if(location_speed_info->flags & 0x02)
    {
        printf("total_distance:");
        LNP_uint32_print(location_speed_info->total_distance);
        printf("(0x%04x%04x)\n", (uint16_t)((location_speed_info->total_distance & 0xffff0000) >> 16), (uint16_t)((location_speed_info->total_distance & 0xffff)));
    }
    if(location_speed_info->flags & 0x04)
    {
        printf("latitude      :");
        LNP_uint32_print(location_speed_info->latitude);
        printf("(0x%04x%04x)\n",(uint16_t)((location_speed_info->latitude >> 16) & 0xffff),(uint16_t)(location_speed_info->latitude & 0xffff));
        
        printf("longitude     :");
        LNP_uint32_print(location_speed_info->longitude);
        printf("(0x%04x%04x)\n",(uint16_t)((location_speed_info->longitude >> 16) & 0xffff),(uint16_t)(location_speed_info->longitude & 0xffff));
    }
    if(location_speed_info->flags & 0x08)
    {
        printf("elevation     :");
        LNP_int32_print(location_speed_info->elevation);
        printf("(0x%04x%04x)\n",(uint16_t)((location_speed_info->elevation >> 16) & 0xffff),(uint16_t)(location_speed_info->elevation & 0xffff));
    }
    if(location_speed_info->flags & 0x10)
    {
        printf("heading       :%d(0x%04x)\n",location_speed_info->heading,location_speed_info->heading);
    }
    if(location_speed_info->flags & 0x20)
    {
        printf("rolling time  :%d(0x%02x)\n",location_speed_info->rolling_time,location_speed_info->rolling_time);
    }
    if(location_speed_info->flags & 0x40)
    {
        printf("utc time      :");
        TIP_Time_Disp(&location_speed_info->utc_time);
    }
}

/******************************************************************************************/
/**
 *  @brief Display Navigtation
 *
 *  @b Contents of management:
 *
 *  @param[in] navi_info     Navigtation information
 *
 *  @retval none
 */
/******************************************************************************************/
void LNP_Navigation_Disp(RBLE_LNP_NAVIGATION_INFO *navi_info)
{
    printf("flags:0x%04x\n",navi_info->flags);
    
    printf("bearing      :%d(0x%04x)\n",navi_info->bearing,navi_info->bearing);
    printf("heading      :%d(0x%04x)\n",navi_info->heading,navi_info->heading);
    if(navi_info->flags & 0x01)
    {
        printf("remain dis   :");
        LNP_uint32_print(navi_info->remain_dis);
        printf("(0x%04x%04x)\n", (uint16_t)((navi_info->remain_dis >> 16) & 0xffff), (uint16_t)(navi_info->remain_dis & 0xffff));
    }
    if(navi_info->flags & 0x02)
    {
        printf("remain v dis :");
        LNP_int32_print(navi_info->remain_v_dis);
        printf("(0x%04x%04x)\n", (uint16_t)((navi_info->remain_v_dis >> 16) & 0xffff), (uint16_t)(navi_info->remain_v_dis & 0xffff));
    }
    if(navi_info->flags & 0x04)
    {
        printf("estimate time:");
        TIP_Time_Disp(&navi_info->estimate_time);
    }
}

/******************************************************************************************/
/**
 *  @brief Display LN Control Point Indication
 *
 *  @b Contents of management:
 *
 *  @param[in] ind_cp_info     LN Control Point Indication information
 *
 *  @retval none
 */
/******************************************************************************************/
void LNP_LN_Control_Point_Disp(RBLE_LNP_IND_CONTROL_POINT_INFO *ind_cp_info)
{
    if(ind_cp_info->OpCode == RBLE_LNP_OP_RESPONSE_CODE) {
        printf("OpCode = RESPONSE\n");
    }
    else {
        printf("Illegal OpCode = %02x\n", ind_cp_info->OpCode);
    }
    switch(ind_cp_info->request_op_code)
    {
        case RBLE_LNP_OP_SET_CUMULATIVE_CODE:
        case RBLE_LNP_OP_MASK_LS_CONTENTS_CODE:
        case RBLE_LNP_OP_NAVIGATION_CONTROL_CODE:
        case RBLE_LNP_OP_SELECT_ROUTE_CODE:
        case RBLE_LNP_OP_SET_FIX_RATE_CODE:
        case RBLE_LNP_OP_SET_ELEVATION_CODE:
            printf("%s :RES = %d\n", LNP_Control_Point_Disp_Info[ind_cp_info->request_op_code], ind_cp_info->response_value);
            break;
        case RBLE_LNP_OP_REQ_NUM_OF_ROUTE_CODE:
            printf("%s :RES = %d\n", LNP_Control_Point_Disp_Info[ind_cp_info->request_op_code], ind_cp_info->response_value);
            if(ind_cp_info->response_value == RBLE_LNP_RES_SUCCESS_CODE)
            {
                printf("Route Num :%d\n", ind_cp_info->route_num);
            }
            break;
        case RBLE_LNP_OP_REQ_NAME_OF_ROUTE_CODE:
            printf("%s :RES = %d\n", LNP_Control_Point_Disp_Info[ind_cp_info->request_op_code], ind_cp_info->response_value);
            if(ind_cp_info->response_value == RBLE_LNP_RES_SUCCESS_CODE)
            {
                ind_cp_info->route_name[ind_cp_info->name_size] = '\0';
                printf("Route Name:%s\n", ind_cp_info->route_name);
            }
            break;
        default:
            printf("Illegal Req OpCode %d\n",ind_cp_info->request_op_code);
            break;
    }
}

#endif

#ifdef USE_LNPS_SAMPLE
/******************************************************************************************/
/**
 *  @brief Display LN Control Point Write value and Parameter value disp
 *
 *  @b Contents of control point Indication:
 *
 *  @param[in] opcode   request operation code
 *  @param[in] value    parameter value
 *
 *  @retval none
 */
/******************************************************************************************/
void LNP_Write_Value_Disp(uint8_t opcode, uint32_t value)
{
    if( RBLE_LNP_OP_SET_ELEVATION_CODE == opcode ) {
        printf("%s(%d) :Value = %ld(0x%04x%04x)\n", LNP_Control_Point_Disp_Info[opcode], opcode, (int32_t)value, (uint16_t)((value >> 16) & 0xffff), (uint16_t)(value & 0xffff));
    } else {
        printf("%s(%d) :Value = %lu(0x%04x%04x)\n", LNP_Control_Point_Disp_Info[opcode], opcode, value, (uint16_t)((value >> 16) & 0xffff), (uint16_t)(value & 0xffff));
    }
}

void LNP_Chg_LN_CP_Info_Disp(RBLE_LNP_WR_CONTROL_POINT_INFO *wr_cp_info)
{
    switch(wr_cp_info->OpCode)
    {
        case RBLE_LNP_OP_SET_CUMULATIVE_CODE:
            LNP_Write_Value_Disp(wr_cp_info->OpCode, wr_cp_info->cumulative_value);
            break;
        case RBLE_LNP_OP_MASK_LS_CONTENTS_CODE:
            LNP_Write_Value_Disp(wr_cp_info->OpCode, wr_cp_info->content_mask);
            break;
        case RBLE_LNP_OP_NAVIGATION_CONTROL_CODE:
            LNP_Write_Value_Disp(wr_cp_info->OpCode, wr_cp_info->control_val);
            switch(wr_cp_info->control_val)
            {
                case RBLE_LNP_CNTL_NAVI_STOP:
                    printf("NAVI Stop\n");
                    break;
                case RBLE_LNP_CNTL_NAVI_START:
                    printf("NAVI Start\n");
                    break;
                case RBLE_LNP_CNTL_NAVI_PAUSE:
                    printf("NAVI Pause\n");
                    break;
                case RBLE_LNP_CNTL_NAVI_RESUME:
                    printf("NAVI Resume\n");
                    break;
                case RBLE_LNP_CNTL_NAVI_SKIP:
                    printf("NAVI Skip\n");
                    break;
                case RBLE_LNP_CNTL_NAVI_SET_NEAREST:
                    printf("NAVI Set Nearest\n");
                    break;
            }
            break;
        case RBLE_LNP_OP_REQ_NUM_OF_ROUTE_CODE:
            printf("%s(%d)\n", LNP_Control_Point_Disp_Info[wr_cp_info->OpCode], wr_cp_info->OpCode);
            break;
        case RBLE_LNP_OP_REQ_NAME_OF_ROUTE_CODE:
            LNP_Write_Value_Disp(wr_cp_info->OpCode, wr_cp_info->route_num);
            break;
        case RBLE_LNP_OP_SELECT_ROUTE_CODE:
            LNP_Write_Value_Disp(wr_cp_info->OpCode, wr_cp_info->route_num);
            break;
        case RBLE_LNP_OP_SET_FIX_RATE_CODE:
            LNP_Write_Value_Disp(wr_cp_info->OpCode, wr_cp_info->fix_rate);
            break;
        case RBLE_LNP_OP_SET_ELEVATION_CODE:
            LNP_Write_Value_Disp(wr_cp_info->OpCode, ( uint32_t )wr_cp_info->elevation);
            break;
        default:
            printf("Illegal OpCode %d\n",wr_cp_info->OpCode);
            break;
    }
}
#endif

#ifdef USE_RSCPC_SAMPLE
/******************************************************************************************/
/**
 *  @brief Display RSCP RSC Measurements Info
 *
 *  @b Contents of management:
 *
 *  @param[in] *p      RSC Measurements Info
 *
 *  @retval none
 */
/******************************************************************************************/
void RSCP_MEASURE_Info_Disp( RBLE_RSCP_MEASUREMENTS_INFO *p )
{
    printf("Flag :%02x\n", p->flags);

    printf("Instant Speed   :0x%04x(%u)\n", p->instant_speed, p->instant_speed);
    printf("Instant Cadence :0x%02x(%u)\n", p->instant_cadence, p->instant_cadence);
    if((p->flags & 0x1) == 0x1) {
        printf("Stride Length   :0x%04x(%u)\n", p->instant_stride_len, p->instant_stride_len);
    }
    if((p->flags & 0x2) == 0x2) {
        printf("Total Distance  :%ld\n", p->total_distance);
    }
}
#endif

#if defined(USE_RSCPC_SAMPLE)|defined(USE_RSCPS_SAMPLE)
/******************************************************************************************/
/**
 *  @brief Display RSCP SC Control Point Info
 *
 *  @b Contents of management:
 *
 *  @param[in] *p      RSCP Measurements Info
 *
 *  @retval none
 */
/******************************************************************************************/
void RSCP_SC_CP_Info_Disp( RBLE_RSCP_SC_CONTROL_POINT_INFO *p, uint8_t loc_num, uint8_t *res_param )
{
    uint8_t i;
    
    printf("OpCode:%02x\n", p->OpCode);
    
    switch(p->OpCode)
    {
        case RBLE_RSCP_OP_SET_CUMULATIVE_CODE:
            printf("cumulative value :%08x(%lu)\n",p->cumulative_value, p->cumulative_value);
            break;
        case RBLE_RSCP_OP_START_CALIBRATION_CODE:
            printf("start sc\n");
            break;
        case RBLE_RSCP_OP_UPDATE_SL_CODE:
            printf("update sensor location :%02d\n",p->sensor_location);
            break;
        case RBLE_RSCP_OP_REQ_SUPPORTED_SL_CODE:
            printf("req support sensor location\n");
            break;
        case RBLE_RSCP_OP_RESPONSE_CODE:
            switch(p->request_op_code)
            {
                case RBLE_RSCP_OP_SET_CUMULATIVE_CODE:
                    printf("Set Cumulative res\n");
                    break;
                case RBLE_RSCP_OP_START_CALIBRATION_CODE:
                    printf("Start SC res\n");
                    break;
                case RBLE_RSCP_OP_UPDATE_SL_CODE:
                    printf("Update Sensor Location res\n");
                    break;
                case RBLE_RSCP_OP_REQ_SUPPORTED_SL_CODE:
                    printf("Req Supported Sensor Location res\n");
                    break;
                default:
                    printf("Invalid req op code(%d)\n",p->request_op_code);
                    break;
            }
            printf("res value:%d\n",p->response_value);
            if((p->request_op_code == RBLE_RSCP_OP_REQ_SUPPORTED_SL_CODE) && (res_param != NULL))
            {
                printf("location num:%d\n",loc_num);
                for(i=0;i<RBLE_RSCP_SENSORE_LOCATION_MAX;i++) {
                    printf("%02d ",res_param[i]);
                }
                printf("\n");
            }
            break;
        default:
            break;
    }
}
#endif

#ifdef USE_VS_SAMPLE
/******************************************************************************************/
/**
 *  @brief Display VS GPIO Mask Info
 *
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval none
 */
/******************************************************************************************/
void VS_GPIO_Mask_Disp( void )
{
    printf( "Port used as GPIO" );
    if ( GPIO_Mask&(RBLE_VS_GPIO_BIT_0|RBLE_VS_GPIO_BIT_1|RBLE_VS_GPIO_BIT_2|RBLE_VS_GPIO_BIT_3) )
    {
        if ( GPIO_Mask & RBLE_VS_GPIO_BIT_0 ) printf( ": GPIO0" );
        if ( GPIO_Mask & RBLE_VS_GPIO_BIT_1 ) printf( ": GPIO1" );
        if ( GPIO_Mask & RBLE_VS_GPIO_BIT_2 ) printf( ": GPIO2" );
        if ( GPIO_Mask & RBLE_VS_GPIO_BIT_3 ) printf( ": GPIO3" );
    }
    else
    {
        printf( ": none." );
    }
    printf( "\n" );
    return;
}

/******************************************************************************************/
/**
 *  @brief Display VS GPIO Reading Value Info
 *
 *  @b Contents of management:
 *
 *  @param[in]
 *
 *  @retval none
 */
/******************************************************************************************/
void VS_GPIO_Read_Disp( void )
{
    if ( GPIO_Mode == RBLE_VS_GPIO_INPUT_MD )
    {
        if ( (GPIO_Mask & RBLE_VS_GPIO_BIT_0) && !(GPIO_Dir & RBLE_VS_GPIO_BIT_0) )
        {
            (GPIO_Value & RBLE_VS_GPIO_BIT_0)?printf( "GPIO0: HIGH\n" ):printf( "GPIO0: LOW\n" );
        }
        if ( (GPIO_Mask & RBLE_VS_GPIO_BIT_1) && !(GPIO_Dir & RBLE_VS_GPIO_BIT_1) )
        {
            (GPIO_Value & RBLE_VS_GPIO_BIT_1)?printf( "GPIO1: HIGH\n" ):printf( "GPIO1: LOW\n" );
        }
        if ( (GPIO_Mask & RBLE_VS_GPIO_BIT_2) && !(GPIO_Dir & RBLE_VS_GPIO_BIT_2) )
        {
            (GPIO_Value & RBLE_VS_GPIO_BIT_2)?printf( "GPIO2: HIGH\n" ):printf( "GPIO2: LOW\n" );
        }
        if ( (GPIO_Mask & RBLE_VS_GPIO_BIT_3) && !(GPIO_Dir & RBLE_VS_GPIO_BIT_3) )
        {
            (GPIO_Value & RBLE_VS_GPIO_BIT_3)?printf( "GPIO3: HIGH\n" ):printf( "GPIO3: LOW\n" );
        }
    }
    else
    {
        printf( "It's Output Mode now.\n" );
    }
    return;
}
#endif

int_t RBLE_Get_Random( void )
{
    return( rand() );
}

#ifdef USE_PTS_SAMPLE
static BOOL RBLE_PTS_L2CAP_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case L2CAP_TC_LE_CPU_BV_01_C:
                Pts_Flg.ChangeParam = TRUE;
                break;
            case L2CAP_TC_LE_CPU_BV_02_C:
            case L2CAP_TC_LE_CPU_BI_01_C:
                Pts_Flg.ChangeParamResp = TRUE;
                break;
            case L2CAP_TC_LE_CPU_BI_02_C:
            case L2CAP_TC_LE_REJ_BI_01_C:
            default:
                break;
        }
    }

    return( TRUE );
}

static BOOL RBLE_PTS_GAP_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case GAP_TC_CONN_CPUP_BV_04_C:
            case GAP_TC_CONN_CPUP_BV_05_C:
                Pts_Flg.ChangeParamResp = TRUE;
                break;
            case GAP_TC_SEC_AUT_BV_11_C:
            case GAP_TC_SEC_AUT_BV_12_C:
            case GAP_TC_SEC_AUT_BV_13_C:
            case GAP_TC_SEC_AUT_BV_14_C:
            case GAP_TC_SEC_AUT_BV_23_C:
            case GAP_TC_SEC_AUT_BV_24_C:
                Pts_Flg.HTPT_Enable = TRUE;
                Pts_Flg.Gap_Sec_Test = TRUE;
                if ( ( GAP_TC_SEC_AUT_BV_23_C == RBLE_Parameter_Arg[ 0 ] )
                  || ( GAP_TC_SEC_AUT_BV_24_C == RBLE_Parameter_Arg[ 0 ] ) ) {
                    Pts_Flg.Seq_Enc_Req = TRUE;
                } else if ( GAP_TC_SEC_AUT_BV_13_C == RBLE_Parameter_Arg[ 0 ] ) {
                    Pts_Flg.Auth_Req = TRUE;
                } else {
                }
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_SM_Start( void )
{
    return( TRUE );
}

static BOOL RBLE_PTS_GATT_Start( void )
{
/*
    uint16_t                        Handle;
    uint16_t                        Size;
    uint8_t                         Data[ RBLE_GATT_MAX_LONG_VALUE ];
*/

    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case GATT_TC_GAC_SR_BV_01_C:        // 2000
                Gatt_Data.Handle = 0x00D3;


                break;
            default:
                break;
        }
    }

    


    return( TRUE );
}

static BOOL RBLE_PTS_FMP_Start( void )
{
    return( TRUE );
}

static BOOL RBLE_PTS_IAS_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case IAS_TC_SD_BV_01_C:     //500
                Pts_Flg.FMPT_Enable = TRUE;
                printf( "Select FMPT_Enable\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_PXP_Start( void )
{
    return( TRUE );
}

static BOOL RBLE_PTS_LLS_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case LLS_TC_SD_BV_01_C:     //700
                Pts_Flg.PXPR_Enable = TRUE;
                printf( "Select PXPR_Enable\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_TPS_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case TPS_TC_SD_BV_01_C:     //800
                Pts_Flg.PXPR_Enable = TRUE;
                printf( "Select PXPR_Enable\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_HTP_Start( void )
{
    return( TRUE );
}

static BOOL RBLE_PTS_HTS_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case HTS_TC_SD_BV_01_C:     //1000
                Pts_Flg.HTPT_Enable = TRUE;
                printf( "Select HTPT_Enable\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_DIS_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case DIS_TC_SD_BV_01_C:     //1100
                Pts_Flg.HTPT_Enable = TRUE;
                printf( "Select HTPT_Enable\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_BLP_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case BLP_TC_BPF_BP_BV_03_I:
            case BLP_TC_BPF_BP_BV_04_I:
            case BLP_TC_BPF_BP_BV_05_I:
            case BLP_TC_BPF_BP_BV_08_I:
                Pts_Flg.BLPS_Enable = TRUE;
                printf( "Select BLPS_Enable\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_BLS_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case BLS_TC_SD_BV_01_C:     //1300
                Pts_Flg.BLPS_Enable = TRUE;
                printf( "Select BLPS_Enable\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_HOGP_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case HOGP_TC_HGDS_HD_BV_01_C:       //1403
            case HOGP_TC_HGDS_HD_BV_02_C:       //1404
                Pts_Flg.HOGPD_Enable = TRUE;
                printf( "Select HOGPD_Enable\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_HIDS_Start( void )
{

    memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );
    Pts_Flg.HOGPD_Enable = TRUE;
    printf( "Select HOGPD_Enable\n" );

    return( TRUE );
}

static BOOL RBLE_PTS_BAS_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case BAS_TC_SD_BV_01_C:     //1600
            case BAS_TC_DEC_BV_01_C:    //1601
            case BAS_TC_DES_BV_01_C:    //1602
            case BAS_TC_DES_BV_02_C:    //1603
            case BAS_TC_CR_BV_01_C:     //1604
            case BAS_TC_CON_BV_01_C:    //1605
            case BAS_TC_CN_BV_01_C:     //1606
                Pts_Flg.HOGPD_Enable = TRUE;
                printf( "Select HOGPD_Enable\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_SCPP_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case SCPP_TC_SPDS_SC_BV_01_C:   //1700
            case SCPP_TC_SPDC_SC_BV_01_C:   //1701
            case SCPP_TC_SPDC_SC_BV_02_C:   //1702
            case SCPP_TC_SPDC_SC_BV_03_C:   //1703
            case SCPP_TC_SPWF_SC_BV_01_C:   //1704
            case SCPP_TC_SPCF_SC_BV_01_C:   //1705
            case SCPP_TC_SPNF_SC_BV_01_C:   //1706
                Pts_Flg.SCPP_Enable = TRUE;
                printf( "Select ScPP_Enable\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_SCPS_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );

        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case SCPS_TC_SD_BV_01_C:    //1800
            case SCPS_TC_DEC_BV_01_C:   //1801
            case SCPS_TC_DEC_BV_02_C:   //1802
            case SCPS_TC_DES_BV_01_C:   //1803
            case SCPS_TC_CW_BV_01_C:    //1804
            case SCPS_TC_DR_BV_01_C:    //1805
            case SCPS_TC_DW_BV_01_C:    //1806
            case SCPS_TC_CON_BV_01_C:   //1807
            case SCPS_TC_CN_BV_01_C:    //1808
                Pts_Flg.SCPP_Enable = TRUE;
                printf( "Select ScPP_Enable\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_HRP_Start( void )
{
    memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );
    Pts_Flg.HRPS_Enable = TRUE;
    
    printf( "Select HRPS_Enable\n" );
    return( TRUE );
}

static BOOL RBLE_PTS_CSCP_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );
        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case CSCP_TC_CSCF_CSC_BV_01_I:          /* 2100 */
                Pts_Flg.CSCPS_Enable = TRUE;
                printf( "Select CSCPS_Enable\n" );
                break;
            case CSCP_TC_CSCF_CSC_BV_09_I:      /* 2118 */
            case CSCP_TC_CSCF_CSC_BV_10_I:      /* 2119 */
                Pts_Flg.CSCP_LinkLoss = TRUE;
                printf( "Select CSCP_LinkLoss\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_CSCS_Start( void )
{
    memset( &Pts_Flg, 0, sizeof( Pts_Flg ) );
    Pts_Flg.CSCPS_Enable = TRUE;
    
    printf( "Select CSCPS_Enable\n" );
    return( TRUE );
}

static BOOL RBLE_PTS_GLPS_Start( void )
{
    Pts_Flg.GLPS_Enable = TRUE;
    
    printf( "Select GLPS_Enable\n" );
    return( TRUE );
}

static BOOL RBLE_PTS_TIPS_Start( void )
{
    Pts_Flg.TIPS_Enable = TRUE;
    
    printf( "Select TIPS_Enable\n" );
    return( TRUE );
}

static BOOL RBLE_PTS_LNPS_Start( void )
{
    Pts_Flg.LNPS_Enable = TRUE;
    printf( "Select LNS_Enable\n" );

    if ( 0 != RBLE_Parameter_Cnt ) {
        switch ( RBLE_Parameter_Arg[ 0 ] ) {
            case LNS_TC_CR_BV_0X_C:
                Pts_Flg.LNPS_PosQual = TRUE;
                Pts_Flg.LNPS_PosQual_Flags = ( uint16_t )RBLE_Parameter_Arg[ 1 ];
                printf( " Select Set_PositionQuality\n" );
                break;
            default:
                break;
        }
    }
    return( TRUE );
}

static BOOL RBLE_PTS_LNPC_Start( void )
{
    printf( "LNP Auto Route Set Enable\n" );
    Pts_Flg.LNPC_AutoRouteSet = TRUE;
    return( TRUE );
}

static BOOL RBLE_PTS_CPS_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        Pts_Flg.CPS_Manual_Res = TRUE;
        
        printf( "Select CPS Manual Res\n" );
    }
    else {
        Pts_Flg.CPS_Enable = TRUE;
        
        printf( "Select CPS_Enable\n" );
    }
    return( TRUE );
}

static BOOL RBLE_PTS_CPP_Start( void )
{
    if ( 0 != RBLE_Parameter_Cnt ) {
        switch (RBLE_Parameter_Arg[ 0 ]) {
            case 1:
                printf( "Select 1st connect\n" );
                Pts_Flg.CPP_Con_2nd = FALSE;
                break;
            case 2:
                printf( "Select 2nd connect\n" );
                Pts_Flg.CPP_Con_2nd = TRUE;
                break;
            case 3:
                printf( "CP Broadcaster(TRUE)\n" );
                Pts_Flg.CPP_RcvAdv = TRUE;
                break;
            case 4:
            default:
                printf( "CP Broadcaster(FALSE)\n" );
                Pts_Flg.CPP_RcvAdv = FALSE;
                break;
        }
    }
    else {
        Pts_Flg.CPP_Enable = TRUE;
        
        printf( "Select CPP_Enable\n" );
    }
    return( TRUE );
}

static BOOL RBLE_PTS_PASS_Start( void )
{
    Pts_Flg.PASPS_Enable = TRUE;
    
    printf( "Select PASPS_Enable\n" );
    return( TRUE );
}

static BOOL RBLE_PTS_RSCS_Start( void )
{
    Pts_Flg.RSCPS_Enable = TRUE;
    
    printf( "Select RSCPS_Enable\n" );
    return( TRUE );
}
#endif
#endif  /* CONFIG_EMBEDDED */
#endif  /* CFG_SAMPLE */
